include('Axioms/CSR001+0.ax').
include('Axioms/CSR001+3.ax').
fof(push_not_pull,axiom,(
    ! [Agent,Trolley] : push(Agent,Trolley) != pull(Agent,Trolley) )).

fof(plus1_2,axiom,(
    plus(n1,n2) = n3 )).

fof(not_releasedAt,hypothesis,(
    ! [Fluent,Time] : ~ releasedAt(Fluent,Time) )).

fof(less0,axiom,(
    ~ ? [X] : less(X,n0) )).

fof(less5,axiom,(
    ! [X] :
      ( less(X,n5)
    <=> less_or_equal(X,n4) ) )).

fof(less6,axiom,(
    ! [X] :
      ( less(X,n6)
    <=> less_or_equal(X,n5) ) )).

fof(less_or_equal,axiom,(
    ! [X,Y] :
      ( less_or_equal(X,Y)
    <=> ( less(X,Y)
        | Y = X ) ) )).

fof(plus0_3,axiom,(
    plus(n0,n3) = n3 )).

fof(symmetry_of_plus,axiom,(
    ! [X,Y] : plus(X,Y) = plus(Y,X) )).

fof(pull_unique,axiom,(
    ! [Agent1,Agent2,Trolley1,Trolley2] :
      ( ( Trolley2 != Trolley1
        & Agent2 != Agent1 )
     => pull(Agent1,Trolley1) != pull(Agent2,Trolley2) ) )).

fof(less7,axiom,(
    ! [X] :
      ( less(X,n7)
    <=> less_or_equal(X,n6) ) )).

fof(initiates_all_defn,axiom,(
    ! [Event,Fluent,Time] :
      ( initiates(Event,Fluent,Time)
    <=> ? [Agent,Trolley] :
          ( ( ~ happens(pull(Agent,Trolley),Time)
            & forwards(Trolley) = Fluent
            & Event = push(Agent,Trolley) )
          | ( Fluent = backwards(Trolley)
            & ~ happens(push(Agent,Trolley),Time)
            & Event = pull(Agent,Trolley) )
          | ( happens(push(Agent,Trolley),Time)
            & spinning(Trolley) = Fluent
            & Event = pull(Agent,Trolley) ) ) ) )).

fof(plus0_1,axiom,(
    n1 = plus(n0,n1) )).

fof(less2,axiom,(
    ! [X] :
      ( less(X,n2)
    <=> less_or_equal(X,n1) ) )).

fof(releases_all_defn,axiom,(
    ! [Event,Fluent,Time] : ~ releases(Event,Fluent,Time) )).

fof(plus0_0,axiom,(
    plus(n0,n0) = n0 )).

fof(less_property,axiom,(
    ! [X,Y] :
      ( ( X != Y
        & ~ less(Y,X) )
    <=> less(X,Y) ) )).

fof(plus0_2,axiom,(
    n2 = plus(n0,n2) )).

fof(less4,axiom,(
    ! [X] :
      ( less_or_equal(X,n3)
    <=> less(X,n4) ) )).

fof(less1,axiom,(
    ! [X] :
      ( less_or_equal(X,n0)
    <=> less(X,n1) ) )).

fof(plus3_3,axiom,(
    plus(n3,n3) = n6 )).

fof(forwards_not_spinning,axiom,(
    ! [Trolley] : forwards(Trolley) != spinning(Trolley) )).

fof(initial_cond,hypothesis,
    ( ~ holdsAt(forwards(trolley1),n0)
    & ~ holdsAt(forwards(trolley2),n0)
    & ~ holdsAt(backwards(trolley2),n0)
    & ~ holdsAt(forwards(trolley3),n0)
    & ~ holdsAt(spinning(trolley3),n0)
    & ~ holdsAt(forwards(trolley4),n0)
    & ~ holdsAt(forwards(trolley5),n0)
    & ~ holdsAt(spinning(trolley5),n0)
    & ~ holdsAt(forwards(trolley6),n0)
    & ~ holdsAt(backwards(trolley6),n0)
    & ~ holdsAt(spinning(trolley6),n0)
    & ~ holdsAt(forwards(trolley7),n0)
    & ~ holdsAt(backwards(trolley7),n0)
    & ~ holdsAt(spinning(trolley9),n0)
    & ~ holdsAt(backwards(trolley9),n0)
    & ~ holdsAt(forwards(trolley9),n0)
    & ~ holdsAt(spinning(trolley8),n0)
    & ~ holdsAt(backwards(trolley8),n0)
    & ~ holdsAt(forwards(trolley8),n0)
    & ~ holdsAt(spinning(trolley7),n0)
    & ~ holdsAt(backwards(trolley5),n0)
    & ~ holdsAt(spinning(trolley4),n0)
    & ~ holdsAt(backwards(trolley4),n0)
    & ~ holdsAt(backwards(trolley3),n0)
    & ~ holdsAt(spinning(trolley2),n0)
    & ~ holdsAt(spinning(trolley1),n0)
    & ~ holdsAt(backwards(trolley1),n0) )).

fof(plus1_1,axiom,(
    plus(n1,n1) = n2 )).

fof(terminates_all_defn,axiom,(
    ! [Event,Fluent,Time] :
      ( ? [Agent,Trolley] :
          ( ( Fluent = backwards(Trolley)
            & happens(push(Agent,Trolley),Time)
            & pull(Agent,Trolley) = Event )
          | ( push(Agent,Trolley) = Event
            & spinning(Trolley) = Fluent
            & ~ happens(pull(Agent,Trolley),Time) )
          | ( Fluent = spinning(Trolley)
            & ~ happens(push(Agent,Trolley),Time)
            & pull(Agent,Trolley) = Event )
          | ( Event = pull(Agent,Trolley)
            & happens(push(Agent,Trolley),Time)
            & forwards(Trolley) = Fluent )
          | ( forwards(Trolley) = Fluent
            & ~ happens(push(Agent,Trolley),Time)
            & Event = pull(Agent,Trolley) )
          | ( backwards(Trolley) = Fluent
            & ~ happens(pull(Agent,Trolley),Time)
            & Event = push(Agent,Trolley) ) )
    <=> terminates(Event,Fluent,Time) ) )).

fof(forwards_not_backwards,axiom,(
    ! [Trolley] : backwards(Trolley) != forwards(Trolley) )).

fof(happens_all_defn,axiom,(
    ! [Event,Time] :
      ( happens(Event,Time)
    <=> ( ( push(agent2,trolley2) = Event
          & Time = n0 )
        | ( Time = n0
          & Event = pull(agent4,trolley4) )
        | ( n0 = Time
          & push(agent6,trolley6) = Event )
        | ( Event = pull(agent7,trolley7)
          & Time = n0 )
        | ( n0 = Time
          & Event = push(agent7,trolley7) )
        | ( n0 = Time
          & Event = push(agent8,trolley8) )
        | ( push(agent9,trolley9) = Event
          & Time = n0 )
        | ( Event = pull(agent9,trolley9)
          & n0 = Time )
        | ( Time = n0
          & pull(agent8,trolley8) = Event )
        | ( pull(agent6,trolley6) = Event
          & n0 = Time )
        | ( n0 = Time
          & push(agent5,trolley5) = Event )
        | ( Time = n0
          & Event = pull(agent5,trolley5) )
        | ( Event = push(agent4,trolley4)
          & Time = n0 )
        | ( push(agent3,trolley3) = Event
          & Time = n0 )
        | ( Time = n0
          & Event = pull(agent3,trolley3) )
        | ( Event = pull(agent2,trolley2)
          & n0 = Time )
        | ( n0 = Time
          & Event = push(agent1,trolley1) )
        | ( pull(agent1,trolley1) = Event
          & n0 = Time ) ) ) )).

fof(push_unique,axiom,(
    ! [Agent1,Agent2,Trolley1,Trolley2] :
      ( ( Agent1 != Agent2
        & Trolley1 != Trolley2 )
     => push(Agent1,Trolley1) != push(Agent2,Trolley2) ) )).

fof(less9,axiom,(
    ! [X] :
      ( less(X,n9)
    <=> less_or_equal(X,n8) ) )).

fof(spinning_not_backwards,axiom,(
    ! [Trolley] : backwards(Trolley) != spinning(Trolley) )).

fof(less8,axiom,(
    ! [X] :
      ( less(X,n8)
    <=> less_or_equal(X,n7) ) )).

fof(plus2_2,axiom,(
    n4 = plus(n2,n2) )).

fof(less3,axiom,(
    ! [X] :
      ( less_or_equal(X,n2)
    <=> less(X,n3) ) )).

fof(plus1_3,axiom,(
    n4 = plus(n1,n3) )).

fof(distinct_agents_and_trolleys,hypothesis,
    ( trolley2 != trolley1
    & agent1 != agent2
    & trolley1 != trolley3
    & agent1 != agent3
    & trolley4 != trolley1
    & agent1 != agent4
    & trolley8 != trolley1
    & agent1 != agent8
    & trolley1 != trolley9
    & trolley2 != trolley4
    & agent2 != agent5
    & trolley2 != trolley6
    & trolley2 != trolley7
    & agent2 != agent7
    & trolley2 != trolley8
    & trolley9 != trolley2
    & agent4 != agent3
    & trolley5 != trolley3
    & agent7 != agent3
    & trolley3 != trolley8
    & agent3 != agent8
    & agent4 != agent6
    & agent4 != agent7
    & trolley4 != trolley8
    & agent8 != agent4
    & trolley9 != trolley4
    & agent4 != agent9
    & trolley6 != trolley5
    & agent6 != agent5
    & trolley8 != trolley5
    & agent8 != agent5
    & agent9 != agent5
    & agent6 != agent7
    & trolley6 != trolley8
    & trolley9 != trolley6
    & agent8 != agent7
    & agent8 != agent9
    & trolley9 != trolley8
    & agent7 != agent9
    & trolley7 != trolley9
    & trolley7 != trolley8
    & agent9 != agent6
    & agent6 != agent8
    & trolley6 != trolley7
    & trolley5 != trolley9
    & agent5 != agent7
    & trolley7 != trolley5
    & trolley4 != trolley7
    & trolley6 != trolley4
    & agent5 != agent4
    & trolley5 != trolley4
    & agent9 != agent3
    & trolley3 != trolley9
    & trolley3 != trolley7
    & agent3 != agent6
    & trolley6 != trolley3
    & agent5 != agent3
    & trolley4 != trolley3
    & agent9 != agent2
    & agent2 != agent8
    & agent2 != agent6
    & trolley2 != trolley5
    & agent4 != agent2
    & agent2 != agent3
    & trolley3 != trolley2
    & agent9 != agent1
    & agent7 != agent1
    & trolley7 != trolley1
    & agent6 != agent1
    & trolley1 != trolley6
    & agent5 != agent1
    & trolley1 != trolley5 )).

fof(spinning_3,conjecture,
    ( holdsAt(spinning(trolley2),n1)
    & holdsAt(spinning(trolley3),n1)
    & holdsAt(spinning(trolley4),n1)
    & holdsAt(spinning(trolley5),n1)
    & holdsAt(spinning(trolley6),n1)
    & holdsAt(spinning(trolley7),n1)
    & holdsAt(spinning(trolley9),n1)
    & holdsAt(spinning(trolley8),n1)
    & holdsAt(spinning(trolley1),n1) )).

fof(plus2_3,axiom,(
    n5 = plus(n2,n3) )).

