%------------------------------------------------------------------------------
% File     : SLH023^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Sturm_Tarski problem prob_149__5869580_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Sturm_Tarski/prob_149__5869580_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  375 (   0 unit;  29 type;   0 defn)
%            Number of atoms       : 3587 ( 272 equality;2304 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 2858 ( 161   ~;  41   |;  56   &;2042   @)
%                                         (   0 <=>; 558  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  132 ( 132   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   31 (  29   :;   0   =)
%            Number of variables   : 1053 (   3 sgn; 915   !;  70   ?;  68   ^)
%                                         (1053   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:39.611
%------------------------------------------------------------------------------
% Could-be-implicit typings (6)
thf(ty_n_t__Polynomial__Opoly_It__Polynomial__Opoly_It__Real__Oreal_J_J,type,(
    poly_poly_real: $tType )).

thf(ty_n_t__Polynomial__Opoly_It__Real__Oreal_J,type,(
    poly_real: $tType )).

thf(ty_n_t__Polynomial__Opoly_It__Nat__Onat_J,type,(
    poly_nat: $tType )).

thf(ty_n_t__Set__Oset_It__Real__Oreal_J,type,(
    set_real: $tType )).

thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (23)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Polynomial__Opoly_It__Nat__Onat_J,type,(
    zero_zero_poly_nat: poly_nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Polynomial__Opoly_It__Polynomial__Opoly_It__Real__Oreal_J_J,type,(
    zero_z1423781445y_real: poly_poly_real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Polynomial__Opoly_It__Real__Oreal_J,type,(
    zero_zero_poly_real: poly_real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Polynomial__Opoly_It__Real__Oreal_J,type,(
    ord_less_poly_real: poly_real > poly_real > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Real__Oreal,type,(
    ord_less_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Polynomial_Odegree_001t__Nat__Onat,type,(
    degree_nat: poly_nat > nat )).

thf(sy_c_Polynomial_Odegree_001t__Polynomial__Opoly_It__Real__Oreal_J,type,(
    degree_poly_real: poly_poly_real > nat )).

thf(sy_c_Polynomial_Odegree_001t__Real__Oreal,type,(
    degree_real: poly_real > nat )).

thf(sy_c_Polynomial_Opoly_001t__Nat__Onat,type,(
    poly_nat2: poly_nat > nat > nat )).

thf(sy_c_Polynomial_Opoly_001t__Polynomial__Opoly_It__Real__Oreal_J,type,(
    poly_poly_real2: poly_poly_real > poly_real > poly_real )).

thf(sy_c_Polynomial_Opoly_001t__Real__Oreal,type,(
    poly_real2: poly_real > real > real )).

thf(sy_c_Polynomial_Opoly_Ocoeff_001t__Nat__Onat,type,(
    coeff_nat: poly_nat > nat > nat )).

thf(sy_c_Polynomial_Opoly_Ocoeff_001t__Polynomial__Opoly_It__Real__Oreal_J,type,(
    coeff_poly_real: poly_poly_real > nat > poly_real )).

thf(sy_c_Polynomial_Opoly_Ocoeff_001t__Real__Oreal,type,(
    coeff_real: poly_real > nat > real )).

thf(sy_c_Set_OCollect_001t__Real__Oreal,type,(
    collect_real: ( real > $o ) > set_real )).

thf(sy_c_member_001t__Real__Oreal,type,(
    member_real: real > set_real > $o )).

thf(sy_v_p,type,(
    p: poly_real )).

% Relevant facts (345)
thf(fact_0_assms,axiom,(
    ord_less_real @ zero_zero_real @ ( coeff_real @ p @ ( degree_real @ p ) ) )).

% assms
thf(fact_1_order__refl,axiom,(
    ! [X: real] :
      ( ord_less_eq_real @ X @ X ) )).

% order_refl
thf(fact_2_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_3_poly__pinfty__gt__lc,axiom,(
    ! [P: poly_real] :
      ( ( ord_less_real @ zero_zero_real @ ( coeff_real @ P @ ( degree_real @ P ) ) )
     => ? [N: real] :
        ! [X2: real] :
          ( ( ord_less_eq_real @ N @ X2 )
         => ( ord_less_eq_real @ ( coeff_real @ P @ ( degree_real @ P ) ) @ ( poly_real2 @ P @ X2 ) ) ) ) )).

% poly_pinfty_gt_lc
thf(fact_4_not__eq__pos__or__neg__iff__1,axiom,(
    ! [Lb: real,Ub: real,P: poly_real] :
      ( ( ! [Z: real] :
            ( ( ( ord_less_real @ Lb @ Z )
              & ( ord_less_eq_real @ Z @ Ub ) )
           => ( ( poly_real2 @ P @ Z )
             != zero_zero_real ) ) )
      = ( ! [Z: real] :
            ( ( ( ord_less_real @ Lb @ Z )
              & ( ord_less_eq_real @ Z @ Ub ) )
           => ( ord_less_real @ zero_zero_real @ ( poly_real2 @ P @ Z ) ) )
        | ! [Z: real] :
            ( ( ( ord_less_real @ Lb @ Z )
              & ( ord_less_eq_real @ Z @ Ub ) )
           => ( ord_less_real @ ( poly_real2 @ P @ Z ) @ zero_zero_real ) ) ) ) )).

% not_eq_pos_or_neg_iff_1
thf(fact_5_not__eq__pos__or__neg__iff__2,axiom,(
    ! [Lb: real,Ub: real,P: poly_real] :
      ( ( ! [Z: real] :
            ( ( ( ord_less_eq_real @ Lb @ Z )
              & ( ord_less_real @ Z @ Ub ) )
           => ( ( poly_real2 @ P @ Z )
             != zero_zero_real ) ) )
      = ( ! [Z: real] :
            ( ( ( ord_less_eq_real @ Lb @ Z )
              & ( ord_less_real @ Z @ Ub ) )
           => ( ord_less_real @ zero_zero_real @ ( poly_real2 @ P @ Z ) ) )
        | ! [Z: real] :
            ( ( ( ord_less_eq_real @ Lb @ Z )
              & ( ord_less_real @ Z @ Ub ) )
           => ( ord_less_real @ ( poly_real2 @ P @ Z ) @ zero_zero_real ) ) ) ) )).

% not_eq_pos_or_neg_iff_2
thf(fact_6_poly__eq__poly__eq__iff,axiom,(
    ! [P: poly_real,Q: poly_real] :
      ( ( ( poly_real2 @ P )
        = ( poly_real2 @ Q ) )
      = ( P = Q ) ) )).

% poly_eq_poly_eq_iff
thf(fact_7_poly__eqI,axiom,(
    ! [P: poly_real,Q: poly_real] :
      ( ! [N: nat] :
          ( ( coeff_real @ P @ N )
          = ( coeff_real @ Q @ N ) )
     => ( P = Q ) ) )).

% poly_eqI
thf(fact_8_poly__eq__iff,axiom,
    ( ( ^ [Y: poly_real,Z2: poly_real] : ( Y = Z2 ) )
    = ( ^ [P2: poly_real,Q2: poly_real] :
        ! [N2: nat] :
          ( ( coeff_real @ P2 @ N2 )
          = ( coeff_real @ Q2 @ N2 ) ) ) )).

% poly_eq_iff
thf(fact_9_coeff__inject,axiom,(
    ! [X: poly_real,Y2: poly_real] :
      ( ( ( coeff_real @ X )
        = ( coeff_real @ Y2 ) )
      = ( X = Y2 ) ) )).

% coeff_inject
thf(fact_10_complete__real,axiom,(
    ! [S: set_real] :
      ( ? [X2: real] :
          ( member_real @ X2 @ S )
     => ( ? [Z3: real] :
          ! [X3: real] :
            ( ( member_real @ X3 @ S )
           => ( ord_less_eq_real @ X3 @ Z3 ) )
       => ? [Y3: real] :
            ( ! [X2: real] :
                ( ( member_real @ X2 @ S )
               => ( ord_less_eq_real @ X2 @ Y3 ) )
            & ! [Z3: real] :
                ( ! [X3: real] :
                    ( ( member_real @ X3 @ S )
                   => ( ord_less_eq_real @ X3 @ Z3 ) )
               => ( ord_less_eq_real @ Y3 @ Z3 ) ) ) ) ) )).

% complete_real
thf(fact_11_coeff__0,axiom,(
    ! [N3: nat] :
      ( ( coeff_poly_real @ zero_z1423781445y_real @ N3 )
      = zero_zero_poly_real ) )).

% coeff_0
thf(fact_12_coeff__0,axiom,(
    ! [N3: nat] :
      ( ( coeff_nat @ zero_zero_poly_nat @ N3 )
      = zero_zero_nat ) )).

% coeff_0
thf(fact_13_coeff__0,axiom,(
    ! [N3: nat] :
      ( ( coeff_real @ zero_zero_poly_real @ N3 )
      = zero_zero_real ) )).

% coeff_0
thf(fact_14_poly__0,axiom,(
    ! [X: poly_real] :
      ( ( poly_poly_real2 @ zero_z1423781445y_real @ X )
      = zero_zero_poly_real ) )).

% poly_0
thf(fact_15_poly__0,axiom,(
    ! [X: nat] :
      ( ( poly_nat2 @ zero_zero_poly_nat @ X )
      = zero_zero_nat ) )).

% poly_0
thf(fact_16_poly__0,axiom,(
    ! [X: real] :
      ( ( poly_real2 @ zero_zero_poly_real @ X )
      = zero_zero_real ) )).

% poly_0
thf(fact_17_leading__coeff__0__iff,axiom,(
    ! [P: poly_real] :
      ( ( ( coeff_real @ P @ ( degree_real @ P ) )
        = zero_zero_real )
      = ( P = zero_zero_poly_real ) ) )).

% leading_coeff_0_iff
thf(fact_18_leading__coeff__0__iff,axiom,(
    ! [P: poly_poly_real] :
      ( ( ( coeff_poly_real @ P @ ( degree_poly_real @ P ) )
        = zero_zero_poly_real )
      = ( P = zero_z1423781445y_real ) ) )).

% leading_coeff_0_iff
thf(fact_19_leading__coeff__0__iff,axiom,(
    ! [P: poly_nat] :
      ( ( ( coeff_nat @ P @ ( degree_nat @ P ) )
        = zero_zero_nat )
      = ( P = zero_zero_poly_nat ) ) )).

% leading_coeff_0_iff
thf(fact_20_field__lbound__gt__zero,axiom,(
    ! [D1: real,D2: real] :
      ( ( ord_less_real @ zero_zero_real @ D1 )
     => ( ( ord_less_real @ zero_zero_real @ D2 )
       => ? [E: real] :
            ( ( ord_less_real @ zero_zero_real @ E )
            & ( ord_less_real @ E @ D1 )
            & ( ord_less_real @ E @ D2 ) ) ) ) )).

% field_lbound_gt_zero
thf(fact_21_ord__eq__less__subst,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_22_ord__eq__less__subst,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_23_ord__eq__less__subst,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_24_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_25_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_26_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_27_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_28_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_29_order__less__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_30_order__less__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_31_order__less__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_32_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_33_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_34_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_35_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_36_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_37_lt__ex,axiom,(
    ! [X: real] :
    ? [Y3: real] :
      ( ord_less_real @ Y3 @ X ) )).

% lt_ex
thf(fact_38_gt__ex,axiom,(
    ! [X: real] :
    ? [X_1: real] :
      ( ord_less_real @ X @ X_1 ) )).

% gt_ex
thf(fact_39_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_40_neqE,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_real @ X @ Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% neqE
thf(fact_41_neqE,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% neqE
thf(fact_42_neq__iff,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
      = ( ( ord_less_real @ X @ Y2 )
        | ( ord_less_real @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_43_neq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
      = ( ( ord_less_nat @ X @ Y2 )
        | ( ord_less_nat @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_44_order_Oasym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% order.asym
thf(fact_45_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_46_dense,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ? [Z4: real] :
          ( ( ord_less_real @ X @ Z4 )
          & ( ord_less_real @ Z4 @ Y2 ) ) ) )).

% dense
thf(fact_47_less__imp__neq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_48_less__imp__neq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_49_less__asym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_asym
thf(fact_50_less__asym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_asym
thf(fact_51_less__asym_H,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% less_asym'
thf(fact_52_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_53_less__trans,axiom,(
    ! [X: real,Y2: real,Z5: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ Z5 )
       => ( ord_less_real @ X @ Z5 ) ) ) )).

% less_trans
thf(fact_54_less__trans,axiom,(
    ! [X: nat,Y2: nat,Z5: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z5 )
       => ( ord_less_nat @ X @ Z5 ) ) ) )).

% less_trans
thf(fact_55_less__linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_real @ Y2 @ X ) ) )).

% less_linear
thf(fact_56_less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% less_linear
thf(fact_57_less__irrefl,axiom,(
    ! [X: real] :
      ~ ( ord_less_real @ X @ X ) )).

% less_irrefl
thf(fact_58_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_59_ord__eq__less__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_60_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_61_ord__less__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_62_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_63_dual__order_Oasym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ~ ( ord_less_real @ A @ B ) ) )).

% dual_order.asym
thf(fact_64_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_65_less__imp__not__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_66_less__imp__not__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_67_less__not__sym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_68_less__not__sym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_69_less__induct,axiom,(
    ! [P3: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y4: nat] :
              ( ( ord_less_nat @ Y4 @ X3 )
             => ( P3 @ Y4 ) )
         => ( P3 @ X3 ) )
     => ( P3 @ A ) ) )).

% less_induct
thf(fact_70_antisym__conv3,axiom,(
    ! [Y2: real,X: real] :
      ( ~ ( ord_less_real @ Y2 @ X )
     => ( ( ~ ( ord_less_real @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_71_antisym__conv3,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y2 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_72_less__imp__not__eq2,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_73_less__imp__not__eq2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_74_less__imp__triv,axiom,(
    ! [X: real,Y2: real,P3: $o] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ X )
       => P3 ) ) )).

% less_imp_triv
thf(fact_75_less__imp__triv,axiom,(
    ! [X: nat,Y2: nat,P3: $o] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ X )
       => P3 ) ) )).

% less_imp_triv
thf(fact_76_linorder__cases,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_77_linorder__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_78_dual__order_Oirrefl,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% dual_order.irrefl
thf(fact_79_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_80_order_Ostrict__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_81_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_82_mem__Collect__eq,axiom,(
    ! [A: real,P3: real > $o] :
      ( ( member_real @ A @ ( collect_real @ P3 ) )
      = ( P3 @ A ) ) )).

% mem_Collect_eq
thf(fact_83_Collect__mem__eq,axiom,(
    ! [A2: set_real] :
      ( ( collect_real
        @ ^ [X4: real] :
            ( member_real @ X4 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_84_less__imp__not__less,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_85_less__imp__not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_86_exists__least__iff,axiom,
    ( ( ^ [P4: nat > $o] :
        ? [X5: nat] :
          ( P4 @ X5 ) )
    = ( ^ [P5: nat > $o] :
        ? [N2: nat] :
          ( ( P5 @ N2 )
          & ! [M: nat] :
              ( ( ord_less_nat @ M @ N2 )
             => ~ ( P5 @ M ) ) ) ) )).

% exists_least_iff
thf(fact_87_linorder__less__wlog,axiom,(
    ! [P3: real > real > $o,A: real,B: real] :
      ( ! [A3: real,B2: real] :
          ( ( ord_less_real @ A3 @ B2 )
         => ( P3 @ A3 @ B2 ) )
     => ( ! [A3: real] :
            ( P3 @ A3 @ A3 )
       => ( ! [A3: real,B2: real] :
              ( ( P3 @ B2 @ A3 )
             => ( P3 @ A3 @ B2 ) )
         => ( P3 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_88_linorder__less__wlog,axiom,(
    ! [P3: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B2: nat] :
          ( ( ord_less_nat @ A3 @ B2 )
         => ( P3 @ A3 @ B2 ) )
     => ( ! [A3: nat] :
            ( P3 @ A3 @ A3 )
       => ( ! [A3: nat,B2: nat] :
              ( ( P3 @ B2 @ A3 )
             => ( P3 @ A3 @ B2 ) )
         => ( P3 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_89_dual__order_Ostrict__trans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_real @ C @ B )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_90_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_91_not__less__iff__gr__or__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_real @ X @ Y2 ) )
      = ( ( ord_less_real @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_92_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_93_order_Ostrict__implies__not__eq,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_94_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_95_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_96_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_97_zero__poly_Orep__eq,axiom,
    ( ( coeff_poly_real @ zero_z1423781445y_real )
    = ( ^ [Uu: nat] : zero_zero_poly_real ) )).

% zero_poly.rep_eq
thf(fact_98_zero__poly_Orep__eq,axiom,
    ( ( coeff_nat @ zero_zero_poly_nat )
    = ( ^ [Uu: nat] : zero_zero_nat ) )).

% zero_poly.rep_eq
thf(fact_99_zero__poly_Orep__eq,axiom,
    ( ( coeff_real @ zero_zero_poly_real )
    = ( ^ [Uu: nat] : zero_zero_real ) )).

% zero_poly.rep_eq
thf(fact_100_poly__all__0__iff__0,axiom,(
    ! [P: poly_real] :
      ( ( ! [X4: real] :
            ( ( poly_real2 @ P @ X4 )
            = zero_zero_real ) )
      = ( P = zero_zero_poly_real ) ) )).

% poly_all_0_iff_0
thf(fact_101_poly__all__0__iff__0,axiom,(
    ! [P: poly_poly_real] :
      ( ( ! [X4: poly_real] :
            ( ( poly_poly_real2 @ P @ X4 )
            = zero_zero_poly_real ) )
      = ( P = zero_z1423781445y_real ) ) )).

% poly_all_0_iff_0
thf(fact_102_le__degree,axiom,(
    ! [P: poly_real,N3: nat] :
      ( ( ( coeff_real @ P @ N3 )
       != zero_zero_real )
     => ( ord_less_eq_nat @ N3 @ ( degree_real @ P ) ) ) )).

% le_degree
thf(fact_103_le__degree,axiom,(
    ! [P: poly_poly_real,N3: nat] :
      ( ( ( coeff_poly_real @ P @ N3 )
       != zero_zero_poly_real )
     => ( ord_less_eq_nat @ N3 @ ( degree_poly_real @ P ) ) ) )).

% le_degree
thf(fact_104_le__degree,axiom,(
    ! [P: poly_nat,N3: nat] :
      ( ( ( coeff_nat @ P @ N3 )
       != zero_zero_nat )
     => ( ord_less_eq_nat @ N3 @ ( degree_nat @ P ) ) ) )).

% le_degree
thf(fact_105_leading__coeff__neq__0,axiom,(
    ! [P: poly_poly_real] :
      ( ( P != zero_z1423781445y_real )
     => ( ( coeff_poly_real @ P @ ( degree_poly_real @ P ) )
       != zero_zero_poly_real ) ) )).

% leading_coeff_neq_0
thf(fact_106_leading__coeff__neq__0,axiom,(
    ! [P: poly_nat] :
      ( ( P != zero_zero_poly_nat )
     => ( ( coeff_nat @ P @ ( degree_nat @ P ) )
       != zero_zero_nat ) ) )).

% leading_coeff_neq_0
thf(fact_107_leading__coeff__neq__0,axiom,(
    ! [P: poly_real] :
      ( ( P != zero_zero_poly_real )
     => ( ( coeff_real @ P @ ( degree_real @ P ) )
       != zero_zero_real ) ) )).

% leading_coeff_neq_0
thf(fact_108_poly__0__coeff__0,axiom,(
    ! [P: poly_real] :
      ( ( poly_real2 @ P @ zero_zero_real )
      = ( coeff_real @ P @ zero_zero_nat ) ) )).

% poly_0_coeff_0
thf(fact_109_poly__0__coeff__0,axiom,(
    ! [P: poly_poly_real] :
      ( ( poly_poly_real2 @ P @ zero_zero_poly_real )
      = ( coeff_poly_real @ P @ zero_zero_nat ) ) )).

% poly_0_coeff_0
thf(fact_110_poly__0__coeff__0,axiom,(
    ! [P: poly_nat] :
      ( ( poly_nat2 @ P @ zero_zero_nat )
      = ( coeff_nat @ P @ zero_zero_nat ) ) )).

% poly_0_coeff_0
thf(fact_111_poly__IVT__pos,axiom,(
    ! [A: real,B: real,P: poly_real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ ( poly_real2 @ P @ A ) @ zero_zero_real )
       => ( ( ord_less_real @ zero_zero_real @ ( poly_real2 @ P @ B ) )
         => ? [X3: real] :
              ( ( ord_less_real @ A @ X3 )
              & ( ord_less_real @ X3 @ B )
              & ( ( poly_real2 @ P @ X3 )
                = zero_zero_real ) ) ) ) ) )).

% poly_IVT_pos
thf(fact_112_poly__IVT__neg,axiom,(
    ! [A: real,B: real,P: poly_real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ zero_zero_real @ ( poly_real2 @ P @ A ) )
       => ( ( ord_less_real @ ( poly_real2 @ P @ B ) @ zero_zero_real )
         => ? [X3: real] :
              ( ( ord_less_real @ A @ X3 )
              & ( ord_less_real @ X3 @ B )
              & ( ( poly_real2 @ P @ X3 )
                = zero_zero_real ) ) ) ) ) )).

% poly_IVT_neg
thf(fact_113_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: real,B: real] :
      ( ( A != B )
     => ( ( ord_less_eq_real @ A @ B )
       => ( ord_less_real @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_114_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_115_dual__order_Ostrict__implies__order,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ( ord_less_eq_real @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_116_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_117_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_real
    = ( ^ [B3: real,A4: real] :
          ( ( ord_less_eq_real @ B3 @ A4 )
          & ( A4 != B3 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_118_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B3: nat,A4: nat] :
          ( ( ord_less_eq_nat @ B3 @ A4 )
          & ( A4 != B3 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_119_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_real
    = ( ^ [B3: real,A4: real] :
          ( ( ord_less_real @ B3 @ A4 )
          | ( A4 = B3 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_120_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B3: nat,A4: nat] :
          ( ( ord_less_nat @ B3 @ A4 )
          | ( A4 = B3 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_121_order_Ostrict__implies__order,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ( ord_less_eq_real @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_122_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_123_dense__le__bounded,axiom,(
    ! [X: real,Y2: real,Z5: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ! [W: real] :
            ( ( ord_less_real @ X @ W )
           => ( ( ord_less_real @ W @ Y2 )
             => ( ord_less_eq_real @ W @ Z5 ) ) )
       => ( ord_less_eq_real @ Y2 @ Z5 ) ) ) )).

% dense_le_bounded
thf(fact_124_dense__ge__bounded,axiom,(
    ! [Z5: real,X: real,Y2: real] :
      ( ( ord_less_real @ Z5 @ X )
     => ( ! [W: real] :
            ( ( ord_less_real @ Z5 @ W )
           => ( ( ord_less_real @ W @ X )
             => ( ord_less_eq_real @ Y2 @ W ) ) )
       => ( ord_less_eq_real @ Y2 @ Z5 ) ) ) )).

% dense_ge_bounded
thf(fact_125_dual__order_Ostrict__trans2,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_126_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_127_dual__order_Ostrict__trans1,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_real @ C @ B )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_128_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_129_order_Ostrict__iff__order,axiom,
    ( ord_less_real
    = ( ^ [A4: real,B3: real] :
          ( ( ord_less_eq_real @ A4 @ B3 )
          & ( A4 != B3 ) ) ) )).

% order.strict_iff_order
thf(fact_130_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A4 @ B3 )
          & ( A4 != B3 ) ) ) )).

% order.strict_iff_order
thf(fact_131_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_real
    = ( ^ [A4: real,B3: real] :
          ( ( ord_less_real @ A4 @ B3 )
          | ( A4 = B3 ) ) ) )).

% order.order_iff_strict
thf(fact_132_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A4: nat,B3: nat] :
          ( ( ord_less_nat @ A4 @ B3 )
          | ( A4 = B3 ) ) ) )).

% order.order_iff_strict
thf(fact_133_order_Ostrict__trans2,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_134_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_135_order_Ostrict__trans1,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_136_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_137_not__le__imp__less,axiom,(
    ! [Y2: real,X: real] :
      ( ~ ( ord_less_eq_real @ Y2 @ X )
     => ( ord_less_real @ X @ Y2 ) ) )).

% not_le_imp_less
thf(fact_138_not__le__imp__less,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y2 @ X )
     => ( ord_less_nat @ X @ Y2 ) ) )).

% not_le_imp_less
thf(fact_139_less__le__not__le,axiom,
    ( ord_less_real
    = ( ^ [X4: real,Y5: real] :
          ( ( ord_less_eq_real @ X4 @ Y5 )
          & ~ ( ord_less_eq_real @ Y5 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_140_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_141_le__imp__less__or__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_real @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq
thf(fact_142_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq
thf(fact_143_le__less__linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
      | ( ord_less_real @ Y2 @ X ) ) )).

% le_less_linear
thf(fact_144_le__less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% le_less_linear
thf(fact_145_dense__le,axiom,(
    ! [Y2: real,Z5: real] :
      ( ! [X3: real] :
          ( ( ord_less_real @ X3 @ Y2 )
         => ( ord_less_eq_real @ X3 @ Z5 ) )
     => ( ord_less_eq_real @ Y2 @ Z5 ) ) )).

% dense_le
thf(fact_146_dense__ge,axiom,(
    ! [Z5: real,Y2: real] :
      ( ! [X3: real] :
          ( ( ord_less_real @ Z5 @ X3 )
         => ( ord_less_eq_real @ Y2 @ X3 ) )
     => ( ord_less_eq_real @ Y2 @ Z5 ) ) )).

% dense_ge
thf(fact_147_less__le__trans,axiom,(
    ! [X: real,Y2: real,Z5: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ Z5 )
       => ( ord_less_real @ X @ Z5 ) ) ) )).

% less_le_trans
thf(fact_148_less__le__trans,axiom,(
    ! [X: nat,Y2: nat,Z5: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z5 )
       => ( ord_less_nat @ X @ Z5 ) ) ) )).

% less_le_trans
thf(fact_149_le__less__trans,axiom,(
    ! [X: real,Y2: real,Z5: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ Z5 )
       => ( ord_less_real @ X @ Z5 ) ) ) )).

% le_less_trans
thf(fact_150_le__less__trans,axiom,(
    ! [X: nat,Y2: nat,Z5: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z5 )
       => ( ord_less_nat @ X @ Z5 ) ) ) )).

% le_less_trans
thf(fact_151_less__imp__le,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ord_less_eq_real @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_152_less__imp__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_153_antisym__conv2,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ~ ( ord_less_real @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_154_antisym__conv2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_155_antisym__conv1,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_156_antisym__conv1,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_157_le__neq__trans,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( A != B )
       => ( ord_less_real @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_158_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_159_not__less,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_real @ X @ Y2 ) )
      = ( ord_less_eq_real @ Y2 @ X ) ) )).

% not_less
thf(fact_160_not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ord_less_eq_nat @ Y2 @ X ) ) )).

% not_less
thf(fact_161_not__le,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_eq_real @ X @ Y2 ) )
      = ( ord_less_real @ Y2 @ X ) ) )).

% not_le
thf(fact_162_not__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y2 ) )
      = ( ord_less_nat @ Y2 @ X ) ) )).

% not_le
thf(fact_163_order__less__le__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_164_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_165_order__less__le__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_166_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_167_order__less__le__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_168_order__less__le__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_169_order__less__le__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_170_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_171_order__le__less__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_172_order__le__less__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_173_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_174_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_175_order__le__less__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_176_order__le__less__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_177_order__le__less__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_real @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_178_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_179_less__le,axiom,
    ( ord_less_real
    = ( ^ [X4: real,Y5: real] :
          ( ( ord_less_eq_real @ X4 @ Y5 )
          & ( X4 != Y5 ) ) ) )).

% less_le
thf(fact_180_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( X4 != Y5 ) ) ) )).

% less_le
thf(fact_181_le__less,axiom,
    ( ord_less_eq_real
    = ( ^ [X4: real,Y5: real] :
          ( ( ord_less_real @ X4 @ Y5 )
          | ( X4 = Y5 ) ) ) )).

% le_less
thf(fact_182_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_nat @ X4 @ Y5 )
          | ( X4 = Y5 ) ) ) )).

% le_less
thf(fact_183_leI,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ord_less_eq_real @ Y2 @ X ) ) )).

% leI
thf(fact_184_leI,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% leI
thf(fact_185_leD,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_eq_real @ Y2 @ X )
     => ~ ( ord_less_real @ X @ Y2 ) ) )).

% leD
thf(fact_186_leD,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ~ ( ord_less_nat @ X @ Y2 ) ) )).

% leD
thf(fact_187_less__eq__real__def,axiom,
    ( ord_less_eq_real
    = ( ^ [X4: real,Y5: real] :
          ( ( ord_less_real @ X4 @ Y5 )
          | ( X4 = Y5 ) ) ) )).

% less_eq_real_def
thf(fact_188_dual__order_Oantisym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_189_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_190_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: real,Z2: real] : ( Y = Z2 ) )
    = ( ^ [A4: real,B3: real] :
          ( ( ord_less_eq_real @ B3 @ A4 )
          & ( ord_less_eq_real @ A4 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_191_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z2: nat] : ( Y = Z2 ) )
    = ( ^ [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A4 )
          & ( ord_less_eq_nat @ A4 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_192_dual__order_Otrans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_eq_real @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_193_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_194_linorder__wlog,axiom,(
    ! [P3: real > real > $o,A: real,B: real] :
      ( ! [A3: real,B2: real] :
          ( ( ord_less_eq_real @ A3 @ B2 )
         => ( P3 @ A3 @ B2 ) )
     => ( ! [A3: real,B2: real] :
            ( ( P3 @ B2 @ A3 )
           => ( P3 @ A3 @ B2 ) )
       => ( P3 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_195_linorder__wlog,axiom,(
    ! [P3: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A3 @ B2 )
         => ( P3 @ A3 @ B2 ) )
     => ( ! [A3: nat,B2: nat] :
            ( ( P3 @ B2 @ A3 )
           => ( P3 @ A3 @ B2 ) )
       => ( P3 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_196_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_197_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_198_order__trans,axiom,(
    ! [X: real,Y2: real,Z5: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ Z5 )
       => ( ord_less_eq_real @ X @ Z5 ) ) ) )).

% order_trans
thf(fact_199_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z5: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z5 )
       => ( ord_less_eq_nat @ X @ Z5 ) ) ) )).

% order_trans
thf(fact_200_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_201_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_202_ord__le__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_203_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_204_ord__eq__le__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_205_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_206_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: real,Z2: real] : ( Y = Z2 ) )
    = ( ^ [A4: real,B3: real] :
          ( ( ord_less_eq_real @ A4 @ B3 )
          & ( ord_less_eq_real @ B3 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_207_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z2: nat] : ( Y = Z2 ) )
    = ( ^ [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A4 @ B3 )
          & ( ord_less_eq_nat @ B3 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_208_antisym__conv,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_eq_real @ Y2 @ X )
     => ( ( ord_less_eq_real @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_209_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_210_le__cases3,axiom,(
    ! [X: real,Y2: real,Z5: real] :
      ( ( ( ord_less_eq_real @ X @ Y2 )
       => ~ ( ord_less_eq_real @ Y2 @ Z5 ) )
     => ( ( ( ord_less_eq_real @ Y2 @ X )
         => ~ ( ord_less_eq_real @ X @ Z5 ) )
       => ( ( ( ord_less_eq_real @ X @ Z5 )
           => ~ ( ord_less_eq_real @ Z5 @ Y2 ) )
         => ( ( ( ord_less_eq_real @ Z5 @ Y2 )
             => ~ ( ord_less_eq_real @ Y2 @ X ) )
           => ( ( ( ord_less_eq_real @ Y2 @ Z5 )
               => ~ ( ord_less_eq_real @ Z5 @ X ) )
             => ~ ( ( ord_less_eq_real @ Z5 @ X )
                 => ~ ( ord_less_eq_real @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_211_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z5: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z5 ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z5 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z5 )
           => ~ ( ord_less_eq_nat @ Z5 @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z5 @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z5 )
               => ~ ( ord_less_eq_nat @ Z5 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z5 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_212_order_Otrans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% order.trans
thf(fact_213_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_214_le__cases,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_eq_real @ X @ Y2 )
     => ( ord_less_eq_real @ Y2 @ X ) ) )).

% le_cases
thf(fact_215_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_216_eq__refl,axiom,(
    ! [X: real,Y2: real] :
      ( ( X = Y2 )
     => ( ord_less_eq_real @ X @ Y2 ) ) )).

% eq_refl
thf(fact_217_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_218_linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
      | ( ord_less_eq_real @ Y2 @ X ) ) )).

% linear
thf(fact_219_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_220_antisym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_221_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_222_eq__iff,axiom,
    ( ( ^ [Y: real,Z2: real] : ( Y = Z2 ) )
    = ( ^ [X4: real,Y5: real] :
          ( ( ord_less_eq_real @ X4 @ Y5 )
          & ( ord_less_eq_real @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_223_eq__iff,axiom,
    ( ( ^ [Y: nat,Z2: nat] : ( Y = Z2 ) )
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_224_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_225_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_226_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_227_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_228_ord__eq__le__subst,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_229_ord__eq__le__subst,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_230_ord__eq__le__subst,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_231_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_232_order__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_233_order__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_234_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_235_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_236_order__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_237_order__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_real @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_238_order__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y3: real] :
              ( ( ord_less_eq_real @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_239_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_240_not__gr__zero,axiom,(
    ! [N3: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N3 ) )
      = ( N3 = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_241_le__zero__eq,axiom,(
    ! [N3: nat] :
      ( ( ord_less_eq_nat @ N3 @ zero_zero_nat )
      = ( N3 = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_242_complete__interval,axiom,(
    ! [A: real,B: real,P3: real > $o] :
      ( ( ord_less_real @ A @ B )
     => ( ( P3 @ A )
       => ( ~ ( P3 @ B )
         => ? [C2: real] :
              ( ( ord_less_eq_real @ A @ C2 )
              & ( ord_less_eq_real @ C2 @ B )
              & ! [X2: real] :
                  ( ( ( ord_less_eq_real @ A @ X2 )
                    & ( ord_less_real @ X2 @ C2 ) )
                 => ( P3 @ X2 ) )
              & ! [D: real] :
                  ( ! [X3: real] :
                      ( ( ( ord_less_eq_real @ A @ X3 )
                        & ( ord_less_real @ X3 @ D ) )
                     => ( P3 @ X3 ) )
                 => ( ord_less_eq_real @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_243_complete__interval,axiom,(
    ! [A: nat,B: nat,P3: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P3 @ A )
       => ( ~ ( P3 @ B )
         => ? [C2: nat] :
              ( ( ord_less_eq_nat @ A @ C2 )
              & ( ord_less_eq_nat @ C2 @ B )
              & ! [X2: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X2 )
                    & ( ord_less_nat @ X2 @ C2 ) )
                 => ( P3 @ X2 ) )
              & ! [D: nat] :
                  ( ! [X3: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X3 )
                        & ( ord_less_nat @ X3 @ D ) )
                     => ( P3 @ X3 ) )
                 => ( ord_less_eq_nat @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_244_verit__comp__simplify1_I3_J,axiom,(
    ! [B4: real,A5: real] :
      ( ( ~ ( ord_less_eq_real @ B4 @ A5 ) )
      = ( ord_less_real @ A5 @ B4 ) ) )).

% verit_comp_simplify1(3)
thf(fact_245_verit__comp__simplify1_I3_J,axiom,(
    ! [B4: nat,A5: nat] :
      ( ( ~ ( ord_less_eq_nat @ B4 @ A5 ) )
      = ( ord_less_nat @ A5 @ B4 ) ) )).

% verit_comp_simplify1(3)
thf(fact_246_pinf_I6_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z4 @ X2 )
     => ~ ( ord_less_eq_real @ X2 @ T ) ) )).

% pinf(6)
thf(fact_247_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z4 @ X2 )
     => ~ ( ord_less_eq_nat @ X2 @ T ) ) )).

% pinf(6)
thf(fact_248_pinf_I8_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z4 @ X2 )
     => ( ord_less_eq_real @ T @ X2 ) ) )).

% pinf(8)
thf(fact_249_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z4 @ X2 )
     => ( ord_less_eq_nat @ T @ X2 ) ) )).

% pinf(8)
thf(fact_250_minf_I6_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z4 )
     => ( ord_less_eq_real @ X2 @ T ) ) )).

% minf(6)
thf(fact_251_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z4 )
     => ( ord_less_eq_nat @ X2 @ T ) ) )).

% minf(6)
thf(fact_252_minf_I8_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z4 )
     => ~ ( ord_less_eq_real @ T @ X2 ) ) )).

% minf(8)
thf(fact_253_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z4 )
     => ~ ( ord_less_eq_nat @ T @ X2 ) ) )).

% minf(8)
thf(fact_254_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_poly_real @ zero_zero_poly_real @ zero_zero_poly_real ) )).

% less_numeral_extra(3)
thf(fact_255_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_real @ zero_zero_real @ zero_zero_real ) )).

% less_numeral_extra(3)
thf(fact_256_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_257_gr__zeroI,axiom,(
    ! [N3: nat] :
      ( ( N3 != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N3 ) ) )).

% gr_zeroI
thf(fact_258_degree__0,axiom,
    ( ( degree_real @ zero_zero_poly_real )
    = zero_zero_nat )).

% degree_0
thf(fact_259_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_260_zero__reorient,axiom,(
    ! [X: poly_real] :
      ( ( zero_zero_poly_real = X )
      = ( X = zero_zero_poly_real ) ) )).

% zero_reorient
thf(fact_261_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_262_verit__la__disequality,axiom,(
    ! [A: real,B: real] :
      ( ( A = B )
      | ~ ( ord_less_eq_real @ A @ B )
      | ~ ( ord_less_eq_real @ B @ A ) ) )).

% verit_la_disequality
thf(fact_263_verit__la__disequality,axiom,(
    ! [A: nat,B: nat] :
      ( ( A = B )
      | ~ ( ord_less_eq_nat @ A @ B )
      | ~ ( ord_less_eq_nat @ B @ A ) ) )).

% verit_la_disequality
thf(fact_264_ex__gt__or__lt,axiom,(
    ! [A: real] :
    ? [B2: real] :
      ( ( ord_less_real @ A @ B2 )
      | ( ord_less_real @ B2 @ A ) ) )).

% ex_gt_or_lt
thf(fact_265_verit__comp__simplify1_I1_J,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_266_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_267_pinf_I1_J,axiom,(
    ! [P3: real > $o,P6: real > $o,Q3: real > $o,Q4: real > $o] :
      ( ? [Z3: real] :
        ! [X3: real] :
          ( ( ord_less_real @ Z3 @ X3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: real] :
          ! [X3: real] :
            ( ( ord_less_real @ Z3 @ X3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: real] :
          ! [X2: real] :
            ( ( ord_less_real @ Z4 @ X2 )
           => ( ( ( P3 @ X2 )
                & ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                & ( Q4 @ X2 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_268_pinf_I1_J,axiom,(
    ! [P3: nat > $o,P6: nat > $o,Q3: nat > $o,Q4: nat > $o] :
      ( ? [Z3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ Z3 @ X3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ Z3 @ X3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( ( P3 @ X2 )
                & ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                & ( Q4 @ X2 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_269_pinf_I2_J,axiom,(
    ! [P3: real > $o,P6: real > $o,Q3: real > $o,Q4: real > $o] :
      ( ? [Z3: real] :
        ! [X3: real] :
          ( ( ord_less_real @ Z3 @ X3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: real] :
          ! [X3: real] :
            ( ( ord_less_real @ Z3 @ X3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: real] :
          ! [X2: real] :
            ( ( ord_less_real @ Z4 @ X2 )
           => ( ( ( P3 @ X2 )
                | ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                | ( Q4 @ X2 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_270_pinf_I2_J,axiom,(
    ! [P3: nat > $o,P6: nat > $o,Q3: nat > $o,Q4: nat > $o] :
      ( ? [Z3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ Z3 @ X3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ Z3 @ X3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( ( P3 @ X2 )
                | ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                | ( Q4 @ X2 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_271_pinf_I3_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z4 @ X2 )
     => ( X2 != T ) ) )).

% pinf(3)
thf(fact_272_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z4 @ X2 )
     => ( X2 != T ) ) )).

% pinf(3)
thf(fact_273_pinf_I4_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z4 @ X2 )
     => ( X2 != T ) ) )).

% pinf(4)
thf(fact_274_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z4 @ X2 )
     => ( X2 != T ) ) )).

% pinf(4)
thf(fact_275_pinf_I5_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z4 @ X2 )
     => ~ ( ord_less_real @ X2 @ T ) ) )).

% pinf(5)
thf(fact_276_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z4 @ X2 )
     => ~ ( ord_less_nat @ X2 @ T ) ) )).

% pinf(5)
thf(fact_277_pinf_I7_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z4 @ X2 )
     => ( ord_less_real @ T @ X2 ) ) )).

% pinf(7)
thf(fact_278_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z4 @ X2 )
     => ( ord_less_nat @ T @ X2 ) ) )).

% pinf(7)
thf(fact_279_minf_I1_J,axiom,(
    ! [P3: real > $o,P6: real > $o,Q3: real > $o,Q4: real > $o] :
      ( ? [Z3: real] :
        ! [X3: real] :
          ( ( ord_less_real @ X3 @ Z3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: real] :
          ! [X3: real] :
            ( ( ord_less_real @ X3 @ Z3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: real] :
          ! [X2: real] :
            ( ( ord_less_real @ X2 @ Z4 )
           => ( ( ( P3 @ X2 )
                & ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                & ( Q4 @ X2 ) ) ) ) ) ) )).

% minf(1)
thf(fact_280_minf_I1_J,axiom,(
    ! [P3: nat > $o,P6: nat > $o,Q3: nat > $o,Q4: nat > $o] :
      ( ? [Z3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ Z3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ X3 @ Z3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( ( P3 @ X2 )
                & ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                & ( Q4 @ X2 ) ) ) ) ) ) )).

% minf(1)
thf(fact_281_minf_I2_J,axiom,(
    ! [P3: real > $o,P6: real > $o,Q3: real > $o,Q4: real > $o] :
      ( ? [Z3: real] :
        ! [X3: real] :
          ( ( ord_less_real @ X3 @ Z3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: real] :
          ! [X3: real] :
            ( ( ord_less_real @ X3 @ Z3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: real] :
          ! [X2: real] :
            ( ( ord_less_real @ X2 @ Z4 )
           => ( ( ( P3 @ X2 )
                | ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                | ( Q4 @ X2 ) ) ) ) ) ) )).

% minf(2)
thf(fact_282_minf_I2_J,axiom,(
    ! [P3: nat > $o,P6: nat > $o,Q3: nat > $o,Q4: nat > $o] :
      ( ? [Z3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ Z3 )
         => ( ( P3 @ X3 )
            = ( P6 @ X3 ) ) )
     => ( ? [Z3: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ X3 @ Z3 )
           => ( ( Q3 @ X3 )
              = ( Q4 @ X3 ) ) )
       => ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( ( P3 @ X2 )
                | ( Q3 @ X2 ) )
              = ( ( P6 @ X2 )
                | ( Q4 @ X2 ) ) ) ) ) ) )).

% minf(2)
thf(fact_283_minf_I3_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z4 )
     => ( X2 != T ) ) )).

% minf(3)
thf(fact_284_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z4 )
     => ( X2 != T ) ) )).

% minf(3)
thf(fact_285_minf_I4_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z4 )
     => ( X2 != T ) ) )).

% minf(4)
thf(fact_286_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z4 )
     => ( X2 != T ) ) )).

% minf(4)
thf(fact_287_minf_I5_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z4 )
     => ( ord_less_real @ X2 @ T ) ) )).

% minf(5)
thf(fact_288_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z4 )
     => ( ord_less_nat @ X2 @ T ) ) )).

% minf(5)
thf(fact_289_minf_I7_J,axiom,(
    ! [T: real] :
    ? [Z4: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z4 )
     => ~ ( ord_less_real @ T @ X2 ) ) )).

% minf(7)
thf(fact_290_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z4 )
     => ~ ( ord_less_nat @ T @ X2 ) ) )).

% minf(7)
thf(fact_291_coeff__eq__0,axiom,(
    ! [P: poly_real,N3: nat] :
      ( ( ord_less_nat @ ( degree_real @ P ) @ N3 )
     => ( ( coeff_real @ P @ N3 )
        = zero_zero_real ) ) )).

% coeff_eq_0
thf(fact_292_coeff__eq__0,axiom,(
    ! [P: poly_poly_real,N3: nat] :
      ( ( ord_less_nat @ ( degree_poly_real @ P ) @ N3 )
     => ( ( coeff_poly_real @ P @ N3 )
        = zero_zero_poly_real ) ) )).

% coeff_eq_0
thf(fact_293_coeff__eq__0,axiom,(
    ! [P: poly_nat,N3: nat] :
      ( ( ord_less_nat @ ( degree_nat @ P ) @ N3 )
     => ( ( coeff_nat @ P @ N3 )
        = zero_zero_nat ) ) )).

% coeff_eq_0
thf(fact_294_less__degree__imp,axiom,(
    ! [N3: nat,P: poly_nat] :
      ( ( ord_less_nat @ N3 @ ( degree_nat @ P ) )
     => ? [I: nat] :
          ( ( ord_less_nat @ N3 @ I )
          & ( ( coeff_nat @ P @ I )
           != zero_zero_nat ) ) ) )).

% less_degree_imp
thf(fact_295_last__non__root__interval,axiom,(
    ! [P: poly_real,Ub: real] :
      ( ( P != zero_zero_poly_real )
     => ~ ! [Lb2: real] :
            ( ( ord_less_real @ Lb2 @ Ub )
           => ~ ! [Z3: real] :
                  ( ( ( ord_less_eq_real @ Lb2 @ Z3 )
                    & ( ord_less_real @ Z3 @ Ub ) )
                 => ( ( poly_real2 @ P @ Z3 )
                   != zero_zero_real ) ) ) ) )).

% last_non_root_interval
thf(fact_296_next__non__root__interval,axiom,(
    ! [P: poly_real,Lb: real] :
      ( ( P != zero_zero_poly_real )
     => ~ ! [Ub2: real] :
            ( ( ord_less_real @ Lb @ Ub2 )
           => ~ ! [Z3: real] :
                  ( ( ( ord_less_real @ Lb @ Z3 )
                    & ( ord_less_eq_real @ Z3 @ Ub2 ) )
                 => ( ( poly_real2 @ P @ Z3 )
                   != zero_zero_real ) ) ) ) )).

% next_non_root_interval
thf(fact_297_le0,axiom,(
    ! [N3: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N3 ) )).

% le0
thf(fact_298_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_299_neq0__conv,axiom,(
    ! [N3: nat] :
      ( ( N3 != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N3 ) ) )).

% neq0_conv
thf(fact_300_less__nat__zero__code,axiom,(
    ! [N3: nat] :
      ~ ( ord_less_nat @ N3 @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_301_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_302_nat__neq__iff,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( M2 != N3 )
      = ( ( ord_less_nat @ M2 @ N3 )
        | ( ord_less_nat @ N3 @ M2 ) ) ) )).

% nat_neq_iff
thf(fact_303_less__not__refl,axiom,(
    ! [N3: nat] :
      ~ ( ord_less_nat @ N3 @ N3 ) )).

% less_not_refl
thf(fact_304_less__not__refl2,axiom,(
    ! [N3: nat,M2: nat] :
      ( ( ord_less_nat @ N3 @ M2 )
     => ( M2 != N3 ) ) )).

% less_not_refl2
thf(fact_305_less__not__refl3,axiom,(
    ! [S2: nat,T: nat] :
      ( ( ord_less_nat @ S2 @ T )
     => ( S2 != T ) ) )).

% less_not_refl3
thf(fact_306_less__irrefl__nat,axiom,(
    ! [N3: nat] :
      ~ ( ord_less_nat @ N3 @ N3 ) )).

% less_irrefl_nat
thf(fact_307_nat__less__induct,axiom,(
    ! [P3: nat > $o,N3: nat] :
      ( ! [N: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N )
             => ( P3 @ M3 ) )
         => ( P3 @ N ) )
     => ( P3 @ N3 ) ) )).

% nat_less_induct
thf(fact_308_infinite__descent,axiom,(
    ! [P3: nat > $o,N3: nat] :
      ( ! [N: nat] :
          ( ~ ( P3 @ N )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N )
              & ~ ( P3 @ M3 ) ) )
     => ( P3 @ N3 ) ) )).

% infinite_descent
thf(fact_309_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_310_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_311_infinite__descent0,axiom,(
    ! [P3: nat > $o,N3: nat] :
      ( ( P3 @ zero_zero_nat )
     => ( ! [N: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N )
           => ( ~ ( P3 @ N )
             => ? [M3: nat] :
                  ( ( ord_less_nat @ M3 @ N )
                  & ~ ( P3 @ M3 ) ) ) )
       => ( P3 @ N3 ) ) ) )).

% infinite_descent0
thf(fact_312_gr__implies__not0,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ord_less_nat @ M2 @ N3 )
     => ( N3 != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_313_less__zeroE,axiom,(
    ! [N3: nat] :
      ~ ( ord_less_nat @ N3 @ zero_zero_nat ) )).

% less_zeroE
thf(fact_314_not__less0,axiom,(
    ! [N3: nat] :
      ~ ( ord_less_nat @ N3 @ zero_zero_nat ) )).

% not_less0
thf(fact_315_not__gr0,axiom,(
    ! [N3: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N3 ) )
      = ( N3 = zero_zero_nat ) ) )).

% not_gr0
thf(fact_316_gr0I,axiom,(
    ! [N3: nat] :
      ( ( N3 != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N3 ) ) )).

% gr0I
thf(fact_317_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I2: nat,J: nat] :
      ( ! [I: nat,J2: nat] :
          ( ( ord_less_nat @ I @ J2 )
         => ( ord_less_nat @ ( F @ I ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I2 @ J )
       => ( ord_less_eq_nat @ ( F @ I2 ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_318_le__neq__implies__less,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ord_less_eq_nat @ M2 @ N3 )
     => ( ( M2 != N3 )
       => ( ord_less_nat @ M2 @ N3 ) ) ) )).

% le_neq_implies_less
thf(fact_319_Nat_Oex__has__greatest__nat,axiom,(
    ! [P3: nat > $o,K: nat,B: nat] :
      ( ( P3 @ K )
     => ( ! [Y3: nat] :
            ( ( P3 @ Y3 )
           => ( ord_less_eq_nat @ Y3 @ B ) )
       => ? [X3: nat] :
            ( ( P3 @ X3 )
            & ! [Y4: nat] :
                ( ( P3 @ Y4 )
               => ( ord_less_eq_nat @ Y4 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_320_less__or__eq__imp__le,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ( ord_less_nat @ M2 @ N3 )
        | ( M2 = N3 ) )
     => ( ord_less_eq_nat @ M2 @ N3 ) ) )).

% less_or_eq_imp_le
thf(fact_321_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M: nat,N2: nat] :
          ( ( ord_less_nat @ M @ N2 )
          | ( M = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_322_less__imp__le__nat,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ord_less_nat @ M2 @ N3 )
     => ( ord_less_eq_nat @ M2 @ N3 ) ) )).

% less_imp_le_nat
thf(fact_323_nat__le__linear,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ord_less_eq_nat @ M2 @ N3 )
      | ( ord_less_eq_nat @ N3 @ M2 ) ) )).

% nat_le_linear
thf(fact_324_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M @ N2 )
          & ( M != N2 ) ) ) )).

% nat_less_le
thf(fact_325_le__antisym,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ord_less_eq_nat @ M2 @ N3 )
     => ( ( ord_less_eq_nat @ N3 @ M2 )
       => ( M2 = N3 ) ) ) )).

% le_antisym
thf(fact_326_eq__imp__le,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( M2 = N3 )
     => ( ord_less_eq_nat @ M2 @ N3 ) ) )).

% eq_imp_le
thf(fact_327_le__trans,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I2 @ K ) ) ) )).

% le_trans
thf(fact_328_le__refl,axiom,(
    ! [N3: nat] :
      ( ord_less_eq_nat @ N3 @ N3 ) )).

% le_refl
thf(fact_329_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_330_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_331_ex__least__nat__le,axiom,(
    ! [P3: nat > $o,N3: nat] :
      ( ( P3 @ N3 )
     => ( ~ ( P3 @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N3 )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P3 @ I3 ) )
            & ( P3 @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_332_le__0__eq,axiom,(
    ! [N3: nat] :
      ( ( ord_less_eq_nat @ N3 @ zero_zero_nat )
      = ( N3 = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_333_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N3: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N3 ) )).

% less_eq_nat.simps(1)
thf(fact_334_nat__descend__induct,axiom,(
    ! [N3: nat,P3: nat > $o,M2: nat] :
      ( ! [K2: nat] :
          ( ( ord_less_nat @ N3 @ K2 )
         => ( P3 @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N3 )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K2 @ I3 )
                 => ( P3 @ I3 ) )
             => ( P3 @ K2 ) ) )
       => ( P3 @ M2 ) ) ) )).

% nat_descend_induct
thf(fact_335_diff__self__eq__0,axiom,(
    ! [M2: nat] :
      ( ( minus_minus_nat @ M2 @ M2 )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_336_diff__0__eq__0,axiom,(
    ! [N3: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N3 )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_337_diff__diff__cancel,axiom,(
    ! [I2: nat,N3: nat] :
      ( ( ord_less_eq_nat @ I2 @ N3 )
     => ( ( minus_minus_nat @ N3 @ ( minus_minus_nat @ N3 @ I2 ) )
        = I2 ) ) )).

% diff_diff_cancel
thf(fact_338_zero__less__diff,axiom,(
    ! [N3: nat,M2: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( minus_minus_nat @ N3 @ M2 ) )
      = ( ord_less_nat @ M2 @ N3 ) ) )).

% zero_less_diff
thf(fact_339_diff__is__0__eq,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ( minus_minus_nat @ M2 @ N3 )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M2 @ N3 ) ) )).

% diff_is_0_eq
thf(fact_340_diff__is__0__eq_H,axiom,(
    ! [M2: nat,N3: nat] :
      ( ( ord_less_eq_nat @ M2 @ N3 )
     => ( ( minus_minus_nat @ M2 @ N3 )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_341_diff__less,axiom,(
    ! [N3: nat,M2: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N3 )
     => ( ( ord_less_nat @ zero_zero_nat @ M2 )
       => ( ord_less_nat @ ( minus_minus_nat @ M2 @ N3 ) @ M2 ) ) ) )).

% diff_less
thf(fact_342_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_343_less__diff__iff,axiom,(
    ! [K: nat,M2: nat,N3: nat] :
      ( ( ord_less_eq_nat @ K @ M2 )
     => ( ( ord_less_eq_nat @ K @ N3 )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M2 @ K ) @ ( minus_minus_nat @ N3 @ K ) )
          = ( ord_less_nat @ M2 @ N3 ) ) ) ) )).

% less_diff_iff
thf(fact_344_diff__commute,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I2 @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I2 @ K ) @ J ) ) )).

% diff_commute

% Conjectures (1)
thf(conj_0,conjecture,(
    ? [N4: real] :
    ! [X3: real] :
      ( ~ ( ord_less_eq_real @ N4 @ X3 )
      | ( ord_less_eq_real @ ( coeff_real @ p @ ( degree_real @ p ) ) @ ( poly_real2 @ p @ X3 ) ) ) )).

%------------------------------------------------------------------------------
