%------------------------------------------------------------------------------
% File     : SLH067^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Refine_Basic problem prob_1345__3598258_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Refine_Basic/prob_1345__3598258_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :   52 (   0 unit;  15 type;   0 defn)
%            Number of atoms       :  391 (  29 equality; 246 variable)
%            Maximal formula depth :   14 (   7 average)
%            Number of connectives :  300 (   4   ~;   1   |;   3   &; 227   @)
%                                         (   0 <=>;  65  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  110 ( 110   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   19 (  15   :;   0   =)
%            Number of variables   :  118 (   2 sgn; 106   !;   0   ?;  12   ^)
%                                         ( 118   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:35:14.817
%------------------------------------------------------------------------------
% Could-be-implicit typings (1)
thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (14)
thf(sy_c_If_001_062_I_Eo_Mtf__a_J,type,(
    if_o_a: $o > ( $o > a ) > ( $o > a ) > $o > a )).

thf(sy_c_If_001tf__a,type,(
    if_a: $o > a > a > a )).

thf(sy_c_Orderings_Oord__class_Oless_001_062_I_Eo_Mtf__a_J,type,(
    ord_less_o_a: ( $o > a ) > ( $o > a ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001_062_I_Eo_M_062_I_Eo_Mtf__a_J_J,type,(
    ord_less_eq_o_o_a: ( $o > $o > a ) > ( $o > $o > a ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001_062_I_Eo_Mtf__a_J,type,(
    ord_less_eq_o_a: ( $o > a ) > ( $o > a ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001tf__a,type,(
    ord_less_eq_a: a > a > $o )).

thf(sy_c_RefineG__Transfer_OREFINEG__TRANSFER__ALIGN_001_062_I_Eo_Mtf__a_J_001_062_I_Eo_Mtf__a_J,type,(
    refine735398609_a_o_a: ( $o > a ) > ( $o > a ) > $o )).

thf(sy_c_RefineG__Transfer_OREFINEG__TRANSFER__ALIGN_001tf__a_001tf__a,type,(
    refine19784377GN_a_a: a > a > $o )).

thf(sy_c_RefineG__Transfer_OREFINEG__TRANSFER__POST__SIMP_001_062_I_Eo_Mtf__a_J,type,(
    refine1607546353MP_o_a: ( $o > a ) > ( $o > a ) > $o )).

thf(sy_c_RefineG__Transfer_OREFINEG__TRANSFER__POST__SIMP_001tf__a,type,(
    refine2039862616SIMP_a: a > a > $o )).

thf(sy_v_b,type,(
    b: $o )).

thf(sy_v_e,type,(
    e: a )).

thf(sy_v_m,type,(
    m: a )).

thf(sy_v_t,type,(
    t: a )).

% Relevant facts (29)
thf(fact_0_le__funD,axiom,(
    ! [F: $o > a,G: $o > a,X: $o] :
      ( ( ord_less_eq_o_a @ F @ G )
     => ( ord_less_eq_a @ ( F @ X ) @ ( G @ X ) ) ) )).

% le_funD
thf(fact_1_le__funE,axiom,(
    ! [F: $o > a,G: $o > a,X: $o] :
      ( ( ord_less_eq_o_a @ F @ G )
     => ( ord_less_eq_a @ ( F @ X ) @ ( G @ X ) ) ) )).

% le_funE
thf(fact_2_le__funI,axiom,(
    ! [F: $o > a,G: $o > a] :
      ( ! [X2: $o] :
          ( ord_less_eq_a @ ( F @ X2 ) @ ( G @ X2 ) )
     => ( ord_less_eq_o_a @ F @ G ) ) )).

% le_funI
thf(fact_3_Refine__Misc_Oif__mono,axiom,(
    ! [B: $o,M1: $o > a,M12: $o > a,M2: $o > a,M22: $o > a] :
      ( ( B
       => ( ord_less_eq_o_a @ M1 @ M12 ) )
     => ( ( ~ B
         => ( ord_less_eq_o_a @ M2 @ M22 ) )
       => ( ord_less_eq_o_a @ ( if_o_a @ B @ M1 @ M2 ) @ ( if_o_a @ B @ M12 @ M22 ) ) ) ) )).

% Refine_Misc.if_mono
thf(fact_4_Refine__Misc_Oif__mono,axiom,(
    ! [B: $o,M1: a,M12: a,M2: a,M22: a] :
      ( ( B
       => ( ord_less_eq_a @ M1 @ M12 ) )
     => ( ( ~ B
         => ( ord_less_eq_a @ M2 @ M22 ) )
       => ( ord_less_eq_a @ ( if_a @ B @ M1 @ M2 ) @ ( if_a @ B @ M12 @ M22 ) ) ) ) )).

% Refine_Misc.if_mono
thf(fact_5_le__fun__def,axiom,
    ( ord_less_eq_o_a
    = ( ^ [F2: $o > a,G2: $o > a] :
        ! [X3: $o] :
          ( ord_less_eq_a @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) )).

% le_fun_def
thf(fact_6_ord__eq__le__eq__trans,axiom,(
    ! [A: $o > a,B: $o > a,C: $o > a,D: $o > a] :
      ( ( A = B )
     => ( ( ord_less_eq_o_a @ B @ C )
       => ( ( C = D )
         => ( ord_less_eq_o_a @ A @ D ) ) ) ) )).

% ord_eq_le_eq_trans
thf(fact_7_ord__eq__le__eq__trans,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( A = B )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ( C = D )
         => ( ord_less_eq_a @ A @ D ) ) ) ) )).

% ord_eq_le_eq_trans
thf(fact_8_ord__eq__le__subst,axiom,(
    ! [A: $o > a,F: a > $o > a,B: a,C: a] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ! [X2: a,Y: a] :
              ( ( ord_less_eq_a @ X2 @ Y )
             => ( ord_less_eq_o_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_o_a @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_9_ord__eq__le__subst,axiom,(
    ! [A: a,F: ( $o > a ) > a,B: $o > a,C: $o > a] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_o_a @ B @ C )
       => ( ! [X2: $o > a,Y: $o > a] :
              ( ( ord_less_eq_o_a @ X2 @ Y )
             => ( ord_less_eq_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_a @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_10_ord__eq__le__subst,axiom,(
    ! [A: $o > a,F: ( $o > a ) > $o > a,B: $o > a,C: $o > a] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_o_a @ B @ C )
       => ( ! [X2: $o > a,Y: $o > a] :
              ( ( ord_less_eq_o_a @ X2 @ Y )
             => ( ord_less_eq_o_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_o_a @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_11_ord__eq__le__subst,axiom,(
    ! [A: a,F: a > a,B: a,C: a] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ! [X2: a,Y: a] :
              ( ( ord_less_eq_a @ X2 @ Y )
             => ( ord_less_eq_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_a @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_12_ord__le__eq__trans,axiom,(
    ! [A: $o > a,B: $o > a,C: $o > a] :
      ( ( ord_less_eq_o_a @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_o_a @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_13_ord__le__eq__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_a @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_14_ord__eq__le__trans,axiom,(
    ! [A: $o > a,B: $o > a,C: $o > a] :
      ( ( A = B )
     => ( ( ord_less_eq_o_a @ B @ C )
       => ( ord_less_eq_o_a @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_15_ord__eq__le__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( A = B )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_eq_a @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_16_ord__le__eq__subst,axiom,(
    ! [A: a,B: a,F: a > $o > a,C: $o > a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: a,Y: a] :
              ( ( ord_less_eq_a @ X2 @ Y )
             => ( ord_less_eq_o_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_o_a @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_17_ord__le__eq__subst,axiom,(
    ! [A: $o > a,B: $o > a,F: ( $o > a ) > a,C: a] :
      ( ( ord_less_eq_o_a @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: $o > a,Y: $o > a] :
              ( ( ord_less_eq_o_a @ X2 @ Y )
             => ( ord_less_eq_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_a @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_18_ord__le__eq__subst,axiom,(
    ! [A: $o > a,B: $o > a,F: ( $o > a ) > $o > a,C: $o > a] :
      ( ( ord_less_eq_o_a @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: $o > a,Y: $o > a] :
              ( ( ord_less_eq_o_a @ X2 @ Y )
             => ( ord_less_eq_o_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_o_a @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_19_ord__le__eq__subst,axiom,(
    ! [A: a,B: a,F: a > a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: a,Y: a] :
              ( ( ord_less_eq_a @ X2 @ Y )
             => ( ord_less_eq_a @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_a @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_20_le__rel__bool__arg__iff,axiom,
    ( ord_less_eq_o_o_a
    = ( ^ [X4: $o > $o > a,Y2: $o > $o > a] :
          ( ( ord_less_eq_o_a @ ( X4 @ $false ) @ ( Y2 @ $false ) )
          & ( ord_less_eq_o_a @ ( X4 @ $true ) @ ( Y2 @ $true ) ) ) ) )).

% le_rel_bool_arg_iff
thf(fact_21_le__rel__bool__arg__iff,axiom,
    ( ord_less_eq_o_a
    = ( ^ [X4: $o > a,Y2: $o > a] :
          ( ( ord_less_eq_a @ ( X4 @ $false ) @ ( Y2 @ $false ) )
          & ( ord_less_eq_a @ ( X4 @ $true ) @ ( Y2 @ $true ) ) ) ) )).

% le_rel_bool_arg_iff
thf(fact_22_START__REFINEG__TRANSFER,axiom,(
    ! [D: $o > a,C: $o > a,A: $o > a] :
      ( ( refine735398609_a_o_a @ D @ C )
     => ( ( ord_less_eq_o_a @ C @ A )
       => ( ( refine1607546353MP_o_a @ C @ D )
         => ( ord_less_eq_o_a @ D @ A ) ) ) ) )).

% START_REFINEG_TRANSFER
thf(fact_23_START__REFINEG__TRANSFER,axiom,(
    ! [D: a,C: a,A: a] :
      ( ( refine19784377GN_a_a @ D @ C )
     => ( ( ord_less_eq_a @ C @ A )
       => ( ( refine2039862616SIMP_a @ C @ D )
         => ( ord_less_eq_a @ D @ A ) ) ) ) )).

% START_REFINEG_TRANSFER
thf(fact_24_STOP__REFINEG__TRANSFER,axiom,(
    ! [C: a] :
      ( refine2039862616SIMP_a @ C @ C ) )).

% STOP_REFINEG_TRANSFER
thf(fact_25_REFINEG__TRANSFER__ALIGNI,axiom,(
    ! [X: a,Y3: a] :
      ( refine19784377GN_a_a @ X @ Y3 ) )).

% REFINEG_TRANSFER_ALIGNI
thf(fact_26_REFINEG__TRANSFER__ALIGN__def,axiom,
    ( refine19784377GN_a_a
    = ( ^ [X3: a,Y4: a] : $true ) )).

% REFINEG_TRANSFER_ALIGN_def
thf(fact_27_REFINEG__TRANSFER__POST__SIMP__def,axiom,
    ( refine2039862616SIMP_a
    = ( ^ [Y5: a,Z: a] : ( Y5 = Z ) ) )).

% REFINEG_TRANSFER_POST_SIMP_def
thf(fact_28_less__fun__def,axiom,
    ( ord_less_o_a
    = ( ^ [F2: $o > a,G2: $o > a] :
          ( ( ord_less_eq_o_a @ F2 @ G2 )
          & ~ ( ord_less_eq_o_a @ G2 @ F2 ) ) ) )).

% less_fun_def

% Helper facts (5)
thf(help_If_2_1_If_001tf__a_T,axiom,(
    ! [X: a,Y3: a] :
      ( ( if_a @ $false @ X @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_If_001tf__a_T,axiom,(
    ! [X: a,Y3: a] :
      ( ( if_a @ $true @ X @ Y3 )
      = X ) )).

thf(help_If_3_1_If_001_062_I_Eo_Mtf__a_J_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_If_001_062_I_Eo_Mtf__a_J_T,axiom,(
    ! [X: $o > a,Y3: $o > a] :
      ( ( if_o_a @ $false @ X @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_If_001_062_I_Eo_Mtf__a_J_T,axiom,(
    ! [X: $o > a,Y3: $o > a] :
      ( ( if_o_a @ $true @ X @ Y3 )
      = X ) )).

% Conjectures (3)
thf(conj_0,hypothesis,
    ( b
   => ( ord_less_eq_a @ t @ m ) )).

thf(conj_1,hypothesis,
    ( ~ b
   => ( ord_less_eq_a @ e @ m ) )).

thf(conj_2,conjecture,(
    ord_less_eq_a @ ( if_a @ b @ t @ e ) @ m )).

%------------------------------------------------------------------------------
