%------------------------------------------------------------------------------
% File     : SLH139^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer ListInf problem prob_523__5416764_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : ListInf/prob_523__5416764_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  314 (   0 unit;  25 type;   0 defn)
%            Number of atoms       : 3120 ( 272 equality;1994 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 2374 (  87   ~;  24   |;  40   &;1781   @)
%                                         (   0 <=>; 442  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  340 ( 340   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   29 (  25   :;   0   =)
%            Number of variables   :  902 (   0 sgn; 780   !;  32   ?;  90   ^)
%                                         ( 902   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:32:40.911
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (22)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Omonoid_001t__List__Olist_Itf__a_J,type,(
    monoid_list_a: ( list_a > list_a > list_a ) > list_a > $o )).

thf(sy_c_ListInf__Mirabelle__akbajwqfbr_Oi__take_001tf__a,type,(
    listIn84854903take_a: nat > ( nat > a ) > list_a )).

thf(sy_c_List_Oappend_001tf__a,type,(
    append_a: list_a > list_a > list_a )).

thf(sy_c_List_Obind_001tf__a_001tf__a,type,(
    bind_a_a: list_a > ( a > list_a ) > list_a )).

thf(sy_c_List_Ocount__list_001tf__a,type,(
    count_list_a: list_a > a > nat )).

thf(sy_c_List_Odrop_001tf__a,type,(
    drop_a: nat > list_a > list_a )).

thf(sy_c_List_Olist_ONil_001tf__a,type,(
    nil_a: list_a )).

thf(sy_c_List_Olist__ex1_001tf__a,type,(
    list_ex1_a: ( a > $o ) > list_a > $o )).

thf(sy_c_List_Omember_001tf__a,type,(
    member_a: list_a > a > $o )).

thf(sy_c_List_Otake_001tf__a,type,(
    take_a: nat > list_a > list_a )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001_062_I_Eo_Mt__Nat__Onat_J,type,(
    ord_less_o_nat: ( $o > nat ) > ( $o > nat ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001_062_I_Eo_M_062_I_Eo_Mt__Nat__Onat_J_J,type,(
    ord_less_eq_o_o_nat: ( $o > $o > nat ) > ( $o > $o > nat ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001_062_I_Eo_Mt__Nat__Onat_J,type,(
    ord_less_eq_o_nat: ( $o > nat ) > ( $o > nat ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oorder__class_OGreatest_001_062_I_Eo_Mt__Nat__Onat_J,type,(
    order_Greatest_o_nat: ( ( $o > nat ) > $o ) > $o > nat )).

thf(sy_c_Orderings_Oorder__class_OGreatest_001t__Nat__Onat,type,(
    order_Greatest_nat: ( nat > $o ) > nat )).

thf(sy_v_f,type,(
    f: nat > a )).

thf(sy_v_m,type,(
    m: nat )).

thf(sy_v_n,type,(
    n: nat )).

% Relevant facts (287)
thf(fact_0_ilist__i__take__eq__conv,axiom,
    ( ( ^ [Y: nat > a,Z: nat > a] : ( Y = Z ) )
    = ( ^ [F: nat > a,G: nat > a] :
        ! [N: nat] :
          ( ( listIn84854903take_a @ N @ F )
          = ( listIn84854903take_a @ N @ G ) ) ) )).

% ilist_i_take_eq_conv
thf(fact_1_append_Oassoc,axiom,(
    ! [A: list_a,B: list_a,C: list_a] :
      ( ( append_a @ ( append_a @ A @ B ) @ C )
      = ( append_a @ A @ ( append_a @ B @ C ) ) ) )).

% append.assoc
thf(fact_2_append__assoc,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a] :
      ( ( append_a @ ( append_a @ Xs @ Ys ) @ Zs )
      = ( append_a @ Xs @ ( append_a @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_3_append__same__eq,axiom,(
    ! [Ys: list_a,Xs: list_a,Zs: list_a] :
      ( ( ( append_a @ Ys @ Xs )
        = ( append_a @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_4_same__append__eq,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = ( append_a @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_5_order__refl,axiom,(
    ! [X: $o > nat] :
      ( ord_less_eq_o_nat @ X @ X ) )).

% order_refl
thf(fact_6_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_7_list__drop__eq__conv,axiom,
    ( ( ^ [Y: list_a,Z: list_a] : ( Y = Z ) )
    = ( ^ [Xs2: list_a,Ys2: list_a] :
        ! [N: nat] :
          ( ( drop_a @ N @ Xs2 )
          = ( drop_a @ N @ Ys2 ) ) ) )).

% list_drop_eq_conv
thf(fact_8_i__take__drop__map__empty__iff,axiom,(
    ! [M: nat,N2: nat,F2: nat > a] :
      ( ( ( drop_a @ M @ ( listIn84854903take_a @ N2 @ F2 ) )
        = nil_a )
      = ( ord_less_eq_nat @ N2 @ M ) ) )).

% i_take_drop_map_empty_iff
thf(fact_9_append__eq__appendI,axiom,(
    ! [Xs: list_a,Xs1: list_a,Zs: list_a,Ys: list_a,Us: list_a] :
      ( ( ( append_a @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append_a @ Xs1 @ Us ) )
       => ( ( append_a @ Xs @ Ys )
          = ( append_a @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_10_append__eq__append__conv2,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a,Ts: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = ( append_a @ Zs @ Ts ) )
      = ( ? [Us2: list_a] :
            ( ( ( Xs
                = ( append_a @ Zs @ Us2 ) )
              & ( ( append_a @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append_a @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append_a @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_11_le__refl,axiom,(
    ! [N2: nat] :
      ( ord_less_eq_nat @ N2 @ N2 ) )).

% le_refl
thf(fact_12_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_13_eq__imp__le,axiom,(
    ! [M: nat,N2: nat] :
      ( ( M = N2 )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% eq_imp_le
thf(fact_14_append_Oright__neutral,axiom,(
    ! [A: list_a] :
      ( ( append_a @ A @ nil_a )
      = A ) )).

% append.right_neutral
thf(fact_15_append__is__Nil__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = nil_a )
      = ( ( Xs = nil_a )
        & ( Ys = nil_a ) ) ) )).

% append_is_Nil_conv
thf(fact_16_Nil__is__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( nil_a
        = ( append_a @ Xs @ Ys ) )
      = ( ( Xs = nil_a )
        & ( Ys = nil_a ) ) ) )).

% Nil_is_append_conv
thf(fact_17_self__append__conv2,axiom,(
    ! [Ys: list_a,Xs: list_a] :
      ( ( Ys
        = ( append_a @ Xs @ Ys ) )
      = ( Xs = nil_a ) ) )).

% self_append_conv2
thf(fact_18_append__self__conv2,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = Ys )
      = ( Xs = nil_a ) ) )).

% append_self_conv2
thf(fact_19_self__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( Xs
        = ( append_a @ Xs @ Ys ) )
      = ( Ys = nil_a ) ) )).

% self_append_conv
thf(fact_20_append__self__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = Xs )
      = ( Ys = nil_a ) ) )).

% append_self_conv
thf(fact_21_append__Nil2,axiom,(
    ! [Xs: list_a] :
      ( ( append_a @ Xs @ nil_a )
      = Xs ) )).

% append_Nil2
thf(fact_22_append_Oleft__neutral,axiom,(
    ! [A: list_a] :
      ( ( append_a @ nil_a @ A )
      = A ) )).

% append.left_neutral
thf(fact_23_append__Nil,axiom,(
    ! [Ys: list_a] :
      ( ( append_a @ nil_a @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_24_eq__Nil__appendI,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append_a @ nil_a @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_25_drop__Nil,axiom,(
    ! [N2: nat] :
      ( ( drop_a @ N2 @ nil_a )
      = nil_a ) )).

% drop_Nil
thf(fact_26_dual__order_Oantisym,axiom,(
    ! [B: $o > nat,A: $o > nat] :
      ( ( ord_less_eq_o_nat @ B @ A )
     => ( ( ord_less_eq_o_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_27_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_28_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: $o > nat,Z: $o > nat] : ( Y = Z ) )
    = ( ^ [A2: $o > nat,B2: $o > nat] :
          ( ( ord_less_eq_o_nat @ B2 @ A2 )
          & ( ord_less_eq_o_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_29_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_30_dual__order_Otrans,axiom,(
    ! [B: $o > nat,A: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ B @ A )
     => ( ( ord_less_eq_o_nat @ C @ B )
       => ( ord_less_eq_o_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_31_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_32_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_33_dual__order_Orefl,axiom,(
    ! [A: $o > nat] :
      ( ord_less_eq_o_nat @ A @ A ) )).

% dual_order.refl
thf(fact_34_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_35_order__trans,axiom,(
    ! [X: $o > nat,Y2: $o > nat,Z2: $o > nat] :
      ( ( ord_less_eq_o_nat @ X @ Y2 )
     => ( ( ord_less_eq_o_nat @ Y2 @ Z2 )
       => ( ord_less_eq_o_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_36_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_37_order__class_Oorder_Oantisym,axiom,(
    ! [A: $o > nat,B: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_eq_o_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_38_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_39_ord__le__eq__trans,axiom,(
    ! [A: $o > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_o_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_40_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_41_ord__eq__le__trans,axiom,(
    ! [A: $o > nat,B: $o > nat,C: $o > nat] :
      ( ( A = B )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ord_less_eq_o_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_42_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_43_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: $o > nat,Z: $o > nat] : ( Y = Z ) )
    = ( ^ [A2: $o > nat,B2: $o > nat] :
          ( ( ord_less_eq_o_nat @ A2 @ B2 )
          & ( ord_less_eq_o_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_44_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_45_antisym__conv,axiom,(
    ! [Y2: $o > nat,X: $o > nat] :
      ( ( ord_less_eq_o_nat @ Y2 @ X )
     => ( ( ord_less_eq_o_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_46_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_47_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_48_order_Otrans,axiom,(
    ! [A: $o > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ord_less_eq_o_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_49_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_50_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_51_eq__refl,axiom,(
    ! [X: $o > nat,Y2: $o > nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_o_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_52_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_53_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_54_antisym,axiom,(
    ! [X: $o > nat,Y2: $o > nat] :
      ( ( ord_less_eq_o_nat @ X @ Y2 )
     => ( ( ord_less_eq_o_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_55_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_56_eq__iff,axiom,
    ( ( ^ [Y: $o > nat,Z: $o > nat] : ( Y = Z ) )
    = ( ^ [X2: $o > nat,Y3: $o > nat] :
          ( ( ord_less_eq_o_nat @ X2 @ Y3 )
          & ( ord_less_eq_o_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_57_eq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_58_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > $o > nat,C: $o > nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_59_ord__le__eq__subst,axiom,(
    ! [A: $o > nat,B: $o > nat,F2: ( $o > nat ) > nat,C: nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_60_ord__le__eq__subst,axiom,(
    ! [A: $o > nat,B: $o > nat,F2: ( $o > nat ) > $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_61_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_62_ord__eq__le__subst,axiom,(
    ! [A: $o > nat,F2: nat > $o > nat,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_63_ord__eq__le__subst,axiom,(
    ! [A: nat,F2: ( $o > nat ) > nat,B: $o > nat,C: $o > nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_64_ord__eq__le__subst,axiom,(
    ! [A: $o > nat,F2: ( $o > nat ) > $o > nat,B: $o > nat,C: $o > nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_65_ord__eq__le__subst,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_66_order__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > $o > nat,C: $o > nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_o_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_67_order__subst2,axiom,(
    ! [A: $o > nat,B: $o > nat,F2: ( $o > nat ) > nat,C: nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_68_order__subst2,axiom,(
    ! [A: $o > nat,B: $o > nat,F2: ( $o > nat ) > $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_eq_o_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_69_order__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_70_order__subst1,axiom,(
    ! [A: nat,F2: ( $o > nat ) > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_71_order__subst1,axiom,(
    ! [A: $o > nat,F2: nat > $o > nat,B: nat,C: nat] :
      ( ( ord_less_eq_o_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_72_order__subst1,axiom,(
    ! [A: $o > nat,F2: ( $o > nat ) > $o > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_73_order__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_74_le__fun__def,axiom,
    ( ord_less_eq_o_nat
    = ( ^ [F: $o > nat,G: $o > nat] :
        ! [X2: $o] :
          ( ord_less_eq_nat @ ( F @ X2 ) @ ( G @ X2 ) ) ) )).

% le_fun_def
thf(fact_75_le__funI,axiom,(
    ! [F2: $o > nat,G2: $o > nat] :
      ( ! [X3: $o] :
          ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
     => ( ord_less_eq_o_nat @ F2 @ G2 ) ) )).

% le_funI
thf(fact_76_le__funE,axiom,(
    ! [F2: $o > nat,G2: $o > nat,X: $o] :
      ( ( ord_less_eq_o_nat @ F2 @ G2 )
     => ( ord_less_eq_nat @ ( F2 @ X ) @ ( G2 @ X ) ) ) )).

% le_funE
thf(fact_77_le__funD,axiom,(
    ! [F2: $o > nat,G2: $o > nat,X: $o] :
      ( ( ord_less_eq_o_nat @ F2 @ G2 )
     => ( ord_less_eq_nat @ ( F2 @ X ) @ ( G2 @ X ) ) ) )).

% le_funD
thf(fact_78_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y5: nat] :
                ( ( P @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_79_nat__le__linear,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
      | ( ord_less_eq_nat @ N2 @ M ) ) )).

% nat_le_linear
thf(fact_80_le__antisym,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( ord_less_eq_nat @ N2 @ M )
       => ( M = N2 ) ) ) )).

% le_antisym
thf(fact_81_list__ex1__simps_I1_J,axiom,(
    ! [P: a > $o] :
      ~ ( list_ex1_a @ P @ nil_a ) )).

% list_ex1_simps(1)
thf(fact_82_drop__all__iff,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ( ( drop_a @ N2 @ Xs )
        = nil_a )
      = ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N2 ) ) )).

% drop_all_iff
thf(fact_83_drop__all,axiom,(
    ! [Xs: list_a,N2: nat] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N2 )
     => ( ( drop_a @ N2 @ Xs )
        = nil_a ) ) )).

% drop_all
thf(fact_84_bind__simps_I1_J,axiom,(
    ! [F2: a > list_a] :
      ( ( bind_a_a @ nil_a @ F2 )
      = nil_a ) )).

% bind_simps(1)
thf(fact_85_Greatest__equality,axiom,(
    ! [P: ( $o > nat ) > $o,X: $o > nat] :
      ( ( P @ X )
     => ( ! [Y4: $o > nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_o_nat @ Y4 @ X ) )
       => ( ( order_Greatest_o_nat @ P )
          = X ) ) ) )).

% Greatest_equality
thf(fact_86_Greatest__equality,axiom,(
    ! [P: nat > $o,X: nat] :
      ( ( P @ X )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ X ) )
       => ( ( order_Greatest_nat @ P )
          = X ) ) ) )).

% Greatest_equality
thf(fact_87_GreatestI2__order,axiom,(
    ! [P: ( $o > nat ) > $o,X: $o > nat,Q: ( $o > nat ) > $o] :
      ( ( P @ X )
     => ( ! [Y4: $o > nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_o_nat @ Y4 @ X ) )
       => ( ! [X3: $o > nat] :
              ( ( P @ X3 )
             => ( ! [Y5: $o > nat] :
                    ( ( P @ Y5 )
                   => ( ord_less_eq_o_nat @ Y5 @ X3 ) )
               => ( Q @ X3 ) ) )
         => ( Q @ ( order_Greatest_o_nat @ P ) ) ) ) ) )).

% GreatestI2_order
thf(fact_88_GreatestI2__order,axiom,(
    ! [P: nat > $o,X: nat,Q: nat > $o] :
      ( ( P @ X )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ X ) )
       => ( ! [X3: nat] :
              ( ( P @ X3 )
             => ( ! [Y5: nat] :
                    ( ( P @ Y5 )
                   => ( ord_less_eq_nat @ Y5 @ X3 ) )
               => ( Q @ X3 ) ) )
         => ( Q @ ( order_Greatest_nat @ P ) ) ) ) ) )).

% GreatestI2_order
thf(fact_89_bounded__Max__nat,axiom,(
    ! [P: nat > $o,X: nat,M2: nat] :
      ( ( P @ X )
     => ( ! [X3: nat] :
            ( ( P @ X3 )
           => ( ord_less_eq_nat @ X3 @ M2 ) )
       => ~ ! [M3: nat] :
              ( ( P @ M3 )
             => ~ ! [X4: nat] :
                    ( ( P @ X4 )
                   => ( ord_less_eq_nat @ X4 @ M3 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_90_member__rec_I2_J,axiom,(
    ! [Y2: a] :
      ~ ( member_a @ nil_a @ Y2 ) )).

% member_rec(2)
thf(fact_91_append_Omonoid__axioms,axiom,(
    monoid_list_a @ append_a @ nil_a )).

% append.monoid_axioms
thf(fact_92_le__rel__bool__arg__iff,axiom,
    ( ord_less_eq_o_o_nat
    = ( ^ [X5: $o > $o > nat,Y6: $o > $o > nat] :
          ( ( ord_less_eq_o_nat @ ( X5 @ $false ) @ ( Y6 @ $false ) )
          & ( ord_less_eq_o_nat @ ( X5 @ $true ) @ ( Y6 @ $true ) ) ) ) )).

% le_rel_bool_arg_iff
thf(fact_93_le__rel__bool__arg__iff,axiom,
    ( ord_less_eq_o_nat
    = ( ^ [X5: $o > nat,Y6: $o > nat] :
          ( ( ord_less_eq_nat @ ( X5 @ $false ) @ ( Y6 @ $false ) )
          & ( ord_less_eq_nat @ ( X5 @ $true ) @ ( Y6 @ $true ) ) ) ) )).

% le_rel_bool_arg_iff
thf(fact_94_append__eq__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a,Us: list_a,Vs: list_a] :
      ( ( ( ( size_size_list_a @ Xs )
          = ( size_size_list_a @ Ys ) )
        | ( ( size_size_list_a @ Us )
          = ( size_size_list_a @ Vs ) ) )
     => ( ( ( append_a @ Xs @ Us )
          = ( append_a @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) )).

% append_eq_append_conv
thf(fact_95_i__take__length,axiom,(
    ! [N2: nat,F2: nat > a] :
      ( ( size_size_list_a @ ( listIn84854903take_a @ N2 @ F2 ) )
      = N2 ) )).

% i_take_length
thf(fact_96_Ex__list__of__length,axiom,(
    ! [N2: nat] :
    ? [Xs3: list_a] :
      ( ( size_size_list_a @ Xs3 )
      = N2 ) )).

% Ex_list_of_length
thf(fact_97_neq__if__length__neq,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( size_size_list_a @ Xs )
       != ( size_size_list_a @ Ys ) )
     => ( Xs != Ys ) ) )).

% neq_if_length_neq
thf(fact_98_size__neq__size__imp__neq,axiom,(
    ! [X: list_a,Y2: list_a] :
      ( ( ( size_size_list_a @ X )
       != ( size_size_list_a @ Y2 ) )
     => ( X != Y2 ) ) )).

% size_neq_size_imp_neq
thf(fact_99_GreatestI__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ( P @ ( order_Greatest_nat @ P ) ) ) ) )).

% GreatestI_nat
thf(fact_100_Greatest__le__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ( ord_less_eq_nat @ K @ ( order_Greatest_nat @ P ) ) ) ) )).

% Greatest_le_nat
thf(fact_101_GreatestI__ex__nat,axiom,(
    ! [P: nat > $o,B: nat] :
      ( ? [X_1: nat] :
          ( P @ X_1 )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ( P @ ( order_Greatest_nat @ P ) ) ) ) )).

% GreatestI_ex_nat
thf(fact_102_monoid_Oright__neutral,axiom,(
    ! [F2: list_a > list_a > list_a,Z2: list_a,A: list_a] :
      ( ( monoid_list_a @ F2 @ Z2 )
     => ( ( F2 @ A @ Z2 )
        = A ) ) )).

% monoid.right_neutral
thf(fact_103_monoid_Oleft__neutral,axiom,(
    ! [F2: list_a > list_a > list_a,Z2: list_a,A: list_a] :
      ( ( monoid_list_a @ F2 @ Z2 )
     => ( ( F2 @ Z2 @ A )
        = A ) ) )).

% monoid.left_neutral
thf(fact_104_count__le__length,axiom,(
    ! [Xs: list_a,X: a] :
      ( ord_less_eq_nat @ ( count_list_a @ Xs @ X ) @ ( size_size_list_a @ Xs ) ) )).

% count_le_length
thf(fact_105_drop__append,axiom,(
    ! [N2: nat,Xs: list_a,Ys: list_a] :
      ( ( drop_a @ N2 @ ( append_a @ Xs @ Ys ) )
      = ( append_a @ ( drop_a @ N2 @ Xs ) @ ( drop_a @ ( minus_minus_nat @ N2 @ ( size_size_list_a @ Xs ) ) @ Ys ) ) ) )).

% drop_append
thf(fact_106_append__eq__append__conv__if,axiom,(
    ! [Xs_1: list_a,Xs_2: list_a,Ys_1: list_a,Ys_2: list_a] :
      ( ( ( append_a @ Xs_1 @ Xs_2 )
        = ( append_a @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs_1 ) @ ( size_size_list_a @ Ys_1 ) )
         => ( ( Xs_1
              = ( take_a @ ( size_size_list_a @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append_a @ ( drop_a @ ( size_size_list_a @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq_nat @ ( size_size_list_a @ Xs_1 ) @ ( size_size_list_a @ Ys_1 ) )
         => ( ( ( take_a @ ( size_size_list_a @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append_a @ ( drop_a @ ( size_size_list_a @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) )).

% append_eq_append_conv_if
thf(fact_107_drop__not__empty__conv,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ( ( drop_a @ N2 @ Xs )
       != nil_a )
      = ( ord_less_nat @ N2 @ ( size_size_list_a @ Xs ) ) ) )).

% drop_not_empty_conv
thf(fact_108_diff__diff__cancel,axiom,(
    ! [I: nat,N2: nat] :
      ( ( ord_less_eq_nat @ I @ N2 )
     => ( ( minus_minus_nat @ N2 @ ( minus_minus_nat @ N2 @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_109_take__all,axiom,(
    ! [Xs: list_a,N2: nat] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N2 )
     => ( ( take_a @ N2 @ Xs )
        = Xs ) ) )).

% take_all
thf(fact_110_take__all__iff,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ( ( take_a @ N2 @ Xs )
        = Xs )
      = ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N2 ) ) )).

% take_all_iff
thf(fact_111_length__drop,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ( size_size_list_a @ ( drop_a @ N2 @ Xs ) )
      = ( minus_minus_nat @ ( size_size_list_a @ Xs ) @ N2 ) ) )).

% length_drop
thf(fact_112_append__take__drop__id,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ( append_a @ ( take_a @ N2 @ Xs ) @ ( drop_a @ N2 @ Xs ) )
      = Xs ) )).

% append_take_drop_id
thf(fact_113_take__append,axiom,(
    ! [N2: nat,Xs: list_a,Ys: list_a] :
      ( ( take_a @ N2 @ ( append_a @ Xs @ Ys ) )
      = ( append_a @ ( take_a @ N2 @ Xs ) @ ( take_a @ ( minus_minus_nat @ N2 @ ( size_size_list_a @ Xs ) ) @ Ys ) ) ) )).

% take_append
thf(fact_114_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_115_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N2 )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N2 @ K ) )
          = ( ord_less_nat @ M @ N2 ) ) ) ) )).

% less_diff_iff
thf(fact_116_drop__take,axiom,(
    ! [N2: nat,M: nat,Xs: list_a] :
      ( ( drop_a @ N2 @ ( take_a @ M @ Xs ) )
      = ( take_a @ ( minus_minus_nat @ M @ N2 ) @ ( drop_a @ N2 @ Xs ) ) ) )).

% drop_take
thf(fact_117_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_118_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_119_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_120_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_121_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_122_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P @ B3 @ A3 )
             => ( P @ A3 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_123_exists__least__iff,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X6: nat] :
          ( P2 @ X6 ) )
    = ( ^ [P3: nat > $o] :
        ? [N: nat] :
          ( ( P3 @ N )
          & ! [M4: nat] :
              ( ( ord_less_nat @ M4 @ N )
             => ~ ( P3 @ M4 ) ) ) ) )).

% exists_least_iff
thf(fact_124_less__imp__not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_125_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_126_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_127_linorder__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_128_less__imp__triv,axiom,(
    ! [X: nat,Y2: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_129_less__imp__not__eq2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_130_antisym__conv3,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y2 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_131_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y5: nat] :
              ( ( ord_less_nat @ Y5 @ X3 )
             => ( P @ Y5 ) )
         => ( P @ X3 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_132_less__not__sym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_133_less__imp__not__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_134_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_135_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_136_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_137_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_138_less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% less_linear
thf(fact_139_less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_140_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_141_less__asym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_asym
thf(fact_142_less__imp__neq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_143_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_144_neq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
      = ( ( ord_less_nat @ X @ Y2 )
        | ( ord_less_nat @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_145_neqE,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% neqE
thf(fact_146_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_12: nat] :
      ( ord_less_nat @ X @ X_12 ) )).

% gt_ex
thf(fact_147_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_148_order__less__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_149_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_150_ord__eq__less__subst,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_151_list__take__eq__conv,axiom,
    ( ( ^ [Y: list_a,Z: list_a] : ( Y = Z ) )
    = ( ^ [Xs2: list_a,Ys2: list_a] :
        ! [N: nat] :
          ( ( take_a @ N @ Xs2 )
          = ( take_a @ N @ Ys2 ) ) ) )).

% list_take_eq_conv
thf(fact_152_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N2: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N2 ) @ K ) ) )).

% less_imp_diff_less
thf(fact_153_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_154_infinite__descent,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M5: nat] :
              ( ( ord_less_nat @ M5 @ N3 )
              & ~ ( P @ M5 ) ) )
     => ( P @ N2 ) ) )).

% infinite_descent
thf(fact_155_nat__less__induct,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M5: nat] :
              ( ( ord_less_nat @ M5 @ N3 )
             => ( P @ M5 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) )).

% nat_less_induct
thf(fact_156_less__irrefl__nat,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ N2 ) )).

% less_irrefl_nat
thf(fact_157_diff__less__mono2,axiom,(
    ! [M: nat,N2: nat,L: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N2 ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_158_take__equalityI,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ! [I2: nat] :
          ( ( take_a @ I2 @ Xs )
          = ( take_a @ I2 @ Ys ) )
     => ( Xs = Ys ) ) )).

% take_equalityI
thf(fact_159_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_160_less__not__refl2,axiom,(
    ! [N2: nat,M: nat] :
      ( ( ord_less_nat @ N2 @ M )
     => ( M != N2 ) ) )).

% less_not_refl2
thf(fact_161_less__not__refl,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ N2 ) )).

% less_not_refl
thf(fact_162_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_163_nat__neq__iff,axiom,(
    ! [M: nat,N2: nat] :
      ( ( M != N2 )
      = ( ( ord_less_nat @ M @ N2 )
        | ( ord_less_nat @ N2 @ M ) ) ) )).

% nat_neq_iff
thf(fact_164_take__Nil,axiom,(
    ! [N2: nat] :
      ( ( take_a @ N2 @ nil_a )
      = nil_a ) )).

% take_Nil
thf(fact_165_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: $o > nat,B: $o > nat] :
      ( ( A != B )
     => ( ( ord_less_eq_o_nat @ A @ B )
       => ( ord_less_o_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_166_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_167_dual__order_Ostrict__implies__order,axiom,(
    ! [B: $o > nat,A: $o > nat] :
      ( ( ord_less_o_nat @ B @ A )
     => ( ord_less_eq_o_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_168_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_169_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_o_nat
    = ( ^ [B2: $o > nat,A2: $o > nat] :
          ( ( ord_less_eq_o_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_170_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_171_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_o_nat
    = ( ^ [B2: $o > nat,A2: $o > nat] :
          ( ( ord_less_o_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_172_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_173_order_Ostrict__implies__order,axiom,(
    ! [A: $o > nat,B: $o > nat] :
      ( ( ord_less_o_nat @ A @ B )
     => ( ord_less_eq_o_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_174_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_175_dual__order_Ostrict__trans2,axiom,(
    ! [B: $o > nat,A: $o > nat,C: $o > nat] :
      ( ( ord_less_o_nat @ B @ A )
     => ( ( ord_less_eq_o_nat @ C @ B )
       => ( ord_less_o_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_176_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_177_dual__order_Ostrict__trans1,axiom,(
    ! [B: $o > nat,A: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ B @ A )
     => ( ( ord_less_o_nat @ C @ B )
       => ( ord_less_o_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_178_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_179_order_Ostrict__iff__order,axiom,
    ( ord_less_o_nat
    = ( ^ [A2: $o > nat,B2: $o > nat] :
          ( ( ord_less_eq_o_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_180_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_181_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_o_nat
    = ( ^ [A2: $o > nat,B2: $o > nat] :
          ( ( ord_less_o_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_182_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_183_order_Ostrict__trans2,axiom,(
    ! [A: $o > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_o_nat @ A @ B )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ord_less_o_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_184_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_185_order_Ostrict__trans1,axiom,(
    ! [A: $o > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_o_nat @ B @ C )
       => ( ord_less_o_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_186_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_187_not__le__imp__less,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y2 @ X )
     => ( ord_less_nat @ X @ Y2 ) ) )).

% not_le_imp_less
thf(fact_188_less__le__not__le,axiom,
    ( ord_less_o_nat
    = ( ^ [X2: $o > nat,Y3: $o > nat] :
          ( ( ord_less_eq_o_nat @ X2 @ Y3 )
          & ~ ( ord_less_eq_o_nat @ Y3 @ X2 ) ) ) )).

% less_le_not_le
thf(fact_189_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ~ ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% less_le_not_le
thf(fact_190_le__imp__less__or__eq,axiom,(
    ! [X: $o > nat,Y2: $o > nat] :
      ( ( ord_less_eq_o_nat @ X @ Y2 )
     => ( ( ord_less_o_nat @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq
thf(fact_191_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq
thf(fact_192_le__less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% le_less_linear
thf(fact_193_less__le__trans,axiom,(
    ! [X: $o > nat,Y2: $o > nat,Z2: $o > nat] :
      ( ( ord_less_o_nat @ X @ Y2 )
     => ( ( ord_less_eq_o_nat @ Y2 @ Z2 )
       => ( ord_less_o_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_194_less__le__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_195_le__less__trans,axiom,(
    ! [X: $o > nat,Y2: $o > nat,Z2: $o > nat] :
      ( ( ord_less_eq_o_nat @ X @ Y2 )
     => ( ( ord_less_o_nat @ Y2 @ Z2 )
       => ( ord_less_o_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_196_le__less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_197_less__imp__le,axiom,(
    ! [X: $o > nat,Y2: $o > nat] :
      ( ( ord_less_o_nat @ X @ Y2 )
     => ( ord_less_eq_o_nat @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_198_less__imp__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_199_antisym__conv2,axiom,(
    ! [X: $o > nat,Y2: $o > nat] :
      ( ( ord_less_eq_o_nat @ X @ Y2 )
     => ( ( ~ ( ord_less_o_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_200_antisym__conv2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_201_antisym__conv1,axiom,(
    ! [X: $o > nat,Y2: $o > nat] :
      ( ~ ( ord_less_o_nat @ X @ Y2 )
     => ( ( ord_less_eq_o_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_202_antisym__conv1,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_203_le__neq__trans,axiom,(
    ! [A: $o > nat,B: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_o_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_204_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_205_not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ord_less_eq_nat @ Y2 @ X ) ) )).

% not_less
thf(fact_206_not__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y2 ) )
      = ( ord_less_nat @ Y2 @ X ) ) )).

% not_le
thf(fact_207_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > $o > nat,C: $o > nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_o_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_208_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_209_order__less__le__subst1,axiom,(
    ! [A: $o > nat,F2: nat > $o > nat,B: nat,C: nat] :
      ( ( ord_less_o_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_210_order__less__le__subst1,axiom,(
    ! [A: nat,F2: ( $o > nat ) > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_211_order__less__le__subst1,axiom,(
    ! [A: $o > nat,F2: ( $o > nat ) > $o > nat,B: $o > nat,C: $o > nat] :
      ( ( ord_less_o_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_o_nat @ B @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_212_order__less__le__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_213_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > $o > nat,C: $o > nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_o_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_214_order__le__less__subst2,axiom,(
    ! [A: $o > nat,B: $o > nat,F2: ( $o > nat ) > nat,C: nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_215_order__le__less__subst2,axiom,(
    ! [A: $o > nat,B: $o > nat,F2: ( $o > nat ) > $o > nat,C: $o > nat] :
      ( ( ord_less_eq_o_nat @ A @ B )
     => ( ( ord_less_o_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: $o > nat,Y4: $o > nat] :
              ( ( ord_less_eq_o_nat @ X3 @ Y4 )
             => ( ord_less_eq_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_o_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_216_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_217_order__le__less__subst1,axiom,(
    ! [A: $o > nat,F2: nat > $o > nat,B: nat,C: nat] :
      ( ( ord_less_eq_o_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_o_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_o_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_218_order__le__less__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_219_less__le,axiom,
    ( ord_less_o_nat
    = ( ^ [X2: $o > nat,Y3: $o > nat] :
          ( ( ord_less_eq_o_nat @ X2 @ Y3 )
          & ( X2 != Y3 ) ) ) )).

% less_le
thf(fact_220_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( X2 != Y3 ) ) ) )).

% less_le
thf(fact_221_le__less,axiom,
    ( ord_less_eq_o_nat
    = ( ^ [X2: $o > nat,Y3: $o > nat] :
          ( ( ord_less_o_nat @ X2 @ Y3 )
          | ( X2 = Y3 ) ) ) )).

% le_less
thf(fact_222_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_nat @ X2 @ Y3 )
          | ( X2 = Y3 ) ) ) )).

% le_less
thf(fact_223_leI,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% leI
thf(fact_224_leD,axiom,(
    ! [Y2: $o > nat,X: $o > nat] :
      ( ( ord_less_eq_o_nat @ Y2 @ X )
     => ~ ( ord_less_o_nat @ X @ Y2 ) ) )).

% leD
thf(fact_225_leD,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ~ ( ord_less_nat @ X @ Y2 ) ) )).

% leD
thf(fact_226_list__take__drop__eq__conv,axiom,
    ( ( ^ [Y: list_a,Z: list_a] : ( Y = Z ) )
    = ( ^ [Xs2: list_a,Ys2: list_a] :
        ? [N: nat] :
          ( ( ( take_a @ N @ Xs2 )
            = ( take_a @ N @ Ys2 ) )
          & ( ( drop_a @ N @ Xs2 )
            = ( drop_a @ N @ Ys2 ) ) ) ) )).

% list_take_drop_eq_conv
thf(fact_227_list__take__drop__imp__eq,axiom,(
    ! [N2: nat,Xs: list_a,Ys: list_a] :
      ( ( ( take_a @ N2 @ Xs )
        = ( take_a @ N2 @ Ys ) )
     => ( ( ( drop_a @ N2 @ Xs )
          = ( drop_a @ N2 @ Ys ) )
       => ( Xs = Ys ) ) ) )).

% list_take_drop_imp_eq
thf(fact_228_diff__le__mono2,axiom,(
    ! [M: nat,N2: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N2 ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_229_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_230_diff__le__self,axiom,(
    ! [M: nat,N2: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N2 ) @ M ) )).

% diff_le_self
thf(fact_231_diff__le__mono,axiom,(
    ! [M: nat,N2: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N2 @ L ) ) ) )).

% diff_le_mono
thf(fact_232_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N2 )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N2 @ K ) )
          = ( minus_minus_nat @ M @ N2 ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_233_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N2 )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N2 @ K ) )
          = ( ord_less_eq_nat @ M @ N2 ) ) ) ) )).

% le_diff_iff
thf(fact_234_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N2 )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N2 @ K ) )
          = ( M = N2 ) ) ) ) )).

% eq_diff_iff
thf(fact_235_less__mono__imp__le__mono,axiom,(
    ! [F2: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_236_le__neq__implies__less,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( M != N2 )
       => ( ord_less_nat @ M @ N2 ) ) ) )).

% le_neq_implies_less
thf(fact_237_less__or__eq__imp__le,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ( ord_less_nat @ M @ N2 )
        | ( M = N2 ) )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% less_or_eq_imp_le
thf(fact_238_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M4: nat,N: nat] :
          ( ( ord_less_nat @ M4 @ N )
          | ( M4 = N ) ) ) )).

% le_eq_less_or_eq
thf(fact_239_less__imp__le__nat,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% less_imp_le_nat
thf(fact_240_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M4: nat,N: nat] :
          ( ( ord_less_eq_nat @ M4 @ N )
          & ( M4 != N ) ) ) )).

% nat_less_le
thf(fact_241_i__take__commute,axiom,(
    ! [B: nat,A: nat,S: nat > a] :
      ( ( take_a @ B @ ( listIn84854903take_a @ A @ S ) )
      = ( take_a @ A @ ( listIn84854903take_a @ B @ S ) ) ) )).

% i_take_commute
thf(fact_242_length__induct,axiom,(
    ! [P: list_a > $o,Xs: list_a] :
      ( ! [Xs3: list_a] :
          ( ! [Ys3: list_a] :
              ( ( ord_less_nat @ ( size_size_list_a @ Ys3 ) @ ( size_size_list_a @ Xs3 ) )
             => ( P @ Ys3 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs ) ) )).

% length_induct
thf(fact_243_length__take__le,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ord_less_eq_nat @ ( size_size_list_a @ ( take_a @ N2 @ Xs ) ) @ ( size_size_list_a @ Xs ) ) )).

% length_take_le
thf(fact_244_i__take__take__eq2,axiom,(
    ! [N2: nat,M: nat,F2: nat > a] :
      ( ( ord_less_eq_nat @ N2 @ M )
     => ( ( take_a @ M @ ( listIn84854903take_a @ N2 @ F2 ) )
        = ( listIn84854903take_a @ N2 @ F2 ) ) ) )).

% i_take_take_eq2
thf(fact_245_i__take__take__eq1,axiom,(
    ! [M: nat,N2: nat,F2: nat > a] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( take_a @ M @ ( listIn84854903take_a @ N2 @ F2 ) )
        = ( listIn84854903take_a @ M @ F2 ) ) ) )).

% i_take_take_eq1
thf(fact_246_length__greater__imp__not__empty,axiom,(
    ! [N2: nat,Xs: list_a] :
      ( ( ord_less_nat @ N2 @ ( size_size_list_a @ Xs ) )
     => ( Xs != nil_a ) ) )).

% length_greater_imp_not_empty
thf(fact_247_append__eq__conv__conj,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = Zs )
      = ( ( Xs
          = ( take_a @ ( size_size_list_a @ Xs ) @ Zs ) )
        & ( Ys
          = ( drop_a @ ( size_size_list_a @ Xs ) @ Zs ) ) ) ) )).

% append_eq_conv_conj
thf(fact_248_less__diff__le__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N2 @ M )
       => ( ord_less_nat @ I @ ( minus_minus_nat @ J @ N2 ) ) ) ) )).

% less_diff_le_imp_less
thf(fact_249_nat__diff__left__cancel__le1,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N2 ) )
     => ( ( ord_less_nat @ M @ K )
       => ( ord_less_eq_nat @ N2 @ M ) ) ) )).

% nat_diff_left_cancel_le1
thf(fact_250_nat__diff__right__cancel__le1,axiom,(
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N2 @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( ord_less_eq_nat @ M @ N2 ) ) ) )).

% nat_diff_right_cancel_le1
thf(fact_251_le__diff__swap,axiom,(
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ I @ K )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ J ) @ I )
          = ( ord_less_eq_nat @ ( minus_minus_nat @ K @ I ) @ J ) ) ) ) )).

% le_diff_swap
thf(fact_252_le__diff__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_eq_nat @ I @ J ) ) )).

% le_diff_imp_le
thf(fact_253_less__fun__def,axiom,
    ( ord_less_o_nat
    = ( ^ [F: $o > nat,G: $o > nat] :
          ( ( ord_less_eq_o_nat @ F @ G )
          & ~ ( ord_less_eq_o_nat @ G @ F ) ) ) )).

% less_fun_def
thf(fact_254_eq__imp__diff__eq,axiom,(
    ! [M: nat,N2: nat,K: nat] :
      ( ( M = N2 )
     => ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N2 @ K ) ) ) )).

% eq_imp_diff_eq
thf(fact_255_le__greater__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [N: nat,A2: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ A2 @ X2 )
         => ( N != X2 ) ) ) )).

% le_greater_neq_conv
thf(fact_256_greater__le__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,N: nat] :
        ! [X2: nat] :
          ( ( ord_less_eq_nat @ X2 @ A2 )
         => ( N != X2 ) ) ) )).

% greater_le_neq_conv
thf(fact_257_less__ge__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [N: nat,A2: nat] :
        ! [X2: nat] :
          ( ( ord_less_eq_nat @ A2 @ X2 )
         => ( N != X2 ) ) ) )).

% less_ge_neq_conv
thf(fact_258_ge__less__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,N: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ A2 )
         => ( N != X2 ) ) ) )).

% ge_less_neq_conv
thf(fact_259_nat__diff__right__cancel__less,axiom,(
    ! [N2: nat,K: nat,M: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ N2 @ K ) @ ( minus_minus_nat @ M @ K ) )
     => ( ord_less_nat @ N2 @ M ) ) )).

% nat_diff_right_cancel_less
thf(fact_260_nat__diff__right__cancel__eq2,axiom,(
    ! [M: nat,K: nat,N2: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N2 @ K ) )
     => ( ( ord_less_nat @ K @ N2 )
       => ( M = N2 ) ) ) )).

% nat_diff_right_cancel_eq2
thf(fact_261_nat__diff__right__cancel__eq1,axiom,(
    ! [M: nat,K: nat,N2: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N2 @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( M = N2 ) ) ) )).

% nat_diff_right_cancel_eq1
thf(fact_262_nat__diff__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N2 ) )
     => ( ord_less_nat @ N2 @ M ) ) )).

% nat_diff_left_cancel_less
thf(fact_263_nat__diff__left__cancel__eq2,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N2 ) )
     => ( ( ord_less_nat @ N2 @ K )
       => ( M = N2 ) ) ) )).

% nat_diff_left_cancel_eq2
thf(fact_264_nat__diff__left__cancel__eq1,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N2 ) )
     => ( ( ord_less_nat @ M @ K )
       => ( M = N2 ) ) ) )).

% nat_diff_left_cancel_eq1
thf(fact_265_less__diff__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_nat @ I @ J ) ) )).

% less_diff_imp_less
thf(fact_266_nat__diff__right__cancel__le2,axiom,(
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N2 @ K ) )
     => ( ( ord_less_eq_nat @ K @ N2 )
       => ( ord_less_eq_nat @ M @ N2 ) ) ) )).

% nat_diff_right_cancel_le2
thf(fact_267_nat__diff__left__cancel__le2,axiom,(
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N2 ) )
     => ( ( ord_less_eq_nat @ N2 @ K )
       => ( ord_less_eq_nat @ N2 @ M ) ) ) )).

% nat_diff_left_cancel_le2
thf(fact_268_le__diff__le__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N2 @ M )
       => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ N2 ) ) ) ) )).

% le_diff_le_imp_le
thf(fact_269_eq__diff__left__iff,axiom,(
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ K )
     => ( ( ord_less_eq_nat @ N2 @ K )
       => ( ( ( minus_minus_nat @ K @ M )
            = ( minus_minus_nat @ K @ N2 ) )
          = ( M = N2 ) ) ) ) )).

% eq_diff_left_iff
thf(fact_270_le__imp__diff__le,axiom,(
    ! [J: nat,K: nat,N2: nat] :
      ( ( ord_less_eq_nat @ J @ K )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ J @ N2 ) @ K ) ) )).

% le_imp_diff_le
thf(fact_271_nat__descend__induct,axiom,(
    ! [N2: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less_nat @ N2 @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N2 )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K2 @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) )).

% nat_descend_induct
thf(fact_272_complete__interval,axiom,(
    ! [A: nat,B: nat,P: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C2: nat] :
              ( ( ord_less_eq_nat @ A @ C2 )
              & ( ord_less_eq_nat @ C2 @ B )
              & ! [X4: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X4 )
                    & ( ord_less_nat @ X4 @ C2 ) )
                 => ( P @ X4 ) )
              & ! [D: nat] :
                  ( ! [X3: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X3 )
                        & ( ord_less_nat @ X3 @ D ) )
                     => ( P @ X3 ) )
                 => ( ord_less_eq_nat @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_273_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ X4 @ Z3 )
     => ~ ( ord_less_eq_nat @ T @ X4 ) ) )).

% minf(8)
thf(fact_274_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ X4 @ Z3 )
     => ( ord_less_eq_nat @ X4 @ T ) ) )).

% minf(6)
thf(fact_275_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ X4 @ Z3 )
     => ~ ( ord_less_nat @ T @ X4 ) ) )).

% minf(7)
thf(fact_276_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ X4 @ Z3 )
     => ( ord_less_nat @ X4 @ T ) ) )).

% minf(5)
thf(fact_277_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ X4 @ Z3 )
     => ( X4 != T ) ) )).

% minf(4)
thf(fact_278_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ X4 @ Z3 )
     => ( X4 != T ) ) )).

% minf(3)
thf(fact_279_minf_I2_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ Z4 )
         => ( ( P @ X3 )
            = ( P4 @ X3 ) ) )
     => ( ? [Z4: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ X3 @ Z4 )
           => ( ( Q @ X3 )
              = ( Q2 @ X3 ) ) )
       => ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z3 )
           => ( ( ( P @ X4 )
                | ( Q @ X4 ) )
              = ( ( P4 @ X4 )
                | ( Q2 @ X4 ) ) ) ) ) ) )).

% minf(2)
thf(fact_280_minf_I1_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ Z4 )
         => ( ( P @ X3 )
            = ( P4 @ X3 ) ) )
     => ( ? [Z4: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ X3 @ Z4 )
           => ( ( Q @ X3 )
              = ( Q2 @ X3 ) ) )
       => ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z3 )
           => ( ( ( P @ X4 )
                & ( Q @ X4 ) )
              = ( ( P4 @ X4 )
                & ( Q2 @ X4 ) ) ) ) ) ) )).

% minf(1)
thf(fact_281_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ Z3 @ X4 )
     => ( ord_less_nat @ T @ X4 ) ) )).

% pinf(7)
thf(fact_282_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ Z3 @ X4 )
     => ~ ( ord_less_nat @ X4 @ T ) ) )).

% pinf(5)
thf(fact_283_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ Z3 @ X4 )
     => ( X4 != T ) ) )).

% pinf(4)
thf(fact_284_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X4: nat] :
      ( ( ord_less_nat @ Z3 @ X4 )
     => ( X4 != T ) ) )).

% pinf(3)
thf(fact_285_pinf_I2_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ Z4 @ X3 )
         => ( ( P @ X3 )
            = ( P4 @ X3 ) ) )
     => ( ? [Z4: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ Z4 @ X3 )
           => ( ( Q @ X3 )
              = ( Q2 @ X3 ) ) )
       => ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z3 @ X4 )
           => ( ( ( P @ X4 )
                | ( Q @ X4 ) )
              = ( ( P4 @ X4 )
                | ( Q2 @ X4 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_286_pinf_I1_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ Z4 @ X3 )
         => ( ( P @ X3 )
            = ( P4 @ X3 ) ) )
     => ( ? [Z4: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ Z4 @ X3 )
           => ( ( Q @ X3 )
              = ( Q2 @ X3 ) ) )
       => ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z3 @ X4 )
           => ( ( ( P @ X4 )
                & ( Q @ X4 ) )
              = ( ( P4 @ X4 )
                & ( Q2 @ X4 ) ) ) ) ) ) )).

% pinf(1)

% Conjectures (2)
thf(conj_0,hypothesis,(
    ord_less_eq_nat @ m @ n )).

thf(conj_1,conjecture,
    ( ( append_a @ ( listIn84854903take_a @ m @ f ) @ ( drop_a @ m @ ( listIn84854903take_a @ n @ f ) ) )
    = ( listIn84854903take_a @ n @ f ) )).

%------------------------------------------------------------------------------
