%------------------------------------------------------------------------------
% File     : SLH145^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Liouville_Numbers problem prob_169__5866724_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Liouville_Numbers/prob_169__5866724_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  388 (   0 unit;  34 type;   0 defn)
%            Number of atoms       : 3372 ( 320 equality;1699 variable)
%            Maximal formula depth :   14 (   7 average)
%            Number of connectives : 2464 (  86   ~;  25   |;  35   &;1986   @)
%                                         (   0 <=>; 332  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   65 (  65   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   36 (  34   :;   0   =)
%            Number of variables   :  777 (   0 sgn; 721   !;  15   ?;  41   ^)
%                                         ( 777   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:40:29.526
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__Set__Oset_It__Real__Oreal_J,type,(
    set_real: $tType )).

thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_t__Int__Oint,type,(
    int: $tType )).

% Explicit typings (30)
thf(sy_c_Groups_Oabs__class_Oabs_001t__Int__Oint,type,(
    abs_abs_int: int > int )).

thf(sy_c_Groups_Oabs__class_Oabs_001t__Real__Oreal,type,(
    abs_abs_real: real > real )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Int__Oint,type,(
    minus_minus_int: int > int > int )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Real__Oreal,type,(
    minus_minus_real: real > real > real )).

thf(sy_c_Groups_Oone__class_Oone_001t__Int__Oint,type,(
    one_one_int: int )).

thf(sy_c_Groups_Oone__class_Oone_001t__Real__Oreal,type,(
    one_one_real: real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Int__Oint,type,(
    zero_zero_int: int )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Int_Oring__1__class_Oof__int_001t__Int__Oint,type,(
    ring_1_of_int_int: int > int )).

thf(sy_c_Int_Oring__1__class_Oof__int_001t__Real__Oreal,type,(
    ring_1_of_int_real: int > real )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Int__Oint,type,(
    ord_less_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Real__Oreal,type,(
    ord_less_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Int__Oint,type,(
    ord_less_eq_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Polynomial_Oalgebraic_001t__Real__Oreal,type,(
    algebraic_real: real > $o )).

thf(sy_c_Power_Opower__class_Opower_001t__Int__Oint,type,(
    power_power_int: int > nat > int )).

thf(sy_c_Power_Opower__class_Opower_001t__Real__Oreal,type,(
    power_power_real: real > nat > real )).

thf(sy_c_Rat_Ofield__char__0__class_ORats_001t__Real__Oreal,type,(
    field_1537545994s_real: set_real )).

thf(sy_c_Rings_Odivide__class_Odivide_001t__Int__Oint,type,(
    divide_divide_int: int > int > int )).

thf(sy_c_Rings_Odivide__class_Odivide_001t__Real__Oreal,type,(
    divide_divide_real: real > real > real )).

thf(sy_c_Set_OCollect_001t__Real__Oreal,type,(
    collect_real: ( real > $o ) > set_real )).

thf(sy_c_member_001t__Real__Oreal,type,(
    member_real: real > set_real > $o )).

thf(sy_v_A_H____,type,(
    a: real )).

thf(sy_v_A____,type,(
    a2: real )).

thf(sy_v_A__set____,type,(
    a_set: set_real )).

thf(sy_v_a____,type,(
    a3: int )).

thf(sy_v_b____,type,(
    b: int )).

thf(sy_v_n____,type,(
    n: nat )).

thf(sy_v_roots____,type,(
    roots: set_real )).

thf(sy_v_x,type,(
    x: real )).

% Relevant facts (353)
thf(fact_0_assms_I2_J,axiom,(
    algebraic_real @ x )).

% assms(2)
thf(fact_1_irrationsl,axiom,(
    ~ ( member_real @ x @ field_1537545994s_real ) )).

% irrationsl
thf(fact_2__092_060open_062x_A_092_060notin_062_Aroots_092_060close_062,axiom,(
    ~ ( member_real @ x @ roots ) )).

% \<open>x \<notin> roots\<close>
thf(fact_3_of__int__abs,axiom,(
    ! [X: int] :
      ( ( ring_1_of_int_int @ ( abs_abs_int @ X ) )
      = ( abs_abs_int @ ( ring_1_of_int_int @ X ) ) ) )).

% of_int_abs
thf(fact_4_of__int__abs,axiom,(
    ! [X: int] :
      ( ( ring_1_of_int_real @ ( abs_abs_int @ X ) )
      = ( abs_abs_real @ ( ring_1_of_int_real @ X ) ) ) )).

% of_int_abs
thf(fact_5_of__int__diff,axiom,(
    ! [W: int,Z: int] :
      ( ( ring_1_of_int_int @ ( minus_minus_int @ W @ Z ) )
      = ( minus_minus_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z ) ) ) )).

% of_int_diff
thf(fact_6_of__int__diff,axiom,(
    ! [W: int,Z: int] :
      ( ( ring_1_of_int_real @ ( minus_minus_int @ W @ Z ) )
      = ( minus_minus_real @ ( ring_1_of_int_real @ W ) @ ( ring_1_of_int_real @ Z ) ) ) )).

% of_int_diff
thf(fact_7_abs__divide,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( divide_divide_real @ A @ B ) )
      = ( divide_divide_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_divide
thf(fact_8_of__int__le__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_eq_int @ W @ Z ) ) )).

% of_int_le_iff
thf(fact_9_of__int__le__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_eq_real @ ( ring_1_of_int_real @ W ) @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_eq_int @ W @ Z ) ) )).

% of_int_le_iff
thf(fact_10_ab,axiom,(
    ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ x @ ( divide_divide_real @ ( ring_1_of_int_real @ a3 ) @ ( ring_1_of_int_real @ b ) ) ) ) @ ( divide_divide_real @ a2 @ ( power_power_real @ ( ring_1_of_int_real @ b ) @ n ) ) )).

% ab
thf(fact_11_abs__triangle__ineq2,axiom,(
    ! [A: int,B: int] :
      ( ord_less_eq_int @ ( minus_minus_int @ ( abs_abs_int @ A ) @ ( abs_abs_int @ B ) ) @ ( abs_abs_int @ ( minus_minus_int @ A @ B ) ) ) )).

% abs_triangle_ineq2
thf(fact_12_abs__triangle__ineq2,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq2
thf(fact_13_abs__triangle__ineq3,axiom,(
    ! [A: int,B: int] :
      ( ord_less_eq_int @ ( abs_abs_int @ ( minus_minus_int @ ( abs_abs_int @ A ) @ ( abs_abs_int @ B ) ) ) @ ( abs_abs_int @ ( minus_minus_int @ A @ B ) ) ) )).

% abs_triangle_ineq3
thf(fact_14_abs__triangle__ineq3,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq3
thf(fact_15_abs__triangle__ineq2__sym,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_triangle_ineq2_sym
thf(fact_16_abs__triangle__ineq2__sym,axiom,(
    ! [A: int,B: int] :
      ( ord_less_eq_int @ ( minus_minus_int @ ( abs_abs_int @ A ) @ ( abs_abs_int @ B ) ) @ ( abs_abs_int @ ( minus_minus_int @ B @ A ) ) ) )).

% abs_triangle_ineq2_sym
thf(fact_17__092_060open_062_092_060not_062_AA_A_P_Areal__of__int_Ab_A_094_An_A_060_A_092_060bar_062x_A_N_Areal__of__int_Aa_A_P_Areal__of__int_Ab_092_060bar_062_092_060close_062,axiom,(
    ~ ( ord_less_real @ ( divide_divide_real @ a2 @ ( power_power_real @ ( ring_1_of_int_real @ b ) @ n ) ) @ ( abs_abs_real @ ( minus_minus_real @ x @ ( divide_divide_real @ ( ring_1_of_int_real @ a3 ) @ ( ring_1_of_int_real @ b ) ) ) ) ) )).

% \<open>\<not> A / real_of_int b ^ n < \<bar>x - real_of_int a / real_of_int b\<bar>\<close>
thf(fact_18_of__int__eq__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ( ring_1_of_int_real @ W )
        = ( ring_1_of_int_real @ Z ) )
      = ( W = Z ) ) )).

% of_int_eq_iff
thf(fact_19_abs__abs,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_abs
thf(fact_20_abs__abs,axiom,(
    ! [A: int] :
      ( ( abs_abs_int @ ( abs_abs_int @ A ) )
      = ( abs_abs_int @ A ) ) )).

% abs_abs
thf(fact_21_abs__idempotent,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_idempotent
thf(fact_22_abs__idempotent,axiom,(
    ! [A: int] :
      ( ( abs_abs_int @ ( abs_abs_int @ A ) )
      = ( abs_abs_int @ A ) ) )).

% abs_idempotent
thf(fact_23_of__int__less__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_real @ ( ring_1_of_int_real @ W ) @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_int @ W @ Z ) ) )).

% of_int_less_iff
thf(fact_24_of__int__less__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_int @ W @ Z ) ) )).

% of_int_less_iff
thf(fact_25_of__int__power,axiom,(
    ! [Z: int,N: nat] :
      ( ( ring_1_of_int_real @ ( power_power_int @ Z @ N ) )
      = ( power_power_real @ ( ring_1_of_int_real @ Z ) @ N ) ) )).

% of_int_power
thf(fact_26_of__int__eq__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ( power_power_real @ ( ring_1_of_int_real @ B ) @ W )
        = ( ring_1_of_int_real @ X ) )
      = ( ( power_power_int @ B @ W )
        = X ) ) )).

% of_int_eq_of_int_power_cancel_iff
thf(fact_27_of__int__power__eq__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ( ring_1_of_int_real @ X )
        = ( power_power_real @ ( ring_1_of_int_real @ B ) @ W ) )
      = ( X
        = ( power_power_int @ B @ W ) ) ) )).

% of_int_power_eq_of_int_cancel_iff
thf(fact_28_of__int__less__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ord_less_real @ ( power_power_real @ ( ring_1_of_int_real @ B ) @ W ) @ ( ring_1_of_int_real @ X ) )
      = ( ord_less_int @ ( power_power_int @ B @ W ) @ X ) ) )).

% of_int_less_of_int_power_cancel_iff
thf(fact_29_of__int__less__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ord_less_int @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) @ ( ring_1_of_int_int @ X ) )
      = ( ord_less_int @ ( power_power_int @ B @ W ) @ X ) ) )).

% of_int_less_of_int_power_cancel_iff
thf(fact_30_of__int__power__less__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ord_less_real @ ( ring_1_of_int_real @ X ) @ ( power_power_real @ ( ring_1_of_int_real @ B ) @ W ) )
      = ( ord_less_int @ X @ ( power_power_int @ B @ W ) ) ) )).

% of_int_power_less_of_int_cancel_iff
thf(fact_31_of__int__power__less__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ X ) @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) )
      = ( ord_less_int @ X @ ( power_power_int @ B @ W ) ) ) )).

% of_int_power_less_of_int_cancel_iff
thf(fact_32_of__int__power__le__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ord_less_eq_real @ ( ring_1_of_int_real @ X ) @ ( power_power_real @ ( ring_1_of_int_real @ B ) @ W ) )
      = ( ord_less_eq_int @ X @ ( power_power_int @ B @ W ) ) ) )).

% of_int_power_le_of_int_cancel_iff
thf(fact_33_of__int__power__le__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ X ) @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) )
      = ( ord_less_eq_int @ X @ ( power_power_int @ B @ W ) ) ) )).

% of_int_power_le_of_int_cancel_iff
thf(fact_34_of__int__le__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ord_less_eq_real @ ( power_power_real @ ( ring_1_of_int_real @ B ) @ W ) @ ( ring_1_of_int_real @ X ) )
      = ( ord_less_eq_int @ ( power_power_int @ B @ W ) @ X ) ) )).

% of_int_le_of_int_power_cancel_iff
thf(fact_35_of__int__le__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ord_less_eq_int @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) @ ( ring_1_of_int_int @ X ) )
      = ( ord_less_eq_int @ ( power_power_int @ B @ W ) @ X ) ) )).

% of_int_le_of_int_power_cancel_iff
thf(fact_36_linordered__field__no__lb,axiom,(
    ! [X2: real] :
    ? [Y: real] :
      ( ord_less_real @ Y @ X2 ) )).

% linordered_field_no_lb
thf(fact_37_linordered__field__no__ub,axiom,(
    ! [X2: real] :
    ? [X_1: real] :
      ( ord_less_real @ X2 @ X_1 ) )).

% linordered_field_no_ub
thf(fact_38_linorder__neqE__linordered__idom,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_real @ X @ Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_39_linorder__neqE__linordered__idom,axiom,(
    ! [X: int,Y2: int] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_int @ X @ Y2 )
       => ( ord_less_int @ Y2 @ X ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_40_diff__strict__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ord_less_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ C ) ) ) )).

% diff_strict_right_mono
thf(fact_41_diff__strict__right__mono,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ord_less_int @ ( minus_minus_int @ A @ C ) @ ( minus_minus_int @ B @ C ) ) ) )).

% diff_strict_right_mono
thf(fact_42_diff__strict__left__mono,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ord_less_real @ ( minus_minus_real @ C @ A ) @ ( minus_minus_real @ C @ B ) ) ) )).

% diff_strict_left_mono
thf(fact_43_diff__strict__left__mono,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ord_less_int @ ( minus_minus_int @ C @ A ) @ ( minus_minus_int @ C @ B ) ) ) )).

% diff_strict_left_mono
thf(fact_44_diff__eq__diff__less,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( ord_less_real @ A @ B )
        = ( ord_less_real @ C @ D ) ) ) )).

% diff_eq_diff_less
thf(fact_45_diff__eq__diff__less,axiom,(
    ! [A: int,B: int,C: int,D: int] :
      ( ( ( minus_minus_int @ A @ B )
        = ( minus_minus_int @ C @ D ) )
     => ( ( ord_less_int @ A @ B )
        = ( ord_less_int @ C @ D ) ) ) )).

% diff_eq_diff_less
thf(fact_46_diff__strict__mono,axiom,(
    ! [A: real,B: real,D: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ D @ C )
       => ( ord_less_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ D ) ) ) ) )).

% diff_strict_mono
thf(fact_47_diff__strict__mono,axiom,(
    ! [A: int,B: int,D: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ D @ C )
       => ( ord_less_int @ ( minus_minus_int @ A @ C ) @ ( minus_minus_int @ B @ D ) ) ) ) )).

% diff_strict_mono
thf(fact_48_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B )
      = ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_49_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: int,C: int,B: int] :
      ( ( minus_minus_int @ ( minus_minus_int @ A @ C ) @ B )
      = ( minus_minus_int @ ( minus_minus_int @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_50_diff__eq__diff__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( A = B )
        = ( C = D ) ) ) )).

% diff_eq_diff_eq
thf(fact_51_diff__eq__diff__eq,axiom,(
    ! [A: int,B: int,C: int,D: int] :
      ( ( ( minus_minus_int @ A @ B )
        = ( minus_minus_int @ C @ D ) )
     => ( ( A = B )
        = ( C = D ) ) ) )).

% diff_eq_diff_eq
thf(fact_52_diff__eq__diff__less__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( ord_less_eq_real @ A @ B )
        = ( ord_less_eq_real @ C @ D ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_53_diff__eq__diff__less__eq,axiom,(
    ! [A: int,B: int,C: int,D: int] :
      ( ( ( minus_minus_int @ A @ B )
        = ( minus_minus_int @ C @ D ) )
     => ( ( ord_less_eq_int @ A @ B )
        = ( ord_less_eq_int @ C @ D ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_54_diff__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ C ) ) ) )).

% diff_right_mono
thf(fact_55_diff__right__mono,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ord_less_eq_int @ ( minus_minus_int @ A @ C ) @ ( minus_minus_int @ B @ C ) ) ) )).

% diff_right_mono
thf(fact_56_diff__left__mono,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ord_less_eq_real @ ( minus_minus_real @ C @ A ) @ ( minus_minus_real @ C @ B ) ) ) )).

% diff_left_mono
thf(fact_57_diff__left__mono,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ord_less_eq_int @ ( minus_minus_int @ C @ A ) @ ( minus_minus_int @ C @ B ) ) ) )).

% diff_left_mono
thf(fact_58_diff__mono,axiom,(
    ! [A: real,B: real,D: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ D @ C )
       => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ D ) ) ) ) )).

% diff_mono
thf(fact_59_diff__mono,axiom,(
    ! [A: int,B: int,D: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ D @ C )
       => ( ord_less_eq_int @ ( minus_minus_int @ A @ C ) @ ( minus_minus_int @ B @ D ) ) ) ) )).

% diff_mono
thf(fact_60_diff__divide__distrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( divide_divide_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ ( divide_divide_real @ A @ C ) @ ( divide_divide_real @ B @ C ) ) ) )).

% diff_divide_distrib
thf(fact_61_abs__ge__self,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ ( abs_abs_real @ A ) ) )).

% abs_ge_self
thf(fact_62_abs__ge__self,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ ( abs_abs_int @ A ) ) )).

% abs_ge_self
thf(fact_63_abs__le__D1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ B )
     => ( ord_less_eq_real @ A @ B ) ) )).

% abs_le_D1
thf(fact_64_abs__le__D1,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ ( abs_abs_int @ A ) @ B )
     => ( ord_less_eq_int @ A @ B ) ) )).

% abs_le_D1
thf(fact_65_abs__minus__commute,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( minus_minus_real @ A @ B ) )
      = ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_minus_commute
thf(fact_66_abs__minus__commute,axiom,(
    ! [A: int,B: int] :
      ( ( abs_abs_int @ ( minus_minus_int @ A @ B ) )
      = ( abs_abs_int @ ( minus_minus_int @ B @ A ) ) ) )).

% abs_minus_commute
thf(fact_67__092_060open_062A_A_P_Areal__of__int_Ab_A_094_An_A_092_060le_062_AA_A_P_A1_092_060close_062,axiom,(
    ord_less_eq_real @ ( divide_divide_real @ a2 @ ( power_power_real @ ( ring_1_of_int_real @ b ) @ n ) ) @ ( divide_divide_real @ a2 @ one_one_real ) )).

% \<open>A / real_of_int b ^ n \<le> A / 1\<close>
thf(fact_68__092_060open_062A_A_060_AA_H_092_060close_062,axiom,(
    ord_less_real @ a2 @ a )).

% \<open>A < A'\<close>
thf(fact_69_Rats__abs__iff,axiom,(
    ! [X: real] :
      ( ( member_real @ ( abs_abs_real @ X ) @ field_1537545994s_real )
      = ( member_real @ X @ field_1537545994s_real ) ) )).

% Rats_abs_iff
thf(fact_70_A__pos,axiom,(
    ord_less_real @ zero_zero_real @ a2 )).

% A_pos
thf(fact_71_real__of__int__div4,axiom,(
    ! [N: int,X: int] :
      ( ord_less_eq_real @ ( ring_1_of_int_real @ ( divide_divide_int @ N @ X ) ) @ ( divide_divide_real @ ( ring_1_of_int_real @ N ) @ ( ring_1_of_int_real @ X ) ) ) )).

% real_of_int_div4
thf(fact_72_mem__Collect__eq,axiom,(
    ! [A: real,P: real > $o] :
      ( ( member_real @ A @ ( collect_real @ P ) )
      = ( P @ A ) ) )).

% mem_Collect_eq
thf(fact_73_Collect__mem__eq,axiom,(
    ! [A2: set_real] :
      ( ( collect_real
        @ ^ [X3: real] :
            ( member_real @ X3 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_74_A__less_I1_J,axiom,(
    ord_less_real @ a2 @ one_one_real )).

% A_less(1)
thf(fact_75_order__refl,axiom,(
    ! [X: real] :
      ( ord_less_eq_real @ X @ X ) )).

% order_refl
thf(fact_76_order__refl,axiom,(
    ! [X: int] :
      ( ord_less_eq_int @ X @ X ) )).

% order_refl
thf(fact_77_Rats__no__top__le,axiom,(
    ! [X: real] :
    ? [X4: real] :
      ( ( member_real @ X4 @ field_1537545994s_real )
      & ( ord_less_eq_real @ X @ X4 ) ) )).

% Rats_no_top_le
thf(fact_78_Rats__no__bot__less,axiom,(
    ! [X: real] :
    ? [X4: real] :
      ( ( member_real @ X4 @ field_1537545994s_real )
      & ( ord_less_real @ X4 @ X ) ) )).

% Rats_no_bot_less
thf(fact_79__092_060open_0620_A_060_AA_H_092_060close_062,axiom,(
    ord_less_real @ zero_zero_real @ a )).

% \<open>0 < A'\<close>
thf(fact_80__092_060open_062A_H_A_092_060le_062_A1_092_060close_062,axiom,(
    ord_less_eq_real @ a @ one_one_real )).

% \<open>A' \<le> 1\<close>
thf(fact_81_diff__self,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% diff_self
thf(fact_82_diff__self,axiom,(
    ! [A: int] :
      ( ( minus_minus_int @ A @ A )
      = zero_zero_int ) )).

% diff_self
thf(fact_83_diff__0__right,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_0_right
thf(fact_84_diff__0__right,axiom,(
    ! [A: int] :
      ( ( minus_minus_int @ A @ zero_zero_int )
      = A ) )).

% diff_0_right
thf(fact_85_diff__zero,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_zero
thf(fact_86_diff__zero,axiom,(
    ! [A: int] :
      ( ( minus_minus_int @ A @ zero_zero_int )
      = A ) )).

% diff_zero
thf(fact_87_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_88_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: int] :
      ( ( minus_minus_int @ A @ A )
      = zero_zero_int ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_89_div__0,axiom,(
    ! [A: real] :
      ( ( divide_divide_real @ zero_zero_real @ A )
      = zero_zero_real ) )).

% div_0
thf(fact_90_div__0,axiom,(
    ! [A: int] :
      ( ( divide_divide_int @ zero_zero_int @ A )
      = zero_zero_int ) )).

% div_0
thf(fact_91_divide__eq__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ( divide_divide_real @ A @ B )
        = zero_zero_real )
      = ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% divide_eq_0_iff
thf(fact_92_div__by__0,axiom,(
    ! [A: real] :
      ( ( divide_divide_real @ A @ zero_zero_real )
      = zero_zero_real ) )).

% div_by_0
thf(fact_93_div__by__0,axiom,(
    ! [A: int] :
      ( ( divide_divide_int @ A @ zero_zero_int )
      = zero_zero_int ) )).

% div_by_0
thf(fact_94_divide__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ( divide_divide_real @ C @ A )
        = ( divide_divide_real @ C @ B ) )
      = ( ( C = zero_zero_real )
        | ( A = B ) ) ) )).

% divide_cancel_left
thf(fact_95_divide__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ( divide_divide_real @ A @ C )
        = ( divide_divide_real @ B @ C ) )
      = ( ( C = zero_zero_real )
        | ( A = B ) ) ) )).

% divide_cancel_right
thf(fact_96_division__ring__divide__zero,axiom,(
    ! [A: real] :
      ( ( divide_divide_real @ A @ zero_zero_real )
      = zero_zero_real ) )).

% division_ring_divide_zero
thf(fact_97_div__by__1,axiom,(
    ! [A: real] :
      ( ( divide_divide_real @ A @ one_one_real )
      = A ) )).

% div_by_1
thf(fact_98_div__by__1,axiom,(
    ! [A: int] :
      ( ( divide_divide_int @ A @ one_one_int )
      = A ) )).

% div_by_1
thf(fact_99_abs__0,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_0
thf(fact_100_abs__0,axiom,
    ( ( abs_abs_int @ zero_zero_int )
    = zero_zero_int )).

% abs_0
thf(fact_101_abs__0__eq,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( abs_abs_real @ A ) )
      = ( A = zero_zero_real ) ) )).

% abs_0_eq
thf(fact_102_abs__0__eq,axiom,(
    ! [A: int] :
      ( ( zero_zero_int
        = ( abs_abs_int @ A ) )
      = ( A = zero_zero_int ) ) )).

% abs_0_eq
thf(fact_103_abs__eq__0,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0
thf(fact_104_abs__eq__0,axiom,(
    ! [A: int] :
      ( ( ( abs_abs_int @ A )
        = zero_zero_int )
      = ( A = zero_zero_int ) ) )).

% abs_eq_0
thf(fact_105_abs__zero,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_zero
thf(fact_106_abs__zero,axiom,
    ( ( abs_abs_int @ zero_zero_int )
    = zero_zero_int )).

% abs_zero
thf(fact_107_of__int__eq__0__iff,axiom,(
    ! [Z: int] :
      ( ( ( ring_1_of_int_int @ Z )
        = zero_zero_int )
      = ( Z = zero_zero_int ) ) )).

% of_int_eq_0_iff
thf(fact_108_of__int__eq__0__iff,axiom,(
    ! [Z: int] :
      ( ( ( ring_1_of_int_real @ Z )
        = zero_zero_real )
      = ( Z = zero_zero_int ) ) )).

% of_int_eq_0_iff
thf(fact_109_of__int__0__eq__iff,axiom,(
    ! [Z: int] :
      ( ( zero_zero_int
        = ( ring_1_of_int_int @ Z ) )
      = ( Z = zero_zero_int ) ) )).

% of_int_0_eq_iff
thf(fact_110_of__int__0__eq__iff,axiom,(
    ! [Z: int] :
      ( ( zero_zero_real
        = ( ring_1_of_int_real @ Z ) )
      = ( Z = zero_zero_int ) ) )).

% of_int_0_eq_iff
thf(fact_111_of__int__0,axiom,
    ( ( ring_1_of_int_int @ zero_zero_int )
    = zero_zero_int )).

% of_int_0
thf(fact_112_of__int__0,axiom,
    ( ( ring_1_of_int_real @ zero_zero_int )
    = zero_zero_real )).

% of_int_0
thf(fact_113_abs__1,axiom,
    ( ( abs_abs_int @ one_one_int )
    = one_one_int )).

% abs_1
thf(fact_114_abs__1,axiom,
    ( ( abs_abs_real @ one_one_real )
    = one_one_real )).

% abs_1
thf(fact_115_of__int__eq__1__iff,axiom,(
    ! [Z: int] :
      ( ( ( ring_1_of_int_real @ Z )
        = one_one_real )
      = ( Z = one_one_int ) ) )).

% of_int_eq_1_iff
thf(fact_116_of__int__1,axiom,
    ( ( ring_1_of_int_real @ one_one_int )
    = one_one_real )).

% of_int_1
thf(fact_117_b,axiom,(
    ord_less_int @ zero_zero_int @ b )).

% b
thf(fact_118_diff__ge__0__iff__ge,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_eq_real @ B @ A ) ) )).

% diff_ge_0_iff_ge
thf(fact_119_diff__ge__0__iff__ge,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ ( minus_minus_int @ A @ B ) )
      = ( ord_less_eq_int @ B @ A ) ) )).

% diff_ge_0_iff_ge
thf(fact_120_diff__gt__0__iff__gt,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_real @ B @ A ) ) )).

% diff_gt_0_iff_gt
thf(fact_121_diff__gt__0__iff__gt,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ zero_zero_int @ ( minus_minus_int @ A @ B ) )
      = ( ord_less_int @ B @ A ) ) )).

% diff_gt_0_iff_gt
thf(fact_122_zero__eq__1__divide__iff,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( divide_divide_real @ one_one_real @ A ) )
      = ( A = zero_zero_real ) ) )).

% zero_eq_1_divide_iff
thf(fact_123_one__divide__eq__0__iff,axiom,(
    ! [A: real] :
      ( ( ( divide_divide_real @ one_one_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% one_divide_eq_0_iff
thf(fact_124_eq__divide__eq__1,axiom,(
    ! [B: real,A: real] :
      ( ( one_one_real
        = ( divide_divide_real @ B @ A ) )
      = ( ( A != zero_zero_real )
        & ( A = B ) ) ) )).

% eq_divide_eq_1
thf(fact_125_divide__eq__eq__1,axiom,(
    ! [B: real,A: real] :
      ( ( ( divide_divide_real @ B @ A )
        = one_one_real )
      = ( ( A != zero_zero_real )
        & ( A = B ) ) ) )).

% divide_eq_eq_1
thf(fact_126_divide__self__if,axiom,(
    ! [A: real] :
      ( ( ( A = zero_zero_real )
       => ( ( divide_divide_real @ A @ A )
          = zero_zero_real ) )
      & ( ( A != zero_zero_real )
       => ( ( divide_divide_real @ A @ A )
          = one_one_real ) ) ) )).

% divide_self_if
thf(fact_127_divide__self,axiom,(
    ! [A: real] :
      ( ( A != zero_zero_real )
     => ( ( divide_divide_real @ A @ A )
        = one_one_real ) ) )).

% divide_self
thf(fact_128_one__eq__divide__iff,axiom,(
    ! [A: real,B: real] :
      ( ( one_one_real
        = ( divide_divide_real @ A @ B ) )
      = ( ( B != zero_zero_real )
        & ( A = B ) ) ) )).

% one_eq_divide_iff
thf(fact_129_div__self,axiom,(
    ! [A: real] :
      ( ( A != zero_zero_real )
     => ( ( divide_divide_real @ A @ A )
        = one_one_real ) ) )).

% div_self
thf(fact_130_div__self,axiom,(
    ! [A: int] :
      ( ( A != zero_zero_int )
     => ( ( divide_divide_int @ A @ A )
        = one_one_int ) ) )).

% div_self
thf(fact_131_divide__eq__1__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ( divide_divide_real @ A @ B )
        = one_one_real )
      = ( ( B != zero_zero_real )
        & ( A = B ) ) ) )).

% divide_eq_1_iff
thf(fact_132_abs__of__nonneg,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( abs_abs_real @ A )
        = A ) ) )).

% abs_of_nonneg
thf(fact_133_abs__of__nonneg,axiom,(
    ! [A: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ A )
     => ( ( abs_abs_int @ A )
        = A ) ) )).

% abs_of_nonneg
thf(fact_134_abs__le__self__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ A )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% abs_le_self_iff
thf(fact_135_abs__le__self__iff,axiom,(
    ! [A: int] :
      ( ( ord_less_eq_int @ ( abs_abs_int @ A ) @ A )
      = ( ord_less_eq_int @ zero_zero_int @ A ) ) )).

% abs_le_self_iff
thf(fact_136_abs__le__zero__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_le_zero_iff
thf(fact_137_abs__le__zero__iff,axiom,(
    ! [A: int] :
      ( ( ord_less_eq_int @ ( abs_abs_int @ A ) @ zero_zero_int )
      = ( A = zero_zero_int ) ) )).

% abs_le_zero_iff
thf(fact_138_zero__less__abs__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_real @ zero_zero_real @ ( abs_abs_real @ A ) )
      = ( A != zero_zero_real ) ) )).

% zero_less_abs_iff
thf(fact_139_zero__less__abs__iff,axiom,(
    ! [A: int] :
      ( ( ord_less_int @ zero_zero_int @ ( abs_abs_int @ A ) )
      = ( A != zero_zero_int ) ) )).

% zero_less_abs_iff
thf(fact_140_divide__le__0__1__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( divide_divide_real @ one_one_real @ A ) @ zero_zero_real )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% divide_le_0_1_iff
thf(fact_141_zero__le__divide__1__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( divide_divide_real @ one_one_real @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% zero_le_divide_1_iff
thf(fact_142_zero__less__divide__1__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_real @ zero_zero_real @ ( divide_divide_real @ one_one_real @ A ) )
      = ( ord_less_real @ zero_zero_real @ A ) ) )).

% zero_less_divide_1_iff
thf(fact_143_less__divide__eq__1__pos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ A )
     => ( ( ord_less_real @ one_one_real @ ( divide_divide_real @ B @ A ) )
        = ( ord_less_real @ A @ B ) ) ) )).

% less_divide_eq_1_pos
thf(fact_144_less__divide__eq__1__neg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ zero_zero_real )
     => ( ( ord_less_real @ one_one_real @ ( divide_divide_real @ B @ A ) )
        = ( ord_less_real @ B @ A ) ) ) )).

% less_divide_eq_1_neg
thf(fact_145_divide__less__eq__1__pos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ A )
     => ( ( ord_less_real @ ( divide_divide_real @ B @ A ) @ one_one_real )
        = ( ord_less_real @ B @ A ) ) ) )).

% divide_less_eq_1_pos
thf(fact_146_divide__less__eq__1__neg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ zero_zero_real )
     => ( ( ord_less_real @ ( divide_divide_real @ B @ A ) @ one_one_real )
        = ( ord_less_real @ A @ B ) ) ) )).

% divide_less_eq_1_neg
thf(fact_147_divide__less__0__1__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_real @ ( divide_divide_real @ one_one_real @ A ) @ zero_zero_real )
      = ( ord_less_real @ A @ zero_zero_real ) ) )).

% divide_less_0_1_iff
thf(fact_148_divide__le__0__abs__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( divide_divide_real @ A @ ( abs_abs_real @ B ) ) @ zero_zero_real )
      = ( ( ord_less_eq_real @ A @ zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% divide_le_0_abs_iff
thf(fact_149_zero__le__divide__abs__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( divide_divide_real @ A @ ( abs_abs_real @ B ) ) )
      = ( ( ord_less_eq_real @ zero_zero_real @ A )
        | ( B = zero_zero_real ) ) ) )).

% zero_le_divide_abs_iff
thf(fact_150_of__int__0__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_eq_int @ zero_zero_int @ Z ) ) )).

% of_int_0_le_iff
thf(fact_151_of__int__0__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_eq_int @ zero_zero_int @ Z ) ) )).

% of_int_0_le_iff
thf(fact_152_of__int__le__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_real @ ( ring_1_of_int_real @ Z ) @ zero_zero_real )
      = ( ord_less_eq_int @ Z @ zero_zero_int ) ) )).

% of_int_le_0_iff
thf(fact_153_of__int__le__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ Z ) @ zero_zero_int )
      = ( ord_less_eq_int @ Z @ zero_zero_int ) ) )).

% of_int_le_0_iff
thf(fact_154_of__int__less__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_real @ ( ring_1_of_int_real @ Z ) @ zero_zero_real )
      = ( ord_less_int @ Z @ zero_zero_int ) ) )).

% of_int_less_0_iff
thf(fact_155_of__int__less__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ Z ) @ zero_zero_int )
      = ( ord_less_int @ Z @ zero_zero_int ) ) )).

% of_int_less_0_iff
thf(fact_156_of__int__0__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_int @ zero_zero_int @ Z ) ) )).

% of_int_0_less_iff
thf(fact_157_of__int__0__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_int @ zero_zero_int @ Z ) ) )).

% of_int_0_less_iff
thf(fact_158_of__int__1__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_real @ one_one_real @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_eq_int @ one_one_int @ Z ) ) )).

% of_int_1_le_iff
thf(fact_159_of__int__1__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ one_one_int @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_eq_int @ one_one_int @ Z ) ) )).

% of_int_1_le_iff
thf(fact_160_of__int__le__1__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_real @ ( ring_1_of_int_real @ Z ) @ one_one_real )
      = ( ord_less_eq_int @ Z @ one_one_int ) ) )).

% of_int_le_1_iff
thf(fact_161_of__int__le__1__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ Z ) @ one_one_int )
      = ( ord_less_eq_int @ Z @ one_one_int ) ) )).

% of_int_le_1_iff
thf(fact_162_of__int__less__1__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_real @ ( ring_1_of_int_real @ Z ) @ one_one_real )
      = ( ord_less_int @ Z @ one_one_int ) ) )).

% of_int_less_1_iff
thf(fact_163_of__int__less__1__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ Z ) @ one_one_int )
      = ( ord_less_int @ Z @ one_one_int ) ) )).

% of_int_less_1_iff
thf(fact_164_of__int__1__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_real @ one_one_real @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_int @ one_one_int @ Z ) ) )).

% of_int_1_less_iff
thf(fact_165_of__int__1__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ one_one_int @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_int @ one_one_int @ Z ) ) )).

% of_int_1_less_iff
thf(fact_166_divide__le__eq__1__neg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ ( divide_divide_real @ B @ A ) @ one_one_real )
        = ( ord_less_eq_real @ A @ B ) ) ) )).

% divide_le_eq_1_neg
thf(fact_167_divide__le__eq__1__pos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ ( divide_divide_real @ B @ A ) @ one_one_real )
        = ( ord_less_eq_real @ B @ A ) ) ) )).

% divide_le_eq_1_pos
thf(fact_168_le__divide__eq__1__neg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ one_one_real @ ( divide_divide_real @ B @ A ) )
        = ( ord_less_eq_real @ B @ A ) ) ) )).

% le_divide_eq_1_neg
thf(fact_169_le__divide__eq__1__pos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ one_one_real @ ( divide_divide_real @ B @ A ) )
        = ( ord_less_eq_real @ A @ B ) ) ) )).

% le_divide_eq_1_pos
thf(fact_170__092_060open_062_092_060And_062x_O_Ax_A_092_060in_062_AA__set_A_092_060Longrightarrow_062_AA_H_A_092_060le_062_Ax_092_060close_062,axiom,(
    ! [X: real] :
      ( ( member_real @ X @ a_set )
     => ( ord_less_eq_real @ a @ X ) ) )).

% \<open>\<And>x. x \<in> A_set \<Longrightarrow> A' \<le> x\<close>
thf(fact_171_one__reorient,axiom,(
    ! [X: real] :
      ( ( one_one_real = X )
      = ( X = one_one_real ) ) )).

% one_reorient
thf(fact_172_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_173_zero__reorient,axiom,(
    ! [X: int] :
      ( ( zero_zero_int = X )
      = ( X = zero_zero_int ) ) )).

% zero_reorient
thf(fact_174_zero__neq__one,axiom,(
    zero_zero_real != one_one_real )).

% zero_neq_one
thf(fact_175_zero__neq__one,axiom,(
    zero_zero_int != one_one_int )).

% zero_neq_one
thf(fact_176_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_real @ one_one_real @ zero_zero_real ) )).

% not_one_le_zero
thf(fact_177_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_int @ one_one_int @ zero_zero_int ) )).

% not_one_le_zero
thf(fact_178_zero__le__one,axiom,(
    ord_less_eq_real @ zero_zero_real @ one_one_real )).

% zero_le_one
thf(fact_179_zero__le__one,axiom,(
    ord_less_eq_int @ zero_zero_int @ one_one_int )).

% zero_le_one
thf(fact_180_not__one__less__zero,axiom,(
    ~ ( ord_less_real @ one_one_real @ zero_zero_real ) )).

% not_one_less_zero
thf(fact_181_not__one__less__zero,axiom,(
    ~ ( ord_less_int @ one_one_int @ zero_zero_int ) )).

% not_one_less_zero
thf(fact_182_zero__less__one,axiom,(
    ord_less_real @ zero_zero_real @ one_one_real )).

% zero_less_one
thf(fact_183_zero__less__one,axiom,(
    ord_less_int @ zero_zero_int @ one_one_int )).

% zero_less_one
thf(fact_184_right__inverse__eq,axiom,(
    ! [B: real,A: real] :
      ( ( B != zero_zero_real )
     => ( ( ( divide_divide_real @ A @ B )
          = one_one_real )
        = ( A = B ) ) ) )).

% right_inverse_eq
thf(fact_185_field__lbound__gt__zero,axiom,(
    ! [D1: real,D2: real] :
      ( ( ord_less_real @ zero_zero_real @ D1 )
     => ( ( ord_less_real @ zero_zero_real @ D2 )
       => ? [E: real] :
            ( ( ord_less_real @ zero_zero_real @ E )
            & ( ord_less_real @ E @ D1 )
            & ( ord_less_real @ E @ D2 ) ) ) ) )).

% field_lbound_gt_zero
thf(fact_186_real__arch__pow__inv,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_real @ zero_zero_real @ Y2 )
     => ( ( ord_less_real @ X @ one_one_real )
       => ? [N2: nat] :
            ( ord_less_real @ ( power_power_real @ X @ N2 ) @ Y2 ) ) ) )).

% real_arch_pow_inv
thf(fact_187_less__divide__eq__1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ one_one_real @ ( divide_divide_real @ B @ A ) )
      = ( ( ( ord_less_real @ zero_zero_real @ A )
          & ( ord_less_real @ A @ B ) )
        | ( ( ord_less_real @ A @ zero_zero_real )
          & ( ord_less_real @ B @ A ) ) ) ) )).

% less_divide_eq_1
thf(fact_188_divide__less__eq__1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ ( divide_divide_real @ B @ A ) @ one_one_real )
      = ( ( ( ord_less_real @ zero_zero_real @ A )
          & ( ord_less_real @ B @ A ) )
        | ( ( ord_less_real @ A @ zero_zero_real )
          & ( ord_less_real @ A @ B ) )
        | ( A = zero_zero_real ) ) ) )).

% divide_less_eq_1
thf(fact_189_of__int__pos,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ Z )
     => ( ord_less_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) ) ) )).

% of_int_pos
thf(fact_190_of__int__pos,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ Z )
     => ( ord_less_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) ) ) )).

% of_int_pos
thf(fact_191_eq__iff__diff__eq__0,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [A3: real,B2: real] :
          ( ( minus_minus_real @ A3 @ B2 )
          = zero_zero_real ) ) )).

% eq_iff_diff_eq_0
thf(fact_192_eq__iff__diff__eq__0,axiom,
    ( ( ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    = ( ^ [A3: int,B2: int] :
          ( ( minus_minus_int @ A3 @ B2 )
          = zero_zero_int ) ) )).

% eq_iff_diff_eq_0
thf(fact_193_abs__one,axiom,
    ( ( abs_abs_int @ one_one_int )
    = one_one_int )).

% abs_one
thf(fact_194_abs__one,axiom,
    ( ( abs_abs_real @ one_one_real )
    = one_one_real )).

% abs_one
thf(fact_195_abs__eq__0__iff,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0_iff
thf(fact_196_abs__eq__0__iff,axiom,(
    ! [A: int] :
      ( ( ( abs_abs_int @ A )
        = zero_zero_int )
      = ( A = zero_zero_int ) ) )).

% abs_eq_0_iff
thf(fact_197_real__arch__pow,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ one_one_real @ X )
     => ? [N2: nat] :
          ( ord_less_real @ Y2 @ ( power_power_real @ X @ N2 ) ) ) )).

% real_arch_pow
thf(fact_198_divide__le__eq__1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ ( divide_divide_real @ B @ A ) @ one_one_real )
      = ( ( ( ord_less_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ A ) )
        | ( ( ord_less_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ A @ B ) )
        | ( A = zero_zero_real ) ) ) )).

% divide_le_eq_1
thf(fact_199_le__divide__eq__1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ one_one_real @ ( divide_divide_real @ B @ A ) )
      = ( ( ( ord_less_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ A @ B ) )
        | ( ( ord_less_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ A ) ) ) ) )).

% le_divide_eq_1
thf(fact_200_of__int__nonneg,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ Z )
     => ( ord_less_eq_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) ) ) )).

% of_int_nonneg
thf(fact_201_of__int__nonneg,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ Z )
     => ( ord_less_eq_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) ) ) )).

% of_int_nonneg
thf(fact_202_le__iff__diff__le__0,axiom,
    ( ord_less_eq_real
    = ( ^ [A3: real,B2: real] :
          ( ord_less_eq_real @ ( minus_minus_real @ A3 @ B2 ) @ zero_zero_real ) ) )).

% le_iff_diff_le_0
thf(fact_203_le__iff__diff__le__0,axiom,
    ( ord_less_eq_int
    = ( ^ [A3: int,B2: int] :
          ( ord_less_eq_int @ ( minus_minus_int @ A3 @ B2 ) @ zero_zero_int ) ) )).

% le_iff_diff_le_0
thf(fact_204_less__iff__diff__less__0,axiom,
    ( ord_less_real
    = ( ^ [A3: real,B2: real] :
          ( ord_less_real @ ( minus_minus_real @ A3 @ B2 ) @ zero_zero_real ) ) )).

% less_iff_diff_less_0
thf(fact_205_less__iff__diff__less__0,axiom,
    ( ord_less_int
    = ( ^ [A3: int,B2: int] :
          ( ord_less_int @ ( minus_minus_int @ A3 @ B2 ) @ zero_zero_int ) ) )).

% less_iff_diff_less_0
thf(fact_206_divide__le__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( divide_divide_real @ A @ B ) @ zero_zero_real )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) ) ) )).

% divide_le_0_iff
thf(fact_207_divide__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( divide_divide_real @ A @ C ) @ ( divide_divide_real @ B @ C ) ) ) ) )).

% divide_right_mono
thf(fact_208_zero__le__divide__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( divide_divide_real @ A @ B ) )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) ) ) )).

% zero_le_divide_iff
thf(fact_209_divide__nonneg__nonneg,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y2 )
       => ( ord_less_eq_real @ zero_zero_real @ ( divide_divide_real @ X @ Y2 ) ) ) ) )).

% divide_nonneg_nonneg
thf(fact_210_divide__nonneg__nonpos,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ Y2 @ zero_zero_real )
       => ( ord_less_eq_real @ ( divide_divide_real @ X @ Y2 ) @ zero_zero_real ) ) ) )).

% divide_nonneg_nonpos
thf(fact_211_divide__nonpos__nonneg,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ zero_zero_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y2 )
       => ( ord_less_eq_real @ ( divide_divide_real @ X @ Y2 ) @ zero_zero_real ) ) ) )).

% divide_nonpos_nonneg
thf(fact_212_divide__nonpos__nonpos,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ zero_zero_real )
     => ( ( ord_less_eq_real @ Y2 @ zero_zero_real )
       => ( ord_less_eq_real @ zero_zero_real @ ( divide_divide_real @ X @ Y2 ) ) ) ) )).

% divide_nonpos_nonpos
thf(fact_213_divide__right__mono__neg,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ zero_zero_real )
       => ( ord_less_eq_real @ ( divide_divide_real @ B @ C ) @ ( divide_divide_real @ A @ C ) ) ) ) )).

% divide_right_mono_neg
thf(fact_214_divide__strict__right__mono__neg,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_real @ C @ zero_zero_real )
       => ( ord_less_real @ ( divide_divide_real @ A @ C ) @ ( divide_divide_real @ B @ C ) ) ) ) )).

% divide_strict_right_mono_neg
thf(fact_215_divide__strict__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ zero_zero_real @ C )
       => ( ord_less_real @ ( divide_divide_real @ A @ C ) @ ( divide_divide_real @ B @ C ) ) ) ) )).

% divide_strict_right_mono
thf(fact_216_zero__less__divide__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ ( divide_divide_real @ A @ B ) )
      = ( ( ( ord_less_real @ zero_zero_real @ A )
          & ( ord_less_real @ zero_zero_real @ B ) )
        | ( ( ord_less_real @ A @ zero_zero_real )
          & ( ord_less_real @ B @ zero_zero_real ) ) ) ) )).

% zero_less_divide_iff
thf(fact_217_divide__less__cancel,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_real @ ( divide_divide_real @ A @ C ) @ ( divide_divide_real @ B @ C ) )
      = ( ( ( ord_less_real @ zero_zero_real @ C )
         => ( ord_less_real @ A @ B ) )
        & ( ( ord_less_real @ C @ zero_zero_real )
         => ( ord_less_real @ B @ A ) )
        & ( C != zero_zero_real ) ) ) )).

% divide_less_cancel
thf(fact_218_divide__less__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ ( divide_divide_real @ A @ B ) @ zero_zero_real )
      = ( ( ( ord_less_real @ zero_zero_real @ A )
          & ( ord_less_real @ B @ zero_zero_real ) )
        | ( ( ord_less_real @ A @ zero_zero_real )
          & ( ord_less_real @ zero_zero_real @ B ) ) ) ) )).

% divide_less_0_iff
thf(fact_219_divide__pos__pos,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ zero_zero_real @ X )
     => ( ( ord_less_real @ zero_zero_real @ Y2 )
       => ( ord_less_real @ zero_zero_real @ ( divide_divide_real @ X @ Y2 ) ) ) ) )).

% divide_pos_pos
thf(fact_220_divide__pos__neg,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ zero_zero_real @ X )
     => ( ( ord_less_real @ Y2 @ zero_zero_real )
       => ( ord_less_real @ ( divide_divide_real @ X @ Y2 ) @ zero_zero_real ) ) ) )).

% divide_pos_neg
thf(fact_221_divide__neg__pos,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ zero_zero_real )
     => ( ( ord_less_real @ zero_zero_real @ Y2 )
       => ( ord_less_real @ ( divide_divide_real @ X @ Y2 ) @ zero_zero_real ) ) ) )).

% divide_neg_pos
thf(fact_222_divide__neg__neg,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ zero_zero_real )
     => ( ( ord_less_real @ Y2 @ zero_zero_real )
       => ( ord_less_real @ zero_zero_real @ ( divide_divide_real @ X @ Y2 ) ) ) ) )).

% divide_neg_neg
thf(fact_223_abs__ge__zero,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( abs_abs_real @ A ) ) )).

% abs_ge_zero
thf(fact_224_abs__ge__zero,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ zero_zero_int @ ( abs_abs_int @ A ) ) )).

% abs_ge_zero
thf(fact_225_abs__not__less__zero,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ ( abs_abs_real @ A ) @ zero_zero_real ) )).

% abs_not_less_zero
thf(fact_226_abs__not__less__zero,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ ( abs_abs_int @ A ) @ zero_zero_int ) )).

% abs_not_less_zero
thf(fact_227_abs__of__pos,axiom,(
    ! [A: real] :
      ( ( ord_less_real @ zero_zero_real @ A )
     => ( ( abs_abs_real @ A )
        = A ) ) )).

% abs_of_pos
thf(fact_228_abs__of__pos,axiom,(
    ! [A: int] :
      ( ( ord_less_int @ zero_zero_int @ A )
     => ( ( abs_abs_int @ A )
        = A ) ) )).

% abs_of_pos
thf(fact_229_nonzero__abs__divide,axiom,(
    ! [B: real,A: real] :
      ( ( B != zero_zero_real )
     => ( ( abs_abs_real @ ( divide_divide_real @ A @ B ) )
        = ( divide_divide_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) ) )).

% nonzero_abs_divide
thf(fact_230_order__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_231_order__subst1,axiom,(
    ! [A: real,F: int > real,B: int,C: int] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_232_order__subst1,axiom,(
    ! [A: int,F: real > int,B: real,C: real] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_233_order__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_234_order__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_235_order__subst2,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_236_order__subst2,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_237_order__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_238_ord__eq__le__subst,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_239_ord__eq__le__subst,axiom,(
    ! [A: int,F: real > int,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_240_ord__eq__le__subst,axiom,(
    ! [A: real,F: int > real,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_241_ord__eq__le__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_242_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_243_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_eq_real @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_244_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_245_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_eq_int @ X4 @ Y )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_246_eq__iff,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [X3: real,Y4: real] :
          ( ( ord_less_eq_real @ X3 @ Y4 )
          & ( ord_less_eq_real @ Y4 @ X3 ) ) ) )).

% eq_iff
thf(fact_247_eq__iff,axiom,
    ( ( ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    = ( ^ [X3: int,Y4: int] :
          ( ( ord_less_eq_int @ X3 @ Y4 )
          & ( ord_less_eq_int @ Y4 @ X3 ) ) ) )).

% eq_iff
thf(fact_248_antisym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_249_antisym,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_eq_int @ X @ Y2 )
     => ( ( ord_less_eq_int @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_250_linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
      | ( ord_less_eq_real @ Y2 @ X ) ) )).

% linear
thf(fact_251_linear,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_eq_int @ X @ Y2 )
      | ( ord_less_eq_int @ Y2 @ X ) ) )).

% linear
thf(fact_252_eq__refl,axiom,(
    ! [X: real,Y2: real] :
      ( ( X = Y2 )
     => ( ord_less_eq_real @ X @ Y2 ) ) )).

% eq_refl
thf(fact_253_eq__refl,axiom,(
    ! [X: int,Y2: int] :
      ( ( X = Y2 )
     => ( ord_less_eq_int @ X @ Y2 ) ) )).

% eq_refl
thf(fact_254_le__cases,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_eq_real @ X @ Y2 )
     => ( ord_less_eq_real @ Y2 @ X ) ) )).

% le_cases
thf(fact_255_le__cases,axiom,(
    ! [X: int,Y2: int] :
      ( ~ ( ord_less_eq_int @ X @ Y2 )
     => ( ord_less_eq_int @ Y2 @ X ) ) )).

% le_cases
thf(fact_256_order_Otrans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% order.trans
thf(fact_257_order_Otrans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% order.trans
thf(fact_258_le__cases3,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ( ord_less_eq_real @ X @ Y2 )
       => ~ ( ord_less_eq_real @ Y2 @ Z ) )
     => ( ( ( ord_less_eq_real @ Y2 @ X )
         => ~ ( ord_less_eq_real @ X @ Z ) )
       => ( ( ( ord_less_eq_real @ X @ Z )
           => ~ ( ord_less_eq_real @ Z @ Y2 ) )
         => ( ( ( ord_less_eq_real @ Z @ Y2 )
             => ~ ( ord_less_eq_real @ Y2 @ X ) )
           => ( ( ( ord_less_eq_real @ Y2 @ Z )
               => ~ ( ord_less_eq_real @ Z @ X ) )
             => ~ ( ( ord_less_eq_real @ Z @ X )
                 => ~ ( ord_less_eq_real @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_259_le__cases3,axiom,(
    ! [X: int,Y2: int,Z: int] :
      ( ( ( ord_less_eq_int @ X @ Y2 )
       => ~ ( ord_less_eq_int @ Y2 @ Z ) )
     => ( ( ( ord_less_eq_int @ Y2 @ X )
         => ~ ( ord_less_eq_int @ X @ Z ) )
       => ( ( ( ord_less_eq_int @ X @ Z )
           => ~ ( ord_less_eq_int @ Z @ Y2 ) )
         => ( ( ( ord_less_eq_int @ Z @ Y2 )
             => ~ ( ord_less_eq_int @ Y2 @ X ) )
           => ( ( ( ord_less_eq_int @ Y2 @ Z )
               => ~ ( ord_less_eq_int @ Z @ X ) )
             => ~ ( ( ord_less_eq_int @ Z @ X )
                 => ~ ( ord_less_eq_int @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_260_antisym__conv,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_eq_real @ Y2 @ X )
     => ( ( ord_less_eq_real @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_261_antisym__conv,axiom,(
    ! [Y2: int,X: int] :
      ( ( ord_less_eq_int @ Y2 @ X )
     => ( ( ord_less_eq_int @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_262_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [A3: real,B2: real] :
          ( ( ord_less_eq_real @ A3 @ B2 )
          & ( ord_less_eq_real @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_263_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    = ( ^ [A3: int,B2: int] :
          ( ( ord_less_eq_int @ A3 @ B2 )
          & ( ord_less_eq_int @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_264_ord__eq__le__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_265_ord__eq__le__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_266_ord__le__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_267_ord__le__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_268_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_269_order__class_Oorder_Oantisym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_270_order__trans,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ Z )
       => ( ord_less_eq_real @ X @ Z ) ) ) )).

% order_trans
thf(fact_271_order__trans,axiom,(
    ! [X: int,Y2: int,Z: int] :
      ( ( ord_less_eq_int @ X @ Y2 )
     => ( ( ord_less_eq_int @ Y2 @ Z )
       => ( ord_less_eq_int @ X @ Z ) ) ) )).

% order_trans
thf(fact_272_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_273_dual__order_Orefl,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ A ) )).

% dual_order.refl
thf(fact_274_linorder__wlog,axiom,(
    ! [P: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B3: real] :
          ( ( ord_less_eq_real @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: real,B3: real] :
            ( ( P @ B3 @ A4 )
           => ( P @ A4 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_275_linorder__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A4: int,B3: int] :
          ( ( ord_less_eq_int @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: int,B3: int] :
            ( ( P @ B3 @ A4 )
           => ( P @ A4 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_276_dual__order_Otrans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_eq_real @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_277_dual__order_Otrans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ C @ B )
       => ( ord_less_eq_int @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_278_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [A3: real,B2: real] :
          ( ( ord_less_eq_real @ B2 @ A3 )
          & ( ord_less_eq_real @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_279_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    = ( ^ [A3: int,B2: int] :
          ( ( ord_less_eq_int @ B2 @ A3 )
          & ( ord_less_eq_int @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_280_dual__order_Oantisym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_281_dual__order_Oantisym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_282_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_283_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_284_order_Ostrict__implies__not__eq,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_285_order_Ostrict__implies__not__eq,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_286_not__less__iff__gr__or__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_real @ X @ Y2 ) )
      = ( ( ord_less_real @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_287_not__less__iff__gr__or__eq,axiom,(
    ! [X: int,Y2: int] :
      ( ( ~ ( ord_less_int @ X @ Y2 ) )
      = ( ( ord_less_int @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_288_dual__order_Ostrict__trans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_real @ C @ B )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_289_dual__order_Ostrict__trans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_290_linorder__less__wlog,axiom,(
    ! [P: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B3: real] :
          ( ( ord_less_real @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: real] :
            ( P @ A4 @ A4 )
       => ( ! [A4: real,B3: real] :
              ( ( P @ B3 @ A4 )
             => ( P @ A4 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_291_linorder__less__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A4: int,B3: int] :
          ( ( ord_less_int @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: int] :
            ( P @ A4 @ A4 )
       => ( ! [A4: int,B3: int] :
              ( ( P @ B3 @ A4 )
             => ( P @ A4 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_292_less__imp__not__less,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_293_less__imp__not__less,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ~ ( ord_less_int @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_294_order_Ostrict__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_295_order_Ostrict__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_296_dual__order_Oirrefl,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% dual_order.irrefl
thf(fact_297_dual__order_Oirrefl,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% dual_order.irrefl
thf(fact_298_linorder__cases,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_299_linorder__cases,axiom,(
    ! [X: int,Y2: int] :
      ( ~ ( ord_less_int @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_int @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_300_less__imp__triv,axiom,(
    ! [X: real,Y2: real,P: $o] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_301_less__imp__triv,axiom,(
    ! [X: int,Y2: int,P: $o] :
      ( ( ord_less_int @ X @ Y2 )
     => ( ( ord_less_int @ Y2 @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_302_less__imp__not__eq2,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_303_less__imp__not__eq2,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_304_antisym__conv3,axiom,(
    ! [Y2: real,X: real] :
      ( ~ ( ord_less_real @ Y2 @ X )
     => ( ( ~ ( ord_less_real @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_305_antisym__conv3,axiom,(
    ! [Y2: int,X: int] :
      ( ~ ( ord_less_int @ Y2 @ X )
     => ( ( ~ ( ord_less_int @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_306_less__not__sym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_307_less__not__sym,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ~ ( ord_less_int @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_308_less__imp__not__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_309_less__imp__not__eq,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_310_dual__order_Oasym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ~ ( ord_less_real @ A @ B ) ) )).

% dual_order.asym
thf(fact_311_dual__order_Oasym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ~ ( ord_less_int @ A @ B ) ) )).

% dual_order.asym
thf(fact_312_ord__less__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_313_ord__less__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_314_ord__eq__less__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_315_ord__eq__less__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_316_less__irrefl,axiom,(
    ! [X: real] :
      ~ ( ord_less_real @ X @ X ) )).

% less_irrefl
thf(fact_317_less__irrefl,axiom,(
    ! [X: int] :
      ~ ( ord_less_int @ X @ X ) )).

% less_irrefl
thf(fact_318_less__linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_real @ Y2 @ X ) ) )).

% less_linear
thf(fact_319_less__linear,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_int @ Y2 @ X ) ) )).

% less_linear
thf(fact_320_less__trans,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ Z )
       => ( ord_less_real @ X @ Z ) ) ) )).

% less_trans
thf(fact_321_less__trans,axiom,(
    ! [X: int,Y2: int,Z: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ( ( ord_less_int @ Y2 @ Z )
       => ( ord_less_int @ X @ Z ) ) ) )).

% less_trans
thf(fact_322_less__asym_H,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% less_asym'
thf(fact_323_less__asym_H,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% less_asym'
thf(fact_324_less__asym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_asym
thf(fact_325_less__asym,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ~ ( ord_less_int @ Y2 @ X ) ) )).

% less_asym
thf(fact_326_less__imp__neq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_327_less__imp__neq,axiom,(
    ! [X: int,Y2: int] :
      ( ( ord_less_int @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_328_dense,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ? [Z3: real] :
          ( ( ord_less_real @ X @ Z3 )
          & ( ord_less_real @ Z3 @ Y2 ) ) ) )).

% dense
thf(fact_329_order_Oasym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% order.asym
thf(fact_330_order_Oasym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% order.asym
thf(fact_331_neq__iff,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
      = ( ( ord_less_real @ X @ Y2 )
        | ( ord_less_real @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_332_neq__iff,axiom,(
    ! [X: int,Y2: int] :
      ( ( X != Y2 )
      = ( ( ord_less_int @ X @ Y2 )
        | ( ord_less_int @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_333_neqE,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_real @ X @ Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% neqE
thf(fact_334_neqE,axiom,(
    ! [X: int,Y2: int] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_int @ X @ Y2 )
       => ( ord_less_int @ Y2 @ X ) ) ) )).

% neqE
thf(fact_335_gt__ex,axiom,(
    ! [X: real] :
    ? [X_1: real] :
      ( ord_less_real @ X @ X_1 ) )).

% gt_ex
thf(fact_336_gt__ex,axiom,(
    ! [X: int] :
    ? [X_1: int] :
      ( ord_less_int @ X @ X_1 ) )).

% gt_ex
thf(fact_337_lt__ex,axiom,(
    ! [X: real] :
    ? [Y: real] :
      ( ord_less_real @ Y @ X ) )).

% lt_ex
thf(fact_338_lt__ex,axiom,(
    ! [X: int] :
    ? [Y: int] :
      ( ord_less_int @ Y @ X ) )).

% lt_ex
thf(fact_339_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_real @ X4 @ Y )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_340_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_real @ X4 @ Y )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_341_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_int @ X4 @ Y )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_342_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_int @ X4 @ Y )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_343_order__less__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_real @ X4 @ Y )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_344_order__less__subst1,axiom,(
    ! [A: real,F: int > real,B: int,C: int] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_int @ X4 @ Y )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_345_order__less__subst1,axiom,(
    ! [A: int,F: real > int,B: real,C: real] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_real @ X4 @ Y )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_346_order__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_int @ X4 @ Y )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_347_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y: real] :
              ( ( ord_less_real @ X4 @ Y )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_348_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_int @ X4 @ Y )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_349_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y: int] :
              ( ( ord_less_int @ X4 @ Y )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_350_real__of__int__div3,axiom,(
    ! [N: int,X: int] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( divide_divide_real @ ( ring_1_of_int_real @ N ) @ ( ring_1_of_int_real @ X ) ) @ ( ring_1_of_int_real @ ( divide_divide_int @ N @ X ) ) ) @ one_one_real ) )).

% real_of_int_div3
thf(fact_351_real__of__int__div2,axiom,(
    ! [N: int,X: int] :
      ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ ( divide_divide_real @ ( ring_1_of_int_real @ N ) @ ( ring_1_of_int_real @ X ) ) @ ( ring_1_of_int_real @ ( divide_divide_int @ N @ X ) ) ) ) )).

% real_of_int_div2
thf(fact_352_complete__real,axiom,(
    ! [S: set_real] :
      ( ? [X2: real] :
          ( member_real @ X2 @ S )
     => ( ? [Z4: real] :
          ! [X4: real] :
            ( ( member_real @ X4 @ S )
           => ( ord_less_eq_real @ X4 @ Z4 ) )
       => ? [Y: real] :
            ( ! [X2: real] :
                ( ( member_real @ X2 @ S )
               => ( ord_less_eq_real @ X2 @ Y ) )
            & ! [Z4: real] :
                ( ! [X4: real] :
                    ( ( member_real @ X4 @ S )
                   => ( ord_less_eq_real @ X4 @ Z4 ) )
               => ( ord_less_eq_real @ Y @ Z4 ) ) ) ) ) )).

% complete_real

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ x @ ( divide_divide_real @ ( ring_1_of_int_real @ a3 ) @ ( ring_1_of_int_real @ b ) ) ) ) @ a2 )).

%------------------------------------------------------------------------------
