%------------------------------------------------------------------------------
% File     : SLH198^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer GenClock problem prob_547__3247954_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : GenClock/prob_547__3247954_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  381 (   0 unit;  30 type;   0 defn)
%            Number of atoms       : 3884 ( 417 equality;1732 variable)
%            Maximal formula depth :   17 (   8 average)
%            Number of connectives : 2721 (  22   ~;  22   |;  45   &;2423   @)
%                                         (   0 <=>; 209  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   43 (  43   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   32 (  30   :;   0   =)
%            Number of variables   :  784 (   0 sgn; 761   !;   1   ?;  22   ^)
%                                         ( 784   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:41.458
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (28)
thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OPC,type,(
    genClo1161277105lle_PC: nat > real > real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_O_092_060beta_062,type,(
    genClo1278781456e_beta: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_O_092_060mu_062,type,(
    genClo872980712lle_mu: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_O_092_060rho_062,type,(
    genClo1144207539le_rho: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ocorrect,type,(
    genClo1015804716orrect: nat > real > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OokRead2,type,(
    genClo293725282kRead2: ( nat > real ) > ( nat > real ) > real > ( nat > $o ) > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Orho__bound1,type,(
    genClo2108747022bound1: ( nat > real > real ) > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Orho__bound2,type,(
    genClo2108747023bound2: ( nat > real > real ) > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ormax,type,(
    genClo1650508560e_rmax: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ormin,type,(
    genClo1651033342e_rmin: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ote,type,(
    genClo1163638703lle_te: nat > nat > real )).

thf(sy_c_Groups_Oabs__class_Oabs_001t__Real__Oreal,type,(
    abs_abs_real: real > real )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Real__Oreal,type,(
    minus_minus_real: real > real > real )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Real__Oreal,type,(
    one_one_real: real )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Real__Oreal,type,(
    plus_plus_real: real > real > real )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Real__Oreal,type,(
    times_times_real: real > real > real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_v_i,type,(
    i: nat )).

thf(sy_v_l,type,(
    l: nat )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_q,type,(
    q: nat )).

% Relevant facts (350)
thf(fact_0_posD,axiom,(
    ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) )).

% posD
thf(fact_1_A,axiom,(
    ord_less_eq_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( minus_minus_real @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) )).

% A
thf(fact_2_ie,axiom,(
    ord_less_eq_real @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) )).

% ie
thf(fact_3_posX,axiom,(
    ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) )).

% posX
thf(fact_4_corr__p,axiom,(
    genClo1015804716orrect @ p @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) )).

% corr_p
thf(fact_5_corr__q,axiom,(
    genClo1015804716orrect @ q @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) )).

% corr_q
thf(fact_6_corr__l,axiom,(
    genClo1015804716orrect @ l @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) )).

% corr_l
thf(fact_7__092_060open_062_092_060bar_062te_Ap_A_Ii_A_L_A1_J_A_N_Ate_Aq_A_Ii_A_L_A1_J_092_060bar_062_A_092_060le_062_A_092_060beta_062_092_060close_062,axiom,(
    ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) @ genClo1278781456e_beta )).

% \<open>\<bar>te p (i + 1) - te q (i + 1)\<bar> \<le> \<beta>\<close>
thf(fact_8_corr__l__tq,axiom,(
    genClo1015804716orrect @ l @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) )).

% corr_l_tq
thf(fact_9_corr__q__tq,axiom,(
    genClo1015804716orrect @ q @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) )).

% corr_q_tq
thf(fact_10_abs__1,axiom,
    ( ( abs_abs_real @ one_one_real )
    = one_one_real )).

% abs_1
thf(fact_11_abs__add__abs,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) )
      = ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_add_abs
thf(fact_12_add__diff__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel
thf(fact_13_diff__add__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
      = A ) )).

% diff_add_cancel
thf(fact_14_add__diff__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_15_add__diff__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_16_add__diff__cancel__left_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_17_add__diff__cancel__left_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_18_add__diff__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_19_add__diff__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_20_add__diff__cancel__right_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_21_add__diff__cancel__right_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_22_abs__abs,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_abs
thf(fact_23_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_24_add__right__cancel,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_25_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_26_add__left__cancel,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_27_abs__idempotent,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_idempotent
thf(fact_28_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_29_add__le__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_30_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_31_add__le__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_32_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_33_zero__eq__add__iff__both__eq__0,axiom,(
    ! [X: nat,Y: nat] :
      ( ( zero_zero_nat
        = ( plus_plus_nat @ X @ Y ) )
      = ( ( X = zero_zero_nat )
        & ( Y = zero_zero_nat ) ) ) )).

% zero_eq_add_iff_both_eq_0
thf(fact_34_add__eq__0__iff__both__eq__0,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( plus_plus_nat @ X @ Y )
        = zero_zero_nat )
      = ( ( X = zero_zero_nat )
        & ( Y = zero_zero_nat ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_35_add__cancel__right__right,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( plus_plus_real @ A @ B ) )
      = ( B = zero_zero_real ) ) )).

% add_cancel_right_right
thf(fact_36_add__cancel__right__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ A @ B ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_right
thf(fact_37_add__cancel__right__left,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( plus_plus_real @ B @ A ) )
      = ( B = zero_zero_real ) ) )).

% add_cancel_right_left
thf(fact_38_add__cancel__right__left,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ B @ A ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_left
thf(fact_39_add__cancel__left__right,axiom,(
    ! [A: real,B: real] :
      ( ( ( plus_plus_real @ A @ B )
        = A )
      = ( B = zero_zero_real ) ) )).

% add_cancel_left_right
thf(fact_40_add__cancel__left__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_right
thf(fact_41_add__cancel__left__left,axiom,(
    ! [B: real,A: real] :
      ( ( ( plus_plus_real @ B @ A )
        = A )
      = ( B = zero_zero_real ) ) )).

% add_cancel_left_left
thf(fact_42_add__cancel__left__left,axiom,(
    ! [B: nat,A: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_left
thf(fact_43_double__zero__sym,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( plus_plus_real @ A @ A ) )
      = ( A = zero_zero_real ) ) )).

% double_zero_sym
thf(fact_44_double__zero,axiom,(
    ! [A: real] :
      ( ( ( plus_plus_real @ A @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% double_zero
thf(fact_45_add_Oright__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ A @ zero_zero_real )
      = A ) )).

% add.right_neutral
thf(fact_46_add_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.right_neutral
thf(fact_47_add_Oleft__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% add.left_neutral
thf(fact_48_add_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% add.left_neutral
thf(fact_49_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_50_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_51_diff__zero,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_zero
thf(fact_52_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_53_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_54_diff__0__right,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_0_right
thf(fact_55_diff__self,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% diff_self
thf(fact_56_abs__zero,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_zero
thf(fact_57_abs__eq__0,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0
thf(fact_58_abs__0__eq,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( abs_abs_real @ A ) )
      = ( A = zero_zero_real ) ) )).

% abs_0_eq
thf(fact_59_abs__0,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_0
thf(fact_60_zero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_61_double__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ A ) @ zero_zero_real )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_62_le__add__same__cancel2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( plus_plus_real @ B @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ B ) ) )).

% le_add_same_cancel2
thf(fact_63_le__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel2
thf(fact_64_le__add__same__cancel1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( plus_plus_real @ A @ B ) )
      = ( ord_less_eq_real @ zero_zero_real @ B ) ) )).

% le_add_same_cancel1
thf(fact_65_le__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel1
thf(fact_66_add__le__same__cancel2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ B )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% add_le_same_cancel2
thf(fact_67_add__le__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel2
thf(fact_68_add__le__same__cancel1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ B @ A ) @ B )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% add_le_same_cancel1
thf(fact_69_add__le__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel1
thf(fact_70_diff__ge__0__iff__ge,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_eq_real @ B @ A ) ) )).

% diff_ge_0_iff_ge
thf(fact_71_le__add__diff__inverse2,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_72_le__add__diff__inverse2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_73_le__add__diff__inverse,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( plus_plus_real @ B @ ( minus_minus_real @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_74_le__add__diff__inverse,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ B @ ( minus_minus_nat @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_75_diff__add__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = zero_zero_nat ) )).

% diff_add_zero
thf(fact_76_abs__le__zero__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_le_zero_iff
thf(fact_77_abs__le__self__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ A )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% abs_le_self_iff
thf(fact_78_abs__of__nonneg,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( abs_abs_real @ A )
        = A ) ) )).

% abs_of_nonneg
thf(fact_79_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_80_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_81_rts2a,axiom,(
    ! [P: nat,Q: nat,T: real,I: nat] :
      ( ( ( genClo1015804716orrect @ P @ T )
        & ( genClo1015804716orrect @ Q @ T )
        & ( ord_less_eq_real @ ( plus_plus_real @ ( genClo1163638703lle_te @ Q @ I ) @ genClo1278781456e_beta ) @ T ) )
     => ( ord_less_eq_real @ ( genClo1163638703lle_te @ P @ I ) @ T ) ) )).

% rts2a
thf(fact_82_correct__closed,axiom,(
    ! [P: nat,S: real,T: real] :
      ( ( ( ord_less_eq_real @ S @ T )
        & ( genClo1015804716orrect @ P @ T ) )
     => ( genClo1015804716orrect @ P @ S ) ) )).

% correct_closed
thf(fact_83_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_84_add__nonpos__eq__0__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ zero_zero_real )
     => ( ( ord_less_eq_real @ Y @ zero_zero_real )
       => ( ( ( plus_plus_real @ X @ Y )
            = zero_zero_real )
          = ( ( X = zero_zero_real )
            & ( Y = zero_zero_real ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_85_add__nonpos__eq__0__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ Y @ zero_zero_nat )
       => ( ( ( plus_plus_nat @ X @ Y )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y = zero_zero_nat ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_86_add__nonneg__eq__0__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ( plus_plus_real @ X @ Y )
            = zero_zero_real )
          = ( ( X = zero_zero_real )
            & ( Y = zero_zero_real ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_87_add__nonneg__eq__0__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ X )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ Y )
       => ( ( ( plus_plus_nat @ X @ Y )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y = zero_zero_nat ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_88_add__nonpos__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ zero_zero_real ) ) ) )).

% add_nonpos_nonpos
thf(fact_89_add__nonpos__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_nonpos_nonpos
thf(fact_90_add__nonneg__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_91_add__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_92_add__increasing2,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ C )
     => ( ( ord_less_eq_real @ B @ A )
       => ( ord_less_eq_real @ B @ ( plus_plus_real @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_93_add__increasing2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ C )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_94_add__decreasing2,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ C @ zero_zero_real )
     => ( ( ord_less_eq_real @ A @ B )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_95_add__decreasing2,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_96_add__increasing,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ B @ ( plus_plus_real @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_97_add__increasing,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_98_add__decreasing,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_99_add__decreasing,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_100_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_real @ one_one_real @ zero_zero_real ) )).

% not_one_le_zero
thf(fact_101_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_102_zero__le__one,axiom,(
    ord_less_eq_real @ zero_zero_real @ one_one_real )).

% zero_le_one
thf(fact_103_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_104_le__iff__diff__le__0,axiom,
    ( ord_less_eq_real
    = ( ^ [A2: real,B2: real] :
          ( ord_less_eq_real @ ( minus_minus_real @ A2 @ B2 ) @ zero_zero_real ) ) )).

% le_iff_diff_le_0
thf(fact_105_abs__ge__zero,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( abs_abs_real @ A ) ) )).

% abs_ge_zero
thf(fact_106_PC__monotone,axiom,(
    ! [P: nat,S: real,T: real] :
      ( ( ( genClo1015804716orrect @ P @ T )
        & ( ord_less_eq_real @ S @ T ) )
     => ( ord_less_eq_real @ ( genClo1161277105lle_PC @ P @ S ) @ ( genClo1161277105lle_PC @ P @ T ) ) ) )).

% PC_monotone
thf(fact_107_add__le__imp__le__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
     => ( ord_less_eq_real @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_108_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_109_add__le__imp__le__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
     => ( ord_less_eq_real @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_110_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_111_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
        ? [C2: nat] :
          ( B2
          = ( plus_plus_nat @ A2 @ C2 ) ) ) )).

% le_iff_add
thf(fact_112_add__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) ) ) )).

% add_right_mono
thf(fact_113_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_114_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_115_add__left__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) ) ) )).

% add_left_mono
thf(fact_116_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_117_add__mono,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ D )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ D ) ) ) ) )).

% add_mono
thf(fact_118_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_119_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I2: real,J: real,K: real,L: real] :
      ( ( ( ord_less_eq_real @ I2 @ J )
        & ( ord_less_eq_real @ K @ L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I2 @ K ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_120_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I2 @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I2 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_121_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I2: real,J: real,K: real,L: real] :
      ( ( ( I2 = J )
        & ( ord_less_eq_real @ K @ L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I2 @ K ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_122_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ( I2 = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I2 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_123_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I2: real,J: real,K: real,L: real] :
      ( ( ( ord_less_eq_real @ I2 @ J )
        & ( K = L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I2 @ K ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_124_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I2 @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I2 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_125_diff__eq__diff__less__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( ord_less_eq_real @ A @ B )
        = ( ord_less_eq_real @ C @ D ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_126_diff__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ C ) ) ) )).

% diff_right_mono
thf(fact_127_diff__left__mono,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ord_less_eq_real @ ( minus_minus_real @ C @ A ) @ ( minus_minus_real @ C @ B ) ) ) )).

% diff_left_mono
thf(fact_128_diff__mono,axiom,(
    ! [A: real,B: real,D: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ D @ C )
       => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ D ) ) ) ) )).

% diff_mono
thf(fact_129_add_Ogroup__left__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% add.group_left_neutral
thf(fact_130_add_Ocomm__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ A @ zero_zero_real )
      = A ) )).

% add.comm_neutral
thf(fact_131_add_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.comm_neutral
thf(fact_132_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_133_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_134_zero__neq__one,axiom,(
    zero_zero_real != one_one_real )).

% zero_neq_one
thf(fact_135_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_136_eq__iff__diff__eq__0,axiom,
    ( ( ^ [Y2: real,Z: real] : ( Y2 = Z ) )
    = ( ^ [A2: real,B2: real] :
          ( ( minus_minus_real @ A2 @ B2 )
          = zero_zero_real ) ) )).

% eq_iff_diff_eq_0
thf(fact_137_abs__ge__self,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ ( abs_abs_real @ A ) ) )).

% abs_ge_self
thf(fact_138_abs__le__D1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ B )
     => ( ord_less_eq_real @ A @ B ) ) )).

% abs_le_D1
thf(fact_139_abs__eq__0__iff,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0_iff
thf(fact_140_rts2b,axiom,(
    ! [P: nat,Q: nat,I: nat] :
      ( ( ( genClo1015804716orrect @ P @ ( genClo1163638703lle_te @ P @ I ) )
        & ( genClo1015804716orrect @ Q @ ( genClo1163638703lle_te @ Q @ I ) ) )
     => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ P @ I ) @ ( genClo1163638703lle_te @ Q @ I ) ) ) @ genClo1278781456e_beta ) ) )).

% rts2b
thf(fact_141_rte,axiom,(
    ! [P2: nat,I2: nat] :
      ( ( genClo1015804716orrect @ P2 @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) )
     => ( ord_less_eq_real @ ( genClo1163638703lle_te @ P2 @ I2 ) @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) ) ) )).

% rte
thf(fact_142_beta__bound1,axiom,(
    ! [P2: nat,I2: nat,Q2: nat] :
      ( ( genClo1015804716orrect @ P2 @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) )
     => ( ( genClo1015804716orrect @ Q2 @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) )
       => ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) @ ( genClo1163638703lle_te @ Q2 @ I2 ) ) ) ) ) )).

% beta_bound1
thf(fact_143_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_144_add__right__imp__eq,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_145_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_146_add__left__imp__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_147_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_148_add_Oleft__commute,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( plus_plus_real @ B @ ( plus_plus_real @ A @ C ) )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% add.left_commute
thf(fact_149_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A2: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A2 ) ) )).

% add.commute
thf(fact_150_add_Ocommute,axiom,
    ( plus_plus_real
    = ( ^ [A2: real,B2: real] :
          ( plus_plus_real @ B2 @ A2 ) ) )).

% add.commute
thf(fact_151_add_Oright__cancel,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
      = ( B = C ) ) )).

% add.right_cancel
thf(fact_152_add_Oleft__cancel,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
      = ( B = C ) ) )).

% add.left_cancel
thf(fact_153_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_154_add_Oassoc,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% add.assoc
thf(fact_155_group__cancel_Oadd2,axiom,(
    ! [B3: nat,K: nat,B: nat,A: nat] :
      ( ( B3
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B3 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_156_group__cancel_Oadd2,axiom,(
    ! [B3: real,K: real,B: real,A: real] :
      ( ( B3
        = ( plus_plus_real @ K @ B ) )
     => ( ( plus_plus_real @ A @ B3 )
        = ( plus_plus_real @ K @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_157_group__cancel_Oadd1,axiom,(
    ! [A3: nat,K: nat,A: nat,B: nat] :
      ( ( A3
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A3 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_158_group__cancel_Oadd1,axiom,(
    ! [A3: real,K: real,A: real,B: real] :
      ( ( A3
        = ( plus_plus_real @ K @ A ) )
     => ( ( plus_plus_real @ A3 @ B )
        = ( plus_plus_real @ K @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_159_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ( I2 = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I2 @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_160_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I2: real,J: real,K: real,L: real] :
      ( ( ( I2 = J )
        & ( K = L ) )
     => ( ( plus_plus_real @ I2 @ K )
        = ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_161_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_162_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_163_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_164_one__reorient,axiom,(
    ! [X: real] :
      ( ( one_one_real = X )
      = ( X = one_one_real ) ) )).

% one_reorient
thf(fact_165_diff__right__commute,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B )
      = ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_166_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_167_diff__eq__diff__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( A = B )
        = ( C = D ) ) ) )).

% diff_eq_diff_eq
thf(fact_168_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ( ( minus_minus_nat @ B @ A )
            = C )
          = ( B
            = ( plus_plus_nat @ C @ A ) ) ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_169_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ A @ ( minus_minus_nat @ B @ A ) )
        = B ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_170_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ B ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_171_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A )
        = ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ C ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_172_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ C )
        = ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_173_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ C @ B ) @ A )
        = ( plus_plus_nat @ C @ ( minus_minus_nat @ B @ A ) ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_174_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ C @ B ) @ A ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_175_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ B ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_176_le__add__diff,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ C @ ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A ) ) ) )).

% le_add_diff
thf(fact_177_add__le__add__imp__diff__le,axiom,(
    ! [I2: real,K: real,N: real,J: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ I2 @ K ) @ N )
     => ( ( ord_less_eq_real @ N @ ( plus_plus_real @ J @ K ) )
       => ( ( ord_less_eq_real @ ( plus_plus_real @ I2 @ K ) @ N )
         => ( ( ord_less_eq_real @ N @ ( plus_plus_real @ J @ K ) )
           => ( ord_less_eq_real @ ( minus_minus_real @ N @ K ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_178_add__le__add__imp__diff__le,axiom,(
    ! [I2: nat,K: nat,N: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I2 @ K ) @ N )
     => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
       => ( ( ord_less_eq_nat @ ( plus_plus_nat @ I2 @ K ) @ N )
         => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
           => ( ord_less_eq_nat @ ( minus_minus_nat @ N @ K ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_179_diff__add,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ A )
        = B ) ) )).

% diff_add
thf(fact_180_add__le__imp__le__diff,axiom,(
    ! [I2: real,K: real,N: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ I2 @ K ) @ N )
     => ( ord_less_eq_real @ I2 @ ( minus_minus_real @ N @ K ) ) ) )).

% add_le_imp_le_diff
thf(fact_181_add__le__imp__le__diff,axiom,(
    ! [I2: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I2 @ K ) @ N )
     => ( ord_less_eq_nat @ I2 @ ( minus_minus_nat @ N @ K ) ) ) )).

% add_le_imp_le_diff
thf(fact_182_le__diff__eq,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( minus_minus_real @ C @ B ) )
      = ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ C ) ) )).

% le_diff_eq
thf(fact_183_diff__le__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( ord_less_eq_real @ A @ ( plus_plus_real @ C @ B ) ) ) )).

% diff_le_eq
thf(fact_184_abs__triangle__ineq,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( plus_plus_real @ A @ B ) ) @ ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_triangle_ineq
thf(fact_185_abs__triangle__ineq2__sym,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_triangle_ineq2_sym
thf(fact_186_abs__triangle__ineq3,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq3
thf(fact_187_abs__triangle__ineq2,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq2
thf(fact_188_abs__diff__triangle__ineq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ ( plus_plus_real @ C @ D ) ) ) @ ( plus_plus_real @ ( abs_abs_real @ ( minus_minus_real @ A @ C ) ) @ ( abs_abs_real @ ( minus_minus_real @ B @ D ) ) ) ) )).

% abs_diff_triangle_ineq
thf(fact_189_abs__triangle__ineq4,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) @ ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_triangle_ineq4
thf(fact_190_abs__diff__le__iff,axiom,(
    ! [X: real,A: real,R: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ X @ A ) ) @ R )
      = ( ( ord_less_eq_real @ ( minus_minus_real @ A @ R ) @ X )
        & ( ord_less_eq_real @ X @ ( plus_plus_real @ A @ R ) ) ) ) )).

% abs_diff_le_iff
thf(fact_191_add__implies__diff,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ( plus_plus_real @ C @ B )
        = A )
     => ( C
        = ( minus_minus_real @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_192_add__implies__diff,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ( plus_plus_nat @ C @ B )
        = A )
     => ( C
        = ( minus_minus_nat @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_193_diff__diff__add,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_194_diff__diff__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C )
      = ( minus_minus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_195_diff__add__eq__diff__diff__swap,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B ) ) )).

% diff_add_eq_diff_diff_swap
thf(fact_196_diff__add__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ B ) ) )).

% diff_add_eq
thf(fact_197_diff__diff__eq2,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ B ) ) )).

% diff_diff_eq2
thf(fact_198_add__diff__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ C ) ) )).

% add_diff_eq
thf(fact_199_eq__diff__eq,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( A
        = ( minus_minus_real @ C @ B ) )
      = ( ( plus_plus_real @ A @ B )
        = C ) ) )).

% eq_diff_eq
thf(fact_200_diff__eq__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( minus_minus_real @ A @ B )
        = C )
      = ( A
        = ( plus_plus_real @ C @ B ) ) ) )).

% diff_eq_eq
thf(fact_201_group__cancel_Osub1,axiom,(
    ! [A3: real,K: real,A: real,B: real] :
      ( ( A3
        = ( plus_plus_real @ K @ A ) )
     => ( ( minus_minus_real @ A3 @ B )
        = ( plus_plus_real @ K @ ( minus_minus_real @ A @ B ) ) ) ) )).

% group_cancel.sub1
thf(fact_202_abs__one,axiom,
    ( ( abs_abs_real @ one_one_real )
    = one_one_real )).

% abs_one
thf(fact_203_abs__minus__commute,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( minus_minus_real @ A @ B ) )
      = ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_minus_commute
thf(fact_204_diff__numeral__special_I9_J,axiom,
    ( ( minus_minus_real @ one_one_real @ one_one_real )
    = zero_zero_real )).

% diff_numeral_special(9)
thf(fact_205_init,axiom,(
    ! [P: nat] :
      ( ( genClo1015804716orrect @ P @ zero_zero_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ ( genClo1161277105lle_PC @ P @ zero_zero_real ) )
        & ( ord_less_eq_real @ ( genClo1161277105lle_PC @ P @ zero_zero_real ) @ genClo872980712lle_mu ) ) ) )).

% init
thf(fact_206_beta__bound2,axiom,(
    ! [P2: nat,I2: nat,Q2: nat] :
      ( ( genClo1015804716orrect @ P2 @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) )
     => ( ( genClo1015804716orrect @ Q2 @ ( genClo1163638703lle_te @ Q2 @ I2 ) )
       => ( ord_less_eq_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) @ ( genClo1163638703lle_te @ Q2 @ I2 ) ) @ ( plus_plus_real @ genClo1650508560e_rmax @ genClo1278781456e_beta ) ) ) ) )).

% beta_bound2
thf(fact_207_rts1d,axiom,(
    ! [P2: nat,I2: nat] :
      ( ( genClo1015804716orrect @ P2 @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) )
     => ( ord_less_eq_real @ genClo1651033342e_rmin @ ( minus_minus_real @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) @ ( genClo1163638703lle_te @ P2 @ I2 ) ) ) ) )).

% rts1d
thf(fact_208_rts1,axiom,(
    ! [P: nat,T: real,I: nat] :
      ( ( ( genClo1015804716orrect @ P @ T )
        & ( ord_less_eq_real @ ( genClo1163638703lle_te @ P @ ( plus_plus_nat @ I @ one_one_nat ) ) @ T ) )
     => ( ord_less_eq_real @ genClo1651033342e_rmin @ ( minus_minus_real @ T @ ( genClo1163638703lle_te @ P @ I ) ) ) ) )).

% rts1
thf(fact_209_bound1,axiom,(
    ord_less_eq_real @ ( minus_minus_real @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) @ ( times_times_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( plus_plus_real @ one_one_real @ genClo1144207539le_rho ) ) )).

% bound1
thf(fact_210_rts0d,axiom,(
    ! [P2: nat,I2: nat] :
      ( ( genClo1015804716orrect @ P2 @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) )
     => ( ord_less_eq_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ P2 @ ( plus_plus_nat @ I2 @ one_one_nat ) ) @ ( genClo1163638703lle_te @ P2 @ I2 ) ) @ genClo1650508560e_rmax ) ) )).

% rts0d
thf(fact_211_rts0,axiom,(
    ! [P: nat,T: real,I: nat] :
      ( ( ( genClo1015804716orrect @ P @ T )
        & ( ord_less_eq_real @ T @ ( genClo1163638703lle_te @ P @ ( plus_plus_nat @ I @ one_one_nat ) ) ) )
     => ( ord_less_eq_real @ ( minus_minus_real @ T @ ( genClo1163638703lle_te @ P @ I ) ) @ genClo1650508560e_rmax ) ) )).

% rts0
thf(fact_212_D__beta,axiom,(
    ord_less_eq_real @ ( times_times_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ genClo1144207539le_rho ) @ ( times_times_real @ genClo1278781456e_beta @ genClo1144207539le_rho ) )).

% D_beta
thf(fact_213_okRead2__def,axiom,
    ( genClo293725282kRead2
    = ( ^ [F: nat > real,G: nat > real,X2: real,Ppred: nat > $o] :
        ! [P3: nat] :
          ( ( Ppred @ P3 )
         => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( F @ P3 ) @ ( G @ P3 ) ) ) @ X2 ) ) ) )).

% okRead2_def
thf(fact_214_mult__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ( times_times_real @ A @ C )
        = ( times_times_real @ B @ C ) )
      = ( ( C = zero_zero_real )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_215_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_216_mult__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ( times_times_real @ C @ A )
        = ( times_times_real @ C @ B ) )
      = ( ( C = zero_zero_real )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_217_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_218_mult__eq__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
        = zero_zero_real )
      = ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% mult_eq_0_iff
thf(fact_219_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_220_mult__zero__right,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ zero_zero_real )
      = zero_zero_real ) )).

% mult_zero_right
thf(fact_221_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_222_mult__zero__left,axiom,(
    ! [A: real] :
      ( ( times_times_real @ zero_zero_real @ A )
      = zero_zero_real ) )).

% mult_zero_left
thf(fact_223_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_224_mult_Oleft__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ one_one_real @ A )
      = A ) )).

% mult.left_neutral
thf(fact_225_mult_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% mult.left_neutral
thf(fact_226_mult_Oright__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ one_one_real )
      = A ) )).

% mult.right_neutral
thf(fact_227_mult_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.right_neutral
thf(fact_228_abs__mult__self__eq,axiom,(
    ! [A: real] :
      ( ( times_times_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ A ) )
      = ( times_times_real @ A @ A ) ) )).

% abs_mult_self_eq
thf(fact_229_mult__cancel__left1,axiom,(
    ! [C: real,B: real] :
      ( ( C
        = ( times_times_real @ C @ B ) )
      = ( ( C = zero_zero_real )
        | ( B = one_one_real ) ) ) )).

% mult_cancel_left1
thf(fact_230_mult__cancel__left2,axiom,(
    ! [C: real,A: real] :
      ( ( ( times_times_real @ C @ A )
        = C )
      = ( ( C = zero_zero_real )
        | ( A = one_one_real ) ) ) )).

% mult_cancel_left2
thf(fact_231_mult__cancel__right1,axiom,(
    ! [C: real,B: real] :
      ( ( C
        = ( times_times_real @ B @ C ) )
      = ( ( C = zero_zero_real )
        | ( B = one_one_real ) ) ) )).

% mult_cancel_right1
thf(fact_232_mult__cancel__right2,axiom,(
    ! [A: real,C: real] :
      ( ( ( times_times_real @ A @ C )
        = C )
      = ( ( C = zero_zero_real )
        | ( A = one_one_real ) ) ) )).

% mult_cancel_right2
thf(fact_233_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( times_times_real @ A @ B ) @ C )
      = ( times_times_real @ A @ ( times_times_real @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_234_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_235_mult_Oassoc,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( times_times_real @ A @ B ) @ C )
      = ( times_times_real @ A @ ( times_times_real @ B @ C ) ) ) )).

% mult.assoc
thf(fact_236_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_237_mult_Ocommute,axiom,
    ( times_times_real
    = ( ^ [A2: real,B2: real] :
          ( times_times_real @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_238_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A2: nat,B2: nat] :
          ( times_times_nat @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_239_mult_Oleft__commute,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( times_times_real @ B @ ( times_times_real @ A @ C ) )
      = ( times_times_real @ A @ ( times_times_real @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_240_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_241_mult__right__cancel,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( C != zero_zero_real )
     => ( ( ( times_times_real @ A @ C )
          = ( times_times_real @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_242_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_243_mult__left__cancel,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( C != zero_zero_real )
     => ( ( ( times_times_real @ C @ A )
          = ( times_times_real @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_244_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_245_no__zero__divisors,axiom,(
    ! [A: real,B: real] :
      ( ( A != zero_zero_real )
     => ( ( B != zero_zero_real )
       => ( ( times_times_real @ A @ B )
         != zero_zero_real ) ) ) )).

% no_zero_divisors
thf(fact_246_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_247_divisors__zero,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
        = zero_zero_real )
     => ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% divisors_zero
thf(fact_248_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_249_mult__not__zero,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
       != zero_zero_real )
     => ( ( A != zero_zero_real )
        & ( B != zero_zero_real ) ) ) )).

% mult_not_zero
thf(fact_250_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_251_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_252_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( plus_plus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_253_comm__semiring__class_Odistrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_254_comm__semiring__class_Odistrib,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_255_distrib__left,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( plus_plus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% distrib_left
thf(fact_256_distrib__left,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( plus_plus_nat @ B @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% distrib_left
thf(fact_257_distrib__right,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% distrib_right
thf(fact_258_distrib__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% distrib_right
thf(fact_259_combine__common__factor,axiom,(
    ! [A: real,E: real,B: real,C: real] :
      ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ C ) )
      = ( plus_plus_real @ ( times_times_real @ ( plus_plus_real @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_260_combine__common__factor,axiom,(
    ! [A: nat,E: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ A @ E ) @ ( plus_plus_nat @ ( times_times_nat @ B @ E ) @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_261_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: real] :
      ( ( times_times_real @ one_one_real @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_262_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_263_mult_Ocomm__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ one_one_real )
      = A ) )).

% mult.comm_neutral
thf(fact_264_mult_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.comm_neutral
thf(fact_265_left__diff__distrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% left_diff_distrib
thf(fact_266_right__diff__distrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% right_diff_distrib
thf(fact_267_left__diff__distrib_H,axiom,(
    ! [B: real,C: real,A: real] :
      ( ( times_times_real @ ( minus_minus_real @ B @ C ) @ A )
      = ( minus_minus_real @ ( times_times_real @ B @ A ) @ ( times_times_real @ C @ A ) ) ) )).

% left_diff_distrib'
thf(fact_268_left__diff__distrib_H,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ B @ C ) @ A )
      = ( minus_minus_nat @ ( times_times_nat @ B @ A ) @ ( times_times_nat @ C @ A ) ) ) )).

% left_diff_distrib'
thf(fact_269_right__diff__distrib_H,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% right_diff_distrib'
thf(fact_270_right__diff__distrib_H,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( minus_minus_nat @ B @ C ) )
      = ( minus_minus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% right_diff_distrib'
thf(fact_271_abs__mult,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( times_times_real @ A @ B ) )
      = ( times_times_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_mult
thf(fact_272_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( times_times_real @ C @ A ) @ ( times_times_real @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_273_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_274_zero__le__mult__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) ) ) )).

% zero_le_mult_iff
thf(fact_275_mult__nonneg__nonpos2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ B @ A ) @ zero_zero_real ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_276_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_277_mult__nonpos__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) ) )).

% mult_nonpos_nonneg
thf(fact_278_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_279_mult__nonneg__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) ) )).

% mult_nonneg_nonpos
thf(fact_280_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_281_mult__nonneg__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_282_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_283_split__mult__neg__le,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) )
     => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) )).

% split_mult_neg_le
thf(fact_284_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_285_mult__le__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) ) ) )).

% mult_le_0_iff
thf(fact_286_mult__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_287_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_288_mult__right__mono__neg,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) ) )).

% mult_right_mono_neg
thf(fact_289_mult__left__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( times_times_real @ C @ A ) @ ( times_times_real @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_290_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_291_mult__nonpos__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) ) )).

% mult_nonpos_nonpos
thf(fact_292_mult__left__mono__neg,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ C @ A ) @ ( times_times_real @ C @ B ) ) ) ) )).

% mult_left_mono_neg
thf(fact_293_split__mult__pos__le,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) )
     => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) )).

% split_mult_pos_le
thf(fact_294_zero__le__square,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ A ) ) )).

% zero_le_square
thf(fact_295_mult__mono_H,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ D )
       => ( ( ord_less_eq_real @ zero_zero_real @ A )
         => ( ( ord_less_eq_real @ zero_zero_real @ C )
           => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_296_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_297_mult__mono,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ D )
       => ( ( ord_less_eq_real @ zero_zero_real @ B )
         => ( ( ord_less_eq_real @ zero_zero_real @ C )
           => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_298_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_299_eq__add__iff1,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ C )
        = ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ A @ B ) @ E ) @ C )
        = D ) ) )).

% eq_add_iff1
thf(fact_300_eq__add__iff2,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ C )
        = ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( C
        = ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ B @ A ) @ E ) @ D ) ) ) )).

% eq_add_iff2
thf(fact_301_square__diff__square__factored,axiom,(
    ! [X: real,Y: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) )
      = ( times_times_real @ ( plus_plus_real @ X @ Y ) @ ( minus_minus_real @ X @ Y ) ) ) )).

% square_diff_square_factored
thf(fact_302_synch0,axiom,(
    ! [P: nat] :
      ( ( genClo1163638703lle_te @ P @ zero_zero_nat )
      = zero_zero_real ) )).

% synch0
thf(fact_303_rate__2,axiom,(
    ! [P: nat,S: real,T: real] :
      ( ( ( genClo1015804716orrect @ P @ T )
        & ( ord_less_eq_real @ S @ T ) )
     => ( ord_less_eq_real @ ( times_times_real @ ( minus_minus_real @ T @ S ) @ ( minus_minus_real @ one_one_real @ genClo1144207539le_rho ) ) @ ( minus_minus_real @ ( genClo1161277105lle_PC @ P @ T ) @ ( genClo1161277105lle_PC @ P @ S ) ) ) ) )).

% rate_2
thf(fact_304_rate__1,axiom,(
    ! [P: nat,S: real,T: real] :
      ( ( ( genClo1015804716orrect @ P @ T )
        & ( ord_less_eq_real @ S @ T ) )
     => ( ord_less_eq_real @ ( minus_minus_real @ ( genClo1161277105lle_PC @ P @ T ) @ ( genClo1161277105lle_PC @ P @ S ) ) @ ( times_times_real @ ( minus_minus_real @ T @ S ) @ ( plus_plus_real @ one_one_real @ genClo1144207539le_rho ) ) ) ) )).

% rate_1
thf(fact_305_sum__squares__ge__zero,axiom,(
    ! [X: real,Y: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) ) ) )).

% sum_squares_ge_zero
thf(fact_306_mult__left__le,axiom,(
    ! [C: real,A: real] :
      ( ( ord_less_eq_real @ C @ one_one_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ A )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_307_mult__left__le,axiom,(
    ! [C: nat,A: nat] :
      ( ( ord_less_eq_nat @ C @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_308_mult__le__one,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ one_one_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ( ord_less_eq_real @ B @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ one_one_real ) ) ) ) )).

% mult_le_one
thf(fact_309_mult__le__one,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ one_one_nat ) ) ) ) )).

% mult_le_one
thf(fact_310_mult__right__le__one__le,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ord_less_eq_real @ Y @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ X @ Y ) @ X ) ) ) ) )).

% mult_right_le_one_le
thf(fact_311_mult__left__le__one__le,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ord_less_eq_real @ Y @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ Y @ X ) @ X ) ) ) ) )).

% mult_left_le_one_le
thf(fact_312_ordered__ring__class_Ole__add__iff1,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ A @ E ) @ C ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ A @ B ) @ E ) @ C ) @ D ) ) )).

% ordered_ring_class.le_add_iff1
thf(fact_313_ordered__ring__class_Ole__add__iff2,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ A @ E ) @ C ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( ord_less_eq_real @ C @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ B @ A ) @ E ) @ D ) ) ) )).

% ordered_ring_class.le_add_iff2
thf(fact_314_square__diff__one__factored,axiom,(
    ! [X: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ X ) @ one_one_real )
      = ( times_times_real @ ( plus_plus_real @ X @ one_one_real ) @ ( minus_minus_real @ X @ one_one_real ) ) ) )).

% square_diff_one_factored
thf(fact_315_abs__mult__pos,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( times_times_real @ ( abs_abs_real @ Y ) @ X )
        = ( abs_abs_real @ ( times_times_real @ Y @ X ) ) ) ) )).

% abs_mult_pos
thf(fact_316_abs__eq__mult,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          | ( ord_less_eq_real @ A @ zero_zero_real ) )
        & ( ( ord_less_eq_real @ zero_zero_real @ B )
          | ( ord_less_eq_real @ B @ zero_zero_real ) ) )
     => ( ( abs_abs_real @ ( times_times_real @ A @ B ) )
        = ( times_times_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) ) )).

% abs_eq_mult
thf(fact_317_is__num__normalize_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% is_num_normalize(1)
thf(fact_318_convex__bound__le,axiom,(
    ! [X: real,A: real,Y: real,U: real,V: real] :
      ( ( ord_less_eq_real @ X @ A )
     => ( ( ord_less_eq_real @ Y @ A )
       => ( ( ord_less_eq_real @ zero_zero_real @ U )
         => ( ( ord_less_eq_real @ zero_zero_real @ V )
           => ( ( ( plus_plus_real @ U @ V )
                = one_one_real )
             => ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ U @ X ) @ ( times_times_real @ V @ Y ) ) @ A ) ) ) ) ) ) )).

% convex_bound_le
thf(fact_319_nonoverlap,axiom,(
    ord_less_eq_real @ genClo1278781456e_beta @ genClo1651033342e_rmin )).

% nonoverlap
thf(fact_320_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_real @ zero_zero_real @ zero_zero_real )).

% le_numeral_extra(3)
thf(fact_321_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_322_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_real @ one_one_real @ one_one_real )).

% le_numeral_extra(4)
thf(fact_323_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_324_sum__squares__eq__zero__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) )
        = zero_zero_real )
      = ( ( X = zero_zero_real )
        & ( Y = zero_zero_real ) ) ) )).

% sum_squares_eq_zero_iff
thf(fact_325_rho__bound1__def,axiom,
    ( genClo2108747022bound1
    = ( ^ [C4: nat > real > real] :
        ! [P3: nat,S2: real,T2: real] :
          ( ( ( genClo1015804716orrect @ P3 @ T2 )
            & ( ord_less_eq_real @ S2 @ T2 ) )
         => ( ord_less_eq_real @ ( minus_minus_real @ ( C4 @ P3 @ T2 ) @ ( C4 @ P3 @ S2 ) ) @ ( times_times_real @ ( minus_minus_real @ T2 @ S2 ) @ ( plus_plus_real @ one_one_real @ genClo1144207539le_rho ) ) ) ) ) )).

% rho_bound1_def
thf(fact_326_rho__bound2__def,axiom,
    ( genClo2108747023bound2
    = ( ^ [C4: nat > real > real] :
        ! [P3: nat,S2: real,T2: real] :
          ( ( ( genClo1015804716orrect @ P3 @ T2 )
            & ( ord_less_eq_real @ S2 @ T2 ) )
         => ( ord_less_eq_real @ ( times_times_real @ ( minus_minus_real @ T2 @ S2 ) @ ( minus_minus_real @ one_one_real @ genClo1144207539le_rho ) ) @ ( minus_minus_real @ ( C4 @ P3 @ T2 ) @ ( C4 @ P3 @ S2 ) ) ) ) ) )).

% rho_bound2_def
thf(fact_327_sum__squares__le__zero__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) ) @ zero_zero_real )
      = ( ( X = zero_zero_real )
        & ( Y = zero_zero_real ) ) ) )).

% sum_squares_le_zero_iff
thf(fact_328_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus_nat @ M @ zero_zero_nat )
      = M ) )).

% Nat.add_0_right
thf(fact_329_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        & ( N = zero_zero_nat ) ) ) )).

% add_is_0
thf(fact_330_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_331_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_332_diff__is__0__eq_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_333_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_334_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_335_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_336_diff__is__0__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% diff_is_0_eq
thf(fact_337_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_338_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_339_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_340_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_341_Nat_Odiff__diff__right,axiom,(
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ I2 @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I2 @ K ) @ J ) ) ) )).

% Nat.diff_diff_right
thf(fact_342_Nat_Oadd__diff__assoc2,axiom,(
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I2 )
        = ( minus_minus_nat @ ( plus_plus_nat @ J @ I2 ) @ K ) ) ) )).

% Nat.add_diff_assoc2
thf(fact_343_Nat_Oadd__diff__assoc,axiom,(
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ I2 @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I2 @ J ) @ K ) ) ) )).

% Nat.add_diff_assoc
thf(fact_344_diff__diff__left,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I2 @ J ) @ K )
      = ( minus_minus_nat @ I2 @ ( plus_plus_nat @ J @ K ) ) ) )).

% diff_diff_left
thf(fact_345_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_346_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_347_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_348_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_349_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( abs_abs_real @ ( minus_minus_real @ ( minus_minus_real @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) )
    = ( minus_minus_real @ ( minus_minus_real @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) ) @ ( genClo1161277105lle_PC @ l @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) @ ( minus_minus_real @ ( genClo1163638703lle_te @ p @ ( plus_plus_nat @ i @ one_one_nat ) ) @ ( genClo1163638703lle_te @ q @ ( plus_plus_nat @ i @ one_one_nat ) ) ) ) )).

%------------------------------------------------------------------------------
