%------------------------------------------------------------------------------
% File     : SLH344^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Number_Partition problem prob_64__5324184_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Number_Partition/prob_64__5324184_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  219 (   0 unit;  10 type;   0 defn)
%            Number of atoms       : 1932 ( 178 equality;1063 variable)
%            Maximal formula depth :   14 (   7 average)
%            Number of connectives : 1446 (  79   ~;  23   |;  23   &;1075   @)
%                                         (   0 <=>; 246  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   35 (  35   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   12 (  10   :;   0   =)
%            Number of variables   :  486 (   1 sgn; 445   !;   6   ?;  35   ^)
%                                         ( 486   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:42:15.184
%------------------------------------------------------------------------------
% Could-be-implicit typings (1)
thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (9)
thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Number__Partition__Mirabelle__zerdlymyoj_Opartitions,type,(
    number1551313001itions: ( nat > nat ) > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_i,type,(
    i: nat )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_p,type,(
    p: nat > nat )).

% Relevant facts (208)
thf(fact_0_True,axiom,
    ( ( ord_less_eq_nat @ one_one_nat @ i )
    & ( ord_less_eq_nat @ i @ n ) )).

% True
thf(fact_1__092_060open_062p_Ai_A_K_Ai_A_092_060le_062_An_092_060close_062,axiom,(
    ord_less_eq_nat @ ( times_times_nat @ ( p @ i ) @ i ) @ n )).

% \<open>p i * i \<le> n\<close>
thf(fact_2_assms,axiom,(
    number1551313001itions @ p @ n )).

% assms
thf(fact_3_index__bounds,axiom,(
    ! [I: nat] :
      ( ( ( p @ I )
       != zero_zero_nat )
     => ( ( ord_less_eq_nat @ one_one_nat @ I )
        & ( ord_less_eq_nat @ I @ n ) ) ) )).

% index_bounds
thf(fact_4_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_5_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_6_le__trans,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I2 @ K ) ) ) )).

% le_trans
thf(fact_7_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_8_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_9_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_10_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y: nat] :
            ( ( P @ Y )
           => ( ord_less_eq_nat @ Y @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y2: nat] :
                ( ( P @ Y2 )
               => ( ord_less_eq_nat @ Y2 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_11_bounded__Max__nat,axiom,(
    ! [P: nat > $o,X: nat,M2: nat] :
      ( ( P @ X )
     => ( ! [X2: nat] :
            ( ( P @ X2 )
           => ( ord_less_eq_nat @ X2 @ M2 ) )
       => ~ ! [M3: nat] :
              ( ( P @ M3 )
             => ~ ! [X3: nat] :
                    ( ( P @ X3 )
                   => ( ord_less_eq_nat @ X3 @ M3 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_12_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_13_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_14_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_15_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_16_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_17_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_18_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_19_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_20_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_21_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ one_one_nat @ N )
      = N ) )).

% nat_mult_1
thf(fact_22_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ N @ one_one_nat )
      = N ) )).

% nat_mult_1_right
thf(fact_23_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0
thf(fact_24_mult__eq__self__implies__10,axiom,(
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times_nat @ M @ N ) )
     => ( ( N = one_one_nat )
        | ( M = zero_zero_nat ) ) ) )).

% mult_eq_self_implies_10
thf(fact_25_partitions__zero,axiom,(
    ! [P2: nat > nat] :
      ( ( number1551313001itions @ P2 @ zero_zero_nat )
      = ( P2
        = ( ^ [I3: nat] : zero_zero_nat ) ) ) )).

% partitions_zero
thf(fact_26_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_27_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_28_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_29_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_30_mult__le__mono2,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I2 ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_31_mult__le__mono1,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I2 @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_32_mult__le__mono,axiom,(
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I2 @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_33_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_34_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_35_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_36_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y3: nat,Z: nat] : ( Y3 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_37_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_38_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_39_order__trans,axiom,(
    ! [X: nat,Y4: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
     => ( ( ord_less_eq_nat @ Y4 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_40_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_41_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_42_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_43_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y3: nat,Z: nat] : ( Y3 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_44_antisym__conv,axiom,(
    ! [Y4: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y4 @ X )
     => ( ( ord_less_eq_nat @ X @ Y4 )
        = ( X = Y4 ) ) ) )).

% antisym_conv
thf(fact_45_le__cases3,axiom,(
    ! [X: nat,Y4: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y4 )
       => ~ ( ord_less_eq_nat @ Y4 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y4 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y4 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y4 )
             => ~ ( ord_less_eq_nat @ Y4 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y4 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y4 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_46_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_47_le__cases,axiom,(
    ! [X: nat,Y4: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y4 )
     => ( ord_less_eq_nat @ Y4 @ X ) ) )).

% le_cases
thf(fact_48_eq__refl,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( X = Y4 )
     => ( ord_less_eq_nat @ X @ Y4 ) ) )).

% eq_refl
thf(fact_49_linear,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
      | ( ord_less_eq_nat @ Y4 @ X ) ) )).

% linear
thf(fact_50_antisym,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
     => ( ( ord_less_eq_nat @ Y4 @ X )
       => ( X = Y4 ) ) ) )).

% antisym
thf(fact_51_eq__iff,axiom,
    ( ( ^ [Y3: nat,Z: nat] : ( Y3 = Z ) )
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_52_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_53_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_54_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_55_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_56_mult_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% mult.left_neutral
thf(fact_57_mult_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.right_neutral
thf(fact_58_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_59_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_60_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_61_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_62_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_63_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_64_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_65_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_66_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A2: nat,B2: nat] :
          ( times_times_nat @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_67_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_68_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_69_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_70_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_71_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_72_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_73_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_74_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_75_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_76_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_77_mult_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.comm_neutral
thf(fact_78_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_79_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_80_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_81_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_82_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_83_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_84_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_85_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_86_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_87_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_88_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_89_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_90_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_91_mult__left__le,axiom,(
    ! [C: nat,A: nat] :
      ( ( ord_less_eq_nat @ C @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_92_mult__le__one,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ one_one_nat ) ) ) ) )).

% mult_le_one
thf(fact_93_nat__mult__eq__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( K = zero_zero_nat )
        | ( M = N ) ) ) )).

% nat_mult_eq_cancel_disj
thf(fact_94_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_95_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_96_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_97_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_98_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_99_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_100_nat__mult__less__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel_disj
thf(fact_101_mult__less__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% mult_less_cancel2
thf(fact_102_nat__0__less__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% nat_0_less_mult_iff
thf(fact_103_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one
thf(fact_104_nat__mult__le__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel_disj
thf(fact_105_mult__le__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% mult_le_cancel2
thf(fact_106_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_107_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_108_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_109_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_110_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y4 ) )
      = ( ( ord_less_nat @ Y4 @ X )
        | ( X = Y4 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_111_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_112_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P @ B3 @ A3 )
             => ( P @ A3 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_113_exists__least__iff,axiom,
    ( ( ^ [P3: nat > $o] :
        ? [X5: nat] :
          ( P3 @ X5 ) )
    = ( ^ [P4: nat > $o] :
        ? [N2: nat] :
          ( ( P4 @ N2 )
          & ! [M4: nat] :
              ( ( ord_less_nat @ M4 @ N2 )
             => ~ ( P4 @ M4 ) ) ) ) )).

% exists_least_iff
thf(fact_114_less__imp__not__less,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ~ ( ord_less_nat @ Y4 @ X ) ) )).

% less_imp_not_less
thf(fact_115_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_116_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_117_linorder__cases,axiom,(
    ! [X: nat,Y4: nat] :
      ( ~ ( ord_less_nat @ X @ Y4 )
     => ( ( X != Y4 )
       => ( ord_less_nat @ Y4 @ X ) ) ) )).

% linorder_cases
thf(fact_118_less__imp__triv,axiom,(
    ! [X: nat,Y4: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( ( ord_less_nat @ Y4 @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_119_less__imp__not__eq2,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( Y4 != X ) ) )).

% less_imp_not_eq2
thf(fact_120_antisym__conv3,axiom,(
    ! [Y4: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y4 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y4 ) )
        = ( X = Y4 ) ) ) )).

% antisym_conv3
thf(fact_121_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y2: nat] :
              ( ( ord_less_nat @ Y2 @ X2 )
             => ( P @ Y2 ) )
         => ( P @ X2 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_122_less__not__sym,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ~ ( ord_less_nat @ Y4 @ X ) ) )).

% less_not_sym
thf(fact_123_less__imp__not__eq,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( X != Y4 ) ) )).

% less_imp_not_eq
thf(fact_124_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_125_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_126_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_127_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_128_less__linear,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
      | ( X = Y4 )
      | ( ord_less_nat @ Y4 @ X ) ) )).

% less_linear
thf(fact_129_less__trans,axiom,(
    ! [X: nat,Y4: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( ( ord_less_nat @ Y4 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_130_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_131_less__asym,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ~ ( ord_less_nat @ Y4 @ X ) ) )).

% less_asym
thf(fact_132_less__imp__neq,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( X != Y4 ) ) )).

% less_imp_neq
thf(fact_133_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_134_neq__iff,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( X != Y4 )
      = ( ( ord_less_nat @ X @ Y4 )
        | ( ord_less_nat @ Y4 @ X ) ) ) )).

% neq_iff
thf(fact_135_neqE,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( X != Y4 )
     => ( ~ ( ord_less_nat @ X @ Y4 )
       => ( ord_less_nat @ Y4 @ X ) ) ) )).

% neqE
thf(fact_136_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_137_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_138_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_139_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_140_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_141_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_142_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_143_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_144_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_145_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_146_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_147_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_148_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_149_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_150_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_151_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_152_not__le__imp__less,axiom,(
    ! [Y4: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y4 @ X )
     => ( ord_less_nat @ X @ Y4 ) ) )).

% not_le_imp_less
thf(fact_153_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_154_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
     => ( ( ord_less_nat @ X @ Y4 )
        | ( X = Y4 ) ) ) )).

% le_imp_less_or_eq
thf(fact_155_le__less__linear,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
      | ( ord_less_nat @ Y4 @ X ) ) )).

% le_less_linear
thf(fact_156_less__le__trans,axiom,(
    ! [X: nat,Y4: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( ( ord_less_eq_nat @ Y4 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_157_le__less__trans,axiom,(
    ! [X: nat,Y4: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
     => ( ( ord_less_nat @ Y4 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_158_less__imp__le,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_nat @ X @ Y4 )
     => ( ord_less_eq_nat @ X @ Y4 ) ) )).

% less_imp_le
thf(fact_159_antisym__conv2,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ord_less_eq_nat @ X @ Y4 )
     => ( ( ~ ( ord_less_nat @ X @ Y4 ) )
        = ( X = Y4 ) ) ) )).

% antisym_conv2
thf(fact_160_antisym__conv1,axiom,(
    ! [X: nat,Y4: nat] :
      ( ~ ( ord_less_nat @ X @ Y4 )
     => ( ( ord_less_eq_nat @ X @ Y4 )
        = ( X = Y4 ) ) ) )).

% antisym_conv1
thf(fact_161_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_162_not__less,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y4 ) )
      = ( ord_less_eq_nat @ Y4 @ X ) ) )).

% not_less
thf(fact_163_not__le,axiom,(
    ! [X: nat,Y4: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y4 ) )
      = ( ord_less_nat @ Y4 @ X ) ) )).

% not_le
thf(fact_164_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_165_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_166_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_167_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_168_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( X4 != Y5 ) ) ) )).

% less_le
thf(fact_169_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_nat @ X4 @ Y5 )
          | ( X4 = Y5 ) ) ) )).

% le_less
thf(fact_170_leI,axiom,(
    ! [X: nat,Y4: nat] :
      ( ~ ( ord_less_nat @ X @ Y4 )
     => ( ord_less_eq_nat @ Y4 @ X ) ) )).

% leI
thf(fact_171_leD,axiom,(
    ! [Y4: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y4 @ X )
     => ~ ( ord_less_nat @ X @ Y4 ) ) )).

% leD
thf(fact_172_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_173_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_174_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_175_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_176_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_177_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_178_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_179_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_180_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_181_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N3: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M5: nat] :
                  ( ( ord_less_nat @ M5 @ N3 )
                  & ~ ( P @ M5 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_182_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_183_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I2: nat,J: nat] :
      ( ! [I4: nat,J2: nat] :
          ( ( ord_less_nat @ I4 @ J2 )
         => ( ord_less_nat @ ( F @ I4 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I2 @ J )
       => ( ord_less_eq_nat @ ( F @ I2 ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_184_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_185_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_186_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M4: nat,N2: nat] :
          ( ( ord_less_nat @ M4 @ N2 )
          | ( M4 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_187_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_188_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M4: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M4 @ N2 )
          & ( M4 != N2 ) ) ) )).

% nat_less_le
thf(fact_189_less__numeral__extra_I1_J,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% less_numeral_extra(1)
thf(fact_190_nat__mult__eq__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ( times_times_nat @ K @ M )
          = ( times_times_nat @ K @ N ) )
        = ( M = N ) ) ) )).

% nat_mult_eq_cancel1
thf(fact_191_nat__mult__less__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel1
thf(fact_192_mult__neg__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ zero_zero_nat )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_neg_pos
thf(fact_193_mult__pos__neg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg
thf(fact_194_mult__pos__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_pos_pos
thf(fact_195_mult__pos__neg2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg2
thf(fact_196_zero__less__mult__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos
thf(fact_197_zero__less__mult__pos2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ B @ A ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos2
thf(fact_198_mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_strict_left_mono
thf(fact_199_mult__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_strict_right_mono
thf(fact_200_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_201_zero__less__one,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% zero_less_one
thf(fact_202_not__one__less__zero,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_less_zero
thf(fact_203_less__1__mult,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ one_one_nat @ M )
     => ( ( ord_less_nat @ one_one_nat @ N )
       => ( ord_less_nat @ one_one_nat @ ( times_times_nat @ M @ N ) ) ) ) )).

% less_1_mult
thf(fact_204_nat__mult__le__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel1
thf(fact_205_ex__least__nat__le,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I: nat] :
                ( ( ord_less_nat @ I @ K2 )
               => ~ ( P @ I ) )
            & ( P @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_206_mult__less__mono1,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I2 @ J )
     => ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_nat @ ( times_times_nat @ I2 @ K ) @ ( times_times_nat @ J @ K ) ) ) ) )).

% mult_less_mono1
thf(fact_207_mult__less__mono2,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I2 @ J )
     => ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_nat @ ( times_times_nat @ K @ I2 ) @ ( times_times_nat @ K @ J ) ) ) ) )).

% mult_less_mono2

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_nat @ ( p @ i ) @ n )).

%------------------------------------------------------------------------------
