%------------------------------------------------------------------------------
% File     : SLH345^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Number_Partition problem prob_63__5324152_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Number_Partition/prob_63__5324152_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  276 (   0 unit;  23 type;   0 defn)
%            Number of atoms       : 2746 ( 296 equality;1524 variable)
%            Maximal formula depth :   17 (   8 average)
%            Number of connectives : 1953 (  52   ~;  13   |;  46   &;1552   @)
%                                         (   0 <=>; 290  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   93 (  93   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   25 (  23   :;   0   =)
%            Number of variables   :  709 (   3 sgn; 625   !;   7   ?;  77   ^)
%                                         ( 709   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:42:13.924
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    set_set_nat: $tType )).

thf(ty_n_t__Set__Oset_It__Nat__Onat_J,type,(
    set_nat: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (20)
thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_001t__Nat__Onat_001t__Nat__Onat,type,(
    groups1842438620at_nat: ( nat > nat ) > set_nat > nat )).

thf(sy_c_Number__Partition__Mirabelle__zerdlymyoj_Opartitions,type,(
    number1551313001itions: ( nat > nat ) > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001_062_It__Nat__Onat_M_Eo_J,type,(
    ord_less_eq_nat_o: ( nat > $o ) > ( nat > $o ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Nat__Onat_J,type,(
    ord_less_eq_set_nat: set_nat > set_nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    ord_le1613022364et_nat: set_set_nat > set_set_nat > $o )).

thf(sy_c_Set_OCollect_001t__Nat__Onat,type,(
    collect_nat: ( nat > $o ) > set_nat )).

thf(sy_c_Set_OCollect_001t__Set__Oset_It__Nat__Onat_J,type,(
    collect_set_nat: ( set_nat > $o ) > set_set_nat )).

thf(sy_c_Set_Oinsert_001t__Nat__Onat,type,(
    insert_nat: nat > set_nat > set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Nat__Onat,type,(
    set_ord_atMost_nat: nat > set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Set__Oset_It__Nat__Onat_J,type,(
    set_or1086813439et_nat: set_nat > set_set_nat )).

thf(sy_c_member_001t__Nat__Onat,type,(
    member_nat: nat > set_nat > $o )).

thf(sy_c_member_001t__Set__Oset_It__Nat__Onat_J,type,(
    member_set_nat: set_nat > set_set_nat > $o )).

thf(sy_v_i,type,(
    i: nat )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_p,type,(
    p: nat > nat )).

% Relevant facts (252)
thf(fact_0_assms,axiom,(
    number1551313001itions @ p @ n )).

% assms
thf(fact_1_True,axiom,
    ( ( ord_less_eq_nat @ one_one_nat @ i )
    & ( ord_less_eq_nat @ i @ n ) )).

% True
thf(fact_2_order__refl,axiom,(
    ! [X: set_nat] :
      ( ord_less_eq_set_nat @ X @ X ) )).

% order_refl
thf(fact_3_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_4__092_060open_062p_Ai_A_K_Ai_A_L_A_I_092_060Sum_062i_092_060in_062_123i_H_O_Ai_H_A_092_060le_062_An_A_092_060and_062_Ai_H_A_092_060noteq_062_Ai_125_O_Ap_Ai_A_K_Ai_J_A_061_An_092_060close_062,axiom,
    ( ( plus_plus_nat @ ( times_times_nat @ ( p @ i ) @ i )
      @ ( groups1842438620at_nat
        @ ^ [I: nat] :
            ( times_times_nat @ ( p @ I ) @ I )
        @ ( collect_nat
          @ ^ [I2: nat] :
              ( ( ord_less_eq_nat @ I2 @ n )
              & ( I2 != i ) ) ) ) )
    = n )).

% \<open>p i * i + (\<Sum>i\<in>{i'. i' \<le> n \<and> i' \<noteq> i}. p i * i) = n\<close>
thf(fact_5_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_6_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_7_mult__le__mono,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I3 @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_8_mult__le__mono1,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I3 @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_9_mult__le__mono2,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I3 ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_10_index__bounds,axiom,(
    ! [I4: nat] :
      ( ( ( p @ I4 )
       != zero_zero_nat )
     => ( ( ord_less_eq_nat @ one_one_nat @ I4 )
        & ( ord_less_eq_nat @ I4 @ n ) ) ) )).

% index_bounds
thf(fact_11_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_12_le__trans,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I3 @ K ) ) ) )).

% le_trans
thf(fact_13_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_14_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_15_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_16_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_17_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        & ( N = zero_zero_nat ) ) ) )).

% add_is_0
thf(fact_18_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus_nat @ M @ zero_zero_nat )
      = M ) )).

% Nat.add_0_right
thf(fact_19_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_20_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_21_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_22_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_23_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_24_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_25_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_26_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_27_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = M )
     => ( N = zero_zero_nat ) ) )).

% add_eq_self_zero
thf(fact_28_mult__eq__self__implies__10,axiom,(
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times_nat @ M @ N ) )
     => ( ( N = one_one_nat )
        | ( M = zero_zero_nat ) ) ) )).

% mult_eq_self_implies_10
thf(fact_29_partitions__zero,axiom,(
    ! [P: nat > nat] :
      ( ( number1551313001itions @ P @ zero_zero_nat )
      = ( P
        = ( ^ [I: nat] : zero_zero_nat ) ) ) )).

% partitions_zero
thf(fact_30_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_31_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_32_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_33_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_34_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ N @ one_one_nat )
      = N ) )).

% nat_mult_1_right
thf(fact_35_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ one_one_nat @ N )
      = N ) )).

% nat_mult_1
thf(fact_36_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0
thf(fact_37_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus_nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_38_trans__le__add2,axiom,(
    ! [I3: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ I3 @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_39_trans__le__add1,axiom,(
    ! [I3: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ I3 @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_40_add__le__mono1,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I3 @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_41_add__le__mono,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I3 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_42_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus_nat @ K @ N3 ) ) ) )).

% le_Suc_ex
thf(fact_43_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_44_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: nat,P2: nat > $o] :
      ( ( member_nat @ A @ ( collect_nat @ P2 ) )
      = ( P2 @ A ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A2: set_nat] :
      ( ( collect_nat
        @ ^ [X2: nat] :
            ( member_nat @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [P2: nat > $o,Q: nat > $o] :
      ( ! [X3: nat] :
          ( ( P2 @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect_nat @ P2 )
        = ( collect_nat @ Q ) ) ) )).

% Collect_cong
thf(fact_48_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_49_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_50_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_51_add__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( plus_plus_nat @ M @ N ) )
      = ( plus_plus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% add_mult_distrib2
thf(fact_52_add__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ M @ N ) @ K )
      = ( plus_plus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% add_mult_distrib
thf(fact_53_dual__order_Oantisym,axiom,(
    ! [B: set_nat,A: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_54_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_55_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: set_nat,Z: set_nat] : ( Y = Z ) )
    = ( ^ [A3: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ B2 @ A3 )
          & ( ord_less_eq_set_nat @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_56_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A3 )
          & ( ord_less_eq_nat @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_57_dual__order_Otrans,axiom,(
    ! [B: set_nat,A: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ C @ B )
       => ( ord_less_eq_set_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_58_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_59_linorder__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A4 @ B3 )
         => ( P2 @ A4 @ B3 ) )
     => ( ! [A4: nat,B3: nat] :
            ( ( P2 @ B3 @ A4 )
           => ( P2 @ A4 @ B3 ) )
       => ( P2 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_60_dual__order_Orefl,axiom,(
    ! [A: set_nat] :
      ( ord_less_eq_set_nat @ A @ A ) )).

% dual_order.refl
thf(fact_61_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_62_order__trans,axiom,(
    ! [X: set_nat,Y2: set_nat,Z2: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y2 )
     => ( ( ord_less_eq_set_nat @ Y2 @ Z2 )
       => ( ord_less_eq_set_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_63_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_64_order__class_Oorder_Oantisym,axiom,(
    ! [A: set_nat,B: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_65_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_66_ord__le__eq__trans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_67_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_68_ord__eq__le__trans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( A = B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_69_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_70_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: set_nat,Z: set_nat] : ( Y = Z ) )
    = ( ^ [A3: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ A3 @ B2 )
          & ( ord_less_eq_set_nat @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_71_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A3 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_72_antisym__conv,axiom,(
    ! [Y2: set_nat,X: set_nat] :
      ( ( ord_less_eq_set_nat @ Y2 @ X )
     => ( ( ord_less_eq_set_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_73_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_74_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_75_order_Otrans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_76_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_77_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_78_eq__refl,axiom,(
    ! [X: set_nat,Y2: set_nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_set_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_79_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_80_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_81_antisym,axiom,(
    ! [X: set_nat,Y2: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y2 )
     => ( ( ord_less_eq_set_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_82_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_83_eq__iff,axiom,
    ( ( ^ [Y: set_nat,Z: set_nat] : ( Y = Z ) )
    = ( ^ [X2: set_nat,Y3: set_nat] :
          ( ( ord_less_eq_set_nat @ X2 @ Y3 )
          & ( ord_less_eq_set_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_84_eq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_85_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_86_ord__le__eq__subst,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_87_ord__le__eq__subst,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_88_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_89_ord__eq__le__subst,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_90_ord__eq__le__subst,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_91_ord__eq__le__subst,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_92_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_93_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_94_order__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_95_order__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_96_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_97_order__subst1,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_98_order__subst1,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_99_order__subst1,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y4: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y4 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_100_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_101_Nat_Oex__has__greatest__nat,axiom,(
    ! [P2: nat > $o,K: nat,B: nat] :
      ( ( P2 @ K )
     => ( ! [Y4: nat] :
            ( ( P2 @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X3: nat] :
            ( ( P2 @ X3 )
            & ! [Y5: nat] :
                ( ( P2 @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_102_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_103__092_060open_062_I_092_060Sum_062i_092_060in_062insert_Ai_A_123i_H_O_Ai_H_A_092_060le_062_An_A_092_060and_062_Ai_H_A_092_060noteq_062_Ai_125_O_Ap_Ai_A_K_Ai_J_A_061_An_092_060close_062,axiom,
    ( ( groups1842438620at_nat
      @ ^ [I: nat] :
          ( times_times_nat @ ( p @ I ) @ I )
      @ ( insert_nat @ i
        @ ( collect_nat
          @ ^ [I2: nat] :
              ( ( ord_less_eq_nat @ I2 @ n )
              & ( I2 != i ) ) ) ) )
    = n )).

% \<open>(\<Sum>i\<in>insert i {i'. i' \<le> n \<and> i' \<noteq> i}. p i * i) = n\<close>
thf(fact_104_le__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel2
thf(fact_105_le__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel1
thf(fact_106_add__le__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel2
thf(fact_107_add__le__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel1
thf(fact_108_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_109_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_110_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_111_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_112_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_113_zero__eq__add__iff__both__eq__0,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( zero_zero_nat
        = ( plus_plus_nat @ X @ Y2 ) )
      = ( ( X = zero_zero_nat )
        & ( Y2 = zero_zero_nat ) ) ) )).

% zero_eq_add_iff_both_eq_0
thf(fact_114_add__eq__0__iff__both__eq__0,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ( plus_plus_nat @ X @ Y2 )
        = zero_zero_nat )
      = ( ( X = zero_zero_nat )
        & ( Y2 = zero_zero_nat ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_115_add__cancel__right__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ A @ B ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_right
thf(fact_116_add__cancel__right__left,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ B @ A ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_left
thf(fact_117_add__cancel__left__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_right
thf(fact_118_add__cancel__left__left,axiom,(
    ! [B: nat,A: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_left
thf(fact_119_add_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.right_neutral
thf(fact_120_add_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% add.left_neutral
thf(fact_121_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_122_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_123_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_124_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_125_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_126_mult_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% mult.left_neutral
thf(fact_127_mult_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.right_neutral
thf(fact_128_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_129_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_130_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_131_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_132_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A3: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A3 ) ) )).

% add.commute
thf(fact_133_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_134_group__cancel_Oadd2,axiom,(
    ! [B4: nat,K: nat,B: nat,A: nat] :
      ( ( B4
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B4 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_135_group__cancel_Oadd1,axiom,(
    ! [A2: nat,K: nat,A: nat,B: nat] :
      ( ( A2
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A2 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_136_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ( I3 = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I3 @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_137_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_138_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_139_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_140_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A3: nat,B2: nat] :
          ( times_times_nat @ B2 @ A3 ) ) )).

% mult.commute
thf(fact_141_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_142_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_143_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_144_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I3 @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I3 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_145_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ( I3 = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I3 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_146_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I3 @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I3 @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_147_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_148_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_149_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C2: nat] :
            ( B
           != ( plus_plus_nat @ A @ C2 ) ) ) )).

% less_eqE
thf(fact_150_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_151_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B2: nat] :
        ? [C3: nat] :
          ( B2
          = ( plus_plus_nat @ A3 @ C3 ) ) ) )).

% le_iff_add
thf(fact_152_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_153_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_154_add_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.comm_neutral
thf(fact_155_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_156_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_157_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_158_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_159_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_160_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_161_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_162_comm__semiring__class_Odistrib,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_163_distrib__left,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( plus_plus_nat @ B @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% distrib_left
thf(fact_164_distrib__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% distrib_right
thf(fact_165_combine__common__factor,axiom,(
    ! [A: nat,E: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ A @ E ) @ ( plus_plus_nat @ ( times_times_nat @ B @ E ) @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_166_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_167_mult_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.comm_neutral
thf(fact_168_lambda__zero,axiom,
    ( ( ^ [H: nat] : zero_zero_nat )
    = ( times_times_nat @ zero_zero_nat ) )).

% lambda_zero
thf(fact_169_lambda__one,axiom,
    ( ( ^ [X2: nat] : X2 )
    = ( times_times_nat @ one_one_nat ) )).

% lambda_one
thf(fact_170_add__decreasing,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_171_add__increasing,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_172_add__decreasing2,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_173_add__increasing2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ C )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_174_add__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_175_add__nonpos__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_nonpos_nonpos
thf(fact_176_add__nonneg__eq__0__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ X )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ Y2 )
       => ( ( ( plus_plus_nat @ X @ Y2 )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y2 = zero_zero_nat ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_177_add__nonpos__eq__0__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ Y2 @ zero_zero_nat )
       => ( ( ( plus_plus_nat @ X @ Y2 )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y2 = zero_zero_nat ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_178_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_179_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_180_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_181_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_182_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_183_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_184_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_185_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_186_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_187_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_188_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_189_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_190_mult__le__one,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ one_one_nat ) ) ) ) )).

% mult_le_one
thf(fact_191_mult__left__le,axiom,(
    ! [C: nat,A: nat] :
      ( ( ord_less_eq_nat @ C @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_192_sum_Oneutral__const,axiom,(
    ! [A2: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [Uu: nat] : zero_zero_nat
        @ A2 )
      = zero_zero_nat ) )).

% sum.neutral_const
thf(fact_193_sum,axiom,
    ( ( groups1842438620at_nat
      @ ^ [I: nat] :
          ( times_times_nat @ ( p @ I ) @ I )
      @ ( set_ord_atMost_nat @ n ) )
    = n )).

% sum
thf(fact_194__092_060open_062_123_O_On_125_A_061_Ainsert_Ai_A_123i_H_O_Ai_H_A_092_060le_062_An_A_092_060and_062_Ai_H_A_092_060noteq_062_Ai_125_092_060close_062,axiom,
    ( ( set_ord_atMost_nat @ n )
    = ( insert_nat @ i
      @ ( collect_nat
        @ ^ [I2: nat] :
            ( ( ord_less_eq_nat @ I2 @ n )
            & ( I2 != i ) ) ) ) )).

% \<open>{..n} = insert i {i'. i' \<le> n \<and> i' \<noteq> i}\<close>
thf(fact_195_sum__nonneg,axiom,(
    ! [A2: set_nat,F: nat > nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A2 )
         => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ X3 ) ) )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( groups1842438620at_nat @ F @ A2 ) ) ) )).

% sum_nonneg
thf(fact_196_sum_Ocong,axiom,(
    ! [A2: set_nat,B4: set_nat,G: nat > nat,H2: nat > nat] :
      ( ( A2 = B4 )
     => ( ! [X3: nat] :
            ( ( member_nat @ X3 @ B4 )
           => ( ( G @ X3 )
              = ( H2 @ X3 ) ) )
       => ( ( groups1842438620at_nat @ G @ A2 )
          = ( groups1842438620at_nat @ H2 @ B4 ) ) ) ) )).

% sum.cong
thf(fact_197_sum_Oeq__general,axiom,(
    ! [B4: set_nat,A2: set_nat,H2: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y4: nat] :
          ( ( member_nat @ Y4 @ B4 )
         => ? [X4: nat] :
              ( ( member_nat @ X4 @ A2 )
              & ( ( H2 @ X4 )
                = Y4 )
              & ! [Ya: nat] :
                  ( ( ( member_nat @ Ya @ A2 )
                    & ( ( H2 @ Ya )
                      = Y4 ) )
                 => ( Ya = X4 ) ) ) )
     => ( ! [X3: nat] :
            ( ( member_nat @ X3 @ A2 )
           => ( ( member_nat @ ( H2 @ X3 ) @ B4 )
              & ( ( Gamma @ ( H2 @ X3 ) )
                = ( Phi @ X3 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A2 )
          = ( groups1842438620at_nat @ Gamma @ B4 ) ) ) ) )).

% sum.eq_general
thf(fact_198_sum_Oeq__general__inverses,axiom,(
    ! [B4: set_nat,K: nat > nat,A2: set_nat,H2: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y4: nat] :
          ( ( member_nat @ Y4 @ B4 )
         => ( ( member_nat @ ( K @ Y4 ) @ A2 )
            & ( ( H2 @ ( K @ Y4 ) )
              = Y4 ) ) )
     => ( ! [X3: nat] :
            ( ( member_nat @ X3 @ A2 )
           => ( ( member_nat @ ( H2 @ X3 ) @ B4 )
              & ( ( K @ ( H2 @ X3 ) )
                = X3 )
              & ( ( Gamma @ ( H2 @ X3 ) )
                = ( Phi @ X3 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A2 )
          = ( groups1842438620at_nat @ Gamma @ B4 ) ) ) ) )).

% sum.eq_general_inverses
thf(fact_199_sum_Oreindex__bij__witness,axiom,(
    ! [S: set_nat,I3: nat > nat,J: nat > nat,T: set_nat,H2: nat > nat,G: nat > nat] :
      ( ! [A4: nat] :
          ( ( member_nat @ A4 @ S )
         => ( ( I3 @ ( J @ A4 ) )
            = A4 ) )
     => ( ! [A4: nat] :
            ( ( member_nat @ A4 @ S )
           => ( member_nat @ ( J @ A4 ) @ T ) )
       => ( ! [B3: nat] :
              ( ( member_nat @ B3 @ T )
             => ( ( J @ ( I3 @ B3 ) )
                = B3 ) )
         => ( ! [B3: nat] :
                ( ( member_nat @ B3 @ T )
               => ( member_nat @ ( I3 @ B3 ) @ S ) )
           => ( ! [A4: nat] :
                  ( ( member_nat @ A4 @ S )
                 => ( ( H2 @ ( J @ A4 ) )
                    = ( G @ A4 ) ) )
             => ( ( groups1842438620at_nat @ G @ S )
                = ( groups1842438620at_nat @ H2 @ T ) ) ) ) ) ) ) )).

% sum.reindex_bij_witness
thf(fact_200_sum_Oswap,axiom,(
    ! [G: nat > nat > nat,B4: set_nat,A2: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [I: nat] :
            ( groups1842438620at_nat @ ( G @ I ) @ B4 )
        @ A2 )
      = ( groups1842438620at_nat
        @ ^ [J2: nat] :
            ( groups1842438620at_nat
            @ ^ [I: nat] :
                ( G @ I @ J2 )
            @ A2 )
        @ B4 ) ) )).

% sum.swap
thf(fact_201_partitionsE,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ( number1551313001itions @ P @ N )
     => ~ ( ! [I4: nat] :
              ( ( ( P @ I4 )
               != zero_zero_nat )
             => ( ( ord_less_eq_nat @ one_one_nat @ I4 )
                & ( ord_less_eq_nat @ I4 @ N ) ) )
         => ( ( groups1842438620at_nat
              @ ^ [I: nat] :
                  ( times_times_nat @ ( P @ I ) @ I )
              @ ( set_ord_atMost_nat @ N ) )
           != N ) ) ) )).

% partitionsE
thf(fact_202_partitionsI,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ! [I5: nat] :
          ( ( ( P @ I5 )
           != zero_zero_nat )
         => ( ( ord_less_eq_nat @ one_one_nat @ I5 )
            & ( ord_less_eq_nat @ I5 @ N ) ) )
     => ( ( ( groups1842438620at_nat
            @ ^ [I: nat] :
                ( times_times_nat @ ( P @ I ) @ I )
            @ ( set_ord_atMost_nat @ N ) )
          = N )
       => ( number1551313001itions @ P @ N ) ) ) )).

% partitionsI
thf(fact_203_partitions__def,axiom,
    ( number1551313001itions
    = ( ^ [P3: nat > nat,N2: nat] :
          ( ! [I: nat] :
              ( ( ( P3 @ I )
               != zero_zero_nat )
             => ( ( ord_less_eq_nat @ one_one_nat @ I )
                & ( ord_less_eq_nat @ I @ N2 ) ) )
          & ( ( groups1842438620at_nat
              @ ^ [I: nat] :
                  ( times_times_nat @ ( P3 @ I ) @ I )
              @ ( set_ord_atMost_nat @ N2 ) )
            = N2 ) ) ) )).

% partitions_def
thf(fact_204_sum_Oneutral,axiom,(
    ! [A2: set_nat,G: nat > nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A2 )
         => ( ( G @ X3 )
            = zero_zero_nat ) )
     => ( ( groups1842438620at_nat @ G @ A2 )
        = zero_zero_nat ) ) )).

% sum.neutral
thf(fact_205_sum_Onot__neutral__contains__not__neutral,axiom,(
    ! [G: nat > nat,A2: set_nat] :
      ( ( ( groups1842438620at_nat @ G @ A2 )
       != zero_zero_nat )
     => ~ ! [A4: nat] :
            ( ( member_nat @ A4 @ A2 )
           => ( ( G @ A4 )
              = zero_zero_nat ) ) ) )).

% sum.not_neutral_contains_not_neutral
thf(fact_206_sum__mono,axiom,(
    ! [K3: set_nat,F: nat > nat,G: nat > nat] :
      ( ! [I5: nat] :
          ( ( member_nat @ I5 @ K3 )
         => ( ord_less_eq_nat @ ( F @ I5 ) @ ( G @ I5 ) ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ K3 ) @ ( groups1842438620at_nat @ G @ K3 ) ) ) )).

% sum_mono
thf(fact_207_sum_Odistrib,axiom,(
    ! [G: nat > nat,H2: nat > nat,A2: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [X2: nat] :
            ( plus_plus_nat @ ( G @ X2 ) @ ( H2 @ X2 ) )
        @ A2 )
      = ( plus_plus_nat @ ( groups1842438620at_nat @ G @ A2 ) @ ( groups1842438620at_nat @ H2 @ A2 ) ) ) )).

% sum.distrib
thf(fact_208_sum__product,axiom,(
    ! [F: nat > nat,A2: set_nat,G: nat > nat,B4: set_nat] :
      ( ( times_times_nat @ ( groups1842438620at_nat @ F @ A2 ) @ ( groups1842438620at_nat @ G @ B4 ) )
      = ( groups1842438620at_nat
        @ ^ [I: nat] :
            ( groups1842438620at_nat
            @ ^ [J2: nat] :
                ( times_times_nat @ ( F @ I ) @ ( G @ J2 ) )
            @ B4 )
        @ A2 ) ) )).

% sum_product
thf(fact_209_sum__distrib__left,axiom,(
    ! [R: nat,F: nat > nat,A2: set_nat] :
      ( ( times_times_nat @ R @ ( groups1842438620at_nat @ F @ A2 ) )
      = ( groups1842438620at_nat
        @ ^ [N2: nat] :
            ( times_times_nat @ R @ ( F @ N2 ) )
        @ A2 ) ) )).

% sum_distrib_left
thf(fact_210_sum__distrib__right,axiom,(
    ! [F: nat > nat,A2: set_nat,R: nat] :
      ( ( times_times_nat @ ( groups1842438620at_nat @ F @ A2 ) @ R )
      = ( groups1842438620at_nat
        @ ^ [N2: nat] :
            ( times_times_nat @ ( F @ N2 ) @ R )
        @ A2 ) ) )).

% sum_distrib_right
thf(fact_211_sum__nonpos,axiom,(
    ! [A2: set_nat,F: nat > nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A2 )
         => ( ord_less_eq_nat @ ( F @ X3 ) @ zero_zero_nat ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ A2 ) @ zero_zero_nat ) ) )).

% sum_nonpos
thf(fact_212_atMost__subset__iff,axiom,(
    ! [X: set_nat,Y2: set_nat] :
      ( ( ord_le1613022364et_nat @ ( set_or1086813439et_nat @ X ) @ ( set_or1086813439et_nat @ Y2 ) )
      = ( ord_less_eq_set_nat @ X @ Y2 ) ) )).

% atMost_subset_iff
thf(fact_213_atMost__subset__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_set_nat @ ( set_ord_atMost_nat @ X ) @ ( set_ord_atMost_nat @ Y2 ) )
      = ( ord_less_eq_nat @ X @ Y2 ) ) )).

% atMost_subset_iff
thf(fact_214_atMost__iff,axiom,(
    ! [I3: set_nat,K: set_nat] :
      ( ( member_set_nat @ I3 @ ( set_or1086813439et_nat @ K ) )
      = ( ord_less_eq_set_nat @ I3 @ K ) ) )).

% atMost_iff
thf(fact_215_atMost__iff,axiom,(
    ! [I3: nat,K: nat] :
      ( ( member_nat @ I3 @ ( set_ord_atMost_nat @ K ) )
      = ( ord_less_eq_nat @ I3 @ K ) ) )).

% atMost_iff
thf(fact_216_atMost__eq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ( set_ord_atMost_nat @ X )
        = ( set_ord_atMost_nat @ Y2 ) )
      = ( X = Y2 ) ) )).

% atMost_eq_iff
thf(fact_217_bounded__Max__nat,axiom,(
    ! [P2: nat > $o,X: nat,M3: nat] :
      ( ( P2 @ X )
     => ( ! [X3: nat] :
            ( ( P2 @ X3 )
           => ( ord_less_eq_nat @ X3 @ M3 ) )
       => ~ ! [M4: nat] :
              ( ( P2 @ M4 )
             => ~ ! [X4: nat] :
                    ( ( P2 @ X4 )
                   => ( ord_less_eq_nat @ X4 @ M4 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_218_atMost__def,axiom,
    ( set_or1086813439et_nat
    = ( ^ [U: set_nat] :
          ( collect_set_nat
          @ ^ [X2: set_nat] :
              ( ord_less_eq_set_nat @ X2 @ U ) ) ) )).

% atMost_def
thf(fact_219_atMost__def,axiom,
    ( set_ord_atMost_nat
    = ( ^ [U: nat] :
          ( collect_nat
          @ ^ [X2: nat] :
              ( ord_less_eq_nat @ X2 @ U ) ) ) )).

% atMost_def
thf(fact_220_insert__subset,axiom,(
    ! [X: nat,A2: set_nat,B4: set_nat] :
      ( ( ord_less_eq_set_nat @ ( insert_nat @ X @ A2 ) @ B4 )
      = ( ( member_nat @ X @ B4 )
        & ( ord_less_eq_set_nat @ A2 @ B4 ) ) ) )).

% insert_subset
thf(fact_221_add__scale__eq__noteq,axiom,(
    ! [R: nat,A: nat,B: nat,C: nat,D: nat] :
      ( ( R != zero_zero_nat )
     => ( ( ( A = B )
          & ( C != D ) )
       => ( ( plus_plus_nat @ A @ ( times_times_nat @ R @ C ) )
         != ( plus_plus_nat @ B @ ( times_times_nat @ R @ D ) ) ) ) ) )).

% add_scale_eq_noteq
thf(fact_222_subsetI,axiom,(
    ! [A2: set_nat,B4: set_nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A2 )
         => ( member_nat @ X3 @ B4 ) )
     => ( ord_less_eq_set_nat @ A2 @ B4 ) ) )).

% subsetI
thf(fact_223_subset__antisym,axiom,(
    ! [A2: set_nat,B4: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B4 )
     => ( ( ord_less_eq_set_nat @ B4 @ A2 )
       => ( A2 = B4 ) ) ) )).

% subset_antisym
thf(fact_224_insertCI,axiom,(
    ! [A: nat,B4: set_nat,B: nat] :
      ( ( ~ ( member_nat @ A @ B4 )
       => ( A = B ) )
     => ( member_nat @ A @ ( insert_nat @ B @ B4 ) ) ) )).

% insertCI
thf(fact_225_insert__iff,axiom,(
    ! [A: nat,B: nat,A2: set_nat] :
      ( ( member_nat @ A @ ( insert_nat @ B @ A2 ) )
      = ( ( A = B )
        | ( member_nat @ A @ A2 ) ) ) )).

% insert_iff
thf(fact_226_insert__absorb2,axiom,(
    ! [X: nat,A2: set_nat] :
      ( ( insert_nat @ X @ ( insert_nat @ X @ A2 ) )
      = ( insert_nat @ X @ A2 ) ) )).

% insert_absorb2
thf(fact_227_in__mono,axiom,(
    ! [A2: set_nat,B4: set_nat,X: nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B4 )
     => ( ( member_nat @ X @ A2 )
       => ( member_nat @ X @ B4 ) ) ) )).

% in_mono
thf(fact_228_subsetD,axiom,(
    ! [A2: set_nat,B4: set_nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B4 )
     => ( ( member_nat @ C @ A2 )
       => ( member_nat @ C @ B4 ) ) ) )).

% subsetD
thf(fact_229_equalityE,axiom,(
    ! [A2: set_nat,B4: set_nat] :
      ( ( A2 = B4 )
     => ~ ( ( ord_less_eq_set_nat @ A2 @ B4 )
         => ~ ( ord_less_eq_set_nat @ B4 @ A2 ) ) ) )).

% equalityE
thf(fact_230_subset__eq,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
        ! [X2: nat] :
          ( ( member_nat @ X2 @ A5 )
         => ( member_nat @ X2 @ B5 ) ) ) )).

% subset_eq
thf(fact_231_equalityD1,axiom,(
    ! [A2: set_nat,B4: set_nat] :
      ( ( A2 = B4 )
     => ( ord_less_eq_set_nat @ A2 @ B4 ) ) )).

% equalityD1
thf(fact_232_equalityD2,axiom,(
    ! [A2: set_nat,B4: set_nat] :
      ( ( A2 = B4 )
     => ( ord_less_eq_set_nat @ B4 @ A2 ) ) )).

% equalityD2
thf(fact_233_subset__iff,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
        ! [T2: nat] :
          ( ( member_nat @ T2 @ A5 )
         => ( member_nat @ T2 @ B5 ) ) ) )).

% subset_iff
thf(fact_234_subset__refl,axiom,(
    ! [A2: set_nat] :
      ( ord_less_eq_set_nat @ A2 @ A2 ) )).

% subset_refl
thf(fact_235_Collect__mono,axiom,(
    ! [P2: nat > $o,Q: nat > $o] :
      ( ! [X3: nat] :
          ( ( P2 @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq_set_nat @ ( collect_nat @ P2 ) @ ( collect_nat @ Q ) ) ) )).

% Collect_mono
thf(fact_236_subset__trans,axiom,(
    ! [A2: set_nat,B4: set_nat,C4: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B4 )
     => ( ( ord_less_eq_set_nat @ B4 @ C4 )
       => ( ord_less_eq_set_nat @ A2 @ C4 ) ) ) )).

% subset_trans
thf(fact_237_set__eq__subset,axiom,
    ( ( ^ [Y: set_nat,Z: set_nat] : ( Y = Z ) )
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ( ord_less_eq_set_nat @ A5 @ B5 )
          & ( ord_less_eq_set_nat @ B5 @ A5 ) ) ) )).

% set_eq_subset
thf(fact_238_Collect__mono__iff,axiom,(
    ! [P2: nat > $o,Q: nat > $o] :
      ( ( ord_less_eq_set_nat @ ( collect_nat @ P2 ) @ ( collect_nat @ Q ) )
      = ( ! [X2: nat] :
            ( ( P2 @ X2 )
           => ( Q @ X2 ) ) ) ) )).

% Collect_mono_iff
thf(fact_239_insertE,axiom,(
    ! [A: nat,B: nat,A2: set_nat] :
      ( ( member_nat @ A @ ( insert_nat @ B @ A2 ) )
     => ( ( A != B )
       => ( member_nat @ A @ A2 ) ) ) )).

% insertE
thf(fact_240_insertI1,axiom,(
    ! [A: nat,B4: set_nat] :
      ( member_nat @ A @ ( insert_nat @ A @ B4 ) ) )).

% insertI1
thf(fact_241_insertI2,axiom,(
    ! [A: nat,B4: set_nat,B: nat] :
      ( ( member_nat @ A @ B4 )
     => ( member_nat @ A @ ( insert_nat @ B @ B4 ) ) ) )).

% insertI2
thf(fact_242_Set_Oset__insert,axiom,(
    ! [X: nat,A2: set_nat] :
      ( ( member_nat @ X @ A2 )
     => ~ ! [B6: set_nat] :
            ( ( A2
              = ( insert_nat @ X @ B6 ) )
           => ( member_nat @ X @ B6 ) ) ) )).

% Set.set_insert
thf(fact_243_insert__ident,axiom,(
    ! [X: nat,A2: set_nat,B4: set_nat] :
      ( ~ ( member_nat @ X @ A2 )
     => ( ~ ( member_nat @ X @ B4 )
       => ( ( ( insert_nat @ X @ A2 )
            = ( insert_nat @ X @ B4 ) )
          = ( A2 = B4 ) ) ) ) )).

% insert_ident
thf(fact_244_insert__absorb,axiom,(
    ! [A: nat,A2: set_nat] :
      ( ( member_nat @ A @ A2 )
     => ( ( insert_nat @ A @ A2 )
        = A2 ) ) )).

% insert_absorb
thf(fact_245_insert__eq__iff,axiom,(
    ! [A: nat,A2: set_nat,B: nat,B4: set_nat] :
      ( ~ ( member_nat @ A @ A2 )
     => ( ~ ( member_nat @ B @ B4 )
       => ( ( ( insert_nat @ A @ A2 )
            = ( insert_nat @ B @ B4 ) )
          = ( ( ( A = B )
             => ( A2 = B4 ) )
            & ( ( A != B )
             => ? [C5: set_nat] :
                  ( ( A2
                    = ( insert_nat @ B @ C5 ) )
                  & ~ ( member_nat @ B @ C5 )
                  & ( B4
                    = ( insert_nat @ A @ C5 ) )
                  & ~ ( member_nat @ A @ C5 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_246_insert__commute,axiom,(
    ! [X: nat,Y2: nat,A2: set_nat] :
      ( ( insert_nat @ X @ ( insert_nat @ Y2 @ A2 ) )
      = ( insert_nat @ Y2 @ ( insert_nat @ X @ A2 ) ) ) )).

% insert_commute
thf(fact_247_mk__disjoint__insert,axiom,(
    ! [A: nat,A2: set_nat] :
      ( ( member_nat @ A @ A2 )
     => ? [B6: set_nat] :
          ( ( A2
            = ( insert_nat @ A @ B6 ) )
          & ~ ( member_nat @ A @ B6 ) ) ) )).

% mk_disjoint_insert
thf(fact_248_Collect__subset,axiom,(
    ! [A2: set_nat,P2: nat > $o] :
      ( ord_less_eq_set_nat
      @ ( collect_nat
        @ ^ [X2: nat] :
            ( ( member_nat @ X2 @ A2 )
            & ( P2 @ X2 ) ) )
      @ A2 ) )).

% Collect_subset
thf(fact_249_less__eq__set__def,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ord_less_eq_nat_o
          @ ^ [X2: nat] :
              ( member_nat @ X2 @ A5 )
          @ ^ [X2: nat] :
              ( member_nat @ X2 @ B5 ) ) ) )).

% less_eq_set_def
thf(fact_250_insert__Collect,axiom,(
    ! [A: nat,P2: nat > $o] :
      ( ( insert_nat @ A @ ( collect_nat @ P2 ) )
      = ( collect_nat
        @ ^ [U: nat] :
            ( ( U != A )
           => ( P2 @ U ) ) ) ) )).

% insert_Collect
thf(fact_251_insert__compr,axiom,
    ( insert_nat
    = ( ^ [A3: nat,B5: set_nat] :
          ( collect_nat
          @ ^ [X2: nat] :
              ( ( X2 = A3 )
              | ( member_nat @ X2 @ B5 ) ) ) ) )).

% insert_compr

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_nat @ ( times_times_nat @ ( p @ i ) @ i ) @ n )).

%------------------------------------------------------------------------------
