%------------------------------------------------------------------------------
% File     : SLH346^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Number_Partition problem prob_325__5328976_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Number_Partition/prob_325__5328976_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  301 (   0 unit;  24 type;   0 defn)
%            Number of atoms       : 2915 ( 219 equality;1854 variable)
%            Maximal formula depth :   23 (   8 average)
%            Number of connectives : 2294 (  94   ~;  18   |;  32   &;1691   @)
%                                         (   0 <=>; 459  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  125 ( 125   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   26 (  24   :;   0   =)
%            Number of variables   :  812 (   1 sgn; 731   !;  11   ?;  70   ^)
%                                         ( 812   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:44:19.499
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    set_set_nat: $tType )).

thf(ty_n_t__Set__Oset_It__Nat__Onat_J,type,(
    set_nat: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (21)
thf(sy_c_Finite__Set_Ofinite_001t__Nat__Onat,type,(
    finite_finite_nat: set_nat > $o )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Set__Oset_It__Nat__Onat_J,type,(
    minus_minus_set_nat: set_nat > set_nat > set_nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_001t__Nat__Onat_001t__Nat__Onat,type,(
    groups1842438620at_nat: ( nat > nat ) > set_nat > nat )).

thf(sy_c_Number__Partition__Mirabelle__zerdlymyoj_Opartitions,type,(
    number1551313001itions: ( nat > nat ) > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Set__Oset_It__Nat__Onat_J,type,(
    ord_less_set_nat: set_nat > set_nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Nat__Onat_J,type,(
    ord_less_eq_set_nat: set_nat > set_nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    ord_le1613022364et_nat: set_set_nat > set_set_nat > $o )).

thf(sy_c_Orderings_Oorder__class_OGreatest_001t__Nat__Onat,type,(
    order_Greatest_nat: ( nat > $o ) > nat )).

thf(sy_c_Orderings_Oorder__class_OGreatest_001t__Set__Oset_It__Nat__Onat_J,type,(
    order_710314349et_nat: ( set_nat > $o ) > set_nat )).

thf(sy_c_Set_OCollect_001t__Nat__Onat,type,(
    collect_nat: ( nat > $o ) > set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Nat__Onat,type,(
    set_ord_atMost_nat: nat > set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Set__Oset_It__Nat__Onat_J,type,(
    set_or1086813439et_nat: set_nat > set_set_nat )).

thf(sy_c_member_001t__Nat__Onat,type,(
    member_nat: nat > set_nat > $o )).

thf(sy_c_member_001t__Set__Oset_It__Nat__Onat_J,type,(
    member_set_nat: set_nat > set_set_nat > $o )).

thf(sy_v_k,type,(
    k: nat )).

thf(sy_v_m,type,(
    m: nat )).

thf(sy_v_p,type,(
    p: nat > nat )).

% Relevant facts (276)
thf(fact_0_partitions,axiom,(
    number1551313001itions @ p @ ( minus_minus_nat @ m @ k ) )).

% partitions
thf(fact_1_k,axiom,
    ( ( groups1842438620at_nat @ p @ ( set_ord_atMost_nat @ ( minus_minus_nat @ m @ k ) ) )
    = k )).

% k
thf(fact_2_order__refl,axiom,(
    ! [X: set_nat] :
      ( ord_less_eq_set_nat @ X @ X ) )).

% order_refl
thf(fact_3_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_4_partitions__bounds,axiom,(
    ! [P: nat > nat,N: nat,I: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ord_less_eq_nat @ ( P @ I ) @ N ) ) )).

% partitions_bounds
thf(fact_5_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_6_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_7_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_8_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_9_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_10_Nat_Oex__has__greatest__nat,axiom,(
    ! [P2: nat > $o,K: nat,B: nat] :
      ( ( P2 @ K )
     => ( ! [Y: nat] :
            ( ( P2 @ Y )
           => ( ord_less_eq_nat @ Y @ B ) )
       => ? [X2: nat] :
            ( ( P2 @ X2 )
            & ! [Y2: nat] :
                ( ( P2 @ Y2 )
               => ( ord_less_eq_nat @ Y2 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_11_bounded__Max__nat,axiom,(
    ! [P2: nat > $o,X: nat,M2: nat] :
      ( ( P2 @ X )
     => ( ! [X2: nat] :
            ( ( P2 @ X2 )
           => ( ord_less_eq_nat @ X2 @ M2 ) )
       => ~ ! [M3: nat] :
              ( ( P2 @ M3 )
             => ~ ! [X3: nat] :
                    ( ( P2 @ X3 )
                   => ( ord_less_eq_nat @ X3 @ M3 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_12_linear,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
      | ( ord_less_eq_nat @ Y3 @ X ) ) )).

% linear
thf(fact_13_partitions__zero,axiom,(
    ! [P: nat > nat] :
      ( ( number1551313001itions @ P @ zero_zero_nat )
      = ( P
        = ( ^ [I2: nat] : zero_zero_nat ) ) ) )).

% partitions_zero
thf(fact_14_atMost__eq__iff,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ( set_ord_atMost_nat @ X )
        = ( set_ord_atMost_nat @ Y3 ) )
      = ( X = Y3 ) ) )).

% atMost_eq_iff
thf(fact_15_atMost__iff,axiom,(
    ! [I: set_nat,K: set_nat] :
      ( ( member_set_nat @ I @ ( set_or1086813439et_nat @ K ) )
      = ( ord_less_eq_set_nat @ I @ K ) ) )).

% atMost_iff
thf(fact_16_atMost__iff,axiom,(
    ! [I: nat,K: nat] :
      ( ( member_nat @ I @ ( set_ord_atMost_nat @ K ) )
      = ( ord_less_eq_nat @ I @ K ) ) )).

% atMost_iff
thf(fact_17_atMost__subset__iff,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ( ord_le1613022364et_nat @ ( set_or1086813439et_nat @ X ) @ ( set_or1086813439et_nat @ Y3 ) )
      = ( ord_less_eq_set_nat @ X @ Y3 ) ) )).

% atMost_subset_iff
thf(fact_18_atMost__subset__iff,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_eq_set_nat @ ( set_ord_atMost_nat @ X ) @ ( set_ord_atMost_nat @ Y3 ) )
      = ( ord_less_eq_nat @ X @ Y3 ) ) )).

% atMost_subset_iff
thf(fact_19_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_20_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_21_partitions__parts__bounded,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ P @ ( set_ord_atMost_nat @ N ) ) @ N ) ) )).

% partitions_parts_bounded
thf(fact_22_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_23_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_24_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_25_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N @ L ) ) ) )).

% diff_le_mono
thf(fact_26_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_27_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_28_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_29_dual__order_Oantisym,axiom,(
    ! [B: set_nat,A: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_30_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_31_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A2: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ B2 @ A2 )
          & ( ord_less_eq_set_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_32_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_33_dual__order_Otrans,axiom,(
    ! [B: set_nat,A: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ C @ B )
       => ( ord_less_eq_set_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_34_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_35_linorder__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P2 @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P2 @ B3 @ A3 )
           => ( P2 @ A3 @ B3 ) )
       => ( P2 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_36_dual__order_Orefl,axiom,(
    ! [A: set_nat] :
      ( ord_less_eq_set_nat @ A @ A ) )).

% dual_order.refl
thf(fact_37_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_38_order__trans,axiom,(
    ! [X: set_nat,Y3: set_nat,Z2: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y3 )
     => ( ( ord_less_eq_set_nat @ Y3 @ Z2 )
       => ( ord_less_eq_set_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_39_order__trans,axiom,(
    ! [X: nat,Y3: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
     => ( ( ord_less_eq_nat @ Y3 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_40_order__class_Oorder_Oantisym,axiom,(
    ! [A: set_nat,B: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_41_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_42_ord__le__eq__trans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_43_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_44_ord__eq__le__trans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( A = B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_45_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_46_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A2: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ A2 @ B2 )
          & ( ord_less_eq_set_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_47_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_48_antisym__conv,axiom,(
    ! [Y3: set_nat,X: set_nat] :
      ( ( ord_less_eq_set_nat @ Y3 @ X )
     => ( ( ord_less_eq_set_nat @ X @ Y3 )
        = ( X = Y3 ) ) ) )).

% antisym_conv
thf(fact_49_antisym__conv,axiom,(
    ! [Y3: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y3 @ X )
     => ( ( ord_less_eq_nat @ X @ Y3 )
        = ( X = Y3 ) ) ) )).

% antisym_conv
thf(fact_50_le__cases3,axiom,(
    ! [X: nat,Y3: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y3 )
       => ~ ( ord_less_eq_nat @ Y3 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y3 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y3 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y3 )
             => ~ ( ord_less_eq_nat @ Y3 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y3 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y3 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_51_order_Otrans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_52_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_53_le__cases,axiom,(
    ! [X: nat,Y3: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y3 )
     => ( ord_less_eq_nat @ Y3 @ X ) ) )).

% le_cases
thf(fact_54_eq__refl,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ( X = Y3 )
     => ( ord_less_eq_set_nat @ X @ Y3 ) ) )).

% eq_refl
thf(fact_55_eq__refl,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( X = Y3 )
     => ( ord_less_eq_nat @ X @ Y3 ) ) )).

% eq_refl
thf(fact_56_antisym,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y3 )
     => ( ( ord_less_eq_set_nat @ Y3 @ X )
       => ( X = Y3 ) ) ) )).

% antisym
thf(fact_57_antisym,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
     => ( ( ord_less_eq_nat @ Y3 @ X )
       => ( X = Y3 ) ) ) )).

% antisym
thf(fact_58_mem__Collect__eq,axiom,(
    ! [A: nat,P2: nat > $o] :
      ( ( member_nat @ A @ ( collect_nat @ P2 ) )
      = ( P2 @ A ) ) )).

% mem_Collect_eq
thf(fact_59_Collect__mem__eq,axiom,(
    ! [A4: set_nat] :
      ( ( collect_nat
        @ ^ [X4: nat] :
            ( member_nat @ X4 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_60_eq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [X4: set_nat,Y5: set_nat] :
          ( ( ord_less_eq_set_nat @ X4 @ Y5 )
          & ( ord_less_eq_set_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_61_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_62_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_63_ord__le__eq__subst,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_64_ord__le__eq__subst,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_65_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_66_ord__eq__le__subst,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_67_ord__eq__le__subst,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_68_ord__eq__le__subst,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_69_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_70_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_71_order__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_72_order__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_73_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_74_order__subst1,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_75_order__subst1,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_76_order__subst1,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_77_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_78_diff__is__0__eq_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_79_diff__is__0__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% diff_is_0_eq
thf(fact_80_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_81_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_82_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_83_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_84_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_85_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_86_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_87_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_88_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_89_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_90_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_91_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_92_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_93_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_94_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_95_minus__nat_Odiff__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ zero_zero_nat )
      = M ) )).

% minus_nat.diff_0
thf(fact_96_diffs0__imp__equal,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
     => ( ( ( minus_minus_nat @ N @ M )
          = zero_zero_nat )
       => ( M = N ) ) ) )).

% diffs0_imp_equal
thf(fact_97_sum__nonneg,axiom,(
    ! [A4: set_nat,F: nat > nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A4 )
         => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ X2 ) ) )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( groups1842438620at_nat @ F @ A4 ) ) ) )).

% sum_nonneg
thf(fact_98_sum__nonpos,axiom,(
    ! [A4: set_nat,F: nat > nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A4 )
         => ( ord_less_eq_nat @ ( F @ X2 ) @ zero_zero_nat ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ A4 ) @ zero_zero_nat ) ) )).

% sum_nonpos
thf(fact_99_subsetI,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A4 )
         => ( member_nat @ X2 @ B4 ) )
     => ( ord_less_eq_set_nat @ A4 @ B4 ) ) )).

% subsetI
thf(fact_100_subset__antisym,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ( ord_less_eq_set_nat @ A4 @ B4 )
     => ( ( ord_less_eq_set_nat @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_101_sum_Onot__neutral__contains__not__neutral,axiom,(
    ! [G: nat > nat,A4: set_nat] :
      ( ( ( groups1842438620at_nat @ G @ A4 )
       != zero_zero_nat )
     => ~ ! [A3: nat] :
            ( ( member_nat @ A3 @ A4 )
           => ( ( G @ A3 )
              = zero_zero_nat ) ) ) )).

% sum.not_neutral_contains_not_neutral
thf(fact_102_sum_Oneutral,axiom,(
    ! [A4: set_nat,G: nat > nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A4 )
         => ( ( G @ X2 )
            = zero_zero_nat ) )
     => ( ( groups1842438620at_nat @ G @ A4 )
        = zero_zero_nat ) ) )).

% sum.neutral
thf(fact_103_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_104_Collect__mono__iff,axiom,(
    ! [P2: nat > $o,Q: nat > $o] :
      ( ( ord_less_eq_set_nat @ ( collect_nat @ P2 ) @ ( collect_nat @ Q ) )
      = ( ! [X4: nat] :
            ( ( P2 @ X4 )
           => ( Q @ X4 ) ) ) ) )).

% Collect_mono_iff
thf(fact_105_set__eq__subset,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ( ord_less_eq_set_nat @ A5 @ B5 )
          & ( ord_less_eq_set_nat @ B5 @ A5 ) ) ) )).

% set_eq_subset
thf(fact_106_subset__trans,axiom,(
    ! [A4: set_nat,B4: set_nat,C2: set_nat] :
      ( ( ord_less_eq_set_nat @ A4 @ B4 )
     => ( ( ord_less_eq_set_nat @ B4 @ C2 )
       => ( ord_less_eq_set_nat @ A4 @ C2 ) ) ) )).

% subset_trans
thf(fact_107_Collect__mono,axiom,(
    ! [P2: nat > $o,Q: nat > $o] :
      ( ! [X2: nat] :
          ( ( P2 @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq_set_nat @ ( collect_nat @ P2 ) @ ( collect_nat @ Q ) ) ) )).

% Collect_mono
thf(fact_108_subset__refl,axiom,(
    ! [A4: set_nat] :
      ( ord_less_eq_set_nat @ A4 @ A4 ) )).

% subset_refl
thf(fact_109_double__diff,axiom,(
    ! [A4: set_nat,B4: set_nat,C2: set_nat] :
      ( ( ord_less_eq_set_nat @ A4 @ B4 )
     => ( ( ord_less_eq_set_nat @ B4 @ C2 )
       => ( ( minus_minus_set_nat @ B4 @ ( minus_minus_set_nat @ C2 @ A4 ) )
          = A4 ) ) ) )).

% double_diff
thf(fact_110_Diff__subset,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ord_less_eq_set_nat @ ( minus_minus_set_nat @ A4 @ B4 ) @ A4 ) )).

% Diff_subset
thf(fact_111_subset__iff,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
        ! [T: nat] :
          ( ( member_nat @ T @ A5 )
         => ( member_nat @ T @ B5 ) ) ) )).

% subset_iff
thf(fact_112_equalityD2,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ( A4 = B4 )
     => ( ord_less_eq_set_nat @ B4 @ A4 ) ) )).

% equalityD2
thf(fact_113_equalityD1,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ( A4 = B4 )
     => ( ord_less_eq_set_nat @ A4 @ B4 ) ) )).

% equalityD1
thf(fact_114_subset__eq,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
        ! [X4: nat] :
          ( ( member_nat @ X4 @ A5 )
         => ( member_nat @ X4 @ B5 ) ) ) )).

% subset_eq
thf(fact_115_equalityE,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ( A4 = B4 )
     => ~ ( ( ord_less_eq_set_nat @ A4 @ B4 )
         => ~ ( ord_less_eq_set_nat @ B4 @ A4 ) ) ) )).

% equalityE
thf(fact_116_Diff__mono,axiom,(
    ! [A4: set_nat,C2: set_nat,D: set_nat,B4: set_nat] :
      ( ( ord_less_eq_set_nat @ A4 @ C2 )
     => ( ( ord_less_eq_set_nat @ D @ B4 )
       => ( ord_less_eq_set_nat @ ( minus_minus_set_nat @ A4 @ B4 ) @ ( minus_minus_set_nat @ C2 @ D ) ) ) ) )).

% Diff_mono
thf(fact_117_subsetD,axiom,(
    ! [A4: set_nat,B4: set_nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A4 @ B4 )
     => ( ( member_nat @ C @ A4 )
       => ( member_nat @ C @ B4 ) ) ) )).

% subsetD
thf(fact_118_in__mono,axiom,(
    ! [A4: set_nat,B4: set_nat,X: nat] :
      ( ( ord_less_eq_set_nat @ A4 @ B4 )
     => ( ( member_nat @ X @ A4 )
       => ( member_nat @ X @ B4 ) ) ) )).

% in_mono
thf(fact_119_sum_Ocong,axiom,(
    ! [A4: set_nat,B4: set_nat,G: nat > nat,H: nat > nat] :
      ( ( A4 = B4 )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ B4 )
           => ( ( G @ X2 )
              = ( H @ X2 ) ) )
       => ( ( groups1842438620at_nat @ G @ A4 )
          = ( groups1842438620at_nat @ H @ B4 ) ) ) ) )).

% sum.cong
thf(fact_120_sum_Oeq__general,axiom,(
    ! [B4: set_nat,A4: set_nat,H: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y: nat] :
          ( ( member_nat @ Y @ B4 )
         => ? [X3: nat] :
              ( ( member_nat @ X3 @ A4 )
              & ( ( H @ X3 )
                = Y )
              & ! [Ya: nat] :
                  ( ( ( member_nat @ Ya @ A4 )
                    & ( ( H @ Ya )
                      = Y ) )
                 => ( Ya = X3 ) ) ) )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ A4 )
           => ( ( member_nat @ ( H @ X2 ) @ B4 )
              & ( ( Gamma @ ( H @ X2 ) )
                = ( Phi @ X2 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A4 )
          = ( groups1842438620at_nat @ Gamma @ B4 ) ) ) ) )).

% sum.eq_general
thf(fact_121_sum_Oeq__general__inverses,axiom,(
    ! [B4: set_nat,K: nat > nat,A4: set_nat,H: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y: nat] :
          ( ( member_nat @ Y @ B4 )
         => ( ( member_nat @ ( K @ Y ) @ A4 )
            & ( ( H @ ( K @ Y ) )
              = Y ) ) )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ A4 )
           => ( ( member_nat @ ( H @ X2 ) @ B4 )
              & ( ( K @ ( H @ X2 ) )
                = X2 )
              & ( ( Gamma @ ( H @ X2 ) )
                = ( Phi @ X2 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A4 )
          = ( groups1842438620at_nat @ Gamma @ B4 ) ) ) ) )).

% sum.eq_general_inverses
thf(fact_122_sum_Oreindex__bij__witness,axiom,(
    ! [S: set_nat,I: nat > nat,J: nat > nat,T2: set_nat,H: nat > nat,G: nat > nat] :
      ( ! [A3: nat] :
          ( ( member_nat @ A3 @ S )
         => ( ( I @ ( J @ A3 ) )
            = A3 ) )
     => ( ! [A3: nat] :
            ( ( member_nat @ A3 @ S )
           => ( member_nat @ ( J @ A3 ) @ T2 ) )
       => ( ! [B3: nat] :
              ( ( member_nat @ B3 @ T2 )
             => ( ( J @ ( I @ B3 ) )
                = B3 ) )
         => ( ! [B3: nat] :
                ( ( member_nat @ B3 @ T2 )
               => ( member_nat @ ( I @ B3 ) @ S ) )
           => ( ! [A3: nat] :
                  ( ( member_nat @ A3 @ S )
                 => ( ( H @ ( J @ A3 ) )
                    = ( G @ A3 ) ) )
             => ( ( groups1842438620at_nat @ G @ S )
                = ( groups1842438620at_nat @ H @ T2 ) ) ) ) ) ) ) )).

% sum.reindex_bij_witness
thf(fact_123_sum__mono2,axiom,(
    ! [B4: set_nat,A4: set_nat,F: nat > nat] :
      ( ( finite_finite_nat @ B4 )
     => ( ( ord_less_eq_set_nat @ A4 @ B4 )
       => ( ! [B3: nat] :
              ( ( member_nat @ B3 @ ( minus_minus_set_nat @ B4 @ A4 ) )
             => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ B3 ) ) )
         => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ A4 ) @ ( groups1842438620at_nat @ F @ B4 ) ) ) ) ) )).

% sum_mono2
thf(fact_124_Greatest__equality,axiom,(
    ! [P2: set_nat > $o,X: set_nat] :
      ( ( P2 @ X )
     => ( ! [Y: set_nat] :
            ( ( P2 @ Y )
           => ( ord_less_eq_set_nat @ Y @ X ) )
       => ( ( order_710314349et_nat @ P2 )
          = X ) ) ) )).

% Greatest_equality
thf(fact_125_Greatest__equality,axiom,(
    ! [P2: nat > $o,X: nat] :
      ( ( P2 @ X )
     => ( ! [Y: nat] :
            ( ( P2 @ Y )
           => ( ord_less_eq_nat @ Y @ X ) )
       => ( ( order_Greatest_nat @ P2 )
          = X ) ) ) )).

% Greatest_equality
thf(fact_126_GreatestI2__order,axiom,(
    ! [P2: set_nat > $o,X: set_nat,Q: set_nat > $o] :
      ( ( P2 @ X )
     => ( ! [Y: set_nat] :
            ( ( P2 @ Y )
           => ( ord_less_eq_set_nat @ Y @ X ) )
       => ( ! [X2: set_nat] :
              ( ( P2 @ X2 )
             => ( ! [Y2: set_nat] :
                    ( ( P2 @ Y2 )
                   => ( ord_less_eq_set_nat @ Y2 @ X2 ) )
               => ( Q @ X2 ) ) )
         => ( Q @ ( order_710314349et_nat @ P2 ) ) ) ) ) )).

% GreatestI2_order
thf(fact_127_GreatestI2__order,axiom,(
    ! [P2: nat > $o,X: nat,Q: nat > $o] :
      ( ( P2 @ X )
     => ( ! [Y: nat] :
            ( ( P2 @ Y )
           => ( ord_less_eq_nat @ Y @ X ) )
       => ( ! [X2: nat] :
              ( ( P2 @ X2 )
             => ( ! [Y2: nat] :
                    ( ( P2 @ Y2 )
                   => ( ord_less_eq_nat @ Y2 @ X2 ) )
               => ( Q @ X2 ) ) )
         => ( Q @ ( order_Greatest_nat @ P2 ) ) ) ) ) )).

% GreatestI2_order
thf(fact_128_partitions__remaining__Max__part,axiom,(
    ! [P: nat > nat,N: nat,K: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ ( P @ K ) )
       => ! [I3: nat] :
            ( ( ( ord_less_nat @ ( minus_minus_nat @ N @ K ) @ I3 )
              & ( I3 != K ) )
           => ( ( P @ I3 )
              = zero_zero_nat ) ) ) ) )).

% partitions_remaining_Max_part
thf(fact_129_DiffI,axiom,(
    ! [C: nat,A4: set_nat,B4: set_nat] :
      ( ( member_nat @ C @ A4 )
     => ( ~ ( member_nat @ C @ B4 )
       => ( member_nat @ C @ ( minus_minus_set_nat @ A4 @ B4 ) ) ) ) )).

% DiffI
thf(fact_130_Diff__iff,axiom,(
    ! [C: nat,A4: set_nat,B4: set_nat] :
      ( ( member_nat @ C @ ( minus_minus_set_nat @ A4 @ B4 ) )
      = ( ( member_nat @ C @ A4 )
        & ~ ( member_nat @ C @ B4 ) ) ) )).

% Diff_iff
thf(fact_131_Diff__idemp,axiom,(
    ! [A4: set_nat,B4: set_nat] :
      ( ( minus_minus_set_nat @ ( minus_minus_set_nat @ A4 @ B4 ) @ B4 )
      = ( minus_minus_set_nat @ A4 @ B4 ) ) )).

% Diff_idemp
thf(fact_132_finite__atMost,axiom,(
    ! [K: nat] :
      ( finite_finite_nat @ ( set_ord_atMost_nat @ K ) ) )).

% finite_atMost
thf(fact_133_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_134_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_135_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_136_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_137_sum__eq__0__iff,axiom,(
    ! [F2: set_nat,F: nat > nat] :
      ( ( finite_finite_nat @ F2 )
     => ( ( ( groups1842438620at_nat @ F @ F2 )
          = zero_zero_nat )
        = ( ! [X4: nat] :
              ( ( member_nat @ X4 @ F2 )
             => ( ( F @ X4 )
                = zero_zero_nat ) ) ) ) ) )).

% sum_eq_0_iff
thf(fact_138_sum_Oinfinite,axiom,(
    ! [A4: set_nat,G: nat > nat] :
      ( ~ ( finite_finite_nat @ A4 )
     => ( ( groups1842438620at_nat @ G @ A4 )
        = zero_zero_nat ) ) )).

% sum.infinite
thf(fact_139_zero__less__diff,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( minus_minus_nat @ N @ M ) )
      = ( ord_less_nat @ M @ N ) ) )).

% zero_less_diff
thf(fact_140_DiffE,axiom,(
    ! [C: nat,A4: set_nat,B4: set_nat] :
      ( ( member_nat @ C @ ( minus_minus_set_nat @ A4 @ B4 ) )
     => ~ ( ( member_nat @ C @ A4 )
         => ( member_nat @ C @ B4 ) ) ) )).

% DiffE
thf(fact_141_DiffD1,axiom,(
    ! [C: nat,A4: set_nat,B4: set_nat] :
      ( ( member_nat @ C @ ( minus_minus_set_nat @ A4 @ B4 ) )
     => ( member_nat @ C @ A4 ) ) )).

% DiffD1
thf(fact_142_DiffD2,axiom,(
    ! [C: nat,A4: set_nat,B4: set_nat] :
      ( ( member_nat @ C @ ( minus_minus_set_nat @ A4 @ B4 ) )
     => ~ ( member_nat @ C @ B4 ) ) )).

% DiffD2
thf(fact_143_sum__strict__mono__ex1,axiom,(
    ! [A4: set_nat,F: nat > nat,G: nat > nat] :
      ( ( finite_finite_nat @ A4 )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ A4 )
           => ( ord_less_eq_nat @ ( F @ X2 ) @ ( G @ X2 ) ) )
       => ( ? [X3: nat] :
              ( ( member_nat @ X3 @ A4 )
              & ( ord_less_nat @ ( F @ X3 ) @ ( G @ X3 ) ) )
         => ( ord_less_nat @ ( groups1842438620at_nat @ F @ A4 ) @ ( groups1842438620at_nat @ G @ A4 ) ) ) ) ) )).

% sum_strict_mono_ex1
thf(fact_144_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_145_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_146_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_147_less__not__refl3,axiom,(
    ! [S2: nat,T3: nat] :
      ( ( ord_less_nat @ S2 @ T3 )
     => ( S2 != T3 ) ) )).

% less_not_refl3
thf(fact_148_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_149_nat__less__induct,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M4: nat] :
              ( ( ord_less_nat @ M4 @ N2 )
             => ( P2 @ M4 ) )
         => ( P2 @ N2 ) )
     => ( P2 @ N ) ) )).

% nat_less_induct
thf(fact_150_infinite__descent,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P2 @ N2 )
         => ? [M4: nat] :
              ( ( ord_less_nat @ M4 @ N2 )
              & ~ ( P2 @ M4 ) ) )
     => ( P2 @ N ) ) )).

% infinite_descent
thf(fact_151_linorder__neqE__nat,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( X != Y3 )
     => ( ~ ( ord_less_nat @ X @ Y3 )
       => ( ord_less_nat @ Y3 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_152_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_153_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_154_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_155_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_156_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_157_neqE,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( X != Y3 )
     => ( ~ ( ord_less_nat @ X @ Y3 )
       => ( ord_less_nat @ Y3 @ X ) ) ) )).

% neqE
thf(fact_158_neq__iff,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( X != Y3 )
      = ( ( ord_less_nat @ X @ Y3 )
        | ( ord_less_nat @ Y3 @ X ) ) ) )).

% neq_iff
thf(fact_159_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_160_less__imp__neq,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( X != Y3 ) ) )).

% less_imp_neq
thf(fact_161_less__asym,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ~ ( ord_less_nat @ Y3 @ X ) ) )).

% less_asym
thf(fact_162_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_163_less__trans,axiom,(
    ! [X: nat,Y3: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( ( ord_less_nat @ Y3 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_164_less__linear,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
      | ( X = Y3 )
      | ( ord_less_nat @ Y3 @ X ) ) )).

% less_linear
thf(fact_165_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_166_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_167_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_168_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_169_less__imp__not__eq,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( X != Y3 ) ) )).

% less_imp_not_eq
thf(fact_170_less__not__sym,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ~ ( ord_less_nat @ Y3 @ X ) ) )).

% less_not_sym
thf(fact_171_less__induct,axiom,(
    ! [P2: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y2: nat] :
              ( ( ord_less_nat @ Y2 @ X2 )
             => ( P2 @ Y2 ) )
         => ( P2 @ X2 ) )
     => ( P2 @ A ) ) )).

% less_induct
thf(fact_172_antisym__conv3,axiom,(
    ! [Y3: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y3 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y3 ) )
        = ( X = Y3 ) ) ) )).

% antisym_conv3
thf(fact_173_less__imp__not__eq2,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( Y3 != X ) ) )).

% less_imp_not_eq2
thf(fact_174_less__imp__triv,axiom,(
    ! [X: nat,Y3: nat,P2: $o] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( ( ord_less_nat @ Y3 @ X )
       => P2 ) ) )).

% less_imp_triv
thf(fact_175_bounded__nat__set__is__finite,axiom,(
    ! [N3: set_nat,N: nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ N3 )
         => ( ord_less_nat @ X2 @ N ) )
     => ( finite_finite_nat @ N3 ) ) )).

% bounded_nat_set_is_finite
thf(fact_176_linorder__cases,axiom,(
    ! [X: nat,Y3: nat] :
      ( ~ ( ord_less_nat @ X @ Y3 )
     => ( ( X != Y3 )
       => ( ord_less_nat @ Y3 @ X ) ) ) )).

% linorder_cases
thf(fact_177_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_178_finite__nat__set__iff__bounded,axiom,
    ( finite_finite_nat
    = ( ^ [N4: set_nat] :
        ? [M5: nat] :
        ! [X4: nat] :
          ( ( member_nat @ X4 @ N4 )
         => ( ord_less_nat @ X4 @ M5 ) ) ) )).

% finite_nat_set_iff_bounded
thf(fact_179_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_180_less__imp__not__less,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ~ ( ord_less_nat @ Y3 @ X ) ) )).

% less_imp_not_less
thf(fact_181_exists__least__iff,axiom,
    ( ( ^ [P3: nat > $o] :
        ? [X5: nat] :
          ( P3 @ X5 ) )
    = ( ^ [P4: nat > $o] :
        ? [N5: nat] :
          ( ( P4 @ N5 )
          & ! [M5: nat] :
              ( ( ord_less_nat @ M5 @ N5 )
             => ~ ( P4 @ M5 ) ) ) ) )).

% exists_least_iff
thf(fact_182_linorder__less__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P2 @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P2 @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P2 @ B3 @ A3 )
             => ( P2 @ A3 @ B3 ) )
         => ( P2 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_183_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_184_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y3 ) )
      = ( ( ord_less_nat @ Y3 @ X )
        | ( X = Y3 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_185_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_186_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_187_leD,axiom,(
    ! [Y3: set_nat,X: set_nat] :
      ( ( ord_less_eq_set_nat @ Y3 @ X )
     => ~ ( ord_less_set_nat @ X @ Y3 ) ) )).

% leD
thf(fact_188_leD,axiom,(
    ! [Y3: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y3 @ X )
     => ~ ( ord_less_nat @ X @ Y3 ) ) )).

% leD
thf(fact_189_leI,axiom,(
    ! [X: nat,Y3: nat] :
      ( ~ ( ord_less_nat @ X @ Y3 )
     => ( ord_less_eq_nat @ Y3 @ X ) ) )).

% leI
thf(fact_190_le__less,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [X4: set_nat,Y5: set_nat] :
          ( ( ord_less_set_nat @ X4 @ Y5 )
          | ( X4 = Y5 ) ) ) )).

% le_less
thf(fact_191_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_nat @ X4 @ Y5 )
          | ( X4 = Y5 ) ) ) )).

% le_less
thf(fact_192_less__le,axiom,
    ( ord_less_set_nat
    = ( ^ [X4: set_nat,Y5: set_nat] :
          ( ( ord_less_eq_set_nat @ X4 @ Y5 )
          & ( X4 != Y5 ) ) ) )).

% less_le
thf(fact_193_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( X4 != Y5 ) ) ) )).

% less_le
thf(fact_194_order__le__less__subst1,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_195_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_196_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_197_order__le__less__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_198_order__le__less__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_199_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_200_order__less__le__subst1,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( ord_less_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_201_order__less__le__subst1,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_202_order__less__le__subst1,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_203_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_204_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_set_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_205_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y: nat] :
              ( ( ord_less_nat @ X2 @ Y )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_206_not__le,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y3 ) )
      = ( ord_less_nat @ Y3 @ X ) ) )).

% not_le
thf(fact_207_not__less,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y3 ) )
      = ( ord_less_eq_nat @ Y3 @ X ) ) )).

% not_less
thf(fact_208_le__neq__trans,axiom,(
    ! [A: set_nat,B: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_set_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_209_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_210_antisym__conv1,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ~ ( ord_less_set_nat @ X @ Y3 )
     => ( ( ord_less_eq_set_nat @ X @ Y3 )
        = ( X = Y3 ) ) ) )).

% antisym_conv1
thf(fact_211_antisym__conv1,axiom,(
    ! [X: nat,Y3: nat] :
      ( ~ ( ord_less_nat @ X @ Y3 )
     => ( ( ord_less_eq_nat @ X @ Y3 )
        = ( X = Y3 ) ) ) )).

% antisym_conv1
thf(fact_212_antisym__conv2,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y3 )
     => ( ( ~ ( ord_less_set_nat @ X @ Y3 ) )
        = ( X = Y3 ) ) ) )).

% antisym_conv2
thf(fact_213_antisym__conv2,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
     => ( ( ~ ( ord_less_nat @ X @ Y3 ) )
        = ( X = Y3 ) ) ) )).

% antisym_conv2
thf(fact_214_less__imp__le,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ( ord_less_set_nat @ X @ Y3 )
     => ( ord_less_eq_set_nat @ X @ Y3 ) ) )).

% less_imp_le
thf(fact_215_less__imp__le,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( ord_less_eq_nat @ X @ Y3 ) ) )).

% less_imp_le
thf(fact_216_le__less__trans,axiom,(
    ! [X: set_nat,Y3: set_nat,Z2: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y3 )
     => ( ( ord_less_set_nat @ Y3 @ Z2 )
       => ( ord_less_set_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_217_le__less__trans,axiom,(
    ! [X: nat,Y3: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
     => ( ( ord_less_nat @ Y3 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_218_less__le__trans,axiom,(
    ! [X: set_nat,Y3: set_nat,Z2: set_nat] :
      ( ( ord_less_set_nat @ X @ Y3 )
     => ( ( ord_less_eq_set_nat @ Y3 @ Z2 )
       => ( ord_less_set_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_219_less__le__trans,axiom,(
    ! [X: nat,Y3: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y3 )
     => ( ( ord_less_eq_nat @ Y3 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_220_le__less__linear,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
      | ( ord_less_nat @ Y3 @ X ) ) )).

% le_less_linear
thf(fact_221_le__imp__less__or__eq,axiom,(
    ! [X: set_nat,Y3: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y3 )
     => ( ( ord_less_set_nat @ X @ Y3 )
        | ( X = Y3 ) ) ) )).

% le_imp_less_or_eq
thf(fact_222_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ord_less_eq_nat @ X @ Y3 )
     => ( ( ord_less_nat @ X @ Y3 )
        | ( X = Y3 ) ) ) )).

% le_imp_less_or_eq
thf(fact_223_less__le__not__le,axiom,
    ( ord_less_set_nat
    = ( ^ [X4: set_nat,Y5: set_nat] :
          ( ( ord_less_eq_set_nat @ X4 @ Y5 )
          & ~ ( ord_less_eq_set_nat @ Y5 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_224_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_225_not__le__imp__less,axiom,(
    ! [Y3: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y3 @ X )
     => ( ord_less_nat @ X @ Y3 ) ) )).

% not_le_imp_less
thf(fact_226_order_Ostrict__trans1,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_set_nat @ B @ C )
       => ( ord_less_set_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_227_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_228_order_Ostrict__trans2,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_set_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_229_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_230_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A2: set_nat,B2: set_nat] :
          ( ( ord_less_set_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_231_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_232_order_Ostrict__iff__order,axiom,
    ( ord_less_set_nat
    = ( ^ [A2: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_233_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_234_dual__order_Ostrict__trans1,axiom,(
    ! [B: set_nat,A: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_set_nat @ C @ B )
       => ( ord_less_set_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_235_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_236_dual__order_Ostrict__trans2,axiom,(
    ! [B: set_nat,A: set_nat,C: set_nat] :
      ( ( ord_less_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ C @ B )
       => ( ord_less_set_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_237_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_238_order_Ostrict__implies__order,axiom,(
    ! [A: set_nat,B: set_nat] :
      ( ( ord_less_set_nat @ A @ B )
     => ( ord_less_eq_set_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_239_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_240_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [B2: set_nat,A2: set_nat] :
          ( ( ord_less_set_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_241_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_242_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_set_nat
    = ( ^ [B2: set_nat,A2: set_nat] :
          ( ( ord_less_eq_set_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_243_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_244_dual__order_Ostrict__implies__order,axiom,(
    ! [B: set_nat,A: set_nat] :
      ( ( ord_less_set_nat @ B @ A )
     => ( ord_less_eq_set_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_245_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_246_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: set_nat,B: set_nat] :
      ( ( A != B )
     => ( ( ord_less_eq_set_nat @ A @ B )
       => ( ord_less_set_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_247_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_248_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_249_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_250_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_251_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_252_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_253_finite__nat__set__iff__bounded__le,axiom,
    ( finite_finite_nat
    = ( ^ [N4: set_nat] :
        ? [M5: nat] :
        ! [X4: nat] :
          ( ( member_nat @ X4 @ N4 )
         => ( ord_less_eq_nat @ X4 @ M5 ) ) ) )).

% finite_nat_set_iff_bounded_le
thf(fact_254_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_255_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_256_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_257_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_258_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_259_infinite__descent0,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P2 @ N2 )
             => ? [M4: nat] :
                  ( ( ord_less_nat @ M4 @ N2 )
                  & ~ ( P2 @ M4 ) ) ) )
       => ( P2 @ N ) ) ) )).

% infinite_descent0
thf(fact_260_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_261_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M5: nat,N5: nat] :
          ( ( ord_less_eq_nat @ M5 @ N5 )
          & ( M5 != N5 ) ) ) )).

% nat_less_le
thf(fact_262_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_263_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M5: nat,N5: nat] :
          ( ( ord_less_nat @ M5 @ N5 )
          | ( M5 = N5 ) ) ) )).

% le_eq_less_or_eq
thf(fact_264_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_265_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_266_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I4: nat,J2: nat] :
          ( ( ord_less_nat @ I4 @ J2 )
         => ( ord_less_nat @ ( F @ I4 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_267_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_268_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_269_sum__pos2,axiom,(
    ! [I5: set_nat,I: nat,F: nat > nat] :
      ( ( finite_finite_nat @ I5 )
     => ( ( member_nat @ I @ I5 )
       => ( ( ord_less_nat @ zero_zero_nat @ ( F @ I ) )
         => ( ! [I4: nat] :
                ( ( member_nat @ I4 @ I5 )
               => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ I4 ) ) )
           => ( ord_less_nat @ zero_zero_nat @ ( groups1842438620at_nat @ F @ I5 ) ) ) ) ) ) )).

% sum_pos2
thf(fact_270_sum__strict__mono2,axiom,(
    ! [B4: set_nat,A4: set_nat,B: nat,F: nat > nat] :
      ( ( finite_finite_nat @ B4 )
     => ( ( ord_less_eq_set_nat @ A4 @ B4 )
       => ( ( member_nat @ B @ ( minus_minus_set_nat @ B4 @ A4 ) )
         => ( ( ord_less_nat @ zero_zero_nat @ ( F @ B ) )
           => ( ! [X2: nat] :
                  ( ( member_nat @ X2 @ B4 )
                 => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ X2 ) ) )
             => ( ord_less_nat @ ( groups1842438620at_nat @ F @ A4 ) @ ( groups1842438620at_nat @ F @ B4 ) ) ) ) ) ) ) )).

% sum_strict_mono2
thf(fact_271_sum__mono__inv,axiom,(
    ! [F: nat > nat,I5: set_nat,G: nat > nat,I: nat] :
      ( ( ( groups1842438620at_nat @ F @ I5 )
        = ( groups1842438620at_nat @ G @ I5 ) )
     => ( ! [I4: nat] :
            ( ( member_nat @ I4 @ I5 )
           => ( ord_less_eq_nat @ ( F @ I4 ) @ ( G @ I4 ) ) )
       => ( ( member_nat @ I @ I5 )
         => ( ( finite_finite_nat @ I5 )
           => ( ( F @ I )
              = ( G @ I ) ) ) ) ) ) )).

% sum_mono_inv
thf(fact_272_sum_Oreindex__bij__witness__not__neutral,axiom,(
    ! [S3: set_nat,T4: set_nat,S: set_nat,I: nat > nat,J: nat > nat,T2: set_nat,G: nat > nat,H: nat > nat] :
      ( ( finite_finite_nat @ S3 )
     => ( ( finite_finite_nat @ T4 )
       => ( ! [A3: nat] :
              ( ( member_nat @ A3 @ ( minus_minus_set_nat @ S @ S3 ) )
             => ( ( I @ ( J @ A3 ) )
                = A3 ) )
         => ( ! [A3: nat] :
                ( ( member_nat @ A3 @ ( minus_minus_set_nat @ S @ S3 ) )
               => ( member_nat @ ( J @ A3 ) @ ( minus_minus_set_nat @ T2 @ T4 ) ) )
           => ( ! [B3: nat] :
                  ( ( member_nat @ B3 @ ( minus_minus_set_nat @ T2 @ T4 ) )
                 => ( ( J @ ( I @ B3 ) )
                    = B3 ) )
             => ( ! [B3: nat] :
                    ( ( member_nat @ B3 @ ( minus_minus_set_nat @ T2 @ T4 ) )
                   => ( member_nat @ ( I @ B3 ) @ ( minus_minus_set_nat @ S @ S3 ) ) )
               => ( ! [A3: nat] :
                      ( ( member_nat @ A3 @ S3 )
                     => ( ( G @ A3 )
                        = zero_zero_nat ) )
                 => ( ! [B3: nat] :
                        ( ( member_nat @ B3 @ T4 )
                       => ( ( H @ B3 )
                          = zero_zero_nat ) )
                   => ( ! [A3: nat] :
                          ( ( member_nat @ A3 @ S )
                         => ( ( H @ ( J @ A3 ) )
                            = ( G @ A3 ) ) )
                     => ( ( groups1842438620at_nat @ G @ S )
                        = ( groups1842438620at_nat @ H @ T2 ) ) ) ) ) ) ) ) ) ) ) )).

% sum.reindex_bij_witness_not_neutral
thf(fact_273_ex__least__nat__le,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ N )
     => ( ~ ( P2 @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P2 @ I3 ) )
            & ( P2 @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_274_diff__less,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ M )
       => ( ord_less_nat @ ( minus_minus_nat @ M @ N ) @ M ) ) ) )).

% diff_less
thf(fact_275_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_nat @ k @ m )).

%------------------------------------------------------------------------------
