%------------------------------------------------------------------------------
% File     : SLH379^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer ListInf problem prob_562__5417588_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : ListInf/prob_562__5417588_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  252 (   0 unit;  20 type;   0 defn)
%            Number of atoms       : 2621 ( 280 equality;1544 variable)
%            Maximal formula depth :   15 (   8 average)
%            Number of connectives : 1898 (  69   ~;  17   |;  30   &;1518   @)
%                                         (   0 <=>; 264  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  133 ( 133   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   22 (  20   :;   0   =)
%            Number of variables   :  673 (   0 sgn; 598   !;  11   ?;  64   ^)
%                                         ( 673   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:32:50.818
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (17)
thf(sy_c_Fun_Ofun__upd_001t__Nat__Onat_001tf__a,type,(
    fun_upd_nat_a: ( nat > a ) > nat > a > nat > a )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_List2_Omap2_001tf__a_001tf__a_001tf__a,type,(
    map2_a_a_a: ( a > a > a ) > list_a > list_a > list_a )).

thf(sy_c_ListInf__Mirabelle__akbajwqfbr_Oi__append_001tf__a,type,(
    listIn1312259492pend_a: list_a > ( nat > a ) > nat > a )).

thf(sy_c_ListInf__Mirabelle__akbajwqfbr_Oi__drop_001tf__a,type,(
    listIn1417627087drop_a: nat > ( nat > a ) > nat > a )).

thf(sy_c_ListInf__Mirabelle__akbajwqfbr_Oi__take_001tf__a,type,(
    listIn84854903take_a: nat > ( nat > a ) > list_a )).

thf(sy_c_List_Oappend_001tf__a,type,(
    append_a: list_a > list_a > list_a )).

thf(sy_c_List_Odrop_001tf__a,type,(
    drop_a: nat > list_a > list_a )).

thf(sy_c_List_Olist_ONil_001tf__a,type,(
    nil_a: list_a )).

thf(sy_c_List_Otake_001tf__a,type,(
    take_a: nat > list_a > list_a )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_f,type,(
    f: nat > a )).

thf(sy_v_g,type,(
    g: nat > a )).

thf(sy_v_xs,type,(
    xs: list_a )).

thf(sy_v_ys,type,(
    ys: list_a )).

% Relevant facts (230)
thf(fact_0_same__i__append__eq,axiom,(
    ! [Xs: list_a,F: nat > a,G: nat > a] :
      ( ( ( listIn1312259492pend_a @ Xs @ F )
        = ( listIn1312259492pend_a @ Xs @ G ) )
      = ( F = G ) ) )).

% same_i_append_eq
thf(fact_1_i__append__eq__i__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a,F: nat > a,G: nat > a] :
      ( ( ( size_size_list_a @ Xs )
        = ( size_size_list_a @ Ys ) )
     => ( ( ( listIn1312259492pend_a @ Xs @ F )
          = ( listIn1312259492pend_a @ Ys @ G ) )
        = ( ( Xs = Ys )
          & ( F = G ) ) ) ) )).

% i_append_eq_i_append_conv
thf(fact_2_take__all,axiom,(
    ! [Xs: list_a,N: nat] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( take_a @ N @ Xs )
        = Xs ) ) )).

% take_all
thf(fact_3_take__all__iff,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ( ( take_a @ N @ Xs )
        = Xs )
      = ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N ) ) )).

% take_all_iff
thf(fact_4_length__take__le,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ord_less_eq_nat @ ( size_size_list_a @ ( take_a @ N @ Xs ) ) @ ( size_size_list_a @ Xs ) ) )).

% length_take_le
thf(fact_5_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_6_list__take__drop__imp__eq,axiom,(
    ! [N: nat,Xs: list_a,Ys: list_a] :
      ( ( ( take_a @ N @ Xs )
        = ( take_a @ N @ Ys ) )
     => ( ( ( drop_a @ N @ Xs )
          = ( drop_a @ N @ Ys ) )
       => ( Xs = Ys ) ) ) )).

% list_take_drop_imp_eq
thf(fact_7_list__take__drop__eq__conv,axiom,
    ( ( ^ [Y: list_a,Z: list_a] : ( Y = Z ) )
    = ( ^ [Xs2: list_a,Ys2: list_a] :
        ? [N2: nat] :
          ( ( ( take_a @ N2 @ Xs2 )
            = ( take_a @ N2 @ Ys2 ) )
          & ( ( drop_a @ N2 @ Xs2 )
            = ( drop_a @ N2 @ Ys2 ) ) ) ) )).

% list_take_drop_eq_conv
thf(fact_8_i__append__i__drop__eq1,axiom,(
    ! [N: nat,Xs: list_a,F: nat > a] :
      ( ( ord_less_eq_nat @ N @ ( size_size_list_a @ Xs ) )
     => ( ( listIn1417627087drop_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
        = ( listIn1312259492pend_a @ ( drop_a @ N @ Xs ) @ F ) ) ) )).

% i_append_i_drop_eq1
thf(fact_9_i__append__i__take__eq1,axiom,(
    ! [N: nat,Xs: list_a,F: nat > a] :
      ( ( ord_less_eq_nat @ N @ ( size_size_list_a @ Xs ) )
     => ( ( listIn84854903take_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
        = ( take_a @ N @ Xs ) ) ) )).

% i_append_i_take_eq1
thf(fact_10_i__append__nth2,axiom,(
    ! [Xs: list_a,N: nat,F: nat > a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( listIn1312259492pend_a @ Xs @ F @ N )
        = ( F @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) ) ) ) )).

% i_append_nth2
thf(fact_11_list__drop__eq__conv,axiom,
    ( ( ^ [Y: list_a,Z: list_a] : ( Y = Z ) )
    = ( ^ [Xs2: list_a,Ys2: list_a] :
        ! [N2: nat] :
          ( ( drop_a @ N2 @ Xs2 )
          = ( drop_a @ N2 @ Ys2 ) ) ) )).

% list_drop_eq_conv
thf(fact_12_take__equalityI,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ! [I: nat] :
          ( ( take_a @ I @ Xs )
          = ( take_a @ I @ Ys ) )
     => ( Xs = Ys ) ) )).

% take_equalityI
thf(fact_13_list__take__eq__conv,axiom,
    ( ( ^ [Y: list_a,Z: list_a] : ( Y = Z ) )
    = ( ^ [Xs2: list_a,Ys2: list_a] :
        ! [N2: nat] :
          ( ( take_a @ N2 @ Xs2 )
          = ( take_a @ N2 @ Ys2 ) ) ) )).

% list_take_eq_conv
thf(fact_14_i__take__length,axiom,(
    ! [N: nat,F: nat > a] :
      ( ( size_size_list_a @ ( listIn84854903take_a @ N @ F ) )
      = N ) )).

% i_take_length
thf(fact_15_length__drop,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ( size_size_list_a @ ( drop_a @ N @ Xs ) )
      = ( minus_minus_nat @ ( size_size_list_a @ Xs ) @ N ) ) )).

% length_drop
thf(fact_16_i__append__i__take__i__drop__id,axiom,(
    ! [N: nat,F: nat > a] :
      ( ( listIn1312259492pend_a @ ( listIn84854903take_a @ N @ F ) @ ( listIn1417627087drop_a @ N @ F ) )
      = F ) )).

% i_append_i_take_i_drop_id
thf(fact_17_i__append__i__drop,axiom,(
    ! [N: nat,Xs: list_a,F: nat > a] :
      ( ( listIn1417627087drop_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
      = ( listIn1312259492pend_a @ ( drop_a @ N @ Xs ) @ ( listIn1417627087drop_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ F ) ) ) )).

% i_append_i_drop
thf(fact_18_i__take__drop,axiom,(
    ! [M: nat,N: nat,F: nat > a] :
      ( ( drop_a @ M @ ( listIn84854903take_a @ N @ F ) )
      = ( listIn84854903take_a @ ( minus_minus_nat @ N @ M ) @ ( listIn1417627087drop_a @ M @ F ) ) ) )).

% i_take_drop
thf(fact_19_i__drop__commute,axiom,(
    ! [B: nat,A: nat,S: nat > a] :
      ( ( listIn1417627087drop_a @ B @ ( listIn1417627087drop_a @ A @ S ) )
      = ( listIn1417627087drop_a @ A @ ( listIn1417627087drop_a @ B @ S ) ) ) )).

% i_drop_commute
thf(fact_20_ilist__i__drop__eq__conv,axiom,
    ( ( ^ [Y: nat > a,Z: nat > a] : ( Y = Z ) )
    = ( ^ [F2: nat > a,G2: nat > a] :
        ! [N2: nat] :
          ( ( listIn1417627087drop_a @ N2 @ F2 )
          = ( listIn1417627087drop_a @ N2 @ G2 ) ) ) )).

% ilist_i_drop_eq_conv
thf(fact_21_ilist__i__take__eq__conv,axiom,
    ( ( ^ [Y: nat > a,Z: nat > a] : ( Y = Z ) )
    = ( ^ [F2: nat > a,G2: nat > a] :
        ! [N2: nat] :
          ( ( listIn84854903take_a @ N2 @ F2 )
          = ( listIn84854903take_a @ N2 @ G2 ) ) ) )).

% ilist_i_take_eq_conv
thf(fact_22_ilist__i__take__i__drop__imp__eq,axiom,(
    ! [N: nat,F: nat > a,G: nat > a] :
      ( ( ( listIn84854903take_a @ N @ F )
        = ( listIn84854903take_a @ N @ G ) )
     => ( ( ( listIn1417627087drop_a @ N @ F )
          = ( listIn1417627087drop_a @ N @ G ) )
       => ( F = G ) ) ) )).

% ilist_i_take_i_drop_imp_eq
thf(fact_23_ilist__i__take__i__drop__eq__conv,axiom,
    ( ( ^ [Y: nat > a,Z: nat > a] : ( Y = Z ) )
    = ( ^ [F2: nat > a,G2: nat > a] :
        ? [N2: nat] :
          ( ( ( listIn84854903take_a @ N2 @ F2 )
            = ( listIn84854903take_a @ N2 @ G2 ) )
          & ( ( listIn1417627087drop_a @ N2 @ F2 )
            = ( listIn1417627087drop_a @ N2 @ G2 ) ) ) ) )).

% ilist_i_take_i_drop_eq_conv
thf(fact_24_i__drop__nth__sub,axiom,(
    ! [N: nat,X: nat,S: nat > a] :
      ( ( ord_less_eq_nat @ N @ X )
     => ( ( listIn1417627087drop_a @ N @ S @ ( minus_minus_nat @ X @ N ) )
        = ( S @ X ) ) ) )).

% i_drop_nth_sub
thf(fact_25_i__append__eq__conv__conj,axiom,(
    ! [Xs: list_a,F: nat > a,G: nat > a] :
      ( ( ( listIn1312259492pend_a @ Xs @ F )
        = G )
      = ( ( Xs
          = ( listIn84854903take_a @ ( size_size_list_a @ Xs ) @ G ) )
        & ( F
          = ( listIn1417627087drop_a @ ( size_size_list_a @ Xs ) @ G ) ) ) ) )).

% i_append_eq_conv_conj
thf(fact_26_i__take__commute,axiom,(
    ! [B: nat,A: nat,S: nat > a] :
      ( ( take_a @ B @ ( listIn84854903take_a @ A @ S ) )
      = ( take_a @ A @ ( listIn84854903take_a @ B @ S ) ) ) )).

% i_take_commute
thf(fact_27_drop__take,axiom,(
    ! [N: nat,M: nat,Xs: list_a] :
      ( ( drop_a @ N @ ( take_a @ M @ Xs ) )
      = ( take_a @ ( minus_minus_nat @ M @ N ) @ ( drop_a @ N @ Xs ) ) ) )).

% drop_take
thf(fact_28_i__append__i__drop__eq2,axiom,(
    ! [Xs: list_a,N: nat,F: nat > a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( listIn1417627087drop_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
        = ( listIn1417627087drop_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ F ) ) ) )).

% i_append_i_drop_eq2
thf(fact_29_i__take__take__eq2,axiom,(
    ! [N: nat,M: nat,F: nat > a] :
      ( ( ord_less_eq_nat @ N @ M )
     => ( ( take_a @ M @ ( listIn84854903take_a @ N @ F ) )
        = ( listIn84854903take_a @ N @ F ) ) ) )).

% i_take_take_eq2
thf(fact_30_i__take__take__eq1,axiom,(
    ! [M: nat,N: nat,F: nat > a] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( take_a @ M @ ( listIn84854903take_a @ N @ F ) )
        = ( listIn84854903take_a @ M @ F ) ) ) )).

% i_take_take_eq1
thf(fact_31_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_32_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_33_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_34_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_35_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_36_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_37_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_38_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_39_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_40_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_41_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_42_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_43_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_44_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_45_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_46_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_47_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_48_eq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_49_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_50_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_51_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_52_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_53_neq__if__length__neq,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( size_size_list_a @ Xs )
       != ( size_size_list_a @ Ys ) )
     => ( Xs != Ys ) ) )).

% neq_if_length_neq
thf(fact_54_Ex__list__of__length,axiom,(
    ! [N: nat] :
    ? [Xs3: list_a] :
      ( ( size_size_list_a @ Xs3 )
      = N ) )).

% Ex_list_of_length
thf(fact_55_diff__diff__cancel,axiom,(
    ! [I2: nat,N: nat] :
      ( ( ord_less_eq_nat @ I2 @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I2 ) )
        = I2 ) ) )).

% diff_diff_cancel
thf(fact_56_nat__diff__right__cancel__le2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le2
thf(fact_57_nat__diff__left__cancel__le2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le2
thf(fact_58_le__diff__le__imp__le,axiom,(
    ! [I2: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I2 @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_eq_nat @ I2 @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% le_diff_le_imp_le
thf(fact_59_eq__diff__left__iff,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ K )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ( ( minus_minus_nat @ K @ M )
            = ( minus_minus_nat @ K @ N ) )
          = ( M = N ) ) ) ) )).

% eq_diff_left_iff
thf(fact_60_le__imp__diff__le,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ K )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% le_imp_diff_le
thf(fact_61_le__diff__imp__le,axiom,(
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I2 @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_eq_nat @ I2 @ J ) ) )).

% le_diff_imp_le
thf(fact_62_le__diff__swap,axiom,(
    ! [I2: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ I2 @ K )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ J ) @ I2 )
          = ( ord_less_eq_nat @ ( minus_minus_nat @ K @ I2 ) @ J ) ) ) ) )).

% le_diff_swap
thf(fact_63_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_64_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_65_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_66_le__trans,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I2 @ K ) ) ) )).

% le_trans
thf(fact_67_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_68_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_69_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_70_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y5: nat] :
                ( ( P @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_71_size__neq__size__imp__neq,axiom,(
    ! [X: list_a,Y2: list_a] :
      ( ( ( size_size_list_a @ X )
       != ( size_size_list_a @ Y2 ) )
     => ( X != Y2 ) ) )).

% size_neq_size_imp_neq
thf(fact_72_eq__imp__diff__eq,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( M = N )
     => ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) ) ) )).

% eq_imp_diff_eq
thf(fact_73_diff__commute,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I2 @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I2 @ K ) @ J ) ) )).

% diff_commute
thf(fact_74_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_75_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_76_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_77_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N @ L ) ) ) )).

% diff_le_mono
thf(fact_78_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_79_i__append__i__take,axiom,(
    ! [N: nat,Xs: list_a,F: nat > a] :
      ( ( listIn84854903take_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
      = ( append_a @ ( take_a @ N @ Xs ) @ ( listIn84854903take_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ F ) ) ) )).

% i_append_i_take
thf(fact_80_i__append__i__take__if,axiom,(
    ! [N: nat,Xs: list_a,F: nat > a] :
      ( ( ( ord_less_eq_nat @ N @ ( size_size_list_a @ Xs ) )
       => ( ( listIn84854903take_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
          = ( take_a @ N @ Xs ) ) )
      & ( ~ ( ord_less_eq_nat @ N @ ( size_size_list_a @ Xs ) )
       => ( ( listIn84854903take_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
          = ( append_a @ Xs @ ( listIn84854903take_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ F ) ) ) ) ) )).

% i_append_i_take_if
thf(fact_81_same__append__eq,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = ( append_a @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_82_append__same__eq,axiom,(
    ! [Ys: list_a,Xs: list_a,Zs: list_a] :
      ( ( ( append_a @ Ys @ Xs )
        = ( append_a @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_83_append__assoc,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a] :
      ( ( append_a @ ( append_a @ Xs @ Ys ) @ Zs )
      = ( append_a @ Xs @ ( append_a @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_84_append_Oassoc,axiom,(
    ! [A: list_a,B: list_a,C: list_a] :
      ( ( append_a @ ( append_a @ A @ B ) @ C )
      = ( append_a @ A @ ( append_a @ B @ C ) ) ) )).

% append.assoc
thf(fact_85_append__eq__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a,Us: list_a,Vs: list_a] :
      ( ( ( ( size_size_list_a @ Xs )
          = ( size_size_list_a @ Ys ) )
        | ( ( size_size_list_a @ Us )
          = ( size_size_list_a @ Vs ) ) )
     => ( ( ( append_a @ Xs @ Us )
          = ( append_a @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) )).

% append_eq_append_conv
thf(fact_86_i__append__assoc,axiom,(
    ! [Xs: list_a,Ys: list_a,F: nat > a] :
      ( ( listIn1312259492pend_a @ Xs @ ( listIn1312259492pend_a @ Ys @ F ) )
      = ( listIn1312259492pend_a @ ( append_a @ Xs @ Ys ) @ F ) ) )).

% i_append_assoc
thf(fact_87_append__take__drop__id,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ( append_a @ ( take_a @ N @ Xs ) @ ( drop_a @ N @ Xs ) )
      = Xs ) )).

% append_take_drop_id
thf(fact_88_take__append,axiom,(
    ! [N: nat,Xs: list_a,Ys: list_a] :
      ( ( take_a @ N @ ( append_a @ Xs @ Ys ) )
      = ( append_a @ ( take_a @ N @ Xs ) @ ( take_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ Ys ) ) ) )).

% take_append
thf(fact_89_drop__append,axiom,(
    ! [N: nat,Xs: list_a,Ys: list_a] :
      ( ( drop_a @ N @ ( append_a @ Xs @ Ys ) )
      = ( append_a @ ( drop_a @ N @ Xs ) @ ( drop_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ Ys ) ) ) )).

% drop_append
thf(fact_90_i__take__drop__append,axiom,(
    ! [M: nat,N: nat,F: nat > a] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( append_a @ ( listIn84854903take_a @ M @ F ) @ ( drop_a @ M @ ( listIn84854903take_a @ N @ F ) ) )
        = ( listIn84854903take_a @ N @ F ) ) ) )).

% i_take_drop_append
thf(fact_91_append__eq__append__conv2,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a,Ts: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = ( append_a @ Zs @ Ts ) )
      = ( ? [Us2: list_a] :
            ( ( ( Xs
                = ( append_a @ Zs @ Us2 ) )
              & ( ( append_a @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append_a @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append_a @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_92_append__eq__appendI,axiom,(
    ! [Xs: list_a,Xs1: list_a,Zs: list_a,Ys: list_a,Us: list_a] :
      ( ( ( append_a @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append_a @ Xs1 @ Us ) )
       => ( ( append_a @ Xs @ Ys )
          = ( append_a @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_93_i__append__eq__i__append__conv2,axiom,(
    ! [Xs: list_a,F: nat > a,Ys: list_a,G: nat > a] :
      ( ( ( listIn1312259492pend_a @ Xs @ F )
        = ( listIn1312259492pend_a @ Ys @ G ) )
      = ( ? [Zs2: list_a] :
            ( ( ( Xs
                = ( append_a @ Ys @ Zs2 ) )
              & ( ( listIn1312259492pend_a @ Zs2 @ F )
                = G ) )
            | ( ( ( append_a @ Xs @ Zs2 )
                = Ys )
              & ( F
                = ( listIn1312259492pend_a @ Zs2 @ G ) ) ) ) ) ) )).

% i_append_eq_i_append_conv2
thf(fact_94_i__append__eq__i__appendI,axiom,(
    ! [Xs: list_a,Xs4: list_a,Ys: list_a,F: nat > a,G: nat > a] :
      ( ( ( append_a @ Xs @ Xs4 )
        = Ys )
     => ( ( F
          = ( listIn1312259492pend_a @ Xs4 @ G ) )
       => ( ( listIn1312259492pend_a @ Xs @ F )
          = ( listIn1312259492pend_a @ Ys @ G ) ) ) ) )).

% i_append_eq_i_appendI
thf(fact_95_i__append__eq__i__append__conv2__aux,axiom,(
    ! [Xs: list_a,F: nat > a,Ys: list_a,G: nat > a] :
      ( ( ( listIn1312259492pend_a @ Xs @ F )
        = ( listIn1312259492pend_a @ Ys @ G ) )
     => ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ ( size_size_list_a @ Ys ) )
       => ? [Zs3: list_a] :
            ( ( ( append_a @ Xs @ Zs3 )
              = Ys )
            & ( F
              = ( listIn1312259492pend_a @ Zs3 @ G ) ) ) ) ) )).

% i_append_eq_i_append_conv2_aux
thf(fact_96_append__eq__conv__conj,axiom,(
    ! [Xs: list_a,Ys: list_a,Zs: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = Zs )
      = ( ( Xs
          = ( take_a @ ( size_size_list_a @ Xs ) @ Zs ) )
        & ( Ys
          = ( drop_a @ ( size_size_list_a @ Xs ) @ Zs ) ) ) ) )).

% append_eq_conv_conj
thf(fact_97_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_98_append__eq__append__conv__if,axiom,(
    ! [Xs_1: list_a,Xs_2: list_a,Ys_1: list_a,Ys_2: list_a] :
      ( ( ( append_a @ Xs_1 @ Xs_2 )
        = ( append_a @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs_1 ) @ ( size_size_list_a @ Ys_1 ) )
         => ( ( Xs_1
              = ( take_a @ ( size_size_list_a @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append_a @ ( drop_a @ ( size_size_list_a @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq_nat @ ( size_size_list_a @ Xs_1 ) @ ( size_size_list_a @ Ys_1 ) )
         => ( ( ( take_a @ ( size_size_list_a @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append_a @ ( drop_a @ ( size_size_list_a @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) )).

% append_eq_append_conv_if
thf(fact_99_i__append__i__take__eq2,axiom,(
    ! [Xs: list_a,N: nat,F: nat > a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( listIn84854903take_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
        = ( append_a @ Xs @ ( listIn84854903take_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ F ) ) ) ) )).

% i_append_i_take_eq2
thf(fact_100_i__append__i__drop__if,axiom,(
    ! [N: nat,Xs: list_a,F: nat > a] :
      ( ( ( ord_less_nat @ N @ ( size_size_list_a @ Xs ) )
       => ( ( listIn1417627087drop_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
          = ( listIn1312259492pend_a @ ( drop_a @ N @ Xs ) @ F ) ) )
      & ( ~ ( ord_less_nat @ N @ ( size_size_list_a @ Xs ) )
       => ( ( listIn1417627087drop_a @ N @ ( listIn1312259492pend_a @ Xs @ F ) )
          = ( listIn1417627087drop_a @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ F ) ) ) ) )).

% i_append_i_drop_if
thf(fact_101_map2__append2__take__drop,axiom,(
    ! [Ys1: list_a,Xs: list_a,F: a > a > a,Ys22: list_a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Ys1 ) @ ( size_size_list_a @ Xs ) )
     => ( ( map2_a_a_a @ F @ Xs @ ( append_a @ Ys1 @ Ys22 ) )
        = ( append_a @ ( map2_a_a_a @ F @ ( take_a @ ( size_size_list_a @ Ys1 ) @ Xs ) @ Ys1 ) @ ( map2_a_a_a @ F @ ( drop_a @ ( size_size_list_a @ Ys1 ) @ Xs ) @ Ys22 ) ) ) ) )).

% map2_append2_take_drop
thf(fact_102_map2__append1__take__drop,axiom,(
    ! [Xs1: list_a,Ys: list_a,F: a > a > a,Xs22: list_a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs1 ) @ ( size_size_list_a @ Ys ) )
     => ( ( map2_a_a_a @ F @ ( append_a @ Xs1 @ Xs22 ) @ Ys )
        = ( append_a @ ( map2_a_a_a @ F @ Xs1 @ ( take_a @ ( size_size_list_a @ Xs1 ) @ Ys ) ) @ ( map2_a_a_a @ F @ Xs22 @ ( drop_a @ ( size_size_list_a @ Xs1 ) @ Ys ) ) ) ) ) )).

% map2_append1_take_drop
thf(fact_103_i__append__update2,axiom,(
    ! [Xs: list_a,N: nat,F: nat > a,X: a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( fun_upd_nat_a @ ( listIn1312259492pend_a @ Xs @ F ) @ N @ X )
        = ( listIn1312259492pend_a @ Xs @ ( fun_upd_nat_a @ F @ ( minus_minus_nat @ N @ ( size_size_list_a @ Xs ) ) @ X ) ) ) ) )).

% i_append_update2
thf(fact_104_drop__all__iff,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ( ( drop_a @ N @ Xs )
        = nil_a )
      = ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N ) ) )).

% drop_all_iff
thf(fact_105_append__Nil2,axiom,(
    ! [Xs: list_a] :
      ( ( append_a @ Xs @ nil_a )
      = Xs ) )).

% append_Nil2
thf(fact_106_append__self__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = Xs )
      = ( Ys = nil_a ) ) )).

% append_self_conv
thf(fact_107_self__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( Xs
        = ( append_a @ Xs @ Ys ) )
      = ( Ys = nil_a ) ) )).

% self_append_conv
thf(fact_108_append__self__conv2,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = Ys )
      = ( Xs = nil_a ) ) )).

% append_self_conv2
thf(fact_109_self__append__conv2,axiom,(
    ! [Ys: list_a,Xs: list_a] :
      ( ( Ys
        = ( append_a @ Xs @ Ys ) )
      = ( Xs = nil_a ) ) )).

% self_append_conv2
thf(fact_110_Nil__is__append__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( nil_a
        = ( append_a @ Xs @ Ys ) )
      = ( ( Xs = nil_a )
        & ( Ys = nil_a ) ) ) )).

% Nil_is_append_conv
thf(fact_111_append__is__Nil__conv,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( ( append_a @ Xs @ Ys )
        = nil_a )
      = ( ( Xs = nil_a )
        & ( Ys = nil_a ) ) ) )).

% append_is_Nil_conv
thf(fact_112_append_Oright__neutral,axiom,(
    ! [A: list_a] :
      ( ( append_a @ A @ nil_a )
      = A ) )).

% append.right_neutral
thf(fact_113_i__append__Nil,axiom,(
    ! [F: nat > a] :
      ( ( listIn1312259492pend_a @ nil_a @ F )
      = F ) )).

% i_append_Nil
thf(fact_114_drop__all,axiom,(
    ! [Xs: list_a,N: nat] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( drop_a @ N @ Xs )
        = nil_a ) ) )).

% drop_all
thf(fact_115_length__greater__imp__not__empty,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ( ord_less_nat @ N @ ( size_size_list_a @ Xs ) )
     => ( Xs != nil_a ) ) )).

% length_greater_imp_not_empty
thf(fact_116_drop__not__empty__conv,axiom,(
    ! [N: nat,Xs: list_a] :
      ( ( ( drop_a @ N @ Xs )
       != nil_a )
      = ( ord_less_nat @ N @ ( size_size_list_a @ Xs ) ) ) )).

% drop_not_empty_conv
thf(fact_117_map2_Osimps_I1_J,axiom,(
    ! [F: a > a > a,Ys: list_a] :
      ( ( map2_a_a_a @ F @ nil_a @ Ys )
      = nil_a ) )).

% map2.simps(1)
thf(fact_118_map2__Nil,axiom,(
    ! [F: a > a > a,Ys: list_a] :
      ( ( map2_a_a_a @ F @ nil_a @ Ys )
      = nil_a ) )).

% map2_Nil
thf(fact_119_map2__empty__conv,axiom,(
    ! [F: a > a > a,Xs: list_a,Ys: list_a] :
      ( ( ( map2_a_a_a @ F @ Xs @ Ys )
        = nil_a )
      = ( Xs = nil_a ) ) )).

% map2_empty_conv
thf(fact_120_map2__not__empty__conv,axiom,(
    ! [F: a > a > a,Xs: list_a,Ys: list_a] :
      ( ( ( map2_a_a_a @ F @ Xs @ Ys )
       != nil_a )
      = ( Xs != nil_a ) ) )).

% map2_not_empty_conv
thf(fact_121_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_122_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_123_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_124_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_125_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_126_neqE,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% neqE
thf(fact_127_neq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
      = ( ( ord_less_nat @ X @ Y2 )
        | ( ord_less_nat @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_128_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_129_less__imp__neq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_130_less__asym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_asym
thf(fact_131_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_132_less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_133_less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% less_linear
thf(fact_134_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_135_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_136_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_137_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_138_less__imp__not__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_139_less__not__sym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_140_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y5: nat] :
              ( ( ord_less_nat @ Y5 @ X3 )
             => ( P @ Y5 ) )
         => ( P @ X3 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_141_antisym__conv3,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y2 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_142_less__imp__not__eq2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_143_less__imp__triv,axiom,(
    ! [X: nat,Y2: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_144_linorder__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_145_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_146_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_147_less__imp__not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_148_exists__least__iff,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X4: nat] :
          ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ? [N2: nat] :
          ( ( P3 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P3 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_149_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P @ B3 @ A3 )
             => ( P @ A3 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_150_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_151_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_152_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_153_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_154_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_155_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_156_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_157_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_158_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_159_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ( P @ M3 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_160_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_161_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_162_ge__less__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,N2: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ A2 )
         => ( N2 != X2 ) ) ) )).

% ge_less_neq_conv
thf(fact_163_less__ge__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [N2: nat,A2: nat] :
        ! [X2: nat] :
          ( ( ord_less_eq_nat @ A2 @ X2 )
         => ( N2 != X2 ) ) ) )).

% less_ge_neq_conv
thf(fact_164_greater__le__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,N2: nat] :
        ! [X2: nat] :
          ( ( ord_less_eq_nat @ X2 @ A2 )
         => ( N2 != X2 ) ) ) )).

% greater_le_neq_conv
thf(fact_165_le__greater__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [N2: nat,A2: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ A2 @ X2 )
         => ( N2 != X2 ) ) ) )).

% le_greater_neq_conv
thf(fact_166_leD,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ~ ( ord_less_nat @ X @ Y2 ) ) )).

% leD
thf(fact_167_leI,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% leI
thf(fact_168_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_nat @ X2 @ Y3 )
          | ( X2 = Y3 ) ) ) )).

% le_less
thf(fact_169_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( X2 != Y3 ) ) ) )).

% less_le
thf(fact_170_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_171_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_172_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_173_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_174_not__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y2 ) )
      = ( ord_less_nat @ Y2 @ X ) ) )).

% not_le
thf(fact_175_not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ord_less_eq_nat @ Y2 @ X ) ) )).

% not_less
thf(fact_176_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_177_antisym__conv1,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_178_antisym__conv2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_179_less__imp__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_180_le__less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_181_less__le__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_182_le__less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% le_less_linear
thf(fact_183_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq
thf(fact_184_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ~ ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% less_le_not_le
thf(fact_185_not__le__imp__less,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y2 @ X )
     => ( ord_less_nat @ X @ Y2 ) ) )).

% not_le_imp_less
thf(fact_186_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_187_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_188_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_189_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_190_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_191_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_192_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_193_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_194_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_195_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_196_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_197_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) )).

% nat_less_le
thf(fact_198_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_199_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_200_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_201_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_202_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I2: nat,J: nat] :
      ( ! [I: nat,J2: nat] :
          ( ( ord_less_nat @ I @ J2 )
         => ( ord_less_nat @ ( F @ I ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I2 @ J )
       => ( ord_less_eq_nat @ ( F @ I2 ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_203_length__induct,axiom,(
    ! [P: list_a > $o,Xs: list_a] :
      ( ! [Xs3: list_a] :
          ( ! [Ys3: list_a] :
              ( ( ord_less_nat @ ( size_size_list_a @ Ys3 ) @ ( size_size_list_a @ Xs3 ) )
             => ( P @ Ys3 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs ) ) )).

% length_induct
thf(fact_204_nat__diff__right__cancel__less,axiom,(
    ! [N: nat,K: nat,M: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ N @ K ) @ ( minus_minus_nat @ M @ K ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_right_cancel_less
thf(fact_205_nat__diff__right__cancel__eq2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ N )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq2
thf(fact_206_nat__diff__right__cancel__eq1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq1
thf(fact_207_nat__diff__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_left_cancel_less
thf(fact_208_nat__diff__left__cancel__eq2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ N @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq2
thf(fact_209_nat__diff__left__cancel__eq1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq1
thf(fact_210_less__diff__imp__less,axiom,(
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I2 @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_nat @ I2 @ J ) ) )).

% less_diff_imp_less
thf(fact_211_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_212_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_213_map2__length,axiom,(
    ! [F: a > a > a,Xs: list_a,Ys: list_a] :
      ( ( size_size_list_a @ ( map2_a_a_a @ F @ Xs @ Ys ) )
      = ( size_size_list_a @ Xs ) ) )).

% map2_length
thf(fact_214_eq__Nil__appendI,axiom,(
    ! [Xs: list_a,Ys: list_a] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append_a @ nil_a @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_215_append__Nil,axiom,(
    ! [Ys: list_a] :
      ( ( append_a @ nil_a @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_216_append_Oleft__neutral,axiom,(
    ! [A: list_a] :
      ( ( append_a @ nil_a @ A )
      = A ) )).

% append.left_neutral
thf(fact_217_map2__take,axiom,(
    ! [N: nat,F: a > a > a,Xs: list_a,Ys: list_a] :
      ( ( take_a @ N @ ( map2_a_a_a @ F @ Xs @ Ys ) )
      = ( map2_a_a_a @ F @ ( take_a @ N @ Xs ) @ Ys ) ) )).

% map2_take
thf(fact_218_map2__take__take,axiom,(
    ! [N: nat,F: a > a > a,Xs: list_a,Ys: list_a] :
      ( ( take_a @ N @ ( map2_a_a_a @ F @ Xs @ Ys ) )
      = ( map2_a_a_a @ F @ ( take_a @ N @ Xs ) @ ( take_a @ N @ Ys ) ) ) )).

% map2_take_take
thf(fact_219_take__Nil,axiom,(
    ! [N: nat] :
      ( ( take_a @ N @ nil_a )
      = nil_a ) )).

% take_Nil
thf(fact_220_map2__drop,axiom,(
    ! [N: nat,F: a > a > a,Xs: list_a,Ys: list_a] :
      ( ( drop_a @ N @ ( map2_a_a_a @ F @ Xs @ Ys ) )
      = ( map2_a_a_a @ F @ ( drop_a @ N @ Xs ) @ ( drop_a @ N @ Ys ) ) ) )).

% map2_drop
thf(fact_221_drop__Nil,axiom,(
    ! [N: nat] :
      ( ( drop_a @ N @ nil_a )
      = nil_a ) )).

% drop_Nil
thf(fact_222_eq__Nil__i__appendI,axiom,(
    ! [F: nat > a,G: nat > a] :
      ( ( F = G )
     => ( F
        = ( listIn1312259492pend_a @ nil_a @ G ) ) ) )).

% eq_Nil_i_appendI
thf(fact_223_nat__diff__right__cancel__le1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le1
thf(fact_224_nat__diff__left__cancel__le1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le1
thf(fact_225_less__diff__le__imp__less,axiom,(
    ! [I2: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ I2 @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_nat @ I2 @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% less_diff_le_imp_less
thf(fact_226_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_227_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff
thf(fact_228_map2__append__append,axiom,(
    ! [Xs1: list_a,Ys1: list_a,F: a > a > a,Xs22: list_a,Ys22: list_a] :
      ( ( ( size_size_list_a @ Xs1 )
        = ( size_size_list_a @ Ys1 ) )
     => ( ( map2_a_a_a @ F @ ( append_a @ Xs1 @ Xs22 ) @ ( append_a @ Ys1 @ Ys22 ) )
        = ( append_a @ ( map2_a_a_a @ F @ Xs1 @ Ys1 ) @ ( map2_a_a_a @ F @ Xs22 @ Ys22 ) ) ) ) )).

% map2_append_append
thf(fact_229_map2__ys__take,axiom,(
    ! [Xs: list_a,N: nat,F: a > a > a,Ys: list_a] :
      ( ( ord_less_eq_nat @ ( size_size_list_a @ Xs ) @ N )
     => ( ( map2_a_a_a @ F @ Xs @ ( take_a @ N @ Ys ) )
        = ( map2_a_a_a @ F @ Xs @ Ys ) ) ) )).

% map2_ys_take

% Conjectures (2)
thf(conj_0,hypothesis,(
    ord_less_eq_nat @ ( size_size_list_a @ xs ) @ ( size_size_list_a @ ys ) )).

thf(conj_1,conjecture,
    ( ( ( listIn1312259492pend_a @ xs @ f )
      = ( listIn1312259492pend_a @ ys @ g ) )
    = ( ( xs
        = ( take_a @ ( size_size_list_a @ xs ) @ ys ) )
      & ( f
        = ( listIn1312259492pend_a @ ( drop_a @ ( size_size_list_a @ xs ) @ ys ) @ g ) ) ) )).

%------------------------------------------------------------------------------
