%------------------------------------------------------------------------------
% File     : SLH572^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer EdmondsKarp_Termination_Abstract problem prob_303__7590802_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : EdmondsKarp_Termination_Abstract/prob_303__7590802_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  265 (   1 unit;  22 type;   0 defn)
%            Number of atoms       : 2536 ( 203 equality;1565 variable)
%            Maximal formula depth :   16 (   8 average)
%            Number of connectives : 1953 (  66   ~;  16   |;  40   &;1549   @)
%                                         (   0 <=>; 282  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   99 (  99   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   24 (  22   :;   0   =)
%            Number of variables   :  728 (   0 sgn; 645   !;  27   ?;  56   ^)
%                                         ( 728   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:31:20.240
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__List__Olist_It__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J_J,type,(
    list_P559422087at_nat: $tType )).

thf(ty_n_t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    product_prod_nat_nat: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_tf__b,type,(
    b: $tType )).

% Explicit typings (18)
thf(sy_c_EdmondsKarp__Termination__Abstract__Mirabelle__pndqeoznpl_Oek__analysis_001tf__b,type,(
    edmond1517640973ysis_b: ( product_prod_nat_nat > b ) > $o )).

thf(sy_c_Graph_OFinite__Graph_001tf__b,type,(
    finite_Graph_b: ( product_prod_nat_nat > b ) > $o )).

thf(sy_c_Graph_OGraph_Oconnected_001tf__b,type,(
    connected_b: ( product_prod_nat_nat > b ) > nat > nat > $o )).

thf(sy_c_Graph_OGraph_Odist_001tf__b,type,(
    dist_b: ( product_prod_nat_nat > b ) > nat > nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisPath_001tf__b,type,(
    isPath_b: ( product_prod_nat_nat > b ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisShortestPath_001tf__b,type,(
    isShortestPath_b: ( product_prod_nat_nat > b ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisSimplePath_001tf__b,type,(
    isSimplePath_b: ( product_prod_nat_nat > b ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_Omin__dist_001tf__b,type,(
    min_dist_b: ( product_prod_nat_nat > b ) > nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_List_Oappend_001t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    append1441591836at_nat: list_P559422087at_nat > list_P559422087at_nat > list_P559422087at_nat )).

thf(sy_c_List_Olist_ONil_001t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    nil_Pr1308055047at_nat: list_P559422087at_nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_It__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J_J,type,(
    size_s1990949619at_nat: list_P559422087at_nat > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_c_H,type,(
    c: product_prod_nat_nat > b )).

thf(sy_v_s,type,(
    s: nat )).

thf(sy_v_t,type,(
    t: nat )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

% Relevant facts (241)
thf(fact_0__092_060open_062g_H_Odist_As_A_Ig_H_Omin__dist_As_At_J_At_092_060close_062,axiom,(
    dist_b @ c @ s @ ( min_dist_b @ c @ s @ t ) @ t )).

% \<open>g'.dist s (g'.min_dist s t) t\<close>
thf(fact_1_g_H_Odist__def,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_b @ c @ V @ D @ V2 )
      = ( ? [P: list_P559422087at_nat] :
            ( ( isPath_b @ c @ V @ P @ V2 )
            & ( ( size_s1990949619at_nat @ P )
              = D ) ) ) ) )).

% g'.dist_def
thf(fact_2_g_H_OisPath__distD,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isPath_b @ c @ U @ P2 @ V )
     => ( dist_b @ c @ U @ ( size_s1990949619at_nat @ P2 ) @ V ) ) )).

% g'.isPath_distD
thf(fact_3_CONN2,axiom,(
    connected_b @ c @ s @ t )).

% CONN2
thf(fact_4_g_H_Oek__analysis__axioms,axiom,(
    edmond1517640973ysis_b @ c )).

% g'.ek_analysis_axioms
thf(fact_5_g_H_OisShortestPath__min__dist__def,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ c @ U @ P2 @ V )
      = ( ( isPath_b @ c @ U @ P2 @ V )
        & ( ( size_s1990949619at_nat @ P2 )
          = ( min_dist_b @ c @ U @ V ) ) ) ) )).

% g'.isShortestPath_min_dist_def
thf(fact_6_g_H_OFinite__Graph__axioms,axiom,(
    finite_Graph_b @ c )).

% g'.Finite_Graph_axioms
thf(fact_7_g_H_OshortestPath__is__path,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ c @ U @ P2 @ V )
     => ( isPath_b @ c @ U @ P2 @ V ) ) )).

% g'.shortestPath_is_path
thf(fact_8_g_H_OisPath_Osimps_I1_J,axiom,(
    ! [U: nat,V: nat] :
      ( ( isPath_b @ c @ U @ nil_Pr1308055047at_nat @ V )
      = ( U = V ) ) )).

% g'.isPath.simps(1)
thf(fact_9_g_H_OisSPath__pathLE,axiom,(
    ! [S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isPath_b @ c @ S @ P2 @ T )
     => ? [P3: list_P559422087at_nat] :
          ( isSimplePath_b @ c @ S @ P3 @ T ) ) )).

% g'.isSPath_pathLE
thf(fact_10_g_H_OisPath__append,axiom,(
    ! [U: nat,P1: list_P559422087at_nat,P22: list_P559422087at_nat,V: nat] :
      ( ( isPath_b @ c @ U @ ( append1441591836at_nat @ P1 @ P22 ) @ V )
      = ( ? [W: nat] :
            ( ( isPath_b @ c @ U @ P1 @ W )
            & ( isPath_b @ c @ W @ P22 @ V ) ) ) ) )).

% g'.isPath_append
thf(fact_11_g_H_Oconnected__def,axiom,(
    ! [U: nat,V: nat] :
      ( ( connected_b @ c @ U @ V )
      = ( ? [P: list_P559422087at_nat] :
            ( isPath_b @ c @ U @ P @ V ) ) ) )).

% g'.connected_def
thf(fact_12_g_H_Omin__distI__eq,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_b @ c @ V @ D @ V2 )
     => ( ! [D2: nat] :
            ( ( dist_b @ c @ V @ D2 @ V2 )
           => ( ord_less_eq_nat @ D @ D2 ) )
       => ( ( min_dist_b @ c @ V @ V2 )
          = D ) ) ) )).

% g'.min_distI_eq
thf(fact_13_g_H_Omin__dist__minD,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_b @ c @ V @ D @ V2 )
     => ( ord_less_eq_nat @ ( min_dist_b @ c @ V @ V2 ) @ D ) ) )).

% g'.min_dist_minD
thf(fact_14_g_H_Omin__dist__split_I2_J,axiom,(
    ! [U: nat,D1: nat,W2: nat,D22: nat,V: nat] :
      ( ( dist_b @ c @ U @ D1 @ W2 )
     => ( ( dist_b @ c @ W2 @ D22 @ V )
       => ( ( ( min_dist_b @ c @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_b @ c @ W2 @ V )
            = D22 ) ) ) ) )).

% g'.min_dist_split(2)
thf(fact_15_g_H_Omin__dist__split_I1_J,axiom,(
    ! [U: nat,D1: nat,W2: nat,D22: nat,V: nat] :
      ( ( dist_b @ c @ U @ D1 @ W2 )
     => ( ( dist_b @ c @ W2 @ D22 @ V )
       => ( ( ( min_dist_b @ c @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_b @ c @ U @ W2 )
            = D1 ) ) ) ) )).

% g'.min_dist_split(1)
thf(fact_16_Graph_Odist__def,axiom,
    ( dist_b
    = ( ^ [C: product_prod_nat_nat > b,V3: nat,D3: nat,V4: nat] :
        ? [P: list_P559422087at_nat] :
          ( ( isPath_b @ C @ V3 @ P @ V4 )
          & ( ( size_s1990949619at_nat @ P )
            = D3 ) ) ) )).

% Graph.dist_def
thf(fact_17_g_H_Odist__trans,axiom,(
    ! [U: nat,D1: nat,W2: nat,D22: nat,V: nat] :
      ( ( dist_b @ c @ U @ D1 @ W2 )
     => ( ( dist_b @ c @ W2 @ D22 @ V )
       => ( dist_b @ c @ U @ ( plus_plus_nat @ D1 @ D22 ) @ V ) ) ) )).

% g'.dist_trans
thf(fact_18_g_H_Osplit__simple__path,axiom,(
    ! [U: nat,P1: list_P559422087at_nat,P22: list_P559422087at_nat,V: nat] :
      ( ( isSimplePath_b @ c @ U @ ( append1441591836at_nat @ P1 @ P22 ) @ V )
     => ? [W3: nat] :
          ( ( isSimplePath_b @ c @ U @ P1 @ W3 )
          & ( isSimplePath_b @ c @ W3 @ P22 @ V ) ) ) )).

% g'.split_simple_path
thf(fact_19_g_H_Oconnected__by__dist,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_b @ c @ V @ V2 )
      = ( ? [D3: nat] :
            ( dist_b @ c @ V @ D3 @ V2 ) ) ) )).

% g'.connected_by_dist
thf(fact_20_g_H_Osplit__shortest__path,axiom,(
    ! [U: nat,P1: list_P559422087at_nat,P22: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ c @ U @ ( append1441591836at_nat @ P1 @ P22 ) @ V )
     => ? [W3: nat] :
          ( ( isShortestPath_b @ c @ U @ P1 @ W3 )
          & ( isShortestPath_b @ c @ W3 @ P22 @ V ) ) ) )).

% g'.split_shortest_path
thf(fact_21_g_H_Oobtain__shortest__path,axiom,(
    ! [U: nat,V: nat] :
      ( ( connected_b @ c @ U @ V )
     => ~ ! [P4: list_P559422087at_nat] :
            ~ ( isShortestPath_b @ c @ U @ P4 @ V ) ) )).

% g'.obtain_shortest_path
thf(fact_22_g_H_OshortestPath__is__simple,axiom,(
    ! [S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isShortestPath_b @ c @ S @ P2 @ T )
     => ( isSimplePath_b @ c @ S @ P2 @ T ) ) )).

% g'.shortestPath_is_simple
thf(fact_23_g_H_Omin__dist__le,axiom,(
    ! [Src: nat,V: nat,D4: nat] :
      ( ( connected_b @ c @ Src @ V )
     => ( ( ord_less_eq_nat @ D4 @ ( min_dist_b @ c @ Src @ V ) )
       => ? [V5: nat] :
            ( ( connected_b @ c @ Src @ V5 )
            & ( ( min_dist_b @ c @ Src @ V5 )
              = D4 ) ) ) ) )).

% g'.min_dist_le
thf(fact_24_g_H_Omin__dist__is__dist,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_b @ c @ V @ V2 )
     => ( dist_b @ c @ V @ ( min_dist_b @ c @ V @ V2 ) @ V2 ) ) )).

% g'.min_dist_is_dist
thf(fact_25_g_H_OisShortestPath__def,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ c @ U @ P2 @ V )
      = ( ( isPath_b @ c @ U @ P2 @ V )
        & ! [P5: list_P559422087at_nat] :
            ( ( isPath_b @ c @ U @ P5 @ V )
           => ( ord_less_eq_nat @ ( size_s1990949619at_nat @ P2 ) @ ( size_s1990949619at_nat @ P5 ) ) ) ) ) )).

% g'.isShortestPath_def
thf(fact_26_g_H_Omin__distI2,axiom,(
    ! [V: nat,V2: nat,Q: nat > $o] :
      ( ( connected_b @ c @ V @ V2 )
     => ( ! [D5: nat] :
            ( ( dist_b @ c @ V @ D5 @ V2 )
           => ( ! [D6: nat] :
                  ( ( dist_b @ c @ V @ D6 @ V2 )
                 => ( ord_less_eq_nat @ D5 @ D6 ) )
             => ( Q @ D5 ) ) )
       => ( Q @ ( min_dist_b @ c @ V @ V2 ) ) ) ) )).

% g'.min_distI2
thf(fact_27_g_H_OisShortestPath__alt,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ c @ U @ P2 @ V )
      = ( ( isSimplePath_b @ c @ U @ P2 @ V )
        & ( ( size_s1990949619at_nat @ P2 )
          = ( min_dist_b @ c @ U @ V ) ) ) ) )).

% g'.isShortestPath_alt
thf(fact_28_g_H_Oconnected__refl,axiom,(
    ! [V: nat] :
      ( connected_b @ c @ V @ V ) )).

% g'.connected_refl
thf(fact_29_g_H_OsimplePath__same__conv,axiom,(
    ! [S: nat,P2: list_P559422087at_nat] :
      ( ( isSimplePath_b @ c @ S @ P2 @ S )
      = ( P2 = nil_Pr1308055047at_nat ) ) )).

% g'.simplePath_same_conv
thf(fact_30_g_H_OsimplePath__empty__conv,axiom,(
    ! [S: nat,T: nat] :
      ( ( isSimplePath_b @ c @ S @ nil_Pr1308055047at_nat @ T )
      = ( S = T ) ) )).

% g'.simplePath_empty_conv
thf(fact_31_g_H_Oconnected__distI,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_b @ c @ V @ D @ V2 )
     => ( connected_b @ c @ V @ V2 ) ) )).

% g'.connected_distI
thf(fact_32_Graph_Odist_Ocong,axiom,(
    dist_b = dist_b )).

% Graph.dist.cong
thf(fact_33_Graph_Odist__trans,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,D1: nat,W2: nat,D22: nat,V: nat] :
      ( ( dist_b @ C2 @ U @ D1 @ W2 )
     => ( ( dist_b @ C2 @ W2 @ D22 @ V )
       => ( dist_b @ C2 @ U @ ( plus_plus_nat @ D1 @ D22 ) @ V ) ) ) )).

% Graph.dist_trans
thf(fact_34_Graph_Omin__distI2,axiom,(
    ! [C2: product_prod_nat_nat > b,V: nat,V2: nat,Q: nat > $o] :
      ( ( connected_b @ C2 @ V @ V2 )
     => ( ! [D5: nat] :
            ( ( dist_b @ C2 @ V @ D5 @ V2 )
           => ( ! [D6: nat] :
                  ( ( dist_b @ C2 @ V @ D6 @ V2 )
                 => ( ord_less_eq_nat @ D5 @ D6 ) )
             => ( Q @ D5 ) ) )
       => ( Q @ ( min_dist_b @ C2 @ V @ V2 ) ) ) ) )).

% Graph.min_distI2
thf(fact_35_Graph_Omin__dist__le,axiom,(
    ! [C2: product_prod_nat_nat > b,Src: nat,V: nat,D4: nat] :
      ( ( connected_b @ C2 @ Src @ V )
     => ( ( ord_less_eq_nat @ D4 @ ( min_dist_b @ C2 @ Src @ V ) )
       => ? [V5: nat] :
            ( ( connected_b @ C2 @ Src @ V5 )
            & ( ( min_dist_b @ C2 @ Src @ V5 )
              = D4 ) ) ) ) )).

% Graph.min_dist_le
thf(fact_36_Graph_Oconnected_Ocong,axiom,(
    connected_b = connected_b )).

% Graph.connected.cong
thf(fact_37_Graph_Oconnected__refl,axiom,(
    ! [C2: product_prod_nat_nat > b,V: nat] :
      ( connected_b @ C2 @ V @ V ) )).

% Graph.connected_refl
thf(fact_38_Graph_Oconnected__distI,axiom,(
    ! [C2: product_prod_nat_nat > b,V: nat,D: nat,V2: nat] :
      ( ( dist_b @ C2 @ V @ D @ V2 )
     => ( connected_b @ C2 @ V @ V2 ) ) )).

% Graph.connected_distI
thf(fact_39_Graph_Oconnected__by__dist,axiom,
    ( connected_b
    = ( ^ [C: product_prod_nat_nat > b,V3: nat,V4: nat] :
        ? [D3: nat] :
          ( dist_b @ C @ V3 @ D3 @ V4 ) ) )).

% Graph.connected_by_dist
thf(fact_40_Graph_OisSimplePath_Ocong,axiom,(
    isSimplePath_b = isSimplePath_b )).

% Graph.isSimplePath.cong
thf(fact_41_Graph_Osplit__simple__path,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,P1: list_P559422087at_nat,P22: list_P559422087at_nat,V: nat] :
      ( ( isSimplePath_b @ C2 @ U @ ( append1441591836at_nat @ P1 @ P22 ) @ V )
     => ? [W3: nat] :
          ( ( isSimplePath_b @ C2 @ U @ P1 @ W3 )
          & ( isSimplePath_b @ C2 @ W3 @ P22 @ V ) ) ) )).

% Graph.split_simple_path
thf(fact_42_Graph_OisShortestPath_Ocong,axiom,(
    isShortestPath_b = isShortestPath_b )).

% Graph.isShortestPath.cong
thf(fact_43_Graph_Osplit__shortest__path,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,P1: list_P559422087at_nat,P22: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ C2 @ U @ ( append1441591836at_nat @ P1 @ P22 ) @ V )
     => ? [W3: nat] :
          ( ( isShortestPath_b @ C2 @ U @ P1 @ W3 )
          & ( isShortestPath_b @ C2 @ W3 @ P22 @ V ) ) ) )).

% Graph.split_shortest_path
thf(fact_44_Graph_Oobtain__shortest__path,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,V: nat] :
      ( ( connected_b @ C2 @ U @ V )
     => ~ ! [P4: list_P559422087at_nat] :
            ~ ( isShortestPath_b @ C2 @ U @ P4 @ V ) ) )).

% Graph.obtain_shortest_path
thf(fact_45_Graph_OsimplePath__same__conv,axiom,(
    ! [C2: product_prod_nat_nat > b,S: nat,P2: list_P559422087at_nat] :
      ( ( isSimplePath_b @ C2 @ S @ P2 @ S )
      = ( P2 = nil_Pr1308055047at_nat ) ) )).

% Graph.simplePath_same_conv
thf(fact_46_Graph_OsimplePath__empty__conv,axiom,(
    ! [C2: product_prod_nat_nat > b,S: nat,T: nat] :
      ( ( isSimplePath_b @ C2 @ S @ nil_Pr1308055047at_nat @ T )
      = ( S = T ) ) )).

% Graph.simplePath_empty_conv
thf(fact_47_Graph_OshortestPath__is__simple,axiom,(
    ! [C2: product_prod_nat_nat > b,S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isShortestPath_b @ C2 @ S @ P2 @ T )
     => ( isSimplePath_b @ C2 @ S @ P2 @ T ) ) )).

% Graph.shortestPath_is_simple
thf(fact_48_ek__analysis__def,axiom,(
    edmond1517640973ysis_b = finite_Graph_b )).

% ek_analysis_def
thf(fact_49_ek__analysis_Ointro,axiom,(
    ! [C2: product_prod_nat_nat > b] :
      ( ( finite_Graph_b @ C2 )
     => ( edmond1517640973ysis_b @ C2 ) ) )).

% ek_analysis.intro
thf(fact_50_ek__analysis_Oaxioms,axiom,(
    ! [C2: product_prod_nat_nat > b] :
      ( ( edmond1517640973ysis_b @ C2 )
     => ( finite_Graph_b @ C2 ) ) )).

% ek_analysis.axioms
thf(fact_51_Graph_Omin__dist__split_I1_J,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,D1: nat,W2: nat,D22: nat,V: nat] :
      ( ( dist_b @ C2 @ U @ D1 @ W2 )
     => ( ( dist_b @ C2 @ W2 @ D22 @ V )
       => ( ( ( min_dist_b @ C2 @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_b @ C2 @ U @ W2 )
            = D1 ) ) ) ) )).

% Graph.min_dist_split(1)
thf(fact_52_Graph_Omin__dist__split_I2_J,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,D1: nat,W2: nat,D22: nat,V: nat] :
      ( ( dist_b @ C2 @ U @ D1 @ W2 )
     => ( ( dist_b @ C2 @ W2 @ D22 @ V )
       => ( ( ( min_dist_b @ C2 @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_b @ C2 @ W2 @ V )
            = D22 ) ) ) ) )).

% Graph.min_dist_split(2)
thf(fact_53_Graph_Omin__dist__minD,axiom,(
    ! [C2: product_prod_nat_nat > b,V: nat,D: nat,V2: nat] :
      ( ( dist_b @ C2 @ V @ D @ V2 )
     => ( ord_less_eq_nat @ ( min_dist_b @ C2 @ V @ V2 ) @ D ) ) )).

% Graph.min_dist_minD
thf(fact_54_Graph_Omin__distI__eq,axiom,(
    ! [C2: product_prod_nat_nat > b,V: nat,D: nat,V2: nat] :
      ( ( dist_b @ C2 @ V @ D @ V2 )
     => ( ! [D2: nat] :
            ( ( dist_b @ C2 @ V @ D2 @ V2 )
           => ( ord_less_eq_nat @ D @ D2 ) )
       => ( ( min_dist_b @ C2 @ V @ V2 )
          = D ) ) ) )).

% Graph.min_distI_eq
thf(fact_55_Graph_Omin__dist__is__dist,axiom,(
    ! [C2: product_prod_nat_nat > b,V: nat,V2: nat] :
      ( ( connected_b @ C2 @ V @ V2 )
     => ( dist_b @ C2 @ V @ ( min_dist_b @ C2 @ V @ V2 ) @ V2 ) ) )).

% Graph.min_dist_is_dist
thf(fact_56_Graph_OisPath__append,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,P1: list_P559422087at_nat,P22: list_P559422087at_nat,V: nat] :
      ( ( isPath_b @ C2 @ U @ ( append1441591836at_nat @ P1 @ P22 ) @ V )
      = ( ? [W: nat] :
            ( ( isPath_b @ C2 @ U @ P1 @ W )
            & ( isPath_b @ C2 @ W @ P22 @ V ) ) ) ) )).

% Graph.isPath_append
thf(fact_57_Graph_OisPath_Osimps_I1_J,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,V: nat] :
      ( ( isPath_b @ C2 @ U @ nil_Pr1308055047at_nat @ V )
      = ( U = V ) ) )).

% Graph.isPath.simps(1)
thf(fact_58_Graph_Oconnected__def,axiom,
    ( connected_b
    = ( ^ [C: product_prod_nat_nat > b,U2: nat,V3: nat] :
        ? [P: list_P559422087at_nat] :
          ( isPath_b @ C @ U2 @ P @ V3 ) ) )).

% Graph.connected_def
thf(fact_59_Graph_OisSPath__pathLE,axiom,(
    ! [C2: product_prod_nat_nat > b,S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isPath_b @ C2 @ S @ P2 @ T )
     => ? [P3: list_P559422087at_nat] :
          ( isSimplePath_b @ C2 @ S @ P3 @ T ) ) )).

% Graph.isSPath_pathLE
thf(fact_60_Graph_OshortestPath__is__path,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShortestPath_b @ C2 @ U @ P2 @ V )
     => ( isPath_b @ C2 @ U @ P2 @ V ) ) )).

% Graph.shortestPath_is_path
thf(fact_61_Graph_OisShortestPath__def,axiom,
    ( isShortestPath_b
    = ( ^ [C: product_prod_nat_nat > b,U2: nat,P: list_P559422087at_nat,V3: nat] :
          ( ( isPath_b @ C @ U2 @ P @ V3 )
          & ! [P5: list_P559422087at_nat] :
              ( ( isPath_b @ C @ U2 @ P5 @ V3 )
             => ( ord_less_eq_nat @ ( size_s1990949619at_nat @ P ) @ ( size_s1990949619at_nat @ P5 ) ) ) ) ) )).

% Graph.isShortestPath_def
thf(fact_62_Graph_OisShortestPath__alt,axiom,
    ( isShortestPath_b
    = ( ^ [C: product_prod_nat_nat > b,U2: nat,P: list_P559422087at_nat,V3: nat] :
          ( ( isSimplePath_b @ C @ U2 @ P @ V3 )
          & ( ( size_s1990949619at_nat @ P )
            = ( min_dist_b @ C @ U2 @ V3 ) ) ) ) )).

% Graph.isShortestPath_alt
thf(fact_63_Graph_OisShortestPath__min__dist__def,axiom,
    ( isShortestPath_b
    = ( ^ [C: product_prod_nat_nat > b,U2: nat,P: list_P559422087at_nat,V3: nat] :
          ( ( isPath_b @ C @ U2 @ P @ V3 )
          & ( ( size_s1990949619at_nat @ P )
            = ( min_dist_b @ C @ U2 @ V3 ) ) ) ) )).

% Graph.isShortestPath_min_dist_def
thf(fact_64_Graph_OisPath_Ocong,axiom,(
    isPath_b = isPath_b )).

% Graph.isPath.cong
thf(fact_65_Graph_Omin__dist_Ocong,axiom,(
    min_dist_b = min_dist_b )).

% Graph.min_dist.cong
thf(fact_66_Graph_OisPath__distD,axiom,(
    ! [C2: product_prod_nat_nat > b,U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isPath_b @ C2 @ U @ P2 @ V )
     => ( dist_b @ C2 @ U @ ( size_s1990949619at_nat @ P2 ) @ V ) ) )).

% Graph.isPath_distD
thf(fact_67_length__append,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( size_s1990949619at_nat @ ( append1441591836at_nat @ Xs @ Ys ) )
      = ( plus_plus_nat @ ( size_s1990949619at_nat @ Xs ) @ ( size_s1990949619at_nat @ Ys ) ) ) )).

% length_append
thf(fact_68_append__eq__append__conv,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat,Us: list_P559422087at_nat,Vs: list_P559422087at_nat] :
      ( ( ( ( size_s1990949619at_nat @ Xs )
          = ( size_s1990949619at_nat @ Ys ) )
        | ( ( size_s1990949619at_nat @ Us )
          = ( size_s1990949619at_nat @ Vs ) ) )
     => ( ( ( append1441591836at_nat @ Xs @ Us )
          = ( append1441591836at_nat @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) )).

% append_eq_append_conv
thf(fact_69_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_70_append__Nil2,axiom,(
    ! [Xs: list_P559422087at_nat] :
      ( ( append1441591836at_nat @ Xs @ nil_Pr1308055047at_nat )
      = Xs ) )).

% append_Nil2
thf(fact_71_append__self__conv,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Xs @ Ys )
        = Xs )
      = ( Ys = nil_Pr1308055047at_nat ) ) )).

% append_self_conv
thf(fact_72_self__append__conv,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( Xs
        = ( append1441591836at_nat @ Xs @ Ys ) )
      = ( Ys = nil_Pr1308055047at_nat ) ) )).

% self_append_conv
thf(fact_73_append__self__conv2,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Xs @ Ys )
        = Ys )
      = ( Xs = nil_Pr1308055047at_nat ) ) )).

% append_self_conv2
thf(fact_74_self__append__conv2,axiom,(
    ! [Ys: list_P559422087at_nat,Xs: list_P559422087at_nat] :
      ( ( Ys
        = ( append1441591836at_nat @ Xs @ Ys ) )
      = ( Xs = nil_Pr1308055047at_nat ) ) )).

% self_append_conv2
thf(fact_75_Nil__is__append__conv,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( nil_Pr1308055047at_nat
        = ( append1441591836at_nat @ Xs @ Ys ) )
      = ( ( Xs = nil_Pr1308055047at_nat )
        & ( Ys = nil_Pr1308055047at_nat ) ) ) )).

% Nil_is_append_conv
thf(fact_76_append__is__Nil__conv,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Xs @ Ys )
        = nil_Pr1308055047at_nat )
      = ( ( Xs = nil_Pr1308055047at_nat )
        & ( Ys = nil_Pr1308055047at_nat ) ) ) )).

% append_is_Nil_conv
thf(fact_77_same__append__eq,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat,Zs: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Xs @ Ys )
        = ( append1441591836at_nat @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_78_append__same__eq,axiom,(
    ! [Ys: list_P559422087at_nat,Xs: list_P559422087at_nat,Zs: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Ys @ Xs )
        = ( append1441591836at_nat @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_79_append__assoc,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat,Zs: list_P559422087at_nat] :
      ( ( append1441591836at_nat @ ( append1441591836at_nat @ Xs @ Ys ) @ Zs )
      = ( append1441591836at_nat @ Xs @ ( append1441591836at_nat @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_80_append_Oassoc,axiom,(
    ! [A: list_P559422087at_nat,B: list_P559422087at_nat,C2: list_P559422087at_nat] :
      ( ( append1441591836at_nat @ ( append1441591836at_nat @ A @ B ) @ C2 )
      = ( append1441591836at_nat @ A @ ( append1441591836at_nat @ B @ C2 ) ) ) )).

% append.assoc
thf(fact_81_append_Oright__neutral,axiom,(
    ! [A: list_P559422087at_nat] :
      ( ( append1441591836at_nat @ A @ nil_Pr1308055047at_nat )
      = A ) )).

% append.right_neutral
thf(fact_82_size__neq__size__imp__neq,axiom,(
    ! [X: list_P559422087at_nat,Y: list_P559422087at_nat] :
      ( ( ( size_s1990949619at_nat @ X )
       != ( size_s1990949619at_nat @ Y ) )
     => ( X != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_83_Ex__list__of__length,axiom,(
    ! [N: nat] :
    ? [Xs2: list_P559422087at_nat] :
      ( ( size_s1990949619at_nat @ Xs2 )
      = N ) )).

% Ex_list_of_length
thf(fact_84_neq__if__length__neq,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( ( size_s1990949619at_nat @ Xs )
       != ( size_s1990949619at_nat @ Ys ) )
     => ( Xs != Ys ) ) )).

% neq_if_length_neq
thf(fact_85_Nat_Oex__has__greatest__nat,axiom,(
    ! [P6: nat > $o,K: nat,B: nat] :
      ( ( P6 @ K )
     => ( ! [Y2: nat] :
            ( ( P6 @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P6 @ X2 )
            & ! [Y3: nat] :
                ( ( P6 @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_86_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_87_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_88_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_89_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_90_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_91_append__eq__append__conv2,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat,Zs: list_P559422087at_nat,Ts: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Xs @ Ys )
        = ( append1441591836at_nat @ Zs @ Ts ) )
      = ( ? [Us2: list_P559422087at_nat] :
            ( ( ( Xs
                = ( append1441591836at_nat @ Zs @ Us2 ) )
              & ( ( append1441591836at_nat @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append1441591836at_nat @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append1441591836at_nat @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_92_append__eq__appendI,axiom,(
    ! [Xs: list_P559422087at_nat,Xs1: list_P559422087at_nat,Zs: list_P559422087at_nat,Ys: list_P559422087at_nat,Us: list_P559422087at_nat] :
      ( ( ( append1441591836at_nat @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append1441591836at_nat @ Xs1 @ Us ) )
       => ( ( append1441591836at_nat @ Xs @ Ys )
          = ( append1441591836at_nat @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_93_append_Oleft__neutral,axiom,(
    ! [A: list_P559422087at_nat] :
      ( ( append1441591836at_nat @ nil_Pr1308055047at_nat @ A )
      = A ) )).

% append.left_neutral
thf(fact_94_append__Nil,axiom,(
    ! [Ys: list_P559422087at_nat] :
      ( ( append1441591836at_nat @ nil_Pr1308055047at_nat @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_95_eq__Nil__appendI,axiom,(
    ! [Xs: list_P559422087at_nat,Ys: list_P559422087at_nat] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append1441591836at_nat @ nil_Pr1308055047at_nat @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_96_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus_nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_97_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_98_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_99_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_100_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_101_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus_nat @ K @ N3 ) ) ) )).

% le_Suc_ex
thf(fact_102_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_103_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_104_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_105_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_106_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_107_add__le__cancel__right,axiom,(
    ! [A: nat,C2: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ C2 ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_108_add__le__cancel__left,axiom,(
    ! [C2: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C2 @ A ) @ ( plus_plus_nat @ C2 @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_109_g_H_Omin__dist__less,axiom,(
    ! [Src: nat,V: nat,D: nat,D4: nat] :
      ( ( connected_b @ c @ Src @ V )
     => ( ( ( min_dist_b @ c @ Src @ V )
          = D )
       => ( ( ord_less_nat @ D4 @ D )
         => ? [V5: nat] :
              ( ( connected_b @ c @ Src @ V5 )
              & ( ( min_dist_b @ c @ Src @ V5 )
                = D4 ) ) ) ) ) )).

% g'.min_dist_less
thf(fact_110_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C2 @ A ) )
      = ( B = C2 ) ) )).

% add_right_cancel
thf(fact_111_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C2 ) )
      = ( B = C2 ) ) )).

% add_left_cancel
thf(fact_112_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_113_add__less__cancel__right,axiom,(
    ! [A: nat,C2: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ C2 ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_114_add__less__cancel__left,axiom,(
    ! [C2: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C2 @ A ) @ ( plus_plus_nat @ C2 @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_115_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_116_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_117_infinite__descent,axiom,(
    ! [P6: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P6 @ N3 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
              & ~ ( P6 @ M3 ) ) )
     => ( P6 @ N ) ) )).

% infinite_descent
thf(fact_118_nat__less__induct,axiom,(
    ! [P6: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ( P6 @ M3 ) )
         => ( P6 @ N3 ) )
     => ( P6 @ N ) ) )).

% nat_less_induct
thf(fact_119_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_120_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_121_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_122_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_123_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_124_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_125_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_126_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_127_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_128_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_129_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C2 @ B )
       => ( ord_less_nat @ C2 @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_130_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C2 @ B )
       => ( ord_less_nat @ C2 @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_131_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_132_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_133_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% order.strict_trans2
thf(fact_134_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% order.strict_trans1
thf(fact_135_not__le__imp__less,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X )
     => ( ord_less_nat @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_136_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X3: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y4 )
          & ~ ( ord_less_eq_nat @ Y4 @ X3 ) ) ) )).

% less_le_not_le
thf(fact_137_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_138_le__less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% le_less_linear
thf(fact_139_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_140_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_141_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_142_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_143_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_144_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_145_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_146_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_147_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_le_subst2
thf(fact_148_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_149_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_le_less_subst2
thf(fact_150_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_151_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X3: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y4 )
          & ( X3 != Y4 ) ) ) )).

% less_le
thf(fact_152_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X3: nat,Y4: nat] :
          ( ( ord_less_nat @ X3 @ Y4 )
          | ( X3 = Y4 ) ) ) )).

% le_less
thf(fact_153_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_154_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_155_add__less__imp__less__right,axiom,(
    ! [A: nat,C2: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ C2 ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_156_add__less__imp__less__left,axiom,(
    ! [C2: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C2 @ A ) @ ( plus_plus_nat @ C2 @ B ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_157_add__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ C2 ) ) ) )).

% add_strict_right_mono
thf(fact_158_add__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ C2 @ A ) @ ( plus_plus_nat @ C2 @ B ) ) ) )).

% add_strict_left_mono
thf(fact_159_add__strict__mono,axiom,(
    ! [A: nat,B: nat,C2: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C2 @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_160_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_161_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_162_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_163_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_164_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_165_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_166_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_167_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_168_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_169_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_170_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_171_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_172_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_173_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_174_less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_175_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_176_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_177_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% ord_eq_less_trans
thf(fact_178_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% ord_less_eq_trans
thf(fact_179_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_180_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_181_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_182_less__induct,axiom,(
    ! [P6: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P6 @ Y3 ) )
         => ( P6 @ X2 ) )
     => ( P6 @ A ) ) )).

% less_induct
thf(fact_183_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_184_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_185_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P6: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P6 ) ) )).

% less_imp_triv
thf(fact_186_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_187_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_188_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% order.strict_trans
thf(fact_189_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_190_exists__least__iff,axiom,
    ( ( ^ [P7: nat > $o] :
        ? [X4: nat] :
          ( P7 @ X4 ) )
    = ( ^ [P8: nat > $o] :
        ? [N2: nat] :
          ( ( P8 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P8 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_191_linorder__less__wlog,axiom,(
    ! [P6: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P6 @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P6 @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P6 @ B3 @ A3 )
             => ( P6 @ A3 @ B3 ) )
         => ( P6 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_192_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C2 @ B )
       => ( ord_less_nat @ C2 @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_193_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_194_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_195_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_196_length__induct,axiom,(
    ! [P6: list_P559422087at_nat > $o,Xs: list_P559422087at_nat] :
      ( ! [Xs2: list_P559422087at_nat] :
          ( ! [Ys2: list_P559422087at_nat] :
              ( ( ord_less_nat @ ( size_s1990949619at_nat @ Ys2 ) @ ( size_s1990949619at_nat @ Xs2 ) )
             => ( P6 @ Ys2 ) )
         => ( P6 @ Xs2 ) )
     => ( P6 @ Xs ) ) )).

% length_induct
thf(fact_197_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) )).

% nat_less_le
thf(fact_198_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_199_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_200_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_201_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_202_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_203_add__lessD1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ I @ K ) ) )).

% add_lessD1
thf(fact_204_add__less__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ K @ L )
       => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_less_mono
thf(fact_205_not__add__less1,axiom,(
    ! [I: nat,J: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ I ) )).

% not_add_less1
thf(fact_206_not__add__less2,axiom,(
    ! [J: nat,I: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ J @ I ) @ I ) )).

% not_add_less2
thf(fact_207_add__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_less_mono1
thf(fact_208_trans__less__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_less_add1
thf(fact_209_trans__less__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_less_add2
thf(fact_210_less__add__eq__less,axiom,(
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ K @ L )
     => ( ( ( plus_plus_nat @ M @ L )
          = ( plus_plus_nat @ K @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% less_add_eq_less
thf(fact_211_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_212_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_213_add__le__less__mono,axiom,(
    ! [A: nat,B: nat,C2: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C2 @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_214_add__less__le__mono,axiom,(
    ! [A: nat,B: nat,C2: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C2 @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C2 ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_215_mono__nat__linear__lb,axiom,(
    ! [F: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less_nat @ M4 @ N3 )
         => ( ord_less_nat @ ( F @ M4 ) @ ( F @ N3 ) ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ ( F @ M ) @ K ) @ ( F @ ( plus_plus_nat @ M @ K ) ) ) ) )).

% mono_nat_linear_lb
thf(fact_216_Graph_Omin__dist__less,axiom,(
    ! [C2: product_prod_nat_nat > b,Src: nat,V: nat,D: nat,D4: nat] :
      ( ( connected_b @ C2 @ Src @ V )
     => ( ( ( min_dist_b @ C2 @ Src @ V )
          = D )
       => ( ( ord_less_nat @ D4 @ D )
         => ? [V5: nat] :
              ( ( connected_b @ C2 @ Src @ V5 )
              & ( ( min_dist_b @ C2 @ Src @ V5 )
                = D4 ) ) ) ) ) )).

% Graph.min_dist_less
thf(fact_217_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_218_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_219_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_220_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_221_eq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [X3: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y4 )
          & ( ord_less_eq_nat @ Y4 @ X3 ) ) ) )).

% eq_iff
thf(fact_222_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_223_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_224_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_225_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_226_order_Otrans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ord_less_eq_nat @ A @ C2 ) ) ) )).

% order.trans
thf(fact_227_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z ) )
       => ( ( ( ord_less_eq_nat @ X @ Z )
           => ~ ( ord_less_eq_nat @ Z @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z )
               => ~ ( ord_less_eq_nat @ Z @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_228_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_229_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_230_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ord_less_eq_nat @ A @ C2 ) ) ) )).

% ord_eq_le_trans
thf(fact_231_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_eq_nat @ A @ C2 ) ) ) )).

% ord_le_eq_trans
thf(fact_232_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_233_order__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_eq_nat @ X @ Z ) ) ) )).

% order_trans
thf(fact_234_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_235_linorder__wlog,axiom,(
    ! [P6: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P6 @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P6 @ B3 @ A3 )
           => ( P6 @ A3 @ B3 ) )
       => ( P6 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_236_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C2 @ B )
       => ( ord_less_eq_nat @ C2 @ A ) ) ) )).

% dual_order.trans
thf(fact_237_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_238_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_239_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C2 )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C2 ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_240_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)

% Conjectures (2)
thf(conj_0,hypothesis,(
    ! [P9: list_P559422087at_nat] :
      ( ( isPath_b @ c @ s @ P9 @ t )
     => ( ( ( size_s1990949619at_nat @ P9 )
          = ( min_dist_b @ c @ s @ t ) )
       => thesis ) ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
