%------------------------------------------------------------------------------
% File     : SLH576^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer EdmondsKarp_Termination_Abstract problem prob_143__7582904_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : EdmondsKarp_Termination_Abstract/prob_143__7582904_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  260 (   0 unit;  26 type;   0 defn)
%            Number of atoms       : 2295 ( 214 equality;1316 variable)
%            Maximal formula depth :   16 (   8 average)
%            Number of connectives : 1691 (  58   ~;  11   |;  28   &;1358   @)
%                                         (   0 <=>; 236  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   80 (  80   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   28 (  26   :;   0   =)
%            Number of variables   :  621 (   0 sgn; 555   !;  18   ?;  48   ^)
%                                         ( 621   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:23.115
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__List__Olist_It__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J_J,type,(
    list_P559422087at_nat: $tType )).

thf(ty_n_t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    product_prod_nat_nat: $tType )).

thf(ty_n_tf__capacity,type,(
    capacity: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (22)
thf(sy_c_Graph_OGraph_Oconnected_001tf__capacity,type,(
    connected_capacity: ( product_prod_nat_nat > capacity ) > nat > nat > $o )).

thf(sy_c_Graph_OGraph_Odist_001tf__capacity,type,(
    dist_capacity: ( product_prod_nat_nat > capacity ) > nat > nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisPath_001tf__capacity,type,(
    isPath_capacity: ( product_prod_nat_nat > capacity ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisShortestPath_001tf__capacity,type,(
    isShor1936442771pacity: ( product_prod_nat_nat > capacity ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisSimplePath_001tf__capacity,type,(
    isSimp1359852763pacity: ( product_prod_nat_nat > capacity ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_Omin__dist_001tf__capacity,type,(
    min_dist_capacity: ( product_prod_nat_nat > capacity ) > nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_List_Olist_ONil_001t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    nil_Pr1308055047at_nat: list_P559422087at_nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_It__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J_J,type,(
    size_s1990949619at_nat: list_P559422087at_nat > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_c,type,(
    c: product_prod_nat_nat > capacity )).

thf(sy_v_p,type,(
    p: list_P559422087at_nat )).

thf(sy_v_p1____,type,(
    p1: list_P559422087at_nat )).

thf(sy_v_p1a____,type,(
    p1a: list_P559422087at_nat )).

thf(sy_v_p2_Ha____,type,(
    p2_a: list_P559422087at_nat )).

thf(sy_v_s,type,(
    s: nat )).

thf(sy_v_t,type,(
    t: nat )).

thf(sy_v_ua____,type,(
    ua: nat )).

thf(sy_v_v____,type,(
    v: nat )).

thf(sy_v_va____,type,(
    va: nat )).

% Relevant facts (233)
thf(fact_0_min__dist__minD,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
     => ( ord_less_eq_nat @ ( min_dist_capacity @ c @ V @ V2 ) @ D ) ) )).

% min_dist_minD
thf(fact_1__092_060open_062isPath_Au_Ap2_H_At_092_060close_062,axiom,(
    isPath_capacity @ c @ ua @ p2_a @ t )).

% \<open>isPath u p2' t\<close>
thf(fact_2_min__distI__eq,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
     => ( ! [D2: nat] :
            ( ( dist_capacity @ c @ V @ D2 @ V2 )
           => ( ord_less_eq_nat @ D @ D2 ) )
       => ( ( min_dist_capacity @ c @ V @ V2 )
          = D ) ) ) )).

% min_distI_eq
thf(fact_3_dist__def,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
      = ( ? [P: list_P559422087at_nat] :
            ( ( isPath_capacity @ c @ V @ P @ V2 )
            & ( ( size_s1990949619at_nat @ P )
              = D ) ) ) ) )).

% dist_def
thf(fact_4_isPath__distD,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isPath_capacity @ c @ U @ P2 @ V )
     => ( dist_capacity @ c @ U @ ( size_s1990949619at_nat @ P2 ) @ V ) ) )).

% isPath_distD
thf(fact_5_min__dist__le,axiom,(
    ! [Src: nat,V: nat,D3: nat] :
      ( ( connected_capacity @ c @ Src @ V )
     => ( ( ord_less_eq_nat @ D3 @ ( min_dist_capacity @ c @ Src @ V ) )
       => ? [V3: nat] :
            ( ( connected_capacity @ c @ Src @ V3 )
            & ( ( min_dist_capacity @ c @ Src @ V3 )
              = D3 ) ) ) ) )).

% min_dist_le
thf(fact_6_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_7_isShortestPath__min__dist__def,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
      = ( ( isPath_capacity @ c @ U @ P2 @ V )
        & ( ( size_s1990949619at_nat @ P2 )
          = ( min_dist_capacity @ c @ U @ V ) ) ) ) )).

% isShortestPath_min_dist_def
thf(fact_8_isShortestPath__def,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
      = ( ( isPath_capacity @ c @ U @ P2 @ V )
        & ! [P3: list_P559422087at_nat] :
            ( ( isPath_capacity @ c @ U @ P3 @ V )
           => ( ord_less_eq_nat @ ( size_s1990949619at_nat @ P2 ) @ ( size_s1990949619at_nat @ P3 ) ) ) ) ) )).

% isShortestPath_def
thf(fact_9_min__distI2,axiom,(
    ! [V: nat,V2: nat,Q: nat > $o] :
      ( ( connected_capacity @ c @ V @ V2 )
     => ( ! [D4: nat] :
            ( ( dist_capacity @ c @ V @ D4 @ V2 )
           => ( ! [D5: nat] :
                  ( ( dist_capacity @ c @ V @ D5 @ V2 )
                 => ( ord_less_eq_nat @ D4 @ D5 ) )
             => ( Q @ D4 ) ) )
       => ( Q @ ( min_dist_capacity @ c @ V @ V2 ) ) ) ) )).

% min_distI2
thf(fact_10__092_060open_062min__dist_As_At_A_061_Amin__dist_As_Au_A_L_Amin__dist_Au_At_092_060close_062,axiom,
    ( ( min_dist_capacity @ c @ s @ t )
    = ( plus_plus_nat @ ( min_dist_capacity @ c @ s @ ua ) @ ( min_dist_capacity @ c @ ua @ t ) ) )).

% \<open>min_dist s t = min_dist s u + min_dist u t\<close>
thf(fact_11_min__dist__split_I2_J,axiom,(
    ! [U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ c @ U @ D1 @ W )
     => ( ( dist_capacity @ c @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ c @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ c @ W @ V )
            = D22 ) ) ) ) )).

% min_dist_split(2)
thf(fact_12_min__dist__split_I1_J,axiom,(
    ! [U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ c @ U @ D1 @ W )
     => ( ( dist_capacity @ c @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ c @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ c @ U @ W )
            = D1 ) ) ) ) )).

% min_dist_split(1)
thf(fact_13_min__dist__is__dist,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_capacity @ c @ V @ V2 )
     => ( dist_capacity @ c @ V @ ( min_dist_capacity @ c @ V @ V2 ) @ V2 ) ) )).

% min_dist_is_dist
thf(fact_14_Graph_Omin__distI__eq,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ D @ V2 )
     => ( ! [D2: nat] :
            ( ( dist_capacity @ C @ V @ D2 @ V2 )
           => ( ord_less_eq_nat @ D @ D2 ) )
       => ( ( min_dist_capacity @ C @ V @ V2 )
          = D ) ) ) )).

% Graph.min_distI_eq
thf(fact_15_Graph_Omin__dist__minD,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ D @ V2 )
     => ( ord_less_eq_nat @ ( min_dist_capacity @ C @ V @ V2 ) @ D ) ) )).

% Graph.min_dist_minD
thf(fact_16_min__dist__z,axiom,(
    ! [V: nat] :
      ( ( min_dist_capacity @ c @ V @ V )
      = zero_zero_nat ) )).

% min_dist_z
thf(fact_17_dist__trans,axiom,(
    ! [U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ c @ U @ D1 @ W )
     => ( ( dist_capacity @ c @ W @ D22 @ V )
       => ( dist_capacity @ c @ U @ ( plus_plus_nat @ D1 @ D22 ) @ V ) ) ) )).

% dist_trans
thf(fact_18_connected__def,axiom,(
    ! [U: nat,V: nat] :
      ( ( connected_capacity @ c @ U @ V )
      = ( ? [P: list_P559422087at_nat] :
            ( isPath_capacity @ c @ U @ P @ V ) ) ) )).

% connected_def
thf(fact_19_shortestPath__is__path,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
     => ( isPath_capacity @ c @ U @ P2 @ V ) ) )).

% shortestPath_is_path
thf(fact_20_connected__by__dist,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_capacity @ c @ V @ V2 )
      = ( ? [D6: nat] :
            ( dist_capacity @ c @ V @ D6 @ V2 ) ) ) )).

% connected_by_dist
thf(fact_21_obtain__shortest__path,axiom,(
    ! [U: nat,V: nat] :
      ( ( connected_capacity @ c @ U @ V )
     => ~ ! [P4: list_P559422087at_nat] :
            ~ ( isShor1936442771pacity @ c @ U @ P4 @ V ) ) )).

% obtain_shortest_path
thf(fact_22__092_060open_062isPath_As_Ap1_____Av_____092_060close_062,axiom,(
    isPath_capacity @ c @ s @ p1 @ v )).

% \<open>isPath s p1__ v__\<close>
thf(fact_23__092_060open_062connected_As_Au_092_060close_062,axiom,(
    connected_capacity @ c @ s @ ua )).

% \<open>connected s u\<close>
thf(fact_24_SP,axiom,(
    isShor1936442771pacity @ c @ s @ p @ t )).

% SP
thf(fact_25_connected__refl,axiom,(
    ! [V: nat] :
      ( connected_capacity @ c @ V @ V ) )).

% connected_refl
thf(fact_26_dist__z__iff,axiom,(
    ! [V: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ zero_zero_nat @ V2 )
      = ( V2 = V ) ) )).

% dist_z_iff
thf(fact_27_dist__z,axiom,(
    ! [V: nat] :
      ( dist_capacity @ c @ V @ zero_zero_nat @ V ) )).

% dist_z
thf(fact_28_connected__distI,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
     => ( connected_capacity @ c @ V @ V2 ) ) )).

% connected_distI
thf(fact_29_min__dist__z__iff,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_capacity @ c @ V @ V2 )
     => ( ( ( min_dist_capacity @ c @ V @ V2 )
          = zero_zero_nat )
        = ( V2 = V ) ) ) )).

% min_dist_z_iff
thf(fact_30_Graph_Odist__z,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat] :
      ( dist_capacity @ C @ V @ zero_zero_nat @ V ) )).

% Graph.dist_z
thf(fact_31_Graph_Odist_Ocong,axiom,(
    dist_capacity = dist_capacity )).

% Graph.dist.cong
thf(fact_32_Graph_Odist__trans,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ C @ U @ D1 @ W )
     => ( ( dist_capacity @ C @ W @ D22 @ V )
       => ( dist_capacity @ C @ U @ ( plus_plus_nat @ D1 @ D22 ) @ V ) ) ) )).

% Graph.dist_trans
thf(fact_33_Graph_Odist__z__iff,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ zero_zero_nat @ V2 )
      = ( V2 = V ) ) )).

% Graph.dist_z_iff
thf(fact_34_Graph_OisPath_Ocong,axiom,(
    isPath_capacity = isPath_capacity )).

% Graph.isPath.cong
thf(fact_35_Graph_Oconnected__def,axiom,
    ( connected_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,V4: nat] :
        ? [P: list_P559422087at_nat] :
          ( isPath_capacity @ C2 @ U2 @ P @ V4 ) ) )).

% Graph.connected_def
thf(fact_36_Graph_Oconnected_Ocong,axiom,(
    connected_capacity = connected_capacity )).

% Graph.connected.cong
thf(fact_37_Graph_Oconnected__refl,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat] :
      ( connected_capacity @ C @ V @ V ) )).

% Graph.connected_refl
thf(fact_38_Graph_Omin__dist__z__iff,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,V2: nat] :
      ( ( connected_capacity @ C @ V @ V2 )
     => ( ( ( min_dist_capacity @ C @ V @ V2 )
          = zero_zero_nat )
        = ( V2 = V ) ) ) )).

% Graph.min_dist_z_iff
thf(fact_39_Graph_Oconnected__distI,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ D @ V2 )
     => ( connected_capacity @ C @ V @ V2 ) ) )).

% Graph.connected_distI
thf(fact_40_Graph_Oconnected__by__dist,axiom,
    ( connected_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,V4: nat,V5: nat] :
        ? [D6: nat] :
          ( dist_capacity @ C2 @ V4 @ D6 @ V5 ) ) )).

% Graph.connected_by_dist
thf(fact_41_Graph_OisShortestPath_Ocong,axiom,(
    isShor1936442771pacity = isShor1936442771pacity )).

% Graph.isShortestPath.cong
thf(fact_42_Graph_Oobtain__shortest__path,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,V: nat] :
      ( ( connected_capacity @ C @ U @ V )
     => ~ ! [P4: list_P559422087at_nat] :
            ~ ( isShor1936442771pacity @ C @ U @ P4 @ V ) ) )).

% Graph.obtain_shortest_path
thf(fact_43_Graph_OshortestPath__is__path,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ C @ U @ P2 @ V )
     => ( isPath_capacity @ C @ U @ P2 @ V ) ) )).

% Graph.shortestPath_is_path
thf(fact_44_Graph_Omin__dist__split_I1_J,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ C @ U @ D1 @ W )
     => ( ( dist_capacity @ C @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ C @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ C @ U @ W )
            = D1 ) ) ) ) )).

% Graph.min_dist_split(1)
thf(fact_45_Graph_Omin__dist__split_I2_J,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ C @ U @ D1 @ W )
     => ( ( dist_capacity @ C @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ C @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ C @ W @ V )
            = D22 ) ) ) ) )).

% Graph.min_dist_split(2)
thf(fact_46_Graph_Omin__dist__is__dist,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,V2: nat] :
      ( ( connected_capacity @ C @ V @ V2 )
     => ( dist_capacity @ C @ V @ ( min_dist_capacity @ C @ V @ V2 ) @ V2 ) ) )).

% Graph.min_dist_is_dist
thf(fact_47_Graph_Omin__dist__z,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat] :
      ( ( min_dist_capacity @ C @ V @ V )
      = zero_zero_nat ) )).

% Graph.min_dist_z
thf(fact_48_Graph_Omin__distI2,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,V2: nat,Q: nat > $o] :
      ( ( connected_capacity @ C @ V @ V2 )
     => ( ! [D4: nat] :
            ( ( dist_capacity @ C @ V @ D4 @ V2 )
           => ( ! [D5: nat] :
                  ( ( dist_capacity @ C @ V @ D5 @ V2 )
                 => ( ord_less_eq_nat @ D4 @ D5 ) )
             => ( Q @ D4 ) ) )
       => ( Q @ ( min_dist_capacity @ C @ V @ V2 ) ) ) ) )).

% Graph.min_distI2
thf(fact_49_Graph_OisPath__distD,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isPath_capacity @ C @ U @ P2 @ V )
     => ( dist_capacity @ C @ U @ ( size_s1990949619at_nat @ P2 ) @ V ) ) )).

% Graph.isPath_distD
thf(fact_50_Graph_Odist__def,axiom,
    ( dist_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,V4: nat,D6: nat,V5: nat] :
        ? [P: list_P559422087at_nat] :
          ( ( isPath_capacity @ C2 @ V4 @ P @ V5 )
          & ( ( size_s1990949619at_nat @ P )
            = D6 ) ) ) )).

% Graph.dist_def
thf(fact_51_Graph_OisShortestPath__def,axiom,
    ( isShor1936442771pacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,P: list_P559422087at_nat,V4: nat] :
          ( ( isPath_capacity @ C2 @ U2 @ P @ V4 )
          & ! [P3: list_P559422087at_nat] :
              ( ( isPath_capacity @ C2 @ U2 @ P3 @ V4 )
             => ( ord_less_eq_nat @ ( size_s1990949619at_nat @ P ) @ ( size_s1990949619at_nat @ P3 ) ) ) ) ) )).

% Graph.isShortestPath_def
thf(fact_52_Graph_OisShortestPath__min__dist__def,axiom,
    ( isShor1936442771pacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,P: list_P559422087at_nat,V4: nat] :
          ( ( isPath_capacity @ C2 @ U2 @ P @ V4 )
          & ( ( size_s1990949619at_nat @ P )
            = ( min_dist_capacity @ C2 @ U2 @ V4 ) ) ) ) )).

% Graph.isShortestPath_min_dist_def
thf(fact_53_Graph_Omin__dist__le,axiom,(
    ! [C: product_prod_nat_nat > capacity,Src: nat,V: nat,D3: nat] :
      ( ( connected_capacity @ C @ Src @ V )
     => ( ( ord_less_eq_nat @ D3 @ ( min_dist_capacity @ C @ Src @ V ) )
       => ? [V3: nat] :
            ( ( connected_capacity @ C @ Src @ V3 )
            & ( ( min_dist_capacity @ C @ Src @ V3 )
              = D3 ) ) ) ) )).

% Graph.min_dist_le
thf(fact_54_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_55_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_56_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_57_linorder__wlog,axiom,(
    ! [P5: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P5 @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P5 @ B3 @ A3 )
           => ( P5 @ A3 @ B3 ) )
       => ( P5 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_58_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_59_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_60_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_61_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_62_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_63_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_64_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_65_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_66_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_67_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_68_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_69_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_70_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_71_eq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_72_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_73_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_74_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_75_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_76_Graph_Omin__dist_Ocong,axiom,(
    min_dist_capacity = min_dist_capacity )).

% Graph.min_dist.cong
thf(fact_77_add__le__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel1
thf(fact_78_add__le__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel2
thf(fact_79_le__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel1
thf(fact_80_le__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel2
thf(fact_81_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_82_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        & ( N = zero_zero_nat ) ) ) )).

% add_is_0
thf(fact_83_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus_nat @ M @ zero_zero_nat )
      = M ) )).

% Nat.add_0_right
thf(fact_84_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_85_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_86_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_87_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_88_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_89_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_90_zero__eq__add__iff__both__eq__0,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( zero_zero_nat
        = ( plus_plus_nat @ X @ Y2 ) )
      = ( ( X = zero_zero_nat )
        & ( Y2 = zero_zero_nat ) ) ) )).

% zero_eq_add_iff_both_eq_0
thf(fact_91_add__eq__0__iff__both__eq__0,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ( plus_plus_nat @ X @ Y2 )
        = zero_zero_nat )
      = ( ( X = zero_zero_nat )
        & ( Y2 = zero_zero_nat ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_92_add__cancel__right__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ A @ B ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_right
thf(fact_93_add__cancel__right__left,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ B @ A ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_left
thf(fact_94_add__cancel__left__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_right
thf(fact_95_add__cancel__left__left,axiom,(
    ! [B: nat,A: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_left
thf(fact_96_add_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.right_neutral
thf(fact_97_add_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% add.left_neutral
thf(fact_98_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_99_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_100_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_101_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_102_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_103_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A2: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A2 ) ) )).

% add.commute
thf(fact_104_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_105_group__cancel_Oadd2,axiom,(
    ! [B4: nat,K: nat,B: nat,A: nat] :
      ( ( B4
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B4 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_106_group__cancel_Oadd1,axiom,(
    ! [A4: nat,K: nat,A: nat,B: nat] :
      ( ( A4
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A4 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_107_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_108_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_109_size__neq__size__imp__neq,axiom,(
    ! [X: list_P559422087at_nat,Y2: list_P559422087at_nat] :
      ( ( ( size_s1990949619at_nat @ X )
       != ( size_s1990949619at_nat @ Y2 ) )
     => ( X != Y2 ) ) )).

% size_neq_size_imp_neq
thf(fact_110_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_111_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_112_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_113_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_114_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_115_Nat_Oex__has__greatest__nat,axiom,(
    ! [P5: nat > $o,K: nat,B: nat] :
      ( ( P5 @ K )
     => ( ! [Y4: nat] :
            ( ( P5 @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X3: nat] :
            ( ( P5 @ X3 )
            & ! [Y5: nat] :
                ( ( P5 @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_116_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_117_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_118_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_119_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_120_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_121_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_122_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_123_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_124_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
        ? [C2: nat] :
          ( B2
          = ( plus_plus_nat @ A2 @ C2 ) ) ) )).

% le_iff_add
thf(fact_125_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_126_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_127_add_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.comm_neutral
thf(fact_128_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_129_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_130_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_131_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_132_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_133_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = M )
     => ( N = zero_zero_nat ) ) )).

% add_eq_self_zero
thf(fact_134_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_135_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_136_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_137_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_138_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_139_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_140_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus_nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_141_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_142_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_143_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_144_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_145_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus_nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_146_add__nonpos__eq__0__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ Y2 @ zero_zero_nat )
       => ( ( ( plus_plus_nat @ X @ Y2 )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y2 = zero_zero_nat ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_147_add__nonneg__eq__0__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ X )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ Y2 )
       => ( ( ( plus_plus_nat @ X @ Y2 )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y2 = zero_zero_nat ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_148_add__nonpos__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_nonpos_nonpos
thf(fact_149_add__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_150_add__increasing2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ C )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_151_add__decreasing2,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_152_add__increasing,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_153_add__decreasing,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_154_P1,axiom,(
    isPath_capacity @ c @ s @ p1a @ va )).

% P1
thf(fact_155_isShortestPath__alt,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
      = ( ( isSimp1359852763pacity @ c @ U @ P2 @ V )
        & ( ( size_s1990949619at_nat @ P2 )
          = ( min_dist_capacity @ c @ U @ V ) ) ) ) )).

% isShortestPath_alt
thf(fact_156_min__dist__less,axiom,(
    ! [Src: nat,V: nat,D: nat,D3: nat] :
      ( ( connected_capacity @ c @ Src @ V )
     => ( ( ( min_dist_capacity @ c @ Src @ V )
          = D )
       => ( ( ord_less_nat @ D3 @ D )
         => ? [V3: nat] :
              ( ( connected_capacity @ c @ Src @ V3 )
              & ( ( min_dist_capacity @ c @ Src @ V3 )
                = D3 ) ) ) ) ) )).

% min_dist_less
thf(fact_157__092_060open_062min__dist_As_Au_A_060_Alength_Ap1_092_060close_062,axiom,(
    ord_less_nat @ ( min_dist_capacity @ c @ s @ ua ) @ ( size_s1990949619at_nat @ p1a ) )).

% \<open>min_dist s u < length p1\<close>
thf(fact_158_isPath_Osimps_I1_J,axiom,(
    ! [U: nat,V: nat] :
      ( ( isPath_capacity @ c @ U @ nil_Pr1308055047at_nat @ V )
      = ( U = V ) ) )).

% isPath.simps(1)
thf(fact_159_isSPath__pathLE,axiom,(
    ! [S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isPath_capacity @ c @ S @ P2 @ T )
     => ? [P6: list_P559422087at_nat] :
          ( isSimp1359852763pacity @ c @ S @ P6 @ T ) ) )).

% isSPath_pathLE
thf(fact_160_shortestPath__is__simple,axiom,(
    ! [S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isShor1936442771pacity @ c @ S @ P2 @ T )
     => ( isSimp1359852763pacity @ c @ S @ P2 @ T ) ) )).

% shortestPath_is_simple
thf(fact_161_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_162_add__less__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_163_add__less__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_164_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_165_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_166_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_167_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_168_add__less__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_nat @ A @ zero_zero_nat ) ) )).

% add_less_same_cancel1
thf(fact_169_add__less__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_nat @ A @ zero_zero_nat ) ) )).

% add_less_same_cancel2
thf(fact_170_less__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_nat @ zero_zero_nat @ B ) ) )).

% less_add_same_cancel1
thf(fact_171_less__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_nat @ zero_zero_nat @ B ) ) )).

% less_add_same_cancel2
thf(fact_172_add__gr__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( plus_plus_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        | ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% add_gr_0
thf(fact_173_simplePath__empty__conv,axiom,(
    ! [S: nat,T: nat] :
      ( ( isSimp1359852763pacity @ c @ S @ nil_Pr1308055047at_nat @ T )
      = ( S = T ) ) )).

% simplePath_empty_conv
thf(fact_174_simplePath__same__conv,axiom,(
    ! [S: nat,P2: list_P559422087at_nat] :
      ( ( isSimp1359852763pacity @ c @ S @ P2 @ S )
      = ( P2 = nil_Pr1308055047at_nat ) ) )).

% simplePath_same_conv
thf(fact_175_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_176_infinite__descent,axiom,(
    ! [P5: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P5 @ N2 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N2 )
              & ~ ( P5 @ M3 ) ) )
     => ( P5 @ N ) ) )).

% infinite_descent
thf(fact_177_nat__less__induct,axiom,(
    ! [P5: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N2 )
             => ( P5 @ M3 ) )
         => ( P5 @ N2 ) )
     => ( P5 @ N ) ) )).

% nat_less_induct
thf(fact_178_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_179_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_180_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_181_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_182_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_183_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_184_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_185_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_186_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_187_linorder__less__wlog,axiom,(
    ! [P5: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P5 @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P5 @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P5 @ B3 @ A3 )
             => ( P5 @ A3 @ B3 ) )
         => ( P5 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_188_exists__least__iff,axiom,
    ( ( ^ [P7: nat > $o] :
        ? [X4: nat] :
          ( P7 @ X4 ) )
    = ( ^ [P8: nat > $o] :
        ? [N3: nat] :
          ( ( P8 @ N3 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N3 )
             => ~ ( P8 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_189_less__imp__not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_190_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_191_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_192_linorder__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_193_less__imp__triv,axiom,(
    ! [X: nat,Y2: nat,P5: $o] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ X )
       => P5 ) ) )).

% less_imp_triv
thf(fact_194_less__imp__not__eq2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_195_antisym__conv3,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y2 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_196_less__induct,axiom,(
    ! [P5: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y5: nat] :
              ( ( ord_less_nat @ Y5 @ X3 )
             => ( P5 @ Y5 ) )
         => ( P5 @ X3 ) )
     => ( P5 @ A ) ) )).

% less_induct
thf(fact_197_less__not__sym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_198_less__imp__not__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_199_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_200_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_201_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_202_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_203_less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% less_linear
thf(fact_204_less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_205_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_206_less__asym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_asym
thf(fact_207_less__imp__neq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_208_Graph_OsimplePath__empty__conv,axiom,(
    ! [C: product_prod_nat_nat > capacity,S: nat,T: nat] :
      ( ( isSimp1359852763pacity @ C @ S @ nil_Pr1308055047at_nat @ T )
      = ( S = T ) ) )).

% Graph.simplePath_empty_conv
thf(fact_209_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_210_neq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
      = ( ( ord_less_nat @ X @ Y2 )
        | ( ord_less_nat @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_211_Graph_OsimplePath__same__conv,axiom,(
    ! [C: product_prod_nat_nat > capacity,S: nat,P2: list_P559422087at_nat] :
      ( ( isSimp1359852763pacity @ C @ S @ P2 @ S )
      = ( P2 = nil_Pr1308055047at_nat ) ) )).

% Graph.simplePath_same_conv
thf(fact_212_neqE,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% neqE
thf(fact_213_Graph_OisSimplePath_Ocong,axiom,(
    isSimp1359852763pacity = isSimp1359852763pacity )).

% Graph.isSimplePath.cong
thf(fact_214_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_215_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_216_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_217_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_218_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_219_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_220_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_221_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_222_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_223_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_224_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_225_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_226_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_227_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_228_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_229_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_230_not__le__imp__less,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y2 @ X )
     => ( ord_less_nat @ X @ Y2 ) ) )).

% not_le_imp_less
thf(fact_231_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ~ ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% less_le_not_le
thf(fact_232_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_nat @ ( min_dist_capacity @ c @ ua @ t ) @ ( size_s1990949619at_nat @ p2_a ) )).

%------------------------------------------------------------------------------
