%------------------------------------------------------------------------------
% File     : SLH668^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Safety_Regular problem prob_297__3353112_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Safety_Regular/prob_297__3353112_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  312 (   1 unit;  31 type;   0 defn)
%            Number of atoms       : 2515 ( 359 equality; 989 variable)
%            Maximal formula depth :   11 (   6 average)
%            Number of connectives : 1543 (  27   ~;   0   |;   2   &;1469   @)
%                                         (   0 <=>;  45  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   36 (  36   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   33 (  31   :;   0   =)
%            Number of variables   :  503 (   0 sgn; 481   !;   2   ?;  20   ^)
%                                         ( 503   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:37:42.699
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Cars__Ocars,type,(
    cars: $tType )).

thf(ty_n_t__Num__Onum,type,(
    num: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (27)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Real__Oreal,type,(
    minus_minus_real: real > real > real )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Real__Oreal,type,(
    one_one_real: real )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Num__Onum,type,(
    plus_plus_num: num > num > num )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Real__Oreal,type,(
    plus_plus_real: real > real > real )).

thf(sy_c_Groups_Ouminus__class_Ouminus_001t__Real__Oreal,type,(
    uminus_uminus_real: real > real )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Num_OBitM,type,(
    bitM: num > num )).

thf(sy_c_Num_Oinc,type,(
    inc: num > num )).

thf(sy_c_Num_Oneg__numeral__class_Odbl_001t__Real__Oreal,type,(
    neg_numeral_dbl_real: real > real )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec_001t__Real__Oreal,type,(
    neg_nu533782273c_real: real > real )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc_001t__Real__Oreal,type,(
    neg_nu1973887165c_real: real > real )).

thf(sy_c_Num_Oneg__numeral__class_Osub_001t__Real__Oreal,type,(
    neg_numeral_sub_real: num > num > real )).

thf(sy_c_Num_Onum_OBit0,type,(
    bit0: num > num )).

thf(sy_c_Num_Onum_OBit1,type,(
    bit1: num > num )).

thf(sy_c_Num_Onum_OOne,type,(
    one: num )).

thf(sy_c_Num_Onumeral__class_Onumeral_001t__Nat__Onat,type,(
    numeral_numeral_nat: num > nat )).

thf(sy_c_Num_Onumeral__class_Onumeral_001t__Real__Oreal,type,(
    numeral_numeral_real: num > real )).

thf(sy_c_Num_Opow,type,(
    pow: num > num > num )).

thf(sy_c_Num_Oring__1__class_Oiszero_001t__Real__Oreal,type,(
    ring_1_iszero_real: real > $o )).

thf(sy_c_Num_Osqr,type,(
    sqr: num > num )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Num__Onum,type,(
    ord_less_eq_num: num > num > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

% Relevant facts (279)
thf(fact_0_semiring__norm_I86_J,axiom,(
    ! [M: num] :
      ( ( bit1 @ M )
     != one ) )).

% semiring_norm(86)
thf(fact_1_semiring__norm_I84_J,axiom,(
    ! [N: num] :
      ( one
     != ( bit1 @ N ) ) )).

% semiring_norm(84)
thf(fact_2_semiring__norm_I89_J,axiom,(
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) )).

% semiring_norm(89)
thf(fact_3_semiring__norm_I88_J,axiom,(
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) )).

% semiring_norm(88)
thf(fact_4_semiring__norm_I85_J,axiom,(
    ! [M: num] :
      ( ( bit0 @ M )
     != one ) )).

% semiring_norm(85)
thf(fact_5_semiring__norm_I83_J,axiom,(
    ! [N: num] :
      ( one
     != ( bit0 @ N ) ) )).

% semiring_norm(83)
thf(fact_6_num_Oinduct,axiom,(
    ! [P: num > $o,Num: num] :
      ( ( P @ one )
     => ( ! [X: num] :
            ( ( P @ X )
           => ( P @ ( bit0 @ X ) ) )
       => ( ! [X: num] :
              ( ( P @ X )
             => ( P @ ( bit1 @ X ) ) )
         => ( P @ Num ) ) ) ) )).

% num.induct
thf(fact_7_num_Oexhaust,axiom,(
    ! [Y: num] :
      ( ( Y != one )
     => ( ! [X2: num] :
            ( Y
           != ( bit0 @ X2 ) )
       => ~ ! [X3: num] :
              ( Y
             != ( bit1 @ X3 ) ) ) ) )).

% num.exhaust
thf(fact_8_verit__eq__simplify_I9_J,axiom,(
    ! [X32: num,Y3: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y3 ) )
      = ( X32 = Y3 ) ) )).

% verit_eq_simplify(9)
thf(fact_9_semiring__norm_I90_J,axiom,(
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) )).

% semiring_norm(90)
thf(fact_10_verit__eq__simplify_I8_J,axiom,(
    ! [X22: num,Y2: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y2 ) )
      = ( X22 = Y2 ) ) )).

% verit_eq_simplify(8)
thf(fact_11_semiring__norm_I87_J,axiom,(
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) )).

% semiring_norm(87)
thf(fact_12_numeral__eq__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ( numeral_numeral_real @ M )
        = ( numeral_numeral_real @ N ) )
      = ( M = N ) ) )).

% numeral_eq_iff
thf(fact_13_numeral__eq__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ( numeral_numeral_nat @ M )
        = ( numeral_numeral_nat @ N ) )
      = ( M = N ) ) )).

% numeral_eq_iff
thf(fact_14_verit__eq__simplify_I10_J,axiom,(
    ! [X22: num] :
      ( one
     != ( bit0 @ X22 ) ) )).

% verit_eq_simplify(10)
thf(fact_15_verit__eq__simplify_I14_J,axiom,(
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) )).

% verit_eq_simplify(14)
thf(fact_16_verit__eq__simplify_I12_J,axiom,(
    ! [X32: num] :
      ( one
     != ( bit1 @ X32 ) ) )).

% verit_eq_simplify(12)
thf(fact_17_dbl__inc__simps_I5_J,axiom,(
    ! [K: num] :
      ( ( neg_nu1973887165c_real @ ( numeral_numeral_real @ K ) )
      = ( numeral_numeral_real @ ( bit1 @ K ) ) ) )).

% dbl_inc_simps(5)
thf(fact_18_sub__num__simps_I5_J,axiom,(
    ! [K: num] :
      ( ( neg_numeral_sub_real @ ( bit1 @ K ) @ one )
      = ( numeral_numeral_real @ ( bit0 @ K ) ) ) )).

% sub_num_simps(5)
thf(fact_19_dbl__simps_I5_J,axiom,(
    ! [K: num] :
      ( ( neg_numeral_dbl_real @ ( numeral_numeral_real @ K ) )
      = ( numeral_numeral_real @ ( bit0 @ K ) ) ) )).

% dbl_simps(5)
thf(fact_20_semiring__norm_I3_J,axiom,(
    ! [N: num] :
      ( ( plus_plus_num @ one @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) )).

% semiring_norm(3)
thf(fact_21_semiring__norm_I4_J,axiom,(
    ! [N: num] :
      ( ( plus_plus_num @ one @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus_num @ N @ one ) ) ) )).

% semiring_norm(4)
thf(fact_22_semiring__norm_I5_J,axiom,(
    ! [M: num] :
      ( ( plus_plus_num @ ( bit0 @ M ) @ one )
      = ( bit1 @ M ) ) )).

% semiring_norm(5)
thf(fact_23_semiring__norm_I8_J,axiom,(
    ! [M: num] :
      ( ( plus_plus_num @ ( bit1 @ M ) @ one )
      = ( bit0 @ ( plus_plus_num @ M @ one ) ) ) )).

% semiring_norm(8)
thf(fact_24_semiring__norm_I10_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus_num @ ( plus_plus_num @ M @ N ) @ one ) ) ) )).

% semiring_norm(10)
thf(fact_25_inc_Osimps_I2_J,axiom,(
    ! [X4: num] :
      ( ( inc @ ( bit0 @ X4 ) )
      = ( bit1 @ X4 ) ) )).

% inc.simps(2)
thf(fact_26_inc_Osimps_I3_J,axiom,(
    ! [X4: num] :
      ( ( inc @ ( bit1 @ X4 ) )
      = ( bit0 @ ( inc @ X4 ) ) ) )).

% inc.simps(3)
thf(fact_27_inc_Osimps_I1_J,axiom,
    ( ( inc @ one )
    = ( bit0 @ one ) )).

% inc.simps(1)
thf(fact_28_semiring__norm_I6_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus_num @ M @ N ) ) ) )).

% semiring_norm(6)
thf(fact_29_numeral__plus__numeral,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_real @ ( numeral_numeral_real @ M ) @ ( numeral_numeral_real @ N ) )
      = ( numeral_numeral_real @ ( plus_plus_num @ M @ N ) ) ) )).

% numeral_plus_numeral
thf(fact_30_numeral__plus__numeral,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_nat @ ( numeral_numeral_nat @ M ) @ ( numeral_numeral_nat @ N ) )
      = ( numeral_numeral_nat @ ( plus_plus_num @ M @ N ) ) ) )).

% numeral_plus_numeral
thf(fact_31_add__numeral__left,axiom,(
    ! [V: num,W: num,Z: real] :
      ( ( plus_plus_real @ ( numeral_numeral_real @ V ) @ ( plus_plus_real @ ( numeral_numeral_real @ W ) @ Z ) )
      = ( plus_plus_real @ ( numeral_numeral_real @ ( plus_plus_num @ V @ W ) ) @ Z ) ) )).

% add_numeral_left
thf(fact_32_add__numeral__left,axiom,(
    ! [V: num,W: num,Z: nat] :
      ( ( plus_plus_nat @ ( numeral_numeral_nat @ V ) @ ( plus_plus_nat @ ( numeral_numeral_nat @ W ) @ Z ) )
      = ( plus_plus_nat @ ( numeral_numeral_nat @ ( plus_plus_num @ V @ W ) ) @ Z ) ) )).

% add_numeral_left
thf(fact_33_semiring__norm_I2_J,axiom,
    ( ( plus_plus_num @ one @ one )
    = ( bit0 @ one ) )).

% semiring_norm(2)
thf(fact_34_semiring__norm_I9_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus_num @ M @ N ) ) ) )).

% semiring_norm(9)
thf(fact_35_semiring__norm_I7_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus_num @ M @ N ) ) ) )).

% semiring_norm(7)
thf(fact_36_sub__num__simps_I6_J,axiom,(
    ! [K: num,L: num] :
      ( ( neg_numeral_sub_real @ ( bit0 @ K ) @ ( bit0 @ L ) )
      = ( neg_numeral_dbl_real @ ( neg_numeral_sub_real @ K @ L ) ) ) )).

% sub_num_simps(6)
thf(fact_37_sub__num__simps_I9_J,axiom,(
    ! [K: num,L: num] :
      ( ( neg_numeral_sub_real @ ( bit1 @ K ) @ ( bit1 @ L ) )
      = ( neg_numeral_dbl_real @ ( neg_numeral_sub_real @ K @ L ) ) ) )).

% sub_num_simps(9)
thf(fact_38_sub__num__simps_I8_J,axiom,(
    ! [K: num,L: num] :
      ( ( neg_numeral_sub_real @ ( bit1 @ K ) @ ( bit0 @ L ) )
      = ( neg_nu1973887165c_real @ ( neg_numeral_sub_real @ K @ L ) ) ) )).

% sub_num_simps(8)
thf(fact_39_is__num__normalize_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% is_num_normalize(1)
thf(fact_40_add__inc,axiom,(
    ! [X4: num,Y: num] :
      ( ( plus_plus_num @ X4 @ ( inc @ Y ) )
      = ( inc @ ( plus_plus_num @ X4 @ Y ) ) ) )).

% add_inc
thf(fact_41_dbl__def,axiom,
    ( neg_numeral_dbl_real
    = ( ^ [X5: real] :
          ( plus_plus_real @ X5 @ X5 ) ) )).

% dbl_def
thf(fact_42_add__One,axiom,(
    ! [X4: num] :
      ( ( plus_plus_num @ X4 @ one )
      = ( inc @ X4 ) ) )).

% add_One
thf(fact_43_add__One__commute,axiom,(
    ! [N: num] :
      ( ( plus_plus_num @ one @ N )
      = ( plus_plus_num @ N @ one ) ) )).

% add_One_commute
thf(fact_44_sub__inc__One__eq,axiom,(
    ! [N: num] :
      ( ( neg_numeral_sub_real @ ( inc @ N ) @ one )
      = ( numeral_numeral_real @ N ) ) )).

% sub_inc_One_eq
thf(fact_45_num__induct,axiom,(
    ! [P: num > $o,X4: num] :
      ( ( P @ one )
     => ( ! [X: num] :
            ( ( P @ X )
           => ( P @ ( inc @ X ) ) )
       => ( P @ X4 ) ) ) )).

% num_induct
thf(fact_46_numeral__Bit0,axiom,(
    ! [N: num] :
      ( ( numeral_numeral_real @ ( bit0 @ N ) )
      = ( plus_plus_real @ ( numeral_numeral_real @ N ) @ ( numeral_numeral_real @ N ) ) ) )).

% numeral_Bit0
thf(fact_47_numeral__Bit0,axiom,(
    ! [N: num] :
      ( ( numeral_numeral_nat @ ( bit0 @ N ) )
      = ( plus_plus_nat @ ( numeral_numeral_nat @ N ) @ ( numeral_numeral_nat @ N ) ) ) )).

% numeral_Bit0
thf(fact_48_sub__num__simps_I7_J,axiom,(
    ! [K: num,L: num] :
      ( ( neg_numeral_sub_real @ ( bit0 @ K ) @ ( bit1 @ L ) )
      = ( neg_nu533782273c_real @ ( neg_numeral_sub_real @ K @ L ) ) ) )).

% sub_num_simps(7)
thf(fact_49_add__right__cancel,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_50_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_51_add__left__cancel,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_52_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_53_sub__num__simps_I4_J,axiom,(
    ! [K: num] :
      ( ( neg_numeral_sub_real @ ( bit0 @ K ) @ one )
      = ( numeral_numeral_real @ ( bitM @ K ) ) ) )).

% sub_num_simps(4)
thf(fact_54_sub__num__simps_I3_J,axiom,(
    ! [L: num] :
      ( ( neg_numeral_sub_real @ one @ ( bit1 @ L ) )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( bit0 @ L ) ) ) ) )).

% sub_num_simps(3)
thf(fact_55_sqr_Osimps_I3_J,axiom,(
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus_num @ ( sqr @ N ) @ N ) ) ) ) )).

% sqr.simps(3)
thf(fact_56_dbl__inc__simps_I3_J,axiom,
    ( ( neg_nu1973887165c_real @ one_one_real )
    = ( numeral_numeral_real @ ( bit1 @ one ) ) )).

% dbl_inc_simps(3)
thf(fact_57_dbl__simps_I3_J,axiom,
    ( ( neg_numeral_dbl_real @ one_one_real )
    = ( numeral_numeral_real @ ( bit0 @ one ) ) )).

% dbl_simps(3)
thf(fact_58_numeral__plus__one,axiom,(
    ! [N: num] :
      ( ( plus_plus_real @ ( numeral_numeral_real @ N ) @ one_one_real )
      = ( numeral_numeral_real @ ( plus_plus_num @ N @ one ) ) ) )).

% numeral_plus_one
thf(fact_59_numeral__plus__one,axiom,(
    ! [N: num] :
      ( ( plus_plus_nat @ ( numeral_numeral_nat @ N ) @ one_one_nat )
      = ( numeral_numeral_nat @ ( plus_plus_num @ N @ one ) ) ) )).

% numeral_plus_one
thf(fact_60_add_Oinverse__inverse,axiom,(
    ! [A: real] :
      ( ( uminus_uminus_real @ ( uminus_uminus_real @ A ) )
      = A ) )).

% add.inverse_inverse
thf(fact_61_neg__equal__iff__equal,axiom,(
    ! [A: real,B: real] :
      ( ( ( uminus_uminus_real @ A )
        = ( uminus_uminus_real @ B ) )
      = ( A = B ) ) )).

% neg_equal_iff_equal
thf(fact_62_verit__minus__simplify_I4_J,axiom,(
    ! [B: real] :
      ( ( uminus_uminus_real @ ( uminus_uminus_real @ B ) )
      = B ) )).

% verit_minus_simplify(4)
thf(fact_63_add__minus__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ A @ ( plus_plus_real @ ( uminus_uminus_real @ A ) @ B ) )
      = B ) )).

% add_minus_cancel
thf(fact_64_minus__add__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ A ) @ ( plus_plus_real @ A @ B ) )
      = B ) )).

% minus_add_cancel
thf(fact_65_minus__add__distrib,axiom,(
    ! [A: real,B: real] :
      ( ( uminus_uminus_real @ ( plus_plus_real @ A @ B ) )
      = ( plus_plus_real @ ( uminus_uminus_real @ A ) @ ( uminus_uminus_real @ B ) ) ) )).

% minus_add_distrib
thf(fact_66_neg__numeral__eq__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ( uminus_uminus_real @ ( numeral_numeral_real @ M ) )
        = ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( M = N ) ) )).

% neg_numeral_eq_iff
thf(fact_67_dbl__dec__simps_I3_J,axiom,
    ( ( neg_nu533782273c_real @ one_one_real )
    = one_one_real )).

% dbl_dec_simps(3)
thf(fact_68_add__neg__numeral__simps_I3_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( uminus_uminus_real @ ( plus_plus_real @ ( numeral_numeral_real @ M ) @ ( numeral_numeral_real @ N ) ) ) ) )).

% add_neg_numeral_simps(3)
thf(fact_69_one__eq__numeral__iff,axiom,(
    ! [N: num] :
      ( ( one_one_real
        = ( numeral_numeral_real @ N ) )
      = ( one = N ) ) )).

% one_eq_numeral_iff
thf(fact_70_one__eq__numeral__iff,axiom,(
    ! [N: num] :
      ( ( one_one_nat
        = ( numeral_numeral_nat @ N ) )
      = ( one = N ) ) )).

% one_eq_numeral_iff
thf(fact_71_numeral__eq__one__iff,axiom,(
    ! [N: num] :
      ( ( ( numeral_numeral_real @ N )
        = one_one_real )
      = ( N = one ) ) )).

% numeral_eq_one_iff
thf(fact_72_numeral__eq__one__iff,axiom,(
    ! [N: num] :
      ( ( ( numeral_numeral_nat @ N )
        = one_one_nat )
      = ( N = one ) ) )).

% numeral_eq_one_iff
thf(fact_73_dbl__simps_I1_J,axiom,(
    ! [K: num] :
      ( ( neg_numeral_dbl_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ K ) ) )
      = ( uminus_uminus_real @ ( neg_numeral_dbl_real @ ( numeral_numeral_real @ K ) ) ) ) )).

% dbl_simps(1)
thf(fact_74_dbl__inc__simps_I4_J,axiom,
    ( ( neg_nu1973887165c_real @ ( uminus_uminus_real @ one_one_real ) )
    = ( uminus_uminus_real @ one_one_real ) )).

% dbl_inc_simps(4)
thf(fact_75_dbl__dec__simps_I5_J,axiom,(
    ! [K: num] :
      ( ( neg_nu533782273c_real @ ( numeral_numeral_real @ K ) )
      = ( numeral_numeral_real @ ( bitM @ K ) ) ) )).

% dbl_dec_simps(5)
thf(fact_76_numeral__eq__neg__one__iff,axiom,(
    ! [N: num] :
      ( ( ( uminus_uminus_real @ ( numeral_numeral_real @ N ) )
        = ( uminus_uminus_real @ one_one_real ) )
      = ( N = one ) ) )).

% numeral_eq_neg_one_iff
thf(fact_77_neg__one__eq__numeral__iff,axiom,(
    ! [N: num] :
      ( ( ( uminus_uminus_real @ one_one_real )
        = ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( N = one ) ) )).

% neg_one_eq_numeral_iff
thf(fact_78_semiring__norm_I168_J,axiom,(
    ! [V: num,W: num,Y: real] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ V ) ) @ ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ W ) ) @ Y ) )
      = ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ ( plus_plus_num @ V @ W ) ) ) @ Y ) ) )).

% semiring_norm(168)
thf(fact_79_add__neg__numeral__simps_I1_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_real @ ( numeral_numeral_real @ M ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( neg_numeral_sub_real @ M @ N ) ) )).

% add_neg_numeral_simps(1)
thf(fact_80_add__neg__numeral__simps_I2_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( numeral_numeral_real @ N ) )
      = ( neg_numeral_sub_real @ N @ M ) ) )).

% add_neg_numeral_simps(2)
thf(fact_81_semiring__norm_I166_J,axiom,(
    ! [V: num,W: num,Y: real] :
      ( ( plus_plus_real @ ( numeral_numeral_real @ V ) @ ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ W ) ) @ Y ) )
      = ( plus_plus_real @ ( neg_numeral_sub_real @ V @ W ) @ Y ) ) )).

% semiring_norm(166)
thf(fact_82_semiring__norm_I167_J,axiom,(
    ! [V: num,W: num,Y: real] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ V ) ) @ ( plus_plus_real @ ( numeral_numeral_real @ W ) @ Y ) )
      = ( plus_plus_real @ ( neg_numeral_sub_real @ W @ V ) @ Y ) ) )).

% semiring_norm(167)
thf(fact_83_dbl__dec__simps_I1_J,axiom,(
    ! [K: num] :
      ( ( neg_nu533782273c_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ K ) ) )
      = ( uminus_uminus_real @ ( neg_nu1973887165c_real @ ( numeral_numeral_real @ K ) ) ) ) )).

% dbl_dec_simps(1)
thf(fact_84_dbl__inc__simps_I1_J,axiom,(
    ! [K: num] :
      ( ( neg_nu1973887165c_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ K ) ) )
      = ( uminus_uminus_real @ ( neg_nu533782273c_real @ ( numeral_numeral_real @ K ) ) ) ) )).

% dbl_inc_simps(1)
thf(fact_85_one__add__one,axiom,
    ( ( plus_plus_real @ one_one_real @ one_one_real )
    = ( numeral_numeral_real @ ( bit0 @ one ) ) )).

% one_add_one
thf(fact_86_one__add__one,axiom,
    ( ( plus_plus_nat @ one_one_nat @ one_one_nat )
    = ( numeral_numeral_nat @ ( bit0 @ one ) ) )).

% one_add_one
thf(fact_87_one__plus__numeral,axiom,(
    ! [N: num] :
      ( ( plus_plus_real @ one_one_real @ ( numeral_numeral_real @ N ) )
      = ( numeral_numeral_real @ ( plus_plus_num @ one @ N ) ) ) )).

% one_plus_numeral
thf(fact_88_one__plus__numeral,axiom,(
    ! [N: num] :
      ( ( plus_plus_nat @ one_one_nat @ ( numeral_numeral_nat @ N ) )
      = ( numeral_numeral_nat @ ( plus_plus_num @ one @ N ) ) ) )).

% one_plus_numeral
thf(fact_89_add__neg__numeral__special_I5_J,axiom,(
    ! [N: num] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ one_one_real ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( inc @ N ) ) ) ) )).

% add_neg_numeral_special(5)
thf(fact_90_add__neg__numeral__special_I6_J,axiom,(
    ! [M: num] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( uminus_uminus_real @ one_one_real ) )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( inc @ M ) ) ) ) )).

% add_neg_numeral_special(6)
thf(fact_91_add__neg__numeral__special_I9_J,axiom,
    ( ( plus_plus_real @ ( uminus_uminus_real @ one_one_real ) @ ( uminus_uminus_real @ one_one_real ) )
    = ( uminus_uminus_real @ ( numeral_numeral_real @ ( bit0 @ one ) ) ) )).

% add_neg_numeral_special(9)
thf(fact_92_add__neg__numeral__special_I1_J,axiom,(
    ! [M: num] :
      ( ( plus_plus_real @ one_one_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) )
      = ( neg_numeral_sub_real @ one @ M ) ) )).

% add_neg_numeral_special(1)
thf(fact_93_add__neg__numeral__special_I2_J,axiom,(
    ! [M: num] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ one_one_real )
      = ( neg_numeral_sub_real @ one @ M ) ) )).

% add_neg_numeral_special(2)
thf(fact_94_add__neg__numeral__special_I3_J,axiom,(
    ! [M: num] :
      ( ( plus_plus_real @ ( numeral_numeral_real @ M ) @ ( uminus_uminus_real @ one_one_real ) )
      = ( neg_numeral_sub_real @ M @ one ) ) )).

% add_neg_numeral_special(3)
thf(fact_95_add__neg__numeral__special_I4_J,axiom,(
    ! [N: num] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ one_one_real ) @ ( numeral_numeral_real @ N ) )
      = ( neg_numeral_sub_real @ N @ one ) ) )).

% add_neg_numeral_special(4)
thf(fact_96_dbl__simps_I4_J,axiom,
    ( ( neg_numeral_dbl_real @ ( uminus_uminus_real @ one_one_real ) )
    = ( uminus_uminus_real @ ( numeral_numeral_real @ ( bit0 @ one ) ) ) )).

% dbl_simps(4)
thf(fact_97_sub__num__simps_I2_J,axiom,(
    ! [L: num] :
      ( ( neg_numeral_sub_real @ one @ ( bit0 @ L ) )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( bitM @ L ) ) ) ) )).

% sub_num_simps(2)
thf(fact_98_dbl__dec__simps_I4_J,axiom,
    ( ( neg_nu533782273c_real @ ( uminus_uminus_real @ one_one_real ) )
    = ( uminus_uminus_real @ ( numeral_numeral_real @ ( bit1 @ one ) ) ) )).

% dbl_dec_simps(4)
thf(fact_99_add_Oinverse__distrib__swap,axiom,(
    ! [A: real,B: real] :
      ( ( uminus_uminus_real @ ( plus_plus_real @ A @ B ) )
      = ( plus_plus_real @ ( uminus_uminus_real @ B ) @ ( uminus_uminus_real @ A ) ) ) )).

% add.inverse_distrib_swap
thf(fact_100_group__cancel_Oneg1,axiom,(
    ! [A2: real,K: real,A: real] :
      ( ( A2
        = ( plus_plus_real @ K @ A ) )
     => ( ( uminus_uminus_real @ A2 )
        = ( plus_plus_real @ ( uminus_uminus_real @ K ) @ ( uminus_uminus_real @ A ) ) ) ) )).

% group_cancel.neg1
thf(fact_101_one__neq__neg__numeral,axiom,(
    ! [N: num] :
      ( one_one_real
     != ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) ) )).

% one_neq_neg_numeral
thf(fact_102_numeral__neq__neg__one,axiom,(
    ! [N: num] :
      ( ( numeral_numeral_real @ N )
     != ( uminus_uminus_real @ one_one_real ) ) )).

% numeral_neq_neg_one
thf(fact_103_one__reorient,axiom,(
    ! [X4: real] :
      ( ( one_one_real = X4 )
      = ( X4 = one_one_real ) ) )).

% one_reorient
thf(fact_104_one__reorient,axiom,(
    ! [X4: nat] :
      ( ( one_one_nat = X4 )
      = ( X4 = one_one_nat ) ) )).

% one_reorient
thf(fact_105_equation__minus__iff,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( uminus_uminus_real @ B ) )
      = ( B
        = ( uminus_uminus_real @ A ) ) ) )).

% equation_minus_iff
thf(fact_106_minus__equation__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ( uminus_uminus_real @ A )
        = B )
      = ( ( uminus_uminus_real @ B )
        = A ) ) )).

% minus_equation_iff
thf(fact_107_one__neq__neg__one,axiom,(
    one_one_real
 != ( uminus_uminus_real @ one_one_real ) )).

% one_neq_neg_one
thf(fact_108_verit__negate__coefficient_I3_J,axiom,(
    ! [A: real,B: real] :
      ( ( A = B )
     => ( ( uminus_uminus_real @ A )
        = ( uminus_uminus_real @ B ) ) ) )).

% verit_negate_coefficient(3)
thf(fact_109_uminus__numeral__One,axiom,
    ( ( uminus_uminus_real @ ( numeral_numeral_real @ one ) )
    = ( uminus_uminus_real @ one_one_real ) )).

% uminus_numeral_One
thf(fact_110_nat__1__add__1,axiom,
    ( ( plus_plus_nat @ one_one_nat @ one_one_nat )
    = ( numeral_numeral_nat @ ( bit0 @ one ) ) )).

% nat_1_add_1
thf(fact_111_is__num__normalize_I8_J,axiom,(
    ! [A: real,B: real] :
      ( ( uminus_uminus_real @ ( plus_plus_real @ A @ B ) )
      = ( plus_plus_real @ ( uminus_uminus_real @ B ) @ ( uminus_uminus_real @ A ) ) ) )).

% is_num_normalize(8)
thf(fact_112_numeral__neq__neg__numeral,axiom,(
    ! [M: num,N: num] :
      ( ( numeral_numeral_real @ M )
     != ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) ) )).

% numeral_neq_neg_numeral
thf(fact_113_neg__numeral__neq__numeral,axiom,(
    ! [M: num,N: num] :
      ( ( uminus_uminus_real @ ( numeral_numeral_real @ M ) )
     != ( numeral_numeral_real @ N ) ) )).

% neg_numeral_neq_numeral
thf(fact_114_numerals_I1_J,axiom,
    ( ( numeral_numeral_nat @ one )
    = one_one_nat )).

% numerals(1)
thf(fact_115_semiring__norm_I26_J,axiom,
    ( ( bitM @ one )
    = one )).

% semiring_norm(26)
thf(fact_116_sqr_Osimps_I2_J,axiom,(
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) )).

% sqr.simps(2)
thf(fact_117_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one )
    = one )).

% sqr.simps(1)
thf(fact_118_one__plus__numeral__commute,axiom,(
    ! [X4: num] :
      ( ( plus_plus_real @ one_one_real @ ( numeral_numeral_real @ X4 ) )
      = ( plus_plus_real @ ( numeral_numeral_real @ X4 ) @ one_one_real ) ) )).

% one_plus_numeral_commute
thf(fact_119_one__plus__numeral__commute,axiom,(
    ! [X4: num] :
      ( ( plus_plus_nat @ one_one_nat @ ( numeral_numeral_nat @ X4 ) )
      = ( plus_plus_nat @ ( numeral_numeral_nat @ X4 ) @ one_one_nat ) ) )).

% one_plus_numeral_commute
thf(fact_120_numeral__One,axiom,
    ( ( numeral_numeral_real @ one )
    = one_one_real )).

% numeral_One
thf(fact_121_numeral__One,axiom,
    ( ( numeral_numeral_nat @ one )
    = one_one_nat )).

% numeral_One
thf(fact_122_dbl__inc__def,axiom,
    ( neg_nu1973887165c_real
    = ( ^ [X5: real] :
          ( plus_plus_real @ ( plus_plus_real @ X5 @ X5 ) @ one_one_real ) ) )).

% dbl_inc_def
thf(fact_123_semiring__norm_I27_J,axiom,(
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) )).

% semiring_norm(27)
thf(fact_124_semiring__norm_I28_J,axiom,(
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) )).

% semiring_norm(28)
thf(fact_125_inc__BitM__eq,axiom,(
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) )).

% inc_BitM_eq
thf(fact_126_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_127_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_128_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: real,J: real,K: real,L: real] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_real @ I @ K )
        = ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_129_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_130_group__cancel_Oadd1,axiom,(
    ! [A2: real,K: real,A: real,B: real] :
      ( ( A2
        = ( plus_plus_real @ K @ A ) )
     => ( ( plus_plus_real @ A2 @ B )
        = ( plus_plus_real @ K @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_131_group__cancel_Oadd1,axiom,(
    ! [A2: nat,K: nat,A: nat,B: nat] :
      ( ( A2
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A2 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_132_group__cancel_Oadd2,axiom,(
    ! [B2: real,K: real,B: real,A: real] :
      ( ( B2
        = ( plus_plus_real @ K @ B ) )
     => ( ( plus_plus_real @ A @ B2 )
        = ( plus_plus_real @ K @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_133_group__cancel_Oadd2,axiom,(
    ! [B2: nat,K: nat,B: nat,A: nat] :
      ( ( B2
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B2 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_134_add_Oassoc,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% add.assoc
thf(fact_135_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_136_add_Oleft__cancel,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
      = ( B = C ) ) )).

% add.left_cancel
thf(fact_137_add_Oright__cancel,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
      = ( B = C ) ) )).

% add.right_cancel
thf(fact_138_add_Ocommute,axiom,
    ( plus_plus_real
    = ( ^ [A3: real,B3: real] :
          ( plus_plus_real @ B3 @ A3 ) ) )).

% add.commute
thf(fact_139_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A3: nat,B3: nat] :
          ( plus_plus_nat @ B3 @ A3 ) ) )).

% add.commute
thf(fact_140_add_Oleft__commute,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( plus_plus_real @ B @ ( plus_plus_real @ A @ C ) )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% add.left_commute
thf(fact_141_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_142_add__left__imp__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_143_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_144_add__right__imp__eq,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_145_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_146_BitM__inc__eq,axiom,(
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) )).

% BitM_inc_eq
thf(fact_147_numeral__Bit1,axiom,(
    ! [N: num] :
      ( ( numeral_numeral_real @ ( bit1 @ N ) )
      = ( plus_plus_real @ ( plus_plus_real @ ( numeral_numeral_real @ N ) @ ( numeral_numeral_real @ N ) ) @ one_one_real ) ) )).

% numeral_Bit1
thf(fact_148_numeral__Bit1,axiom,(
    ! [N: num] :
      ( ( numeral_numeral_nat @ ( bit1 @ N ) )
      = ( plus_plus_nat @ ( plus_plus_nat @ ( numeral_numeral_nat @ N ) @ ( numeral_numeral_nat @ N ) ) @ one_one_nat ) ) )).

% numeral_Bit1
thf(fact_149_numeral__inc,axiom,(
    ! [X4: num] :
      ( ( numeral_numeral_real @ ( inc @ X4 ) )
      = ( plus_plus_real @ ( numeral_numeral_real @ X4 ) @ one_one_real ) ) )).

% numeral_inc
thf(fact_150_numeral__inc,axiom,(
    ! [X4: num] :
      ( ( numeral_numeral_nat @ ( inc @ X4 ) )
      = ( plus_plus_nat @ ( numeral_numeral_nat @ X4 ) @ one_one_nat ) ) )).

% numeral_inc
thf(fact_151_one__plus__BitM,axiom,(
    ! [N: num] :
      ( ( plus_plus_num @ one @ ( bitM @ N ) )
      = ( bit0 @ N ) ) )).

% one_plus_BitM
thf(fact_152_BitM__plus__one,axiom,(
    ! [N: num] :
      ( ( plus_plus_num @ ( bitM @ N ) @ one )
      = ( bit0 @ N ) ) )).

% BitM_plus_one
thf(fact_153_eq__numeral__iff__iszero_I7_J,axiom,(
    ! [X4: num] :
      ( ( ( uminus_uminus_real @ ( numeral_numeral_real @ X4 ) )
        = one_one_real )
      = ( ring_1_iszero_real @ ( numeral_numeral_real @ ( plus_plus_num @ X4 @ one ) ) ) ) )).

% eq_numeral_iff_iszero(7)
thf(fact_154_eq__numeral__iff__iszero_I8_J,axiom,(
    ! [Y: num] :
      ( ( one_one_real
        = ( uminus_uminus_real @ ( numeral_numeral_real @ Y ) ) )
      = ( ring_1_iszero_real @ ( numeral_numeral_real @ ( plus_plus_num @ one @ Y ) ) ) ) )).

% eq_numeral_iff_iszero(8)
thf(fact_155_minus__sub__one__diff__one,axiom,(
    ! [M: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ ( neg_numeral_sub_real @ M @ one ) ) @ one_one_real )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) ) )).

% minus_sub_one_diff_one
thf(fact_156_diff__numeral__special_I7_J,axiom,(
    ! [N: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ one_one_real ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( neg_numeral_sub_real @ N @ one ) ) )).

% diff_numeral_special(7)
thf(fact_157_add__diff__cancel__right_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_158_add__diff__cancel__right_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_159_add__diff__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_160_add__diff__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_161_add__diff__cancel__left_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_162_add__diff__cancel__left_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_163_add__diff__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_164_add__diff__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_165_diff__add__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
      = A ) )).

% diff_add_cancel
thf(fact_166_add__diff__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel
thf(fact_167_minus__diff__eq,axiom,(
    ! [A: real,B: real] :
      ( ( uminus_uminus_real @ ( minus_minus_real @ A @ B ) )
      = ( minus_minus_real @ B @ A ) ) )).

% minus_diff_eq
thf(fact_168_diff__minus__eq__add,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ A @ ( uminus_uminus_real @ B ) )
      = ( plus_plus_real @ A @ B ) ) )).

% diff_minus_eq_add
thf(fact_169_uminus__add__conv__diff,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ ( uminus_uminus_real @ A ) @ B )
      = ( minus_minus_real @ B @ A ) ) )).

% uminus_add_conv_diff
thf(fact_170_diff__numeral__simps_I1_J,axiom,(
    ! [M: num,N: num] :
      ( ( minus_minus_real @ ( numeral_numeral_real @ M ) @ ( numeral_numeral_real @ N ) )
      = ( neg_numeral_sub_real @ M @ N ) ) )).

% diff_numeral_simps(1)
thf(fact_171_iszero__neg__numeral,axiom,(
    ! [W: num] :
      ( ( ring_1_iszero_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ W ) ) )
      = ( ring_1_iszero_real @ ( numeral_numeral_real @ W ) ) ) )).

% iszero_neg_numeral
thf(fact_172_diff__numeral__simps_I3_J,axiom,(
    ! [M: num,N: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( numeral_numeral_real @ N ) )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( plus_plus_num @ M @ N ) ) ) ) )).

% diff_numeral_simps(3)
thf(fact_173_diff__numeral__simps_I2_J,axiom,(
    ! [M: num,N: num] :
      ( ( minus_minus_real @ ( numeral_numeral_real @ M ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( numeral_numeral_real @ ( plus_plus_num @ M @ N ) ) ) )).

% diff_numeral_simps(2)
thf(fact_174_diff__numeral__simps_I4_J,axiom,(
    ! [M: num,N: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( neg_numeral_sub_real @ N @ M ) ) )).

% diff_numeral_simps(4)
thf(fact_175_diff__numeral__special_I2_J,axiom,(
    ! [M: num] :
      ( ( minus_minus_real @ ( numeral_numeral_real @ M ) @ one_one_real )
      = ( neg_numeral_sub_real @ M @ one ) ) )).

% diff_numeral_special(2)
thf(fact_176_diff__numeral__special_I1_J,axiom,(
    ! [N: num] :
      ( ( minus_minus_real @ one_one_real @ ( numeral_numeral_real @ N ) )
      = ( neg_numeral_sub_real @ one @ N ) ) )).

% diff_numeral_special(1)
thf(fact_177_diff__numeral__special_I6_J,axiom,(
    ! [M: num] :
      ( ( minus_minus_real @ ( numeral_numeral_real @ M ) @ ( uminus_uminus_real @ one_one_real ) )
      = ( numeral_numeral_real @ ( inc @ M ) ) ) )).

% diff_numeral_special(6)
thf(fact_178_diff__numeral__special_I5_J,axiom,(
    ! [N: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ one_one_real ) @ ( numeral_numeral_real @ N ) )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( inc @ N ) ) ) ) )).

% diff_numeral_special(5)
thf(fact_179_diff__numeral__special_I11_J,axiom,
    ( ( minus_minus_real @ one_one_real @ ( uminus_uminus_real @ one_one_real ) )
    = ( numeral_numeral_real @ ( bit0 @ one ) ) )).

% diff_numeral_special(11)
thf(fact_180_diff__numeral__special_I10_J,axiom,
    ( ( minus_minus_real @ ( uminus_uminus_real @ one_one_real ) @ one_one_real )
    = ( uminus_uminus_real @ ( numeral_numeral_real @ ( bit0 @ one ) ) ) )).

% diff_numeral_special(10)
thf(fact_181_diff__numeral__special_I4_J,axiom,(
    ! [M: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ one_one_real )
      = ( uminus_uminus_real @ ( numeral_numeral_real @ ( plus_plus_num @ M @ one ) ) ) ) )).

% diff_numeral_special(4)
thf(fact_182_diff__numeral__special_I3_J,axiom,(
    ! [N: num] :
      ( ( minus_minus_real @ one_one_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( numeral_numeral_real @ ( plus_plus_num @ one @ N ) ) ) )).

% diff_numeral_special(3)
thf(fact_183_diff__numeral__special_I8_J,axiom,(
    ! [M: num] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( uminus_uminus_real @ one_one_real ) )
      = ( neg_numeral_sub_real @ one @ M ) ) )).

% diff_numeral_special(8)
thf(fact_184_diff__eq__diff__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( A = B )
        = ( C = D ) ) ) )).

% diff_eq_diff_eq
thf(fact_185_diff__right__commute,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B )
      = ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_186_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_187_eq__iff__iszero__diff,axiom,
    ( ( ^ [Y4: real,Z2: real] : ( Y4 = Z2 ) )
    = ( ^ [X5: real,Y5: real] :
          ( ring_1_iszero_real @ ( minus_minus_real @ X5 @ Y5 ) ) ) )).

% eq_iff_iszero_diff
thf(fact_188_group__cancel_Osub1,axiom,(
    ! [A2: real,K: real,A: real,B: real] :
      ( ( A2
        = ( plus_plus_real @ K @ A ) )
     => ( ( minus_minus_real @ A2 @ B )
        = ( plus_plus_real @ K @ ( minus_minus_real @ A @ B ) ) ) ) )).

% group_cancel.sub1
thf(fact_189_diff__eq__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( minus_minus_real @ A @ B )
        = C )
      = ( A
        = ( plus_plus_real @ C @ B ) ) ) )).

% diff_eq_eq
thf(fact_190_eq__diff__eq,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( A
        = ( minus_minus_real @ C @ B ) )
      = ( ( plus_plus_real @ A @ B )
        = C ) ) )).

% eq_diff_eq
thf(fact_191_add__diff__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ C ) ) )).

% add_diff_eq
thf(fact_192_diff__diff__eq2,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ B ) ) )).

% diff_diff_eq2
thf(fact_193_diff__add__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ B ) ) )).

% diff_add_eq
thf(fact_194_diff__add__eq__diff__diff__swap,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B ) ) )).

% diff_add_eq_diff_diff_swap
thf(fact_195_diff__diff__add,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_196_diff__diff__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C )
      = ( minus_minus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_197_add__implies__diff,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ( plus_plus_real @ C @ B )
        = A )
     => ( C
        = ( minus_minus_real @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_198_add__implies__diff,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ( plus_plus_nat @ C @ B )
        = A )
     => ( C
        = ( minus_minus_nat @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_199_minus__diff__commute,axiom,(
    ! [B: real,A: real] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ B ) @ A )
      = ( minus_minus_real @ ( uminus_uminus_real @ A ) @ B ) ) )).

% minus_diff_commute
thf(fact_200_not__iszero__1,axiom,(
    ~ ( ring_1_iszero_real @ one_one_real ) )).

% not_iszero_1
thf(fact_201_not__iszero__numeral,axiom,(
    ! [W: num] :
      ~ ( ring_1_iszero_real @ ( numeral_numeral_real @ W ) ) )).

% not_iszero_numeral
thf(fact_202_group__cancel_Osub2,axiom,(
    ! [B2: real,K: real,B: real,A: real] :
      ( ( B2
        = ( plus_plus_real @ K @ B ) )
     => ( ( minus_minus_real @ A @ B2 )
        = ( plus_plus_real @ ( uminus_uminus_real @ K ) @ ( minus_minus_real @ A @ B ) ) ) ) )).

% group_cancel.sub2
thf(fact_203_diff__conv__add__uminus,axiom,
    ( minus_minus_real
    = ( ^ [A3: real,B3: real] :
          ( plus_plus_real @ A3 @ ( uminus_uminus_real @ B3 ) ) ) )).

% diff_conv_add_uminus
thf(fact_204_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ( minus_minus_real
    = ( ^ [A3: real,B3: real] :
          ( plus_plus_real @ A3 @ ( uminus_uminus_real @ B3 ) ) ) )).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_205_neg__numeral__class_Osub__def,axiom,
    ( neg_numeral_sub_real
    = ( ^ [K2: num,L2: num] :
          ( minus_minus_real @ ( numeral_numeral_real @ K2 ) @ ( numeral_numeral_real @ L2 ) ) ) )).

% neg_numeral_class.sub_def
thf(fact_206_not__iszero__neg__1,axiom,(
    ~ ( ring_1_iszero_real @ ( uminus_uminus_real @ one_one_real ) ) )).

% not_iszero_neg_1
thf(fact_207_not__iszero__Numeral1,axiom,(
    ~ ( ring_1_iszero_real @ ( numeral_numeral_real @ one ) ) )).

% not_iszero_Numeral1
thf(fact_208_eq__numeral__iff__iszero_I1_J,axiom,(
    ! [X4: num,Y: num] :
      ( ( ( numeral_numeral_real @ X4 )
        = ( numeral_numeral_real @ Y ) )
      = ( ring_1_iszero_real @ ( neg_numeral_sub_real @ X4 @ Y ) ) ) )).

% eq_numeral_iff_iszero(1)
thf(fact_209_dbl__dec__def,axiom,
    ( neg_nu533782273c_real
    = ( ^ [X5: real] :
          ( minus_minus_real @ ( plus_plus_real @ X5 @ X5 ) @ one_one_real ) ) )).

% dbl_dec_def
thf(fact_210_not__iszero__neg__Numeral1,axiom,(
    ~ ( ring_1_iszero_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ one ) ) ) )).

% not_iszero_neg_Numeral1
thf(fact_211_numeral__BitM,axiom,(
    ! [N: num] :
      ( ( numeral_numeral_real @ ( bitM @ N ) )
      = ( minus_minus_real @ ( numeral_numeral_real @ ( bit0 @ N ) ) @ one_one_real ) ) )).

% numeral_BitM
thf(fact_212_eq__numeral__iff__iszero_I3_J,axiom,(
    ! [X4: num,Y: num] :
      ( ( ( uminus_uminus_real @ ( numeral_numeral_real @ X4 ) )
        = ( numeral_numeral_real @ Y ) )
      = ( ring_1_iszero_real @ ( numeral_numeral_real @ ( plus_plus_num @ X4 @ Y ) ) ) ) )).

% eq_numeral_iff_iszero(3)
thf(fact_213_eq__numeral__iff__iszero_I2_J,axiom,(
    ! [X4: num,Y: num] :
      ( ( ( numeral_numeral_real @ X4 )
        = ( uminus_uminus_real @ ( numeral_numeral_real @ Y ) ) )
      = ( ring_1_iszero_real @ ( numeral_numeral_real @ ( plus_plus_num @ X4 @ Y ) ) ) ) )).

% eq_numeral_iff_iszero(2)
thf(fact_214_eq__numeral__iff__iszero_I4_J,axiom,(
    ! [X4: num,Y: num] :
      ( ( ( uminus_uminus_real @ ( numeral_numeral_real @ X4 ) )
        = ( uminus_uminus_real @ ( numeral_numeral_real @ Y ) ) )
      = ( ring_1_iszero_real @ ( neg_numeral_sub_real @ Y @ X4 ) ) ) )).

% eq_numeral_iff_iszero(4)
thf(fact_215_eq__numeral__iff__iszero_I6_J,axiom,(
    ! [Y: num] :
      ( ( one_one_real
        = ( numeral_numeral_real @ Y ) )
      = ( ring_1_iszero_real @ ( neg_numeral_sub_real @ one @ Y ) ) ) )).

% eq_numeral_iff_iszero(6)
thf(fact_216_eq__numeral__iff__iszero_I5_J,axiom,(
    ! [X4: num] :
      ( ( ( numeral_numeral_real @ X4 )
        = one_one_real )
      = ( ring_1_iszero_real @ ( neg_numeral_sub_real @ X4 @ one ) ) ) )).

% eq_numeral_iff_iszero(5)
thf(fact_217_diff__diff__left,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ I @ ( plus_plus_nat @ J @ K ) ) ) )).

% diff_diff_left
thf(fact_218_minus__diff__minus,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( uminus_uminus_real @ A ) @ ( uminus_uminus_real @ B ) )
      = ( uminus_uminus_real @ ( minus_minus_real @ A @ B ) ) ) )).

% minus_diff_minus
thf(fact_219_add__diff__add,axiom,(
    ! [A: real,C: real,B: real,D: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ D ) )
      = ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ ( minus_minus_real @ C @ D ) ) ) )).

% add_diff_add
thf(fact_220_pow_Osimps_I2_J,axiom,(
    ! [X4: num,Y: num] :
      ( ( pow @ X4 @ ( bit0 @ Y ) )
      = ( sqr @ ( pow @ X4 @ Y ) ) ) )).

% pow.simps(2)
thf(fact_221_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_222_pow_Osimps_I1_J,axiom,(
    ! [X4: num] :
      ( ( pow @ X4 @ one )
      = X4 ) )).

% pow.simps(1)
thf(fact_223_Nat_Odiff__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% Nat.diff_cancel
thf(fact_224_diff__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ K ) @ ( plus_plus_nat @ N @ K ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% diff_cancel2
thf(fact_225_diff__add__inverse,axiom,(
    ! [N: nat,M: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ N @ M ) @ N )
      = M ) )).

% diff_add_inverse
thf(fact_226_diff__add__inverse2,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ N ) @ N )
      = M ) )).

% diff_add_inverse2
thf(fact_227_not__neg__one__le__neg__numeral__iff,axiom,(
    ! [M: num] :
      ( ( ~ ( ord_less_eq_real @ ( uminus_uminus_real @ one_one_real ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) ) )
      = ( M != one ) ) )).

% not_neg_one_le_neg_numeral_iff
thf(fact_228_Suc__1,axiom,
    ( ( suc @ one_one_nat )
    = ( numeral_numeral_nat @ ( bit0 @ one ) ) )).

% Suc_1
thf(fact_229_semiring__norm_I71_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq_num @ M @ N ) ) )).

% semiring_norm(71)
thf(fact_230_nat_Oinject,axiom,(
    ! [X22: nat,Y2: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y2 ) )
      = ( X22 = Y2 ) ) )).

% nat.inject
thf(fact_231_Suc__le__mono,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq_nat @ N @ M ) ) )).

% Suc_le_mono
thf(fact_232_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_233_semiring__norm_I68_J,axiom,(
    ! [N: num] :
      ( ord_less_eq_num @ one @ N ) )).

% semiring_norm(68)
thf(fact_234_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_235_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_236_semiring__norm_I73_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq_num @ M @ N ) ) )).

% semiring_norm(73)
thf(fact_237_add__le__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_238_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_239_add__le__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_240_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_241_numeral__le__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq_real @ ( numeral_numeral_real @ M ) @ ( numeral_numeral_real @ N ) )
      = ( ord_less_eq_num @ M @ N ) ) )).

% numeral_le_iff
thf(fact_242_numeral__le__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq_nat @ ( numeral_numeral_nat @ M ) @ ( numeral_numeral_nat @ N ) )
      = ( ord_less_eq_num @ M @ N ) ) )).

% numeral_le_iff
thf(fact_243_neg__le__iff__le,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ ( uminus_uminus_real @ B ) @ ( uminus_uminus_real @ A ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% neg_le_iff_le
thf(fact_244_semiring__norm_I69_J,axiom,(
    ! [M: num] :
      ~ ( ord_less_eq_num @ ( bit0 @ M ) @ one ) )).

% semiring_norm(69)
thf(fact_245_add__Suc__right,axiom,(
    ! [M: nat,N: nat] :
      ( ( plus_plus_nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus_nat @ M @ N ) ) ) )).

% add_Suc_right
thf(fact_246_Suc__diff__diff,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus_nat @ ( minus_minus_nat @ M @ N ) @ K ) ) )).

% Suc_diff_diff
thf(fact_247_diff__Suc__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% diff_Suc_Suc
thf(fact_248_Nat_Oadd__diff__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K ) ) ) )).

% Nat.add_diff_assoc
thf(fact_249_Nat_Oadd__diff__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I )
        = ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K ) ) ) )).

% Nat.add_diff_assoc2
thf(fact_250_Nat_Odiff__diff__right,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Nat.diff_diff_right
thf(fact_251_semiring__norm_I72_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq_num @ M @ N ) ) )).

% semiring_norm(72)
thf(fact_252_semiring__norm_I70_J,axiom,(
    ! [M: num] :
      ~ ( ord_less_eq_num @ ( bit1 @ M ) @ one ) )).

% semiring_norm(70)
thf(fact_253_neg__numeral__le__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq_real @ ( uminus_uminus_real @ ( numeral_numeral_real @ M ) ) @ ( uminus_uminus_real @ ( numeral_numeral_real @ N ) ) )
      = ( ord_less_eq_num @ N @ M ) ) )).

% neg_numeral_le_iff
thf(fact_254_diff__Suc__diff__eq2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( suc @ ( minus_minus_nat @ J @ K ) ) @ I )
        = ( minus_minus_nat @ ( suc @ J ) @ ( plus_plus_nat @ K @ I ) ) ) ) )).

% diff_Suc_diff_eq2
thf(fact_255_diff__Suc__diff__eq1,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ I @ ( suc @ ( minus_minus_nat @ J @ K ) ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ K ) @ ( suc @ J ) ) ) ) )).

% diff_Suc_diff_eq1
thf(fact_256_diff__Suc__1,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ ( suc @ N ) @ one_one_nat )
      = N ) )).

% diff_Suc_1
thf(fact_257_numeral__le__one__iff,axiom,(
    ! [N: num] :
      ( ( ord_less_eq_real @ ( numeral_numeral_real @ N ) @ one_one_real )
      = ( ord_less_eq_num @ N @ one ) ) )).

% numeral_le_one_iff
thf(fact_258_numeral__le__one__iff,axiom,(
    ! [N: num] :
      ( ( ord_less_eq_nat @ ( numeral_numeral_nat @ N ) @ one_one_nat )
      = ( ord_less_eq_num @ N @ one ) ) )).

% numeral_le_one_iff
thf(fact_259_Suc__numeral,axiom,(
    ! [N: num] :
      ( ( suc @ ( numeral_numeral_nat @ N ) )
      = ( numeral_numeral_nat @ ( plus_plus_num @ N @ one ) ) ) )).

% Suc_numeral
thf(fact_260_add__2__eq__Suc,axiom,(
    ! [N: nat] :
      ( ( plus_plus_nat @ ( numeral_numeral_nat @ ( bit0 @ one ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) )).

% add_2_eq_Suc
thf(fact_261_add__2__eq__Suc_H,axiom,(
    ! [N: nat] :
      ( ( plus_plus_nat @ N @ ( numeral_numeral_nat @ ( bit0 @ one ) ) )
      = ( suc @ ( suc @ N ) ) ) )).

% add_2_eq_Suc'
thf(fact_262_Nat_Ole__imp__diff__is__add,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ( minus_minus_nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus_nat @ K @ I ) ) ) ) )).

% Nat.le_imp_diff_is_add
thf(fact_263_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus_nat @ one_one_nat ) )).

% Suc_eq_plus1_left
thf(fact_264_add__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ( plus_plus_nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus_nat @ M @ N ) ) ) )).

% add_Suc
thf(fact_265_Nat_Odiff__add__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K )
        = ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I ) ) ) )).

% Nat.diff_add_assoc2
thf(fact_266_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus_nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_267_nat__arith_Osuc1,axiom,(
    ! [A2: nat,K: nat,A: nat] :
      ( ( A2
        = ( plus_plus_nat @ K @ A ) )
     => ( ( suc @ A2 )
        = ( plus_plus_nat @ K @ ( suc @ A ) ) ) ) )).

% nat_arith.suc1
thf(fact_268_Nat_Odiff__add__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K )
        = ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) ) )).

% Nat.diff_add_assoc
thf(fact_269_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_270_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_271_plus__1__eq__Suc,axiom,
    ( ( plus_plus_nat @ one_one_nat )
    = suc )).

% plus_1_eq_Suc
thf(fact_272_Nat_Ole__diff__conv2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Nat.le_diff_conv2
thf(fact_273_add__Suc__shift,axiom,(
    ! [M: nat,N: nat] :
      ( ( plus_plus_nat @ ( suc @ M ) @ N )
      = ( plus_plus_nat @ M @ ( suc @ N ) ) ) )).

% add_Suc_shift
thf(fact_274_le__diff__conv,axiom,(
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ J @ K ) @ I )
      = ( ord_less_eq_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) )).

% le_diff_conv
thf(fact_275_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_276_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N2: nat] :
          ( plus_plus_nat @ N2 @ one_one_nat ) ) )).

% Suc_eq_plus1
thf(fact_277_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_278_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus_nat @ K @ N3 ) ) ) )).

% le_Suc_ex

% Conjectures (2)
thf(conj_0,hypothesis,(
    ! [Pos: cars > real] :
      ( ! [C2: cars] :
          ( ( Pos @ C2 )
          = ( numeral_numeral_real @ ( bit1 @ ( bit0 @ one ) ) ) )
     => thesis ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
